/*!
 * Webogram v0.7.0 - messaging web application for MTProto
 * https://github.com/zhukov/webogram
 * Copyright (C) 2014 Igor Zhukov <igor.beatle@gmail.com>
 * https://github.com/zhukov/webogram/blob/master/LICENSE
 */

Config = window.Config || {};

/*

  IMPORTANT NOTICE
  ================

  Do not publish your Webogram fork with my app credentials (below), or your application may be blocked.
  You can get your own api_id, api_hash at https://my.telegram.org, see manual at https://core.telegram.org/api/obtaining_api_id.

*/

Config.App = {
  id: 1025907,
  hash: '452b0359b988148995f22ff0f4229750',
  version: '0.3.0',
  domains: [],
  baseDcID: 2
};

Config.Modes = {
  test: location.search.indexOf('test=1') > 0/*  || true */,
  debug: location.search.indexOf('debug=1') > 0,
  http: location.search.indexOf('http=1') > 0,
  ssl: location.search.indexOf('ssl=1') > 0 || location.protocol == 'https:' && location.search.indexOf('ssl=0') == -1,
  force_mobile: location.search.indexOf('mobile=1') > 0,
  force_desktop: location.search.indexOf('desktop=1') > 0,
  webcrypto: location.search.indexOf('webcrypto=0') == -1 && 1 == 2,
  packed: location.protocol == 'app:' || location.protocol == 'chrome-extension:',
  ios_standalone: window.navigator.standalone && navigator.userAgent.match(/iOS|iPhone|iPad/),
  chrome_packed: window.chrome && chrome.app && chrome.app.window && true || false,
  animations: true,
  memory_only: false,
  allow_tmpfs: location.search.indexOf('tmpfs=yeahImSureIknowWhatImDoing') > 0 || false,
  push_api: location.search.indexOf('push=1') == -1,
  multipleConnections: true
};

Config.Mobile = false;

Config.Navigator = {
  nativeEmoji: /(Mac|iPhone|iPod|iPad)/i.test(navigator.platform || ''),
  osX: (navigator.platform || '').toLowerCase().indexOf('mac') != -1 ||
    (navigator.userAgent || '').toLowerCase().indexOf('mac') != -1,
  msie: (navigator.userAgent || '').search(/MSIE | Trident\/|Edge\//) != -1,
  retina: window.devicePixelRatio > 1,
  ffos: navigator.userAgent.search(/mobi.+Gecko/i) != -1,
  ffos2p: navigator.userAgent.search(/mobi.+Gecko\/[34567]/i) != -1,
  touch: screen.width <= 768 || ('ontouchstart' in window) || window.DocumentTouch && document instanceof DocumentTouch,
  mobile: screen.width && screen.width < 480 || navigator.userAgent.search(/iOS|iPhone OS|Android|BlackBerry|BB10|Series ?[64]0|J2ME|MIDP|opera mini|opera mobi|mobi.+Gecko|Windows Phone/i) != -1
};

Config.ExtCredentials = {
  gmaps: {
    api_key: 'AIzaSyC72t5GDcP-dob20d-ARwSwOQ41-zgbArg'
  }
};

{
 /*  let img_size = 32;
  let side = 52;
  let sheetUrl = `assets/img/sheet_apple_${img_size}_`; // #.png
  let multiplyX = 100 / 6;
  let sheetSizeX = 6 * (img_size + 2); // size of image in pixels
  let sheetSizeY = side * (img_size + 2); // size of image in pixels
  let sizeX = 100 * (sheetSizeX / img_size);
  let sizeY = 100 * (sheetSizeY / img_size);
  let splitted = true; */

  let img_size = 64;
  let side = 56;
  let sheetUrl = `assets/img/sheet_apple_${img_size}`; // #.png
  let multiplyX = 100 / side;
  let sheetSizeX = side * (img_size + 2); // size of image in pixels
  let sheetSizeY = side * (img_size + 2); // size of image in pixels
  let sizeX = 100 * (sheetSizeX / img_size);
  let sizeY = 100 * (sheetSizeY / img_size);
  let splitted = false;

  Config.Emoji = {
    img_size,
    sheetUrl,
    multiplyX,
    sheetSizeX,
    sheetSizeY,
    sizeX,
    sizeY,
    side,
    splitted,
    keyCategory: 'category',
    keyX: 'sheet_x',
    keyY: 'sheet_y',
    /* keyCategory: '2',
    keyX: '0', // 'sheet_x'
    keyY: '1', // 'sheet_y' */

    emoji: {"#️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":0,"sort_order":132},"*️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":1,"sort_order":133},"0️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":2,"sort_order":134},"1️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":3,"sort_order":135},"2️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":4,"sort_order":136},"3️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":5,"sort_order":137},"4️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":6,"sort_order":138},"5️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":7,"sort_order":139},"6️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":8,"sort_order":140},"7️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":9,"sort_order":141},"8️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":10,"sort_order":142},"9️⃣":{"category":"Symbols","sheet_x":0,"sheet_y":11,"sort_order":143},"©️":{"category":"Symbols","sheet_x":0,"sheet_y":12,"sort_order":129},"®️":{"category":"Symbols","sheet_x":0,"sheet_y":13,"sort_order":130},"🀄":{"category":"Activities","sheet_x":0,"sheet_y":14,"sort_order":73},"🃏":{"category":"Activities","sheet_x":0,"sheet_y":15,"sort_order":72},"🅰️":{"category":"Symbols","sheet_x":0,"sheet_y":16,"sort_order":150},"🅱️":{"category":"Symbols","sheet_x":0,"sheet_y":17,"sort_order":152},"🅾️":{"category":"Symbols","sheet_x":0,"sheet_y":18,"sort_order":161},"🅿️":{"category":"Symbols","sheet_x":0,"sheet_y":19,"sort_order":163},"🆎":{"category":"Symbols","sheet_x":0,"sheet_y":20,"sort_order":151},"🆑":{"category":"Symbols","sheet_x":0,"sheet_y":21,"sort_order":153},"🆒":{"category":"Symbols","sheet_x":0,"sheet_y":22,"sort_order":154},"🆓":{"category":"Symbols","sheet_x":0,"sheet_y":23,"sort_order":155},"🆔":{"category":"Symbols","sheet_x":0,"sheet_y":24,"sort_order":157},"🆕":{"category":"Symbols","sheet_x":0,"sheet_y":25,"sort_order":159},"🆖":{"category":"Symbols","sheet_x":0,"sheet_y":26,"sort_order":160},"🆗":{"category":"Symbols","sheet_x":0,"sheet_y":27,"sort_order":162},"🆘":{"category":"Symbols","sheet_x":0,"sheet_y":28,"sort_order":164},"🆙":{"category":"Symbols","sheet_x":0,"sheet_y":29,"sort_order":165},"🆚":{"category":"Symbols","sheet_x":0,"sheet_y":30,"sort_order":166},"🇦🇨":{"category":"Flags","sheet_x":0,"sheet_y":31,"sort_order":8},"🇦🇩":{"category":"Flags","sheet_x":0,"sheet_y":32,"sort_order":9},"🇦🇪":{"category":"Flags","sheet_x":0,"sheet_y":33,"sort_order":10},"🇦🇫":{"category":"Flags","sheet_x":0,"sheet_y":34,"sort_order":11},"🇦🇬":{"category":"Flags","sheet_x":0,"sheet_y":35,"sort_order":12},"🇦🇮":{"category":"Flags","sheet_x":0,"sheet_y":36,"sort_order":13},"🇦🇱":{"category":"Flags","sheet_x":0,"sheet_y":37,"sort_order":14},"🇦🇲":{"category":"Flags","sheet_x":0,"sheet_y":38,"sort_order":15},"🇦🇴":{"category":"Flags","sheet_x":0,"sheet_y":39,"sort_order":16},"🇦🇶":{"category":"Flags","sheet_x":0,"sheet_y":40,"sort_order":17},"🇦🇷":{"category":"Flags","sheet_x":0,"sheet_y":41,"sort_order":18},"🇦🇸":{"category":"Flags","sheet_x":0,"sheet_y":42,"sort_order":19},"🇦🇹":{"category":"Flags","sheet_x":0,"sheet_y":43,"sort_order":20},"🇦🇺":{"category":"Flags","sheet_x":0,"sheet_y":44,"sort_order":21},"🇦🇼":{"category":"Flags","sheet_x":0,"sheet_y":45,"sort_order":22},"🇦🇽":{"category":"Flags","sheet_x":0,"sheet_y":46,"sort_order":23},"🇦🇿":{"category":"Flags","sheet_x":0,"sheet_y":47,"sort_order":24},"🇧🇦":{"category":"Flags","sheet_x":0,"sheet_y":48,"sort_order":25},"🇧🇧":{"category":"Flags","sheet_x":0,"sheet_y":49,"sort_order":26},"🇧🇩":{"category":"Flags","sheet_x":0,"sheet_y":50,"sort_order":27},"🇧🇪":{"category":"Flags","sheet_x":0,"sheet_y":51,"sort_order":28},"🇧🇫":{"category":"Flags","sheet_x":0,"sheet_y":52,"sort_order":29},"🇧🇬":{"category":"Flags","sheet_x":0,"sheet_y":53,"sort_order":30},"🇧🇭":{"category":"Flags","sheet_x":0,"sheet_y":54,"sort_order":31},"🇧🇮":{"category":"Flags","sheet_x":0,"sheet_y":55,"sort_order":32},"🇧🇯":{"category":"Flags","sheet_x":0,"sheet_y":56,"sort_order":33},"🇧🇱":{"category":"Flags","sheet_x":1,"sheet_y":0,"sort_order":34},"🇧🇲":{"category":"Flags","sheet_x":1,"sheet_y":1,"sort_order":35},"🇧🇳":{"category":"Flags","sheet_x":1,"sheet_y":2,"sort_order":36},"🇧🇴":{"category":"Flags","sheet_x":1,"sheet_y":3,"sort_order":37},"🇧🇶":{"category":"Flags","sheet_x":1,"sheet_y":4,"sort_order":38},"🇧🇷":{"category":"Flags","sheet_x":1,"sheet_y":5,"sort_order":39},"🇧🇸":{"category":"Flags","sheet_x":1,"sheet_y":6,"sort_order":40},"🇧🇹":{"category":"Flags","sheet_x":1,"sheet_y":7,"sort_order":41},"🇧🇻":{"category":"Flags","sheet_x":1,"sheet_y":8,"sort_order":42},"🇧🇼":{"category":"Flags","sheet_x":1,"sheet_y":9,"sort_order":43},"🇧🇾":{"category":"Flags","sheet_x":1,"sheet_y":10,"sort_order":44},"🇧🇿":{"category":"Flags","sheet_x":1,"sheet_y":11,"sort_order":45},"🇨🇦":{"category":"Flags","sheet_x":1,"sheet_y":12,"sort_order":46},"🇨🇨":{"category":"Flags","sheet_x":1,"sheet_y":13,"sort_order":47},"🇨🇩":{"category":"Flags","sheet_x":1,"sheet_y":14,"sort_order":48},"🇨🇫":{"category":"Flags","sheet_x":1,"sheet_y":15,"sort_order":49},"🇨🇬":{"category":"Flags","sheet_x":1,"sheet_y":16,"sort_order":50},"🇨🇭":{"category":"Flags","sheet_x":1,"sheet_y":17,"sort_order":51},"🇨🇮":{"category":"Flags","sheet_x":1,"sheet_y":18,"sort_order":52},"🇨🇰":{"category":"Flags","sheet_x":1,"sheet_y":19,"sort_order":53},"🇨🇱":{"category":"Flags","sheet_x":1,"sheet_y":20,"sort_order":54},"🇨🇲":{"category":"Flags","sheet_x":1,"sheet_y":21,"sort_order":55},"🇨🇳":{"category":"Flags","sheet_x":1,"sheet_y":22,"sort_order":56},"🇨🇴":{"category":"Flags","sheet_x":1,"sheet_y":23,"sort_order":57},"🇨🇵":{"category":"Flags","sheet_x":1,"sheet_y":24,"sort_order":58},"🇨🇷":{"category":"Flags","sheet_x":1,"sheet_y":25,"sort_order":59},"🇨🇺":{"category":"Flags","sheet_x":1,"sheet_y":26,"sort_order":60},"🇨🇻":{"category":"Flags","sheet_x":1,"sheet_y":27,"sort_order":61},"🇨🇼":{"category":"Flags","sheet_x":1,"sheet_y":28,"sort_order":62},"🇨🇽":{"category":"Flags","sheet_x":1,"sheet_y":29,"sort_order":63},"🇨🇾":{"category":"Flags","sheet_x":1,"sheet_y":30,"sort_order":64},"🇨🇿":{"category":"Flags","sheet_x":1,"sheet_y":31,"sort_order":65},"🇩🇪":{"category":"Flags","sheet_x":1,"sheet_y":32,"sort_order":66},"🇩🇬":{"category":"Flags","sheet_x":1,"sheet_y":33,"sort_order":67},"🇩🇯":{"category":"Flags","sheet_x":1,"sheet_y":34,"sort_order":68},"🇩🇰":{"category":"Flags","sheet_x":1,"sheet_y":35,"sort_order":69},"🇩🇲":{"category":"Flags","sheet_x":1,"sheet_y":36,"sort_order":70},"🇩🇴":{"category":"Flags","sheet_x":1,"sheet_y":37,"sort_order":71},"🇩🇿":{"category":"Flags","sheet_x":1,"sheet_y":38,"sort_order":72},"🇪🇦":{"category":"Flags","sheet_x":1,"sheet_y":39,"sort_order":73},"🇪🇨":{"category":"Flags","sheet_x":1,"sheet_y":40,"sort_order":74},"🇪🇪":{"category":"Flags","sheet_x":1,"sheet_y":41,"sort_order":75},"🇪🇬":{"category":"Flags","sheet_x":1,"sheet_y":42,"sort_order":76},"🇪🇭":{"category":"Flags","sheet_x":1,"sheet_y":43,"sort_order":77},"🇪🇷":{"category":"Flags","sheet_x":1,"sheet_y":44,"sort_order":78},"🇪🇸":{"category":"Flags","sheet_x":1,"sheet_y":45,"sort_order":79},"🇪🇹":{"category":"Flags","sheet_x":1,"sheet_y":46,"sort_order":80},"🇪🇺":{"category":"Flags","sheet_x":1,"sheet_y":47,"sort_order":81},"🇫🇮":{"category":"Flags","sheet_x":1,"sheet_y":48,"sort_order":82},"🇫🇯":{"category":"Flags","sheet_x":1,"sheet_y":49,"sort_order":83},"🇫🇰":{"category":"Flags","sheet_x":1,"sheet_y":50,"sort_order":84},"🇫🇲":{"category":"Flags","sheet_x":1,"sheet_y":51,"sort_order":85},"🇫🇴":{"category":"Flags","sheet_x":1,"sheet_y":52,"sort_order":86},"🇫🇷":{"category":"Flags","sheet_x":1,"sheet_y":53,"sort_order":87},"🇬🇦":{"category":"Flags","sheet_x":1,"sheet_y":54,"sort_order":88},"🇬🇧":{"category":"Flags","sheet_x":1,"sheet_y":55,"sort_order":89},"🇬🇩":{"category":"Flags","sheet_x":1,"sheet_y":56,"sort_order":90},"🇬🇪":{"category":"Flags","sheet_x":2,"sheet_y":0,"sort_order":91},"🇬🇫":{"category":"Flags","sheet_x":2,"sheet_y":1,"sort_order":92},"🇬🇬":{"category":"Flags","sheet_x":2,"sheet_y":2,"sort_order":93},"🇬🇭":{"category":"Flags","sheet_x":2,"sheet_y":3,"sort_order":94},"🇬🇮":{"category":"Flags","sheet_x":2,"sheet_y":4,"sort_order":95},"🇬🇱":{"category":"Flags","sheet_x":2,"sheet_y":5,"sort_order":96},"🇬🇲":{"category":"Flags","sheet_x":2,"sheet_y":6,"sort_order":97},"🇬🇳":{"category":"Flags","sheet_x":2,"sheet_y":7,"sort_order":98},"🇬🇵":{"category":"Flags","sheet_x":2,"sheet_y":8,"sort_order":99},"🇬🇶":{"category":"Flags","sheet_x":2,"sheet_y":9,"sort_order":100},"🇬🇷":{"category":"Flags","sheet_x":2,"sheet_y":10,"sort_order":101},"🇬🇸":{"category":"Flags","sheet_x":2,"sheet_y":11,"sort_order":102},"🇬🇹":{"category":"Flags","sheet_x":2,"sheet_y":12,"sort_order":103},"🇬🇺":{"category":"Flags","sheet_x":2,"sheet_y":13,"sort_order":104},"🇬🇼":{"category":"Flags","sheet_x":2,"sheet_y":14,"sort_order":105},"🇬🇾":{"category":"Flags","sheet_x":2,"sheet_y":15,"sort_order":106},"🇭🇰":{"category":"Flags","sheet_x":2,"sheet_y":16,"sort_order":107},"🇭🇲":{"category":"Flags","sheet_x":2,"sheet_y":17,"sort_order":108},"🇭🇳":{"category":"Flags","sheet_x":2,"sheet_y":18,"sort_order":109},"🇭🇷":{"category":"Flags","sheet_x":2,"sheet_y":19,"sort_order":110},"🇭🇹":{"category":"Flags","sheet_x":2,"sheet_y":20,"sort_order":111},"🇭🇺":{"category":"Flags","sheet_x":2,"sheet_y":21,"sort_order":112},"🇮🇨":{"category":"Flags","sheet_x":2,"sheet_y":22,"sort_order":113},"🇮🇩":{"category":"Flags","sheet_x":2,"sheet_y":23,"sort_order":114},"🇮🇪":{"category":"Flags","sheet_x":2,"sheet_y":24,"sort_order":115},"🇮🇱":{"category":"Flags","sheet_x":2,"sheet_y":25,"sort_order":116},"🇮🇲":{"category":"Flags","sheet_x":2,"sheet_y":26,"sort_order":117},"🇮🇳":{"category":"Flags","sheet_x":2,"sheet_y":27,"sort_order":118},"🇮🇴":{"category":"Flags","sheet_x":2,"sheet_y":28,"sort_order":119},"🇮🇶":{"category":"Flags","sheet_x":2,"sheet_y":29,"sort_order":120},"🇮🇷":{"category":"Flags","sheet_x":2,"sheet_y":30,"sort_order":121},"🇮🇸":{"category":"Flags","sheet_x":2,"sheet_y":31,"sort_order":122},"🇮🇹":{"category":"Flags","sheet_x":2,"sheet_y":32,"sort_order":123},"🇯🇪":{"category":"Flags","sheet_x":2,"sheet_y":33,"sort_order":124},"🇯🇲":{"category":"Flags","sheet_x":2,"sheet_y":34,"sort_order":125},"🇯🇴":{"category":"Flags","sheet_x":2,"sheet_y":35,"sort_order":126},"🇯🇵":{"category":"Flags","sheet_x":2,"sheet_y":36,"sort_order":127},"🇰🇪":{"category":"Flags","sheet_x":2,"sheet_y":37,"sort_order":128},"🇰🇬":{"category":"Flags","sheet_x":2,"sheet_y":38,"sort_order":129},"🇰🇭":{"category":"Flags","sheet_x":2,"sheet_y":39,"sort_order":130},"🇰🇮":{"category":"Flags","sheet_x":2,"sheet_y":40,"sort_order":131},"🇰🇲":{"category":"Flags","sheet_x":2,"sheet_y":41,"sort_order":132},"🇰🇳":{"category":"Flags","sheet_x":2,"sheet_y":42,"sort_order":133},"🇰🇵":{"category":"Flags","sheet_x":2,"sheet_y":43,"sort_order":134},"🇰🇷":{"category":"Flags","sheet_x":2,"sheet_y":44,"sort_order":135},"🇰🇼":{"category":"Flags","sheet_x":2,"sheet_y":45,"sort_order":136},"🇰🇾":{"category":"Flags","sheet_x":2,"sheet_y":46,"sort_order":137},"🇰🇿":{"category":"Flags","sheet_x":2,"sheet_y":47,"sort_order":138},"🇱🇦":{"category":"Flags","sheet_x":2,"sheet_y":48,"sort_order":139},"🇱🇧":{"category":"Flags","sheet_x":2,"sheet_y":49,"sort_order":140},"🇱🇨":{"category":"Flags","sheet_x":2,"sheet_y":50,"sort_order":141},"🇱🇮":{"category":"Flags","sheet_x":2,"sheet_y":51,"sort_order":142},"🇱🇰":{"category":"Flags","sheet_x":2,"sheet_y":52,"sort_order":143},"🇱🇷":{"category":"Flags","sheet_x":2,"sheet_y":53,"sort_order":144},"🇱🇸":{"category":"Flags","sheet_x":2,"sheet_y":54,"sort_order":145},"🇱🇹":{"category":"Flags","sheet_x":2,"sheet_y":55,"sort_order":146},"🇱🇺":{"category":"Flags","sheet_x":2,"sheet_y":56,"sort_order":147},"🇱🇻":{"category":"Flags","sheet_x":3,"sheet_y":0,"sort_order":148},"🇱🇾":{"category":"Flags","sheet_x":3,"sheet_y":1,"sort_order":149},"🇲🇦":{"category":"Flags","sheet_x":3,"sheet_y":2,"sort_order":150},"🇲🇨":{"category":"Flags","sheet_x":3,"sheet_y":3,"sort_order":151},"🇲🇩":{"category":"Flags","sheet_x":3,"sheet_y":4,"sort_order":152},"🇲🇪":{"category":"Flags","sheet_x":3,"sheet_y":5,"sort_order":153},"🇲🇫":{"category":"Flags","sheet_x":3,"sheet_y":6,"sort_order":154},"🇲🇬":{"category":"Flags","sheet_x":3,"sheet_y":7,"sort_order":155},"🇲🇭":{"category":"Flags","sheet_x":3,"sheet_y":8,"sort_order":156},"🇲🇰":{"category":"Flags","sheet_x":3,"sheet_y":9,"sort_order":157},"🇲🇱":{"category":"Flags","sheet_x":3,"sheet_y":10,"sort_order":158},"🇲🇲":{"category":"Flags","sheet_x":3,"sheet_y":11,"sort_order":159},"🇲🇳":{"category":"Flags","sheet_x":3,"sheet_y":12,"sort_order":160},"🇲🇴":{"category":"Flags","sheet_x":3,"sheet_y":13,"sort_order":161},"🇲🇵":{"category":"Flags","sheet_x":3,"sheet_y":14,"sort_order":162},"🇲🇶":{"category":"Flags","sheet_x":3,"sheet_y":15,"sort_order":163},"🇲🇷":{"category":"Flags","sheet_x":3,"sheet_y":16,"sort_order":164},"🇲🇸":{"category":"Flags","sheet_x":3,"sheet_y":17,"sort_order":165},"🇲🇹":{"category":"Flags","sheet_x":3,"sheet_y":18,"sort_order":166},"🇲🇺":{"category":"Flags","sheet_x":3,"sheet_y":19,"sort_order":167},"🇲🇻":{"category":"Flags","sheet_x":3,"sheet_y":20,"sort_order":168},"🇲🇼":{"category":"Flags","sheet_x":3,"sheet_y":21,"sort_order":169},"🇲🇽":{"category":"Flags","sheet_x":3,"sheet_y":22,"sort_order":170},"🇲🇾":{"category":"Flags","sheet_x":3,"sheet_y":23,"sort_order":171},"🇲🇿":{"category":"Flags","sheet_x":3,"sheet_y":24,"sort_order":172},"🇳🇦":{"category":"Flags","sheet_x":3,"sheet_y":25,"sort_order":173},"🇳🇨":{"category":"Flags","sheet_x":3,"sheet_y":26,"sort_order":174},"🇳🇪":{"category":"Flags","sheet_x":3,"sheet_y":27,"sort_order":175},"🇳🇫":{"category":"Flags","sheet_x":3,"sheet_y":28,"sort_order":176},"🇳🇬":{"category":"Flags","sheet_x":3,"sheet_y":29,"sort_order":177},"🇳🇮":{"category":"Flags","sheet_x":3,"sheet_y":30,"sort_order":178},"🇳🇱":{"category":"Flags","sheet_x":3,"sheet_y":31,"sort_order":179},"🇳🇴":{"category":"Flags","sheet_x":3,"sheet_y":32,"sort_order":180},"🇳🇵":{"category":"Flags","sheet_x":3,"sheet_y":33,"sort_order":181},"🇳🇷":{"category":"Flags","sheet_x":3,"sheet_y":34,"sort_order":182},"🇳🇺":{"category":"Flags","sheet_x":3,"sheet_y":35,"sort_order":183},"🇳🇿":{"category":"Flags","sheet_x":3,"sheet_y":36,"sort_order":184},"🇴🇲":{"category":"Flags","sheet_x":3,"sheet_y":37,"sort_order":185},"🇵🇦":{"category":"Flags","sheet_x":3,"sheet_y":38,"sort_order":186},"🇵🇪":{"category":"Flags","sheet_x":3,"sheet_y":39,"sort_order":187},"🇵🇫":{"category":"Flags","sheet_x":3,"sheet_y":40,"sort_order":188},"🇵🇬":{"category":"Flags","sheet_x":3,"sheet_y":41,"sort_order":189},"🇵🇭":{"category":"Flags","sheet_x":3,"sheet_y":42,"sort_order":190},"🇵🇰":{"category":"Flags","sheet_x":3,"sheet_y":43,"sort_order":191},"🇵🇱":{"category":"Flags","sheet_x":3,"sheet_y":44,"sort_order":192},"🇵🇲":{"category":"Flags","sheet_x":3,"sheet_y":45,"sort_order":193},"🇵🇳":{"category":"Flags","sheet_x":3,"sheet_y":46,"sort_order":194},"🇵🇷":{"category":"Flags","sheet_x":3,"sheet_y":47,"sort_order":195},"🇵🇸":{"category":"Flags","sheet_x":3,"sheet_y":48,"sort_order":196},"🇵🇹":{"category":"Flags","sheet_x":3,"sheet_y":49,"sort_order":197},"🇵🇼":{"category":"Flags","sheet_x":3,"sheet_y":50,"sort_order":198},"🇵🇾":{"category":"Flags","sheet_x":3,"sheet_y":51,"sort_order":199},"🇶🇦":{"category":"Flags","sheet_x":3,"sheet_y":52,"sort_order":200},"🇷🇪":{"category":"Flags","sheet_x":3,"sheet_y":53,"sort_order":201},"🇷🇴":{"category":"Flags","sheet_x":3,"sheet_y":54,"sort_order":202},"🇷🇸":{"category":"Flags","sheet_x":3,"sheet_y":55,"sort_order":203},"🇷🇺":{"category":"Flags","sheet_x":3,"sheet_y":56,"sort_order":204},"🇷🇼":{"category":"Flags","sheet_x":4,"sheet_y":0,"sort_order":205},"🇸🇦":{"category":"Flags","sheet_x":4,"sheet_y":1,"sort_order":206},"🇸🇧":{"category":"Flags","sheet_x":4,"sheet_y":2,"sort_order":207},"🇸🇨":{"category":"Flags","sheet_x":4,"sheet_y":3,"sort_order":208},"🇸🇩":{"category":"Flags","sheet_x":4,"sheet_y":4,"sort_order":209},"🇸🇪":{"category":"Flags","sheet_x":4,"sheet_y":5,"sort_order":210},"🇸🇬":{"category":"Flags","sheet_x":4,"sheet_y":6,"sort_order":211},"🇸🇭":{"category":"Flags","sheet_x":4,"sheet_y":7,"sort_order":212},"🇸🇮":{"category":"Flags","sheet_x":4,"sheet_y":8,"sort_order":213},"🇸🇯":{"category":"Flags","sheet_x":4,"sheet_y":9,"sort_order":214},"🇸🇰":{"category":"Flags","sheet_x":4,"sheet_y":10,"sort_order":215},"🇸🇱":{"category":"Flags","sheet_x":4,"sheet_y":11,"sort_order":216},"🇸🇲":{"category":"Flags","sheet_x":4,"sheet_y":12,"sort_order":217},"🇸🇳":{"category":"Flags","sheet_x":4,"sheet_y":13,"sort_order":218},"🇸🇴":{"category":"Flags","sheet_x":4,"sheet_y":14,"sort_order":219},"🇸🇷":{"category":"Flags","sheet_x":4,"sheet_y":15,"sort_order":220},"🇸🇸":{"category":"Flags","sheet_x":4,"sheet_y":16,"sort_order":221},"🇸🇹":{"category":"Flags","sheet_x":4,"sheet_y":17,"sort_order":222},"🇸🇻":{"category":"Flags","sheet_x":4,"sheet_y":18,"sort_order":223},"🇸🇽":{"category":"Flags","sheet_x":4,"sheet_y":19,"sort_order":224},"🇸🇾":{"category":"Flags","sheet_x":4,"sheet_y":20,"sort_order":225},"🇸🇿":{"category":"Flags","sheet_x":4,"sheet_y":21,"sort_order":226},"🇹🇦":{"category":"Flags","sheet_x":4,"sheet_y":22,"sort_order":227},"🇹🇨":{"category":"Flags","sheet_x":4,"sheet_y":23,"sort_order":228},"🇹🇩":{"category":"Flags","sheet_x":4,"sheet_y":24,"sort_order":229},"🇹🇫":{"category":"Flags","sheet_x":4,"sheet_y":25,"sort_order":230},"🇹🇬":{"category":"Flags","sheet_x":4,"sheet_y":26,"sort_order":231},"🇹🇭":{"category":"Flags","sheet_x":4,"sheet_y":27,"sort_order":232},"🇹🇯":{"category":"Flags","sheet_x":4,"sheet_y":28,"sort_order":233},"🇹🇰":{"category":"Flags","sheet_x":4,"sheet_y":29,"sort_order":234},"🇹🇱":{"category":"Flags","sheet_x":4,"sheet_y":30,"sort_order":235},"🇹🇲":{"category":"Flags","sheet_x":4,"sheet_y":31,"sort_order":236},"🇹🇳":{"category":"Flags","sheet_x":4,"sheet_y":32,"sort_order":237},"🇹🇴":{"category":"Flags","sheet_x":4,"sheet_y":33,"sort_order":238},"🇹🇷":{"category":"Flags","sheet_x":4,"sheet_y":34,"sort_order":239},"🇹🇹":{"category":"Flags","sheet_x":4,"sheet_y":35,"sort_order":240},"🇹🇻":{"category":"Flags","sheet_x":4,"sheet_y":36,"sort_order":241},"🇹🇼":{"category":"Flags","sheet_x":4,"sheet_y":37,"sort_order":242},"🇹🇿":{"category":"Flags","sheet_x":4,"sheet_y":38,"sort_order":243},"🇺🇦":{"category":"Flags","sheet_x":4,"sheet_y":39,"sort_order":244},"🇺🇬":{"category":"Flags","sheet_x":4,"sheet_y":40,"sort_order":245},"🇺🇲":{"category":"Flags","sheet_x":4,"sheet_y":41,"sort_order":246},"🇺🇳":{"category":"Flags","sheet_x":4,"sheet_y":42,"sort_order":247},"🇺🇸":{"category":"Flags","sheet_x":4,"sheet_y":43,"sort_order":248},"🇺🇾":{"category":"Flags","sheet_x":4,"sheet_y":44,"sort_order":249},"🇺🇿":{"category":"Flags","sheet_x":4,"sheet_y":45,"sort_order":250},"🇻🇦":{"category":"Flags","sheet_x":4,"sheet_y":46,"sort_order":251},"🇻🇨":{"category":"Flags","sheet_x":4,"sheet_y":47,"sort_order":252},"🇻🇪":{"category":"Flags","sheet_x":4,"sheet_y":48,"sort_order":253},"🇻🇬":{"category":"Flags","sheet_x":4,"sheet_y":49,"sort_order":254},"🇻🇮":{"category":"Flags","sheet_x":4,"sheet_y":50,"sort_order":255},"🇻🇳":{"category":"Flags","sheet_x":4,"sheet_y":51,"sort_order":256},"🇻🇺":{"category":"Flags","sheet_x":4,"sheet_y":52,"sort_order":257},"🇼🇫":{"category":"Flags","sheet_x":4,"sheet_y":53,"sort_order":258},"🇼🇸":{"category":"Flags","sheet_x":4,"sheet_y":54,"sort_order":259},"🇽🇰":{"category":"Flags","sheet_x":4,"sheet_y":55,"sort_order":260},"🇾🇪":{"category":"Flags","sheet_x":4,"sheet_y":56,"sort_order":261},"🇾🇹":{"category":"Flags","sheet_x":5,"sheet_y":0,"sort_order":262},"🇿🇦":{"category":"Flags","sheet_x":5,"sheet_y":1,"sort_order":263},"🇿🇲":{"category":"Flags","sheet_x":5,"sheet_y":2,"sort_order":264},"🇿🇼":{"category":"Flags","sheet_x":5,"sheet_y":3,"sort_order":265},"🈁":{"category":"Symbols","sheet_x":5,"sheet_y":4,"sort_order":167},"🈂️":{"category":"Symbols","sheet_x":5,"sheet_y":5,"sort_order":168},"🈚":{"category":"Symbols","sheet_x":5,"sheet_y":6,"sort_order":174},"🈯":{"category":"Symbols","sheet_x":5,"sheet_y":7,"sort_order":171},"🈲":{"category":"Symbols","sheet_x":5,"sheet_y":8,"sort_order":175},"🈳":{"category":"Symbols","sheet_x":5,"sheet_y":9,"sort_order":179},"🈴":{"category":"Symbols","sheet_x":5,"sheet_y":10,"sort_order":178},"🈵":{"category":"Symbols","sheet_x":5,"sheet_y":11,"sort_order":183},"🈶":{"category":"Symbols","sheet_x":5,"sheet_y":12,"sort_order":170},"🈷️":{"category":"Symbols","sheet_x":5,"sheet_y":13,"sort_order":169},"🈸":{"category":"Symbols","sheet_x":5,"sheet_y":14,"sort_order":177},"🈹":{"category":"Symbols","sheet_x":5,"sheet_y":15,"sort_order":173},"🈺":{"category":"Symbols","sheet_x":5,"sheet_y":16,"sort_order":182},"🉐":{"category":"Symbols","sheet_x":5,"sheet_y":17,"sort_order":172},"🉑":{"category":"Symbols","sheet_x":5,"sheet_y":18,"sort_order":176},"🌀":{"category":"Travel & Places","sheet_x":5,"sheet_y":19,"sort_order":197},"🌁":{"category":"Travel & Places","sheet_x":5,"sheet_y":20,"sort_order":49},"🌂":{"category":"Travel & Places","sheet_x":5,"sheet_y":21,"sort_order":199},"🌃":{"category":"Travel & Places","sheet_x":5,"sheet_y":22,"sort_order":50},"🌄":{"category":"Travel & Places","sheet_x":5,"sheet_y":23,"sort_order":52},"🌅":{"category":"Travel & Places","sheet_x":5,"sheet_y":24,"sort_order":53},"🌆":{"category":"Travel & Places","sheet_x":5,"sheet_y":25,"sort_order":54},"🌇":{"category":"Travel & Places","sheet_x":5,"sheet_y":26,"sort_order":55},"🌈":{"category":"Travel & Places","sheet_x":5,"sheet_y":27,"sort_order":198},"🌉":{"category":"Travel & Places","sheet_x":5,"sheet_y":28,"sort_order":56},"🌊":{"category":"Travel & Places","sheet_x":5,"sheet_y":29,"sort_order":210},"🌋":{"category":"Travel & Places","sheet_x":5,"sheet_y":30,"sort_order":10},"🌌":{"category":"Travel & Places","sheet_x":5,"sheet_y":31,"sort_order":184},"🌍":{"category":"Travel & Places","sheet_x":5,"sheet_y":32,"sort_order":1},"🌎":{"category":"Travel & Places","sheet_x":5,"sheet_y":33,"sort_order":2},"🌏":{"category":"Travel & Places","sheet_x":5,"sheet_y":34,"sort_order":3},"🌐":{"category":"Travel & Places","sheet_x":5,"sheet_y":35,"sort_order":4},"🌑":{"category":"Travel & Places","sheet_x":5,"sheet_y":36,"sort_order":164},"🌒":{"category":"Travel & Places","sheet_x":5,"sheet_y":37,"sort_order":165},"🌓":{"category":"Travel & Places","sheet_x":5,"sheet_y":38,"sort_order":166},"🌔":{"category":"Travel & Places","sheet_x":5,"sheet_y":39,"sort_order":167},"🌕":{"category":"Travel & Places","sheet_x":5,"sheet_y":40,"sort_order":168},"🌖":{"category":"Travel & Places","sheet_x":5,"sheet_y":41,"sort_order":169},"🌗":{"category":"Travel & Places","sheet_x":5,"sheet_y":42,"sort_order":170},"🌘":{"category":"Travel & Places","sheet_x":5,"sheet_y":43,"sort_order":171},"🌙":{"category":"Travel & Places","sheet_x":5,"sheet_y":44,"sort_order":172},"🌚":{"category":"Travel & Places","sheet_x":5,"sheet_y":45,"sort_order":173},"🌛":{"category":"Travel & Places","sheet_x":5,"sheet_y":46,"sort_order":174},"🌜":{"category":"Travel & Places","sheet_x":5,"sheet_y":47,"sort_order":175},"🌝":{"category":"Travel & Places","sheet_x":5,"sheet_y":48,"sort_order":178},"🌞":{"category":"Travel & Places","sheet_x":5,"sheet_y":49,"sort_order":179},"🌟":{"category":"Travel & Places","sheet_x":5,"sheet_y":50,"sort_order":182},"🌠":{"category":"Travel & Places","sheet_x":5,"sheet_y":51,"sort_order":183},"🌡️":{"category":"Travel & Places","sheet_x":5,"sheet_y":52,"sort_order":176},"🌤️":{"category":"Travel & Places","sheet_x":5,"sheet_y":53,"sort_order":188},"🌥️":{"category":"Travel & Places","sheet_x":5,"sheet_y":54,"sort_order":189},"🌦️":{"category":"Travel & Places","sheet_x":5,"sheet_y":55,"sort_order":190},"🌧️":{"category":"Travel & Places","sheet_x":5,"sheet_y":56,"sort_order":191},"🌨️":{"category":"Travel & Places","sheet_x":6,"sheet_y":0,"sort_order":192},"🌩️":{"category":"Travel & Places","sheet_x":6,"sheet_y":1,"sort_order":193},"🌪️":{"category":"Travel & Places","sheet_x":6,"sheet_y":2,"sort_order":194},"🌫️":{"category":"Travel & Places","sheet_x":6,"sheet_y":3,"sort_order":195},"🌬️":{"category":"Travel & Places","sheet_x":6,"sheet_y":4,"sort_order":196},"🌭":{"category":"Food & Drink","sheet_x":6,"sheet_y":5,"sort_order":47},"🌮":{"category":"Food & Drink","sheet_x":6,"sheet_y":6,"sort_order":49},"🌯":{"category":"Food & Drink","sheet_x":6,"sheet_y":7,"sort_order":50},"🌰":{"category":"Food & Drink","sheet_x":6,"sheet_y":8,"sort_order":31},"🌱":{"category":"Animals & Nature","sheet_x":6,"sheet_y":9,"sort_order":116},"🌲":{"category":"Animals & Nature","sheet_x":6,"sheet_y":10,"sort_order":117},"🌳":{"category":"Animals & Nature","sheet_x":6,"sheet_y":11,"sort_order":118},"🌴":{"category":"Animals & Nature","sheet_x":6,"sheet_y":12,"sort_order":119},"🌵":{"category":"Animals & Nature","sheet_x":6,"sheet_y":13,"sort_order":120},"🌶️":{"category":"Food & Drink","sheet_x":6,"sheet_y":14,"sort_order":23},"🌷":{"category":"Animals & Nature","sheet_x":6,"sheet_y":15,"sort_order":115},"🌸":{"category":"Animals & Nature","sheet_x":6,"sheet_y":16,"sort_order":107},"🌹":{"category":"Animals & Nature","sheet_x":6,"sheet_y":17,"sort_order":110},"🌺":{"category":"Animals & Nature","sheet_x":6,"sheet_y":18,"sort_order":112},"🌻":{"category":"Animals & Nature","sheet_x":6,"sheet_y":19,"sort_order":113},"🌼":{"category":"Animals & Nature","sheet_x":6,"sheet_y":20,"sort_order":114},"🌽":{"category":"Food & Drink","sheet_x":6,"sheet_y":21,"sort_order":22},"🌾":{"category":"Animals & Nature","sheet_x":6,"sheet_y":22,"sort_order":121},"🌿":{"category":"Animals & Nature","sheet_x":6,"sheet_y":23,"sort_order":122},"🍀":{"category":"Animals & Nature","sheet_x":6,"sheet_y":24,"sort_order":124},"🍁":{"category":"Animals & Nature","sheet_x":6,"sheet_y":25,"sort_order":125},"🍂":{"category":"Animals & Nature","sheet_x":6,"sheet_y":26,"sort_order":126},"🍃":{"category":"Animals & Nature","sheet_x":6,"sheet_y":27,"sort_order":127},"🍄":{"category":"Food & Drink","sheet_x":6,"sheet_y":28,"sort_order":29},"🍅":{"category":"Food & Drink","sheet_x":6,"sheet_y":29,"sort_order":16},"🍆":{"category":"Food & Drink","sheet_x":6,"sheet_y":30,"sort_order":19},"🍇":{"category":"Food & Drink","sheet_x":6,"sheet_y":31,"sort_order":1},"🍈":{"category":"Food & Drink","sheet_x":6,"sheet_y":32,"sort_order":2},"🍉":{"category":"Food & Drink","sheet_x":6,"sheet_y":33,"sort_order":3},"🍊":{"category":"Food & Drink","sheet_x":6,"sheet_y":34,"sort_order":4},"🍋":{"category":"Food & Drink","sheet_x":6,"sheet_y":35,"sort_order":5},"🍌":{"category":"Food & Drink","sheet_x":6,"sheet_y":36,"sort_order":6},"🍍":{"category":"Food & Drink","sheet_x":6,"sheet_y":37,"sort_order":7},"🍎":{"category":"Food & Drink","sheet_x":6,"sheet_y":38,"sort_order":9},"🍏":{"category":"Food & Drink","sheet_x":6,"sheet_y":39,"sort_order":10},"🍐":{"category":"Food & Drink","sheet_x":6,"sheet_y":40,"sort_order":11},"🍑":{"category":"Food & Drink","sheet_x":6,"sheet_y":41,"sort_order":12},"🍒":{"category":"Food & Drink","sheet_x":6,"sheet_y":42,"sort_order":13},"🍓":{"category":"Food & Drink","sheet_x":6,"sheet_y":43,"sort_order":14},"🍔":{"category":"Food & Drink","sheet_x":6,"sheet_y":44,"sort_order":44},"🍕":{"category":"Food & Drink","sheet_x":6,"sheet_y":45,"sort_order":46},"🍖":{"category":"Food & Drink","sheet_x":6,"sheet_y":46,"sort_order":40},"🍗":{"category":"Food & Drink","sheet_x":6,"sheet_y":47,"sort_order":41},"🍘":{"category":"Food & Drink","sheet_x":6,"sheet_y":48,"sort_order":64},"🍙":{"category":"Food & Drink","sheet_x":6,"sheet_y":49,"sort_order":65},"🍚":{"category":"Food & Drink","sheet_x":6,"sheet_y":50,"sort_order":66},"🍛":{"category":"Food & Drink","sheet_x":6,"sheet_y":51,"sort_order":67},"🍜":{"category":"Food & Drink","sheet_x":6,"sheet_y":52,"sort_order":68},"🍝":{"category":"Food & Drink","sheet_x":6,"sheet_y":53,"sort_order":69},"🍞":{"category":"Food & Drink","sheet_x":6,"sheet_y":54,"sort_order":32},"🍟":{"category":"Food & Drink","sheet_x":6,"sheet_y":55,"sort_order":45},"🍠":{"category":"Food & Drink","sheet_x":6,"sheet_y":56,"sort_order":70},"🍡":{"category":"Food & Drink","sheet_x":7,"sheet_y":0,"sort_order":76},"🍢":{"category":"Food & Drink","sheet_x":7,"sheet_y":1,"sort_order":71},"🍣":{"category":"Food & Drink","sheet_x":7,"sheet_y":2,"sort_order":72},"🍤":{"category":"Food & Drink","sheet_x":7,"sheet_y":3,"sort_order":73},"🍥":{"category":"Food & Drink","sheet_x":7,"sheet_y":4,"sort_order":74},"🍦":{"category":"Food & Drink","sheet_x":7,"sheet_y":5,"sort_order":85},"🍧":{"category":"Food & Drink","sheet_x":7,"sheet_y":6,"sort_order":86},"🍨":{"category":"Food & Drink","sheet_x":7,"sheet_y":7,"sort_order":87},"🍩":{"category":"Food & Drink","sheet_x":7,"sheet_y":8,"sort_order":88},"🍪":{"category":"Food & Drink","sheet_x":7,"sheet_y":9,"sort_order":89},"🍫":{"category":"Food & Drink","sheet_x":7,"sheet_y":10,"sort_order":94},"🍬":{"category":"Food & Drink","sheet_x":7,"sheet_y":11,"sort_order":95},"🍭":{"category":"Food & Drink","sheet_x":7,"sheet_y":12,"sort_order":96},"🍮":{"category":"Food & Drink","sheet_x":7,"sheet_y":13,"sort_order":97},"🍯":{"category":"Food & Drink","sheet_x":7,"sheet_y":14,"sort_order":98},"🍰":{"category":"Food & Drink","sheet_x":7,"sheet_y":15,"sort_order":91},"🍱":{"category":"Food & Drink","sheet_x":7,"sheet_y":16,"sort_order":63},"🍲":{"category":"Food & Drink","sheet_x":7,"sheet_y":17,"sort_order":56},"🍳":{"category":"Food & Drink","sheet_x":7,"sheet_y":18,"sort_order":54},"🍴":{"category":"Food & Drink","sheet_x":7,"sheet_y":19,"sort_order":118},"🍵":{"category":"Food & Drink","sheet_x":7,"sheet_y":20,"sort_order":102},"🍶":{"category":"Food & Drink","sheet_x":7,"sheet_y":21,"sort_order":103},"🍷":{"category":"Food & Drink","sheet_x":7,"sheet_y":22,"sort_order":105},"🍸":{"category":"Food & Drink","sheet_x":7,"sheet_y":23,"sort_order":106},"🍹":{"category":"Food & Drink","sheet_x":7,"sheet_y":24,"sort_order":107},"🍺":{"category":"Food & Drink","sheet_x":7,"sheet_y":25,"sort_order":108},"🍻":{"category":"Food & Drink","sheet_x":7,"sheet_y":26,"sort_order":109},"🍼":{"category":"Food & Drink","sheet_x":7,"sheet_y":27,"sort_order":99},"🍽️":{"category":"Food & Drink","sheet_x":7,"sheet_y":28,"sort_order":117},"🍾":{"category":"Food & Drink","sheet_x":7,"sheet_y":29,"sort_order":104},"🍿":{"category":"Food & Drink","sheet_x":7,"sheet_y":30,"sort_order":59},"🎀":{"category":"Activities","sheet_x":7,"sheet_y":31,"sort_order":17},"🎁":{"category":"Activities","sheet_x":7,"sheet_y":32,"sort_order":18},"🎂":{"category":"Food & Drink","sheet_x":7,"sheet_y":33,"sort_order":90},"🎃":{"category":"Activities","sheet_x":7,"sheet_y":34,"sort_order":1},"🎄":{"category":"Activities","sheet_x":7,"sheet_y":35,"sort_order":2},"🎅":{"category":"People & Body","sheet_x":7,"sheet_y":36,"sort_order":177},"🎆":{"category":"Activities","sheet_x":7,"sheet_y":42,"sort_order":3},"🎇":{"category":"Activities","sheet_x":7,"sheet_y":43,"sort_order":4},"🎈":{"category":"Activities","sheet_x":7,"sheet_y":44,"sort_order":7},"🎉":{"category":"Activities","sheet_x":7,"sheet_y":45,"sort_order":8},"🎊":{"category":"Activities","sheet_x":7,"sheet_y":46,"sort_order":9},"🎋":{"category":"Activities","sheet_x":7,"sheet_y":47,"sort_order":10},"🎌":{"category":"Flags","sheet_x":7,"sheet_y":48,"sort_order":3},"🎍":{"category":"Activities","sheet_x":7,"sheet_y":49,"sort_order":11},"🎎":{"category":"Activities","sheet_x":7,"sheet_y":50,"sort_order":12},"🎏":{"category":"Activities","sheet_x":7,"sheet_y":51,"sort_order":13},"🎐":{"category":"Activities","sheet_x":7,"sheet_y":52,"sort_order":14},"🎑":{"category":"Activities","sheet_x":7,"sheet_y":53,"sort_order":15},"🎒":{"category":"Objects","sheet_x":7,"sheet_y":54,"sort_order":25},"🎓":{"category":"Objects","sheet_x":7,"sheet_y":55,"sort_order":37},"🎖️":{"category":"Activities","sheet_x":7,"sheet_y":56,"sort_order":22},"🎗️":{"category":"Activities","sheet_x":8,"sheet_y":0,"sort_order":19},"🎙️":{"category":"Objects","sheet_x":8,"sheet_y":1,"sort_order":56},"🎚️":{"category":"Objects","sheet_x":8,"sheet_y":2,"sort_order":57},"🎛️":{"category":"Objects","sheet_x":8,"sheet_y":3,"sort_order":58},"🎞️":{"category":"Objects","sheet_x":8,"sheet_y":4,"sort_order":89},"🎟️":{"category":"Activities","sheet_x":8,"sheet_y":5,"sort_order":20},"🎠":{"category":"Travel & Places","sheet_x":8,"sheet_y":6,"sort_order":58},"🎡":{"category":"Travel & Places","sheet_x":8,"sheet_y":7,"sort_order":59},"🎢":{"category":"Travel & Places","sheet_x":8,"sheet_y":8,"sort_order":60},"🎣":{"category":"Activities","sheet_x":8,"sheet_y":9,"sort_order":49},"🎤":{"category":"Objects","sheet_x":8,"sheet_y":10,"sort_order":59},"🎥":{"category":"Objects","sheet_x":8,"sheet_y":11,"sort_order":88},"🎦":{"category":"Symbols","sheet_x":8,"sheet_y":12,"sort_order":91},"🎧":{"category":"Objects","sheet_x":8,"sheet_y":13,"sort_order":60},"🎨":{"category":"Activities","sheet_x":8,"sheet_y":14,"sort_order":77},"🎩":{"category":"Objects","sheet_x":8,"sheet_y":15,"sort_order":36},"🎪":{"category":"Travel & Places","sheet_x":8,"sheet_y":16,"sort_order":62},"🎫":{"category":"Activities","sheet_x":8,"sheet_y":17,"sort_order":21},"🎬":{"category":"Objects","sheet_x":8,"sheet_y":18,"sort_order":91},"🎭":{"category":"Activities","sheet_x":8,"sheet_y":19,"sort_order":75},"🎮":{"category":"Activities","sheet_x":8,"sheet_y":20,"sort_order":61},"🎯":{"category":"Activities","sheet_x":8,"sheet_y":21,"sort_order":55},"🎰":{"category":"Activities","sheet_x":8,"sheet_y":22,"sort_order":63},"🎱":{"category":"Activities","sheet_x":8,"sheet_y":23,"sort_order":58},"🎲":{"category":"Activities","sheet_x":8,"sheet_y":24,"sort_order":64},"🎳":{"category":"Activities","sheet_x":8,"sheet_y":25,"sort_order":37},"🎴":{"category":"Activities","sheet_x":8,"sheet_y":26,"sort_order":74},"🎵":{"category":"Objects","sheet_x":8,"sheet_y":27,"sort_order":54},"🎶":{"category":"Objects","sheet_x":8,"sheet_y":28,"sort_order":55},"🎷":{"category":"Objects","sheet_x":8,"sheet_y":29,"sort_order":62},"🎸":{"category":"Objects","sheet_x":8,"sheet_y":30,"sort_order":63},"🎹":{"category":"Objects","sheet_x":8,"sheet_y":31,"sort_order":64},"🎺":{"category":"Objects","sheet_x":8,"sheet_y":32,"sort_order":65},"🎻":{"category":"Objects","sheet_x":8,"sheet_y":33,"sort_order":66},"🎼":{"category":"Objects","sheet_x":8,"sheet_y":34,"sort_order":53},"🎽":{"category":"Activities","sheet_x":8,"sheet_y":35,"sort_order":51},"🎾":{"category":"Activities","sheet_x":8,"sheet_y":36,"sort_order":35},"🎿":{"category":"Activities","sheet_x":8,"sheet_y":37,"sort_order":52},"🏀":{"category":"Activities","sheet_x":8,"sheet_y":38,"sort_order":31},"🏁":{"category":"Flags","sheet_x":8,"sheet_y":39,"sort_order":1},"🏂":{"category":"People & Body","sheet_x":8,"sheet_y":40,"sort_order":248},"🏃‍♀️":{"category":"People & Body","sheet_x":8,"sheet_y":46,"sort_order":232},"🏃‍♂️":{"category":"People & Body","sheet_x":8,"sheet_y":52,"sort_order":231},"🏃":{"category":"People & Body","sheet_x":9,"sheet_y":1,"sort_order":230},"🏄‍♀️":{"category":"People & Body","sheet_x":9,"sheet_y":7,"sort_order":254},"🏄‍♂️":{"category":"People & Body","sheet_x":9,"sheet_y":13,"sort_order":253},"🏄":{"category":"People & Body","sheet_x":9,"sheet_y":19,"sort_order":252},"🏅":{"category":"Activities","sheet_x":9,"sheet_y":25,"sort_order":24},"🏆":{"category":"Activities","sheet_x":9,"sheet_y":26,"sort_order":23},"🏇":{"category":"People & Body","sheet_x":9,"sheet_y":27,"sort_order":246},"🏈":{"category":"Activities","sheet_x":9,"sheet_y":33,"sort_order":33},"🏉":{"category":"Activities","sheet_x":9,"sheet_y":34,"sort_order":34},"🏊‍♀️":{"category":"People & Body","sheet_x":9,"sheet_y":35,"sort_order":260},"🏊‍♂️":{"category":"People & Body","sheet_x":9,"sheet_y":41,"sort_order":259},"🏊":{"category":"People & Body","sheet_x":9,"sheet_y":47,"sort_order":258},"🏋️‍♀️":{"category":"People & Body","sheet_x":9,"sheet_y":53,"sort_order":266},"🏋️‍♂️":{"category":"People & Body","sheet_x":10,"sheet_y":2,"sort_order":265},"🏋️":{"category":"People & Body","sheet_x":10,"sheet_y":8,"sort_order":264},"🏌️‍♀️":{"category":"People & Body","sheet_x":10,"sheet_y":14,"sort_order":251},"🏌️‍♂️":{"category":"People & Body","sheet_x":10,"sheet_y":20,"sort_order":250},"🏌️":{"category":"People & Body","sheet_x":10,"sheet_y":26,"sort_order":249},"🏍️":{"category":"Travel & Places","sheet_x":10,"sheet_y":32,"sort_order":92},"🏎️":{"category":"Travel & Places","sheet_x":10,"sheet_y":33,"sort_order":91},"🏏":{"category":"Activities","sheet_x":10,"sheet_y":34,"sort_order":38},"🏐":{"category":"Activities","sheet_x":10,"sheet_y":35,"sort_order":32},"🏑":{"category":"Activities","sheet_x":10,"sheet_y":36,"sort_order":39},"🏒":{"category":"Activities","sheet_x":10,"sheet_y":37,"sort_order":40},"🏓":{"category":"Activities","sheet_x":10,"sheet_y":38,"sort_order":42},"🏔️":{"category":"Travel & Places","sheet_x":10,"sheet_y":39,"sort_order":8},"🏕️":{"category":"Travel & Places","sheet_x":10,"sheet_y":40,"sort_order":12},"🏖️":{"category":"Travel & Places","sheet_x":10,"sheet_y":41,"sort_order":13},"🏗️":{"category":"Travel & Places","sheet_x":10,"sheet_y":42,"sort_order":19},"🏘️":{"category":"Travel & Places","sheet_x":10,"sheet_y":43,"sort_order":21},"🏙️":{"category":"Travel & Places","sheet_x":10,"sheet_y":44,"sort_order":51},"🏚️":{"category":"Travel & Places","sheet_x":10,"sheet_y":45,"sort_order":22},"🏛️":{"category":"Travel & Places","sheet_x":10,"sheet_y":46,"sort_order":18},"🏜️":{"category":"Travel & Places","sheet_x":10,"sheet_y":47,"sort_order":14},"🏝️":{"category":"Travel & Places","sheet_x":10,"sheet_y":48,"sort_order":15},"🏞️":{"category":"Travel & Places","sheet_x":10,"sheet_y":49,"sort_order":16},"🏟️":{"category":"Travel & Places","sheet_x":10,"sheet_y":50,"sort_order":17},"🏠":{"category":"Travel & Places","sheet_x":10,"sheet_y":51,"sort_order":23},"🏡":{"category":"Travel & Places","sheet_x":10,"sheet_y":52,"sort_order":24},"🏢":{"category":"Travel & Places","sheet_x":10,"sheet_y":53,"sort_order":25},"🏣":{"category":"Travel & Places","sheet_x":10,"sheet_y":54,"sort_order":26},"🏤":{"category":"Travel & Places","sheet_x":10,"sheet_y":55,"sort_order":27},"🏥":{"category":"Travel & Places","sheet_x":10,"sheet_y":56,"sort_order":28},"🏦":{"category":"Travel & Places","sheet_x":11,"sheet_y":0,"sort_order":29},"🏧":{"category":"Symbols","sheet_x":11,"sheet_y":1,"sort_order":1},"🏨":{"category":"Travel & Places","sheet_x":11,"sheet_y":2,"sort_order":30},"🏩":{"category":"Travel & Places","sheet_x":11,"sheet_y":3,"sort_order":31},"🏪":{"category":"Travel & Places","sheet_x":11,"sheet_y":4,"sort_order":32},"🏫":{"category":"Travel & Places","sheet_x":11,"sheet_y":5,"sort_order":33},"🏬":{"category":"Travel & Places","sheet_x":11,"sheet_y":6,"sort_order":34},"🏭":{"category":"Travel & Places","sheet_x":11,"sheet_y":7,"sort_order":35},"🏮":{"category":"Objects","sheet_x":11,"sheet_y":8,"sort_order":102},"🏯":{"category":"Travel & Places","sheet_x":11,"sheet_y":9,"sort_order":36},"🏰":{"category":"Travel & Places","sheet_x":11,"sheet_y":10,"sort_order":37},"🏳️‍🌈":{"category":"Flags","sheet_x":11,"sheet_y":11,"sort_order":6},"🏳️":{"category":"Flags","sheet_x":11,"sheet_y":12,"sort_order":5},"🏴‍☠️":{"category":"Flags","sheet_x":11,"sheet_y":13,"sort_order":7},"🏴󠁧󠁢󠁥󠁮󠁧󠁿":{"category":"Flags","sheet_x":11,"sheet_y":14,"sort_order":266},"🏴󠁧󠁢󠁳󠁣󠁴󠁿":{"category":"Flags","sheet_x":11,"sheet_y":15,"sort_order":267},"🏴󠁧󠁢󠁷󠁬󠁳󠁿":{"category":"Flags","sheet_x":11,"sheet_y":16,"sort_order":268},"🏴":{"category":"Flags","sheet_x":11,"sheet_y":17,"sort_order":4},"🏵️":{"category":"Animals & Nature","sheet_x":11,"sheet_y":18,"sort_order":109},"🏷️":{"category":"Objects","sheet_x":11,"sheet_y":19,"sort_order":120},"🏸":{"category":"Activities","sheet_x":11,"sheet_y":20,"sort_order":43},"🏹":{"category":"Objects","sheet_x":11,"sheet_y":21,"sort_order":189},"🏺":{"category":"Food & Drink","sheet_x":11,"sheet_y":22,"sort_order":121},"🏻":{"category":"Skin Tones","sheet_x":11,"sheet_y":23,"sort_order":1},"🏼":{"category":"Skin Tones","sheet_x":11,"sheet_y":24,"sort_order":2},"🏽":{"category":"Skin Tones","sheet_x":11,"sheet_y":25,"sort_order":3},"🏾":{"category":"Skin Tones","sheet_x":11,"sheet_y":26,"sort_order":4},"🏿":{"category":"Skin Tones","sheet_x":11,"sheet_y":27,"sort_order":5},"🐀":{"category":"Animals & Nature","sheet_x":11,"sheet_y":28,"sort_order":44},"🐁":{"category":"Animals & Nature","sheet_x":11,"sheet_y":29,"sort_order":43},"🐂":{"category":"Animals & Nature","sheet_x":11,"sheet_y":30,"sort_order":25},"🐃":{"category":"Animals & Nature","sheet_x":11,"sheet_y":31,"sort_order":26},"🐄":{"category":"Animals & Nature","sheet_x":11,"sheet_y":32,"sort_order":27},"🐅":{"category":"Animals & Nature","sheet_x":11,"sheet_y":33,"sort_order":17},"🐆":{"category":"Animals & Nature","sheet_x":11,"sheet_y":34,"sort_order":18},"🐇":{"category":"Animals & Nature","sheet_x":11,"sheet_y":35,"sort_order":47},"🐈":{"category":"Animals & Nature","sheet_x":11,"sheet_y":36,"sort_order":14},"🐉":{"category":"Animals & Nature","sheet_x":11,"sheet_y":37,"sort_order":82},"🐊":{"category":"Animals & Nature","sheet_x":11,"sheet_y":38,"sort_order":77},"🐋":{"category":"Animals & Nature","sheet_x":11,"sheet_y":39,"sort_order":86},"🐌":{"category":"Animals & Nature","sheet_x":11,"sheet_y":40,"sort_order":94},"🐍":{"category":"Animals & Nature","sheet_x":11,"sheet_y":41,"sort_order":80},"🐎":{"category":"Animals & Nature","sheet_x":11,"sheet_y":42,"sort_order":20},"🐏":{"category":"Animals & Nature","sheet_x":11,"sheet_y":43,"sort_order":32},"🐐":{"category":"Animals & Nature","sheet_x":11,"sheet_y":44,"sort_order":34},"🐑":{"category":"Animals & Nature","sheet_x":11,"sheet_y":45,"sort_order":33},"🐒":{"category":"Animals & Nature","sheet_x":11,"sheet_y":46,"sort_order":2},"🐓":{"category":"Animals & Nature","sheet_x":11,"sheet_y":47,"sort_order":62},"🐔":{"category":"Animals & Nature","sheet_x":11,"sheet_y":48,"sort_order":61},"🐕‍🦺":{"category":"Animals & Nature","sheet_x":11,"sheet_y":49,"sort_order":8},"🐕":{"category":"Animals & Nature","sheet_x":11,"sheet_y":50,"sort_order":6},"🐖":{"category":"Animals & Nature","sheet_x":11,"sheet_y":51,"sort_order":29},"🐗":{"category":"Animals & Nature","sheet_x":11,"sheet_y":52,"sort_order":30},"🐘":{"category":"Animals & Nature","sheet_x":11,"sheet_y":53,"sort_order":39},"🐙":{"category":"Animals & Nature","sheet_x":11,"sheet_y":54,"sort_order":92},"🐚":{"category":"Animals & Nature","sheet_x":11,"sheet_y":55,"sort_order":93},"🐛":{"category":"Animals & Nature","sheet_x":11,"sheet_y":56,"sort_order":96},"🐜":{"category":"Animals & Nature","sheet_x":12,"sheet_y":0,"sort_order":97},"🐝":{"category":"Animals & Nature","sheet_x":12,"sheet_y":1,"sort_order":98},"🐞":{"category":"Animals & Nature","sheet_x":12,"sheet_y":2,"sort_order":99},"🐟":{"category":"Animals & Nature","sheet_x":12,"sheet_y":3,"sort_order":88},"🐠":{"category":"Animals & Nature","sheet_x":12,"sheet_y":4,"sort_order":89},"🐡":{"category":"Animals & Nature","sheet_x":12,"sheet_y":5,"sort_order":90},"🐢":{"category":"Animals & Nature","sheet_x":12,"sheet_y":6,"sort_order":78},"🐣":{"category":"Animals & Nature","sheet_x":12,"sheet_y":7,"sort_order":63},"🐤":{"category":"Animals & Nature","sheet_x":12,"sheet_y":8,"sort_order":64},"🐥":{"category":"Animals & Nature","sheet_x":12,"sheet_y":9,"sort_order":65},"🐦":{"category":"Animals & Nature","sheet_x":12,"sheet_y":10,"sort_order":66},"🐧":{"category":"Animals & Nature","sheet_x":12,"sheet_y":11,"sort_order":67},"🐨":{"category":"Animals & Nature","sheet_x":12,"sheet_y":12,"sort_order":52},"🐩":{"category":"Animals & Nature","sheet_x":12,"sheet_y":13,"sort_order":9},"🐪":{"category":"Animals & Nature","sheet_x":12,"sheet_y":14,"sort_order":35},"🐫":{"category":"Animals & Nature","sheet_x":12,"sheet_y":15,"sort_order":36},"🐬":{"category":"Animals & Nature","sheet_x":12,"sheet_y":16,"sort_order":87},"🐭":{"category":"Animals & Nature","sheet_x":12,"sheet_y":17,"sort_order":42},"🐮":{"category":"Animals & Nature","sheet_x":12,"sheet_y":18,"sort_order":24},"🐯":{"category":"Animals & Nature","sheet_x":12,"sheet_y":19,"sort_order":16},"🐰":{"category":"Animals & Nature","sheet_x":12,"sheet_y":20,"sort_order":46},"🐱":{"category":"Animals & Nature","sheet_x":12,"sheet_y":21,"sort_order":13},"🐲":{"category":"Animals & Nature","sheet_x":12,"sheet_y":22,"sort_order":81},"🐳":{"category":"Animals & Nature","sheet_x":12,"sheet_y":23,"sort_order":85},"🐴":{"category":"Animals & Nature","sheet_x":12,"sheet_y":24,"sort_order":19},"🐵":{"category":"Animals & Nature","sheet_x":12,"sheet_y":25,"sort_order":1},"🐶":{"category":"Animals & Nature","sheet_x":12,"sheet_y":26,"sort_order":5},"🐷":{"category":"Animals & Nature","sheet_x":12,"sheet_y":27,"sort_order":28},"🐸":{"category":"Animals & Nature","sheet_x":12,"sheet_y":28,"sort_order":76},"🐹":{"category":"Animals & Nature","sheet_x":12,"sheet_y":29,"sort_order":45},"🐺":{"category":"Animals & Nature","sheet_x":12,"sheet_y":30,"sort_order":10},"🐻":{"category":"Animals & Nature","sheet_x":12,"sheet_y":31,"sort_order":51},"🐼":{"category":"Animals & Nature","sheet_x":12,"sheet_y":32,"sort_order":53},"🐽":{"category":"Animals & Nature","sheet_x":12,"sheet_y":33,"sort_order":31},"🐾":{"category":"Animals & Nature","sheet_x":12,"sheet_y":34,"sort_order":59},"🐿️":{"category":"Animals & Nature","sheet_x":12,"sheet_y":35,"sort_order":48},"👀":{"category":"People & Body","sheet_x":12,"sheet_y":36,"sort_order":45},"👁️‍🗨️":{"category":"Smileys & Emotion","sheet_x":12,"sheet_y":37,"sort_order":145},"👁️":{"category":"People & Body","sheet_x":12,"sheet_y":38,"sort_order":46},"👂":{"category":"People & Body","sheet_x":12,"sheet_y":39,"sort_order":39},"👃":{"category":"People & Body","sheet_x":12,"sheet_y":45,"sort_order":41},"👄":{"category":"People & Body","sheet_x":12,"sheet_y":51,"sort_order":48},"👅":{"category":"People & Body","sheet_x":12,"sheet_y":52,"sort_order":47},"👆":{"category":"People & Body","sheet_x":12,"sheet_y":53,"sort_order":15},"👇":{"category":"People & Body","sheet_x":13,"sheet_y":2,"sort_order":17},"👈":{"category":"People & Body","sheet_x":13,"sheet_y":8,"sort_order":13},"👉":{"category":"People & Body","sheet_x":13,"sheet_y":14,"sort_order":14},"👊":{"category":"People & Body","sheet_x":13,"sheet_y":20,"sort_order":22},"👋":{"category":"People & Body","sheet_x":13,"sheet_y":26,"sort_order":1},"👌":{"category":"People & Body","sheet_x":13,"sheet_y":32,"sort_order":6},"👍":{"category":"People & Body","sheet_x":13,"sheet_y":38,"sort_order":19},"👎":{"category":"People & Body","sheet_x":13,"sheet_y":44,"sort_order":20},"👏":{"category":"People & Body","sheet_x":13,"sheet_y":50,"sort_order":25},"👐":{"category":"People & Body","sheet_x":13,"sheet_y":56,"sort_order":27},"👑":{"category":"Objects","sheet_x":14,"sheet_y":5,"sort_order":34},"👒":{"category":"Objects","sheet_x":14,"sheet_y":6,"sort_order":35},"👓":{"category":"Objects","sheet_x":14,"sheet_y":7,"sort_order":1},"👔":{"category":"Objects","sheet_x":14,"sheet_y":8,"sort_order":6},"👕":{"category":"Objects","sheet_x":14,"sheet_y":9,"sort_order":7},"👖":{"category":"Objects","sheet_x":14,"sheet_y":10,"sort_order":8},"👗":{"category":"Objects","sheet_x":14,"sheet_y":11,"sort_order":13},"👘":{"category":"Objects","sheet_x":14,"sheet_y":12,"sort_order":14},"👙":{"category":"Objects","sheet_x":14,"sheet_y":13,"sort_order":19},"👚":{"category":"Objects","sheet_x":14,"sheet_y":14,"sort_order":20},"👛":{"category":"Objects","sheet_x":14,"sheet_y":15,"sort_order":21},"👜":{"category":"Objects","sheet_x":14,"sheet_y":16,"sort_order":22},"👝":{"category":"Objects","sheet_x":14,"sheet_y":17,"sort_order":23},"👞":{"category":"Objects","sheet_x":14,"sheet_y":18,"sort_order":26},"👟":{"category":"Objects","sheet_x":14,"sheet_y":19,"sort_order":27},"👠":{"category":"Objects","sheet_x":14,"sheet_y":20,"sort_order":30},"👡":{"category":"Objects","sheet_x":14,"sheet_y":21,"sort_order":31},"👢":{"category":"Objects","sheet_x":14,"sheet_y":22,"sort_order":33},"👣":{"category":"People & Body","sheet_x":14,"sheet_y":23,"sort_order":334},"👤":{"category":"People & Body","sheet_x":14,"sheet_y":24,"sort_order":332},"👥":{"category":"People & Body","sheet_x":14,"sheet_y":25,"sort_order":333},"👦":{"category":"People & Body","sheet_x":14,"sheet_y":26,"sort_order":51},"👧":{"category":"People & Body","sheet_x":14,"sheet_y":32,"sort_order":52},"👨‍🌾":{"category":"People & Body","sheet_x":14,"sheet_y":38,"sort_order":118},"👨‍🍳":{"category":"People & Body","sheet_x":14,"sheet_y":44,"sort_order":121},"👨‍🎓":{"category":"People & Body","sheet_x":14,"sheet_y":50,"sort_order":109},"👨‍🎤":{"category":"People & Body","sheet_x":14,"sheet_y":56,"sort_order":139},"👨‍🎨":{"category":"People & Body","sheet_x":15,"sheet_y":5,"sort_order":142},"👨‍🏫":{"category":"People & Body","sheet_x":15,"sheet_y":11,"sort_order":112},"👨‍🏭":{"category":"People & Body","sheet_x":15,"sheet_y":17,"sort_order":127},"👨‍👦‍👦":{"category":"People & Body","sheet_x":15,"sheet_y":23,"sort_order":322},"👨‍👦":{"category":"People & Body","sheet_x":15,"sheet_y":24,"sort_order":321},"👨‍👧‍👦":{"category":"People & Body","sheet_x":15,"sheet_y":25,"sort_order":324},"👨‍👧‍👧":{"category":"People & Body","sheet_x":15,"sheet_y":26,"sort_order":325},"👨‍👧":{"category":"People & Body","sheet_x":15,"sheet_y":27,"sort_order":323},"👨‍👨‍👦":{"category":"People & Body","sheet_x":15,"sheet_y":28,"sort_order":311},"👨‍👨‍👦‍👦":{"category":"People & Body","sheet_x":15,"sheet_y":29,"sort_order":314},"👨‍👨‍👧":{"category":"People & Body","sheet_x":15,"sheet_y":30,"sort_order":312},"👨‍👨‍👧‍👦":{"category":"People & Body","sheet_x":15,"sheet_y":31,"sort_order":313},"👨‍👨‍👧‍👧":{"category":"People & Body","sheet_x":15,"sheet_y":32,"sort_order":315},"👨‍👩‍👦":{"category":"People & Body","sheet_x":15,"sheet_y":33,"sort_order":306},"👨‍👩‍👦‍👦":{"category":"People & Body","sheet_x":15,"sheet_y":34,"sort_order":309},"👨‍👩‍👧":{"category":"People & Body","sheet_x":15,"sheet_y":35,"sort_order":307},"👨‍👩‍👧‍👦":{"category":"People & Body","sheet_x":15,"sheet_y":36,"sort_order":308},"👨‍👩‍👧‍👧":{"category":"People & Body","sheet_x":15,"sheet_y":37,"sort_order":310},"👨‍💻":{"category":"People & Body","sheet_x":15,"sheet_y":38,"sort_order":136},"👨‍💼":{"category":"People & Body","sheet_x":15,"sheet_y":44,"sort_order":130},"👨‍🔧":{"category":"People & Body","sheet_x":15,"sheet_y":50,"sort_order":124},"👨‍🔬":{"category":"People & Body","sheet_x":15,"sheet_y":56,"sort_order":133},"👨‍🚀":{"category":"People & Body","sheet_x":16,"sheet_y":5,"sort_order":148},"👨‍🚒":{"category":"People & Body","sheet_x":16,"sheet_y":11,"sort_order":151},"👨‍🦯":{"category":"People & Body","sheet_x":16,"sheet_y":17,"sort_order":222},"👨‍🦰":{"category":"People & Body","sheet_x":16,"sheet_y":23,"sort_order":57},"👨‍🦱":{"category":"People & Body","sheet_x":16,"sheet_y":29,"sort_order":58},"👨‍🦲":{"category":"People & Body","sheet_x":16,"sheet_y":35,"sort_order":60},"👨‍🦳":{"category":"People & Body","sheet_x":16,"sheet_y":41,"sort_order":59},"👨‍🦼":{"category":"People & Body","sheet_x":16,"sheet_y":47,"sort_order":225},"👨‍🦽":{"category":"People & Body","sheet_x":16,"sheet_y":53,"sort_order":228},"👨‍⚕️":{"category":"People & Body","sheet_x":17,"sheet_y":2,"sort_order":106},"👨‍⚖️":{"category":"People & Body","sheet_x":17,"sheet_y":8,"sort_order":115},"👨‍✈️":{"category":"People & Body","sheet_x":17,"sheet_y":14,"sort_order":145},"👨‍❤️‍👨":{"category":"People & Body","sheet_x":17,"sheet_y":20,"sort_order":303},"👨‍❤️‍💋‍👨":{"category":"People & Body","sheet_x":17,"sheet_y":21,"sort_order":299},"👨":{"category":"People & Body","sheet_x":17,"sheet_y":22,"sort_order":55},"👩‍🌾":{"category":"People & Body","sheet_x":17,"sheet_y":28,"sort_order":119},"👩‍🍳":{"category":"People & Body","sheet_x":17,"sheet_y":34,"sort_order":122},"👩‍🎓":{"category":"People & Body","sheet_x":17,"sheet_y":40,"sort_order":110},"👩‍🎤":{"category":"People & Body","sheet_x":17,"sheet_y":46,"sort_order":140},"👩‍🎨":{"category":"People & Body","sheet_x":17,"sheet_y":52,"sort_order":143},"👩‍🏫":{"category":"People & Body","sheet_x":18,"sheet_y":1,"sort_order":113},"👩‍🏭":{"category":"People & Body","sheet_x":18,"sheet_y":7,"sort_order":128},"👩‍👦‍👦":{"category":"People & Body","sheet_x":18,"sheet_y":13,"sort_order":327},"👩‍👦":{"category":"People & Body","sheet_x":18,"sheet_y":14,"sort_order":326},"👩‍👧‍👦":{"category":"People & Body","sheet_x":18,"sheet_y":15,"sort_order":329},"👩‍👧‍👧":{"category":"People & Body","sheet_x":18,"sheet_y":16,"sort_order":330},"👩‍👧":{"category":"People & Body","sheet_x":18,"sheet_y":17,"sort_order":328},"👩‍👩‍👦":{"category":"People & Body","sheet_x":18,"sheet_y":18,"sort_order":316},"👩‍👩‍👦‍👦":{"category":"People & Body","sheet_x":18,"sheet_y":19,"sort_order":319},"👩‍👩‍👧":{"category":"People & Body","sheet_x":18,"sheet_y":20,"sort_order":317},"👩‍👩‍👧‍👦":{"category":"People & Body","sheet_x":18,"sheet_y":21,"sort_order":318},"👩‍👩‍👧‍👧":{"category":"People & Body","sheet_x":18,"sheet_y":22,"sort_order":320},"👩‍💻":{"category":"People & Body","sheet_x":18,"sheet_y":23,"sort_order":137},"👩‍💼":{"category":"People & Body","sheet_x":18,"sheet_y":29,"sort_order":131},"👩‍🔧":{"category":"People & Body","sheet_x":18,"sheet_y":35,"sort_order":125},"👩‍🔬":{"category":"People & Body","sheet_x":18,"sheet_y":41,"sort_order":134},"👩‍🚀":{"category":"People & Body","sheet_x":18,"sheet_y":47,"sort_order":149},"👩‍🚒":{"category":"People & Body","sheet_x":18,"sheet_y":53,"sort_order":152},"👩‍🦯":{"category":"People & Body","sheet_x":19,"sheet_y":2,"sort_order":223},"👩‍🦰":{"category":"People & Body","sheet_x":19,"sheet_y":8,"sort_order":62},"👩‍🦱":{"category":"People & Body","sheet_x":19,"sheet_y":14,"sort_order":64},"👩‍🦲":{"category":"People & Body","sheet_x":19,"sheet_y":20,"sort_order":68},"👩‍🦳":{"category":"People & Body","sheet_x":19,"sheet_y":26,"sort_order":66},"👩‍🦼":{"category":"People & Body","sheet_x":19,"sheet_y":32,"sort_order":226},"👩‍🦽":{"category":"People & Body","sheet_x":19,"sheet_y":38,"sort_order":229},"👩‍⚕️":{"category":"People & Body","sheet_x":19,"sheet_y":44,"sort_order":107},"👩‍⚖️":{"category":"People & Body","sheet_x":19,"sheet_y":50,"sort_order":116},"👩‍✈️":{"category":"People & Body","sheet_x":19,"sheet_y":56,"sort_order":146},"👩‍❤️‍👨":{"category":"People & Body","sheet_x":20,"sheet_y":5,"sort_order":302},"👩‍❤️‍👩":{"category":"People & Body","sheet_x":20,"sheet_y":6,"sort_order":304},"👩‍❤️‍💋‍👨":{"category":"People & Body","sheet_x":20,"sheet_y":7,"sort_order":298},"👩‍❤️‍💋‍👩":{"category":"People & Body","sheet_x":20,"sheet_y":8,"sort_order":300},"👩":{"category":"People & Body","sheet_x":20,"sheet_y":9,"sort_order":61},"👪":{"category":"People & Body","sheet_x":20,"sheet_y":15,"sort_order":305},"👫":{"category":"People & Body","sheet_x":20,"sheet_y":16,"sort_order":295},"👬":{"category":"People & Body","sheet_x":20,"sheet_y":42,"sort_order":296},"👭":{"category":"People & Body","sheet_x":21,"sheet_y":11,"sort_order":294},"👮‍♀️":{"category":"People & Body","sheet_x":21,"sheet_y":37,"sort_order":155},"👮‍♂️":{"category":"People & Body","sheet_x":21,"sheet_y":43,"sort_order":154},"👮":{"category":"People & Body","sheet_x":21,"sheet_y":49,"sort_order":153},"👯‍♀️":{"category":"People & Body","sheet_x":21,"sheet_y":55,"sort_order":238},"👯‍♂️":{"category":"People & Body","sheet_x":21,"sheet_y":56,"sort_order":237},"👯":{"category":"People & Body","sheet_x":22,"sheet_y":0,"sort_order":236},"👰":{"category":"People & Body","sheet_x":22,"sheet_y":1,"sort_order":173},"👱‍♀️":{"category":"People & Body","sheet_x":22,"sheet_y":7,"sort_order":70},"👱‍♂️":{"category":"People & Body","sheet_x":22,"sheet_y":13,"sort_order":71},"👱":{"category":"People & Body","sheet_x":22,"sheet_y":19,"sort_order":54},"👲":{"category":"People & Body","sheet_x":22,"sheet_y":25,"sort_order":170},"👳‍♀️":{"category":"People & Body","sheet_x":22,"sheet_y":31,"sort_order":169},"👳‍♂️":{"category":"People & Body","sheet_x":22,"sheet_y":37,"sort_order":168},"👳":{"category":"People & Body","sheet_x":22,"sheet_y":43,"sort_order":167},"👴":{"category":"People & Body","sheet_x":22,"sheet_y":49,"sort_order":73},"👵":{"category":"People & Body","sheet_x":22,"sheet_y":55,"sort_order":74},"👶":{"category":"People & Body","sheet_x":23,"sheet_y":4,"sort_order":49},"👷‍♀️":{"category":"People & Body","sheet_x":23,"sheet_y":10,"sort_order":164},"👷‍♂️":{"category":"People & Body","sheet_x":23,"sheet_y":16,"sort_order":163},"👷":{"category":"People & Body","sheet_x":23,"sheet_y":22,"sort_order":162},"👸":{"category":"People & Body","sheet_x":23,"sheet_y":28,"sort_order":166},"👹":{"category":"Smileys & Emotion","sheet_x":23,"sheet_y":34,"sort_order":97},"👺":{"category":"Smileys & Emotion","sheet_x":23,"sheet_y":35,"sort_order":98},"👻":{"category":"Smileys & Emotion","sheet_x":23,"sheet_y":36,"sort_order":99},"👼":{"category":"People & Body","sheet_x":23,"sheet_y":37,"sort_order":176},"👽":{"category":"Smileys & Emotion","sheet_x":23,"sheet_y":43,"sort_order":100},"👾":{"category":"Smileys & Emotion","sheet_x":23,"sheet_y":44,"sort_order":101},"👿":{"category":"Smileys & Emotion","sheet_x":23,"sheet_y":45,"sort_order":92},"💀":{"category":"Smileys & Emotion","sheet_x":23,"sheet_y":46,"sort_order":93},"💁‍♀️":{"category":"People & Body","sheet_x":23,"sheet_y":47,"sort_order":89},"💁‍♂️":{"category":"People & Body","sheet_x":23,"sheet_y":53,"sort_order":88},"💁":{"category":"People & Body","sheet_x":24,"sheet_y":2,"sort_order":87},"💂‍♀️":{"category":"People & Body","sheet_x":24,"sheet_y":8,"sort_order":161},"💂‍♂️":{"category":"People & Body","sheet_x":24,"sheet_y":14,"sort_order":160},"💂":{"category":"People & Body","sheet_x":24,"sheet_y":20,"sort_order":159},"💃":{"category":"People & Body","sheet_x":24,"sheet_y":26,"sort_order":233},"💄":{"category":"Objects","sheet_x":24,"sheet_y":32,"sort_order":41},"💅":{"category":"People & Body","sheet_x":24,"sheet_y":33,"sort_order":32},"💆‍♀️":{"category":"People & Body","sheet_x":24,"sheet_y":39,"sort_order":208},"💆‍♂️":{"category":"People & Body","sheet_x":24,"sheet_y":45,"sort_order":207},"💆":{"category":"People & Body","sheet_x":24,"sheet_y":51,"sort_order":206},"💇‍♀️":{"category":"People & Body","sheet_x":25,"sheet_y":0,"sort_order":211},"💇‍♂️":{"category":"People & Body","sheet_x":25,"sheet_y":6,"sort_order":210},"💇":{"category":"People & Body","sheet_x":25,"sheet_y":12,"sort_order":209},"💈":{"category":"Travel & Places","sheet_x":25,"sheet_y":18,"sort_order":61},"💉":{"category":"Objects","sheet_x":25,"sheet_y":19,"sort_order":208},"💊":{"category":"Objects","sheet_x":25,"sheet_y":20,"sort_order":210},"💋":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":21,"sort_order":115},"💌":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":22,"sort_order":116},"💍":{"category":"Objects","sheet_x":25,"sheet_y":23,"sort_order":42},"💎":{"category":"Objects","sheet_x":25,"sheet_y":24,"sort_order":43},"💏":{"category":"People & Body","sheet_x":25,"sheet_y":25,"sort_order":297},"💐":{"category":"Animals & Nature","sheet_x":25,"sheet_y":26,"sort_order":106},"💑":{"category":"People & Body","sheet_x":25,"sheet_y":27,"sort_order":301},"💒":{"category":"Travel & Places","sheet_x":25,"sheet_y":28,"sort_order":38},"💓":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":29,"sort_order":121},"💔":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":30,"sort_order":126},"💕":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":31,"sort_order":123},"💖":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":32,"sort_order":119},"💗":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":33,"sort_order":120},"💘":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":34,"sort_order":117},"💙":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":35,"sort_order":131},"💚":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":36,"sort_order":130},"💛":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":37,"sort_order":129},"💜":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":38,"sort_order":132},"💝":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":39,"sort_order":118},"💞":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":40,"sort_order":122},"💟":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":41,"sort_order":124},"💠":{"category":"Symbols","sheet_x":25,"sheet_y":42,"sort_order":214},"💡":{"category":"Objects","sheet_x":25,"sheet_y":43,"sort_order":100},"💢":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":44,"sort_order":137},"💣":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":45,"sort_order":143},"💤":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":46,"sort_order":149},"💥":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":47,"sort_order":138},"💦":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":48,"sort_order":140},"💧":{"category":"Travel & Places","sheet_x":25,"sheet_y":49,"sort_order":209},"💨":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":50,"sort_order":141},"💩":{"category":"Smileys & Emotion","sheet_x":25,"sheet_y":51,"sort_order":95},"💪":{"category":"People & Body","sheet_x":25,"sheet_y":52,"sort_order":34},"💫":{"category":"Smileys & Emotion","sheet_x":26,"sheet_y":1,"sort_order":139},"💬":{"category":"Smileys & Emotion","sheet_x":26,"sheet_y":2,"sort_order":144},"💭":{"category":"Smileys & Emotion","sheet_x":26,"sheet_y":3,"sort_order":148},"💮":{"category":"Animals & Nature","sheet_x":26,"sheet_y":4,"sort_order":108},"💯":{"category":"Smileys & Emotion","sheet_x":26,"sheet_y":5,"sort_order":136},"💰":{"category":"Objects","sheet_x":26,"sheet_y":6,"sort_order":121},"💱":{"category":"Objects","sheet_x":26,"sheet_y":7,"sort_order":130},"💲":{"category":"Objects","sheet_x":26,"sheet_y":8,"sort_order":131},"💳":{"category":"Objects","sheet_x":26,"sheet_y":9,"sort_order":127},"💴":{"category":"Objects","sheet_x":26,"sheet_y":10,"sort_order":122},"💵":{"category":"Objects","sheet_x":26,"sheet_y":11,"sort_order":123},"💶":{"category":"Objects","sheet_x":26,"sheet_y":12,"sort_order":124},"💷":{"category":"Objects","sheet_x":26,"sheet_y":13,"sort_order":125},"💸":{"category":"Objects","sheet_x":26,"sheet_y":14,"sort_order":126},"💹":{"category":"Objects","sheet_x":26,"sheet_y":15,"sort_order":129},"💺":{"category":"Travel & Places","sheet_x":26,"sheet_y":16,"sort_order":123},"💻":{"category":"Objects","sheet_x":26,"sheet_y":17,"sort_order":77},"💼":{"category":"Objects","sheet_x":26,"sheet_y":18,"sort_order":152},"💽":{"category":"Objects","sheet_x":26,"sheet_y":19,"sort_order":83},"💾":{"category":"Objects","sheet_x":26,"sheet_y":20,"sort_order":84},"💿":{"category":"Objects","sheet_x":26,"sheet_y":21,"sort_order":85},"📀":{"category":"Objects","sheet_x":26,"sheet_y":22,"sort_order":86},"📁":{"category":"Objects","sheet_x":26,"sheet_y":23,"sort_order":153},"📂":{"category":"Objects","sheet_x":26,"sheet_y":24,"sort_order":154},"📃":{"category":"Objects","sheet_x":26,"sheet_y":25,"sort_order":113},"📄":{"category":"Objects","sheet_x":26,"sheet_y":26,"sort_order":115},"📅":{"category":"Objects","sheet_x":26,"sheet_y":27,"sort_order":156},"📆":{"category":"Objects","sheet_x":26,"sheet_y":28,"sort_order":157},"📇":{"category":"Objects","sheet_x":26,"sheet_y":29,"sort_order":160},"📈":{"category":"Objects","sheet_x":26,"sheet_y":30,"sort_order":161},"📉":{"category":"Objects","sheet_x":26,"sheet_y":31,"sort_order":162},"📊":{"category":"Objects","sheet_x":26,"sheet_y":32,"sort_order":163},"📋":{"category":"Objects","sheet_x":26,"sheet_y":33,"sort_order":164},"📌":{"category":"Objects","sheet_x":26,"sheet_y":34,"sort_order":165},"📍":{"category":"Objects","sheet_x":26,"sheet_y":35,"sort_order":166},"📎":{"category":"Objects","sheet_x":26,"sheet_y":36,"sort_order":167},"📏":{"category":"Objects","sheet_x":26,"sheet_y":37,"sort_order":169},"📐":{"category":"Objects","sheet_x":26,"sheet_y":38,"sort_order":170},"📑":{"category":"Objects","sheet_x":26,"sheet_y":39,"sort_order":118},"📒":{"category":"Objects","sheet_x":26,"sheet_y":40,"sort_order":112},"📓":{"category":"Objects","sheet_x":26,"sheet_y":41,"sort_order":111},"📔":{"category":"Objects","sheet_x":26,"sheet_y":42,"sort_order":104},"📕":{"category":"Objects","sheet_x":26,"sheet_y":43,"sort_order":105},"📖":{"category":"Objects","sheet_x":26,"sheet_y":44,"sort_order":106},"📗":{"category":"Objects","sheet_x":26,"sheet_y":45,"sort_order":107},"📘":{"category":"Objects","sheet_x":26,"sheet_y":46,"sort_order":108},"📙":{"category":"Objects","sheet_x":26,"sheet_y":47,"sort_order":109},"📚":{"category":"Objects","sheet_x":26,"sheet_y":48,"sort_order":110},"📛":{"category":"Symbols","sheet_x":26,"sheet_y":49,"sort_order":104},"📜":{"category":"Objects","sheet_x":26,"sheet_y":50,"sort_order":114},"📝":{"category":"Objects","sheet_x":26,"sheet_y":51,"sort_order":151},"📞":{"category":"Objects","sheet_x":26,"sheet_y":52,"sort_order":72},"📟":{"category":"Objects","sheet_x":26,"sheet_y":53,"sort_order":73},"📠":{"category":"Objects","sheet_x":26,"sheet_y":54,"sort_order":74},"📡":{"category":"Objects","sheet_x":26,"sheet_y":55,"sort_order":207},"📢":{"category":"Objects","sheet_x":26,"sheet_y":56,"sort_order":48},"📣":{"category":"Objects","sheet_x":27,"sheet_y":0,"sort_order":49},"📤":{"category":"Objects","sheet_x":27,"sheet_y":1,"sort_order":136},"📥":{"category":"Objects","sheet_x":27,"sheet_y":2,"sort_order":137},"📦":{"category":"Objects","sheet_x":27,"sheet_y":3,"sort_order":138},"📧":{"category":"Objects","sheet_x":27,"sheet_y":4,"sort_order":133},"📨":{"category":"Objects","sheet_x":27,"sheet_y":5,"sort_order":134},"📩":{"category":"Objects","sheet_x":27,"sheet_y":6,"sort_order":135},"📪":{"category":"Objects","sheet_x":27,"sheet_y":7,"sort_order":140},"📫":{"category":"Objects","sheet_x":27,"sheet_y":8,"sort_order":139},"📬":{"category":"Objects","sheet_x":27,"sheet_y":9,"sort_order":141},"📭":{"category":"Objects","sheet_x":27,"sheet_y":10,"sort_order":142},"📮":{"category":"Objects","sheet_x":27,"sheet_y":11,"sort_order":143},"📯":{"category":"Objects","sheet_x":27,"sheet_y":12,"sort_order":50},"📰":{"category":"Objects","sheet_x":27,"sheet_y":13,"sort_order":116},"📱":{"category":"Objects","sheet_x":27,"sheet_y":14,"sort_order":69},"📲":{"category":"Objects","sheet_x":27,"sheet_y":15,"sort_order":70},"📳":{"category":"Symbols","sheet_x":27,"sheet_y":16,"sort_order":95},"📴":{"category":"Symbols","sheet_x":27,"sheet_y":17,"sort_order":96},"📵":{"category":"Symbols","sheet_x":27,"sheet_y":18,"sort_order":23},"📶":{"category":"Symbols","sheet_x":27,"sheet_y":19,"sort_order":94},"📷":{"category":"Objects","sheet_x":27,"sheet_y":20,"sort_order":93},"📸":{"category":"Objects","sheet_x":27,"sheet_y":21,"sort_order":94},"📹":{"category":"Objects","sheet_x":27,"sheet_y":22,"sort_order":95},"📺":{"category":"Objects","sheet_x":27,"sheet_y":23,"sort_order":92},"📻":{"category":"Objects","sheet_x":27,"sheet_y":24,"sort_order":61},"📼":{"category":"Objects","sheet_x":27,"sheet_y":25,"sort_order":96},"📽️":{"category":"Objects","sheet_x":27,"sheet_y":26,"sort_order":90},"📿":{"category":"Objects","sheet_x":27,"sheet_y":27,"sort_order":40},"🔀":{"category":"Symbols","sheet_x":27,"sheet_y":28,"sort_order":73},"🔁":{"category":"Symbols","sheet_x":27,"sheet_y":29,"sort_order":74},"🔂":{"category":"Symbols","sheet_x":27,"sheet_y":30,"sort_order":75},"🔃":{"category":"Symbols","sheet_x":27,"sheet_y":31,"sort_order":41},"🔄":{"category":"Symbols","sheet_x":27,"sheet_y":32,"sort_order":42},"🔅":{"category":"Symbols","sheet_x":27,"sheet_y":33,"sort_order":92},"🔆":{"category":"Symbols","sheet_x":27,"sheet_y":34,"sort_order":93},"🔇":{"category":"Objects","sheet_x":27,"sheet_y":35,"sort_order":44},"🔈":{"category":"Objects","sheet_x":27,"sheet_y":36,"sort_order":45},"🔉":{"category":"Objects","sheet_x":27,"sheet_y":37,"sort_order":46},"🔊":{"category":"Objects","sheet_x":27,"sheet_y":38,"sort_order":47},"🔋":{"category":"Objects","sheet_x":27,"sheet_y":39,"sort_order":75},"🔌":{"category":"Objects","sheet_x":27,"sheet_y":40,"sort_order":76},"🔍":{"category":"Objects","sheet_x":27,"sheet_y":41,"sort_order":97},"🔎":{"category":"Objects","sheet_x":27,"sheet_y":42,"sort_order":98},"🔏":{"category":"Objects","sheet_x":27,"sheet_y":43,"sort_order":177},"🔐":{"category":"Objects","sheet_x":27,"sheet_y":44,"sort_order":178},"🔑":{"category":"Objects","sheet_x":27,"sheet_y":45,"sort_order":179},"🔒":{"category":"Objects","sheet_x":27,"sheet_y":46,"sort_order":175},"🔓":{"category":"Objects","sheet_x":27,"sheet_y":47,"sort_order":176},"🔔":{"category":"Objects","sheet_x":27,"sheet_y":48,"sort_order":51},"🔕":{"category":"Objects","sheet_x":27,"sheet_y":49,"sort_order":52},"🔖":{"category":"Objects","sheet_x":27,"sheet_y":50,"sort_order":119},"🔗":{"category":"Objects","sheet_x":27,"sheet_y":51,"sort_order":197},"🔘":{"category":"Symbols","sheet_x":27,"sheet_y":52,"sort_order":215},"🔙":{"category":"Symbols","sheet_x":27,"sheet_y":53,"sort_order":43},"🔚":{"category":"Symbols","sheet_x":27,"sheet_y":54,"sort_order":44},"🔛":{"category":"Symbols","sheet_x":27,"sheet_y":55,"sort_order":45},"🔜":{"category":"Symbols","sheet_x":27,"sheet_y":56,"sort_order":46},"🔝":{"category":"Symbols","sheet_x":28,"sheet_y":0,"sort_order":47},"🔞":{"category":"Symbols","sheet_x":28,"sheet_y":1,"sort_order":24},"🔟":{"category":"Symbols","sheet_x":28,"sheet_y":2,"sort_order":144},"🔠":{"category":"Symbols","sheet_x":28,"sheet_y":3,"sort_order":145},"🔡":{"category":"Symbols","sheet_x":28,"sheet_y":4,"sort_order":146},"🔢":{"category":"Symbols","sheet_x":28,"sheet_y":5,"sort_order":147},"🔣":{"category":"Symbols","sheet_x":28,"sheet_y":6,"sort_order":148},"🔤":{"category":"Symbols","sheet_x":28,"sheet_y":7,"sort_order":149},"🔥":{"category":"Travel & Places","sheet_x":28,"sheet_y":8,"sort_order":208},"🔦":{"category":"Objects","sheet_x":28,"sheet_y":9,"sort_order":101},"🔧":{"category":"Objects","sheet_x":28,"sheet_y":10,"sort_order":191},"🔨":{"category":"Objects","sheet_x":28,"sheet_y":11,"sort_order":181},"🔩":{"category":"Objects","sheet_x":28,"sheet_y":12,"sort_order":192},"🔪":{"category":"Food & Drink","sheet_x":28,"sheet_y":13,"sort_order":120},"🔫":{"category":"Objects","sheet_x":28,"sheet_y":14,"sort_order":188},"🔬":{"category":"Objects","sheet_x":28,"sheet_y":15,"sort_order":205},"🔭":{"category":"Objects","sheet_x":28,"sheet_y":16,"sort_order":206},"🔮":{"category":"Activities","sheet_x":28,"sheet_y":17,"sort_order":59},"🔯":{"category":"Symbols","sheet_x":28,"sheet_y":18,"sort_order":59},"🔰":{"category":"Symbols","sheet_x":28,"sheet_y":19,"sort_order":105},"🔱":{"category":"Symbols","sheet_x":28,"sheet_y":20,"sort_order":103},"🔲":{"category":"Symbols","sheet_x":28,"sheet_y":21,"sort_order":217},"🔳":{"category":"Symbols","sheet_x":28,"sheet_y":22,"sort_order":216},"🔴":{"category":"Symbols","sheet_x":28,"sheet_y":23,"sort_order":184},"🔵":{"category":"Symbols","sheet_x":28,"sheet_y":24,"sort_order":188},"🔶":{"category":"Symbols","sheet_x":28,"sheet_y":25,"sort_order":208},"🔷":{"category":"Symbols","sheet_x":28,"sheet_y":26,"sort_order":209},"🔸":{"category":"Symbols","sheet_x":28,"sheet_y":27,"sort_order":210},"🔹":{"category":"Symbols","sheet_x":28,"sheet_y":28,"sort_order":211},"🔺":{"category":"Symbols","sheet_x":28,"sheet_y":29,"sort_order":212},"🔻":{"category":"Symbols","sheet_x":28,"sheet_y":30,"sort_order":213},"🔼":{"category":"Symbols","sheet_x":28,"sheet_y":31,"sort_order":83},"🔽":{"category":"Symbols","sheet_x":28,"sheet_y":32,"sort_order":85},"🕉️":{"category":"Symbols","sheet_x":28,"sheet_y":33,"sort_order":50},"🕊️":{"category":"Animals & Nature","sheet_x":28,"sheet_y":34,"sort_order":68},"🕋":{"category":"Travel & Places","sheet_x":28,"sheet_y":35,"sort_order":46},"🕌":{"category":"Travel & Places","sheet_x":28,"sheet_y":36,"sort_order":42},"🕍":{"category":"Travel & Places","sheet_x":28,"sheet_y":37,"sort_order":44},"🕎":{"category":"Symbols","sheet_x":28,"sheet_y":38,"sort_order":58},"🕐":{"category":"Travel & Places","sheet_x":28,"sheet_y":39,"sort_order":142},"🕑":{"category":"Travel & Places","sheet_x":28,"sheet_y":40,"sort_order":144},"🕒":{"category":"Travel & Places","sheet_x":28,"sheet_y":41,"sort_order":146},"🕓":{"category":"Travel & Places","sheet_x":28,"sheet_y":42,"sort_order":148},"🕔":{"category":"Travel & Places","sheet_x":28,"sheet_y":43,"sort_order":150},"🕕":{"category":"Travel & Places","sheet_x":28,"sheet_y":44,"sort_order":152},"🕖":{"category":"Travel & Places","sheet_x":28,"sheet_y":45,"sort_order":154},"🕗":{"category":"Travel & Places","sheet_x":28,"sheet_y":46,"sort_order":156},"🕘":{"category":"Travel & Places","sheet_x":28,"sheet_y":47,"sort_order":158},"🕙":{"category":"Travel & Places","sheet_x":28,"sheet_y":48,"sort_order":160},"🕚":{"category":"Travel & Places","sheet_x":28,"sheet_y":49,"sort_order":162},"🕛":{"category":"Travel & Places","sheet_x":28,"sheet_y":50,"sort_order":140},"🕜":{"category":"Travel & Places","sheet_x":28,"sheet_y":51,"sort_order":143},"🕝":{"category":"Travel & Places","sheet_x":28,"sheet_y":52,"sort_order":145},"🕞":{"category":"Travel & Places","sheet_x":28,"sheet_y":53,"sort_order":147},"🕟":{"category":"Travel & Places","sheet_x":28,"sheet_y":54,"sort_order":149},"🕠":{"category":"Travel & Places","sheet_x":28,"sheet_y":55,"sort_order":151},"🕡":{"category":"Travel & Places","sheet_x":28,"sheet_y":56,"sort_order":153},"🕢":{"category":"Travel & Places","sheet_x":29,"sheet_y":0,"sort_order":155},"🕣":{"category":"Travel & Places","sheet_x":29,"sheet_y":1,"sort_order":157},"🕤":{"category":"Travel & Places","sheet_x":29,"sheet_y":2,"sort_order":159},"🕥":{"category":"Travel & Places","sheet_x":29,"sheet_y":3,"sort_order":161},"🕦":{"category":"Travel & Places","sheet_x":29,"sheet_y":4,"sort_order":163},"🕧":{"category":"Travel & Places","sheet_x":29,"sheet_y":5,"sort_order":141},"🕯️":{"category":"Objects","sheet_x":29,"sheet_y":6,"sort_order":99},"🕰️":{"category":"Travel & Places","sheet_x":29,"sheet_y":7,"sort_order":139},"🕳️":{"category":"Smileys & Emotion","sheet_x":29,"sheet_y":8,"sort_order":142},"🕴️":{"category":"People & Body","sheet_x":29,"sheet_y":9,"sort_order":235},"🕵️‍♀️":{"category":"People & Body","sheet_x":29,"sheet_y":15,"sort_order":158},"🕵️‍♂️":{"category":"People & Body","sheet_x":29,"sheet_y":21,"sort_order":157},"🕵️":{"category":"People & Body","sheet_x":29,"sheet_y":27,"sort_order":156},"🕶️":{"category":"Objects","sheet_x":29,"sheet_y":33,"sort_order":2},"🕷️":{"category":"Animals & Nature","sheet_x":29,"sheet_y":34,"sort_order":101},"🕸️":{"category":"Animals & Nature","sheet_x":29,"sheet_y":35,"sort_order":102},"🕹️":{"category":"Activities","sheet_x":29,"sheet_y":36,"sort_order":62},"🕺":{"category":"People & Body","sheet_x":29,"sheet_y":37,"sort_order":234},"🖇️":{"category":"Objects","sheet_x":29,"sheet_y":43,"sort_order":168},"🖊️":{"category":"Objects","sheet_x":29,"sheet_y":44,"sort_order":148},"🖋️":{"category":"Objects","sheet_x":29,"sheet_y":45,"sort_order":147},"🖌️":{"category":"Objects","sheet_x":29,"sheet_y":46,"sort_order":149},"🖍️":{"category":"Objects","sheet_x":29,"sheet_y":47,"sort_order":150},"🖐️":{"category":"People & Body","sheet_x":29,"sheet_y":48,"sort_order":3},"🖕":{"category":"People & Body","sheet_x":29,"sheet_y":54,"sort_order":16},"🖖":{"category":"People & Body","sheet_x":30,"sheet_y":3,"sort_order":5},"🖤":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":9,"sort_order":134},"🖥️":{"category":"Objects","sheet_x":30,"sheet_y":10,"sort_order":78},"🖨️":{"category":"Objects","sheet_x":30,"sheet_y":11,"sort_order":79},"🖱️":{"category":"Objects","sheet_x":30,"sheet_y":12,"sort_order":81},"🖲️":{"category":"Objects","sheet_x":30,"sheet_y":13,"sort_order":82},"🖼️":{"category":"Activities","sheet_x":30,"sheet_y":14,"sort_order":76},"🗂️":{"category":"Objects","sheet_x":30,"sheet_y":15,"sort_order":155},"🗃️":{"category":"Objects","sheet_x":30,"sheet_y":16,"sort_order":172},"🗄️":{"category":"Objects","sheet_x":30,"sheet_y":17,"sort_order":173},"🗑️":{"category":"Objects","sheet_x":30,"sheet_y":18,"sort_order":174},"🗒️":{"category":"Objects","sheet_x":30,"sheet_y":19,"sort_order":158},"🗓️":{"category":"Objects","sheet_x":30,"sheet_y":20,"sort_order":159},"🗜️":{"category":"Objects","sheet_x":30,"sheet_y":21,"sort_order":194},"🗝️":{"category":"Objects","sheet_x":30,"sheet_y":22,"sort_order":180},"🗞️":{"category":"Objects","sheet_x":30,"sheet_y":23,"sort_order":117},"🗡️":{"category":"Objects","sheet_x":30,"sheet_y":24,"sort_order":186},"🗣️":{"category":"People & Body","sheet_x":30,"sheet_y":25,"sort_order":331},"🗨️":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":26,"sort_order":146},"🗯️":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":27,"sort_order":147},"🗳️":{"category":"Objects","sheet_x":30,"sheet_y":28,"sort_order":144},"🗺️":{"category":"Travel & Places","sheet_x":30,"sheet_y":29,"sort_order":5},"🗻":{"category":"Travel & Places","sheet_x":30,"sheet_y":30,"sort_order":11},"🗼":{"category":"Travel & Places","sheet_x":30,"sheet_y":31,"sort_order":39},"🗽":{"category":"Travel & Places","sheet_x":30,"sheet_y":32,"sort_order":40},"🗾":{"category":"Travel & Places","sheet_x":30,"sheet_y":33,"sort_order":6},"🗿":{"category":"Objects","sheet_x":30,"sheet_y":34,"sort_order":233},"😀":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":35,"sort_order":1},"😁":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":36,"sort_order":4},"😂":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":37,"sort_order":8},"😃":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":38,"sort_order":2},"😄":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":39,"sort_order":3},"😅":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":40,"sort_order":6},"😆":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":41,"sort_order":5},"😇":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":42,"sort_order":13},"😈":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":43,"sort_order":91},"😉":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":44,"sort_order":11},"😊":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":45,"sort_order":12},"😋":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":46,"sort_order":22},"😌":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":47,"sort_order":42},"😍":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":48,"sort_order":15},"😎":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":49,"sort_order":60},"😏":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":50,"sort_order":37},"😐":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":51,"sort_order":34},"😑":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":52,"sort_order":35},"😒":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":53,"sort_order":38},"😓":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":54,"sort_order":83},"😔":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":55,"sort_order":43},"😕":{"category":"Smileys & Emotion","sheet_x":30,"sheet_y":56,"sort_order":63},"😖":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":0,"sort_order":80},"😗":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":1,"sort_order":18},"😘":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":2,"sort_order":17},"😙":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":3,"sort_order":21},"😚":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":4,"sort_order":20},"😛":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":5,"sort_order":23},"😜":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":6,"sort_order":24},"😝":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":7,"sort_order":26},"😞":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":8,"sort_order":82},"😟":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":9,"sort_order":64},"😠":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":10,"sort_order":89},"😡":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":11,"sort_order":88},"😢":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":12,"sort_order":77},"😣":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":13,"sort_order":81},"😤":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":14,"sort_order":87},"😥":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":15,"sort_order":76},"😦":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":16,"sort_order":72},"😧":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":17,"sort_order":73},"😨":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":18,"sort_order":74},"😩":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":19,"sort_order":84},"😪":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":20,"sort_order":44},"😫":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":21,"sort_order":85},"😬":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":22,"sort_order":40},"😭":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":23,"sort_order":78},"😮":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":24,"sort_order":67},"😯":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":25,"sort_order":68},"😰":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":26,"sort_order":75},"😱":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":27,"sort_order":79},"😲":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":28,"sort_order":69},"😳":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":29,"sort_order":70},"😴":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":30,"sort_order":46},"😵":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":31,"sort_order":56},"😶":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":32,"sort_order":36},"😷":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":33,"sort_order":47},"😸":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":34,"sort_order":104},"😹":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":35,"sort_order":105},"😺":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":36,"sort_order":103},"😻":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":37,"sort_order":106},"😼":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":38,"sort_order":107},"😽":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":39,"sort_order":108},"😾":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":40,"sort_order":111},"😿":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":41,"sort_order":110},"🙀":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":42,"sort_order":109},"🙁":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":43,"sort_order":65},"🙂":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":44,"sort_order":9},"🙃":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":45,"sort_order":10},"🙄":{"category":"Smileys & Emotion","sheet_x":31,"sheet_y":46,"sort_order":39},"🙅‍♀️":{"category":"People & Body","sheet_x":31,"sheet_y":47,"sort_order":83},"🙅‍♂️":{"category":"People & Body","sheet_x":31,"sheet_y":53,"sort_order":82},"🙅":{"category":"People & Body","sheet_x":32,"sheet_y":2,"sort_order":81},"🙆‍♀️":{"category":"People & Body","sheet_x":32,"sheet_y":8,"sort_order":86},"🙆‍♂️":{"category":"People & Body","sheet_x":32,"sheet_y":14,"sort_order":85},"🙆":{"category":"People & Body","sheet_x":32,"sheet_y":20,"sort_order":84},"🙇‍♀️":{"category":"People & Body","sheet_x":32,"sheet_y":26,"sort_order":98},"🙇‍♂️":{"category":"People & Body","sheet_x":32,"sheet_y":32,"sort_order":97},"🙇":{"category":"People & Body","sheet_x":32,"sheet_y":38,"sort_order":96},"🙈":{"category":"Smileys & Emotion","sheet_x":32,"sheet_y":44,"sort_order":112},"🙉":{"category":"Smileys & Emotion","sheet_x":32,"sheet_y":45,"sort_order":113},"🙊":{"category":"Smileys & Emotion","sheet_x":32,"sheet_y":46,"sort_order":114},"🙋‍♀️":{"category":"People & Body","sheet_x":32,"sheet_y":47,"sort_order":92},"🙋‍♂️":{"category":"People & Body","sheet_x":32,"sheet_y":53,"sort_order":91},"🙋":{"category":"People & Body","sheet_x":33,"sheet_y":2,"sort_order":90},"🙌":{"category":"People & Body","sheet_x":33,"sheet_y":8,"sort_order":26},"🙍‍♀️":{"category":"People & Body","sheet_x":33,"sheet_y":14,"sort_order":77},"🙍‍♂️":{"category":"People & Body","sheet_x":33,"sheet_y":20,"sort_order":76},"🙍":{"category":"People & Body","sheet_x":33,"sheet_y":26,"sort_order":75},"🙎‍♀️":{"category":"People & Body","sheet_x":33,"sheet_y":32,"sort_order":80},"🙎‍♂️":{"category":"People & Body","sheet_x":33,"sheet_y":38,"sort_order":79},"🙎":{"category":"People & Body","sheet_x":33,"sheet_y":44,"sort_order":78},"🙏":{"category":"People & Body","sheet_x":33,"sheet_y":50,"sort_order":30},"🚀":{"category":"Travel & Places","sheet_x":33,"sheet_y":56,"sort_order":129},"🚁":{"category":"Travel & Places","sheet_x":34,"sheet_y":0,"sort_order":124},"🚂":{"category":"Travel & Places","sheet_x":34,"sheet_y":1,"sort_order":63},"🚃":{"category":"Travel & Places","sheet_x":34,"sheet_y":2,"sort_order":64},"🚄":{"category":"Travel & Places","sheet_x":34,"sheet_y":3,"sort_order":65},"🚅":{"category":"Travel & Places","sheet_x":34,"sheet_y":4,"sort_order":66},"🚆":{"category":"Travel & Places","sheet_x":34,"sheet_y":5,"sort_order":67},"🚇":{"category":"Travel & Places","sheet_x":34,"sheet_y":6,"sort_order":68},"🚈":{"category":"Travel & Places","sheet_x":34,"sheet_y":7,"sort_order":69},"🚉":{"category":"Travel & Places","sheet_x":34,"sheet_y":8,"sort_order":70},"🚊":{"category":"Travel & Places","sheet_x":34,"sheet_y":9,"sort_order":71},"🚋":{"category":"Travel & Places","sheet_x":34,"sheet_y":10,"sort_order":74},"🚌":{"category":"Travel & Places","sheet_x":34,"sheet_y":11,"sort_order":75},"🚍":{"category":"Travel & Places","sheet_x":34,"sheet_y":12,"sort_order":76},"🚎":{"category":"Travel & Places","sheet_x":34,"sheet_y":13,"sort_order":77},"🚏":{"category":"Travel & Places","sheet_x":34,"sheet_y":14,"sort_order":100},"🚐":{"category":"Travel & Places","sheet_x":34,"sheet_y":15,"sort_order":78},"🚑":{"category":"Travel & Places","sheet_x":34,"sheet_y":16,"sort_order":79},"🚒":{"category":"Travel & Places","sheet_x":34,"sheet_y":17,"sort_order":80},"🚓":{"category":"Travel & Places","sheet_x":34,"sheet_y":18,"sort_order":81},"🚔":{"category":"Travel & Places","sheet_x":34,"sheet_y":19,"sort_order":82},"🚕":{"category":"Travel & Places","sheet_x":34,"sheet_y":20,"sort_order":83},"🚖":{"category":"Travel & Places","sheet_x":34,"sheet_y":21,"sort_order":84},"🚗":{"category":"Travel & Places","sheet_x":34,"sheet_y":22,"sort_order":85},"🚘":{"category":"Travel & Places","sheet_x":34,"sheet_y":23,"sort_order":86},"🚙":{"category":"Travel & Places","sheet_x":34,"sheet_y":24,"sort_order":87},"🚚":{"category":"Travel & Places","sheet_x":34,"sheet_y":25,"sort_order":88},"🚛":{"category":"Travel & Places","sheet_x":34,"sheet_y":26,"sort_order":89},"🚜":{"category":"Travel & Places","sheet_x":34,"sheet_y":27,"sort_order":90},"🚝":{"category":"Travel & Places","sheet_x":34,"sheet_y":28,"sort_order":72},"🚞":{"category":"Travel & Places","sheet_x":34,"sheet_y":29,"sort_order":73},"🚟":{"category":"Travel & Places","sheet_x":34,"sheet_y":30,"sort_order":125},"🚠":{"category":"Travel & Places","sheet_x":34,"sheet_y":31,"sort_order":126},"🚡":{"category":"Travel & Places","sheet_x":34,"sheet_y":32,"sort_order":127},"🚢":{"category":"Travel & Places","sheet_x":34,"sheet_y":33,"sort_order":117},"🚣‍♀️":{"category":"People & Body","sheet_x":34,"sheet_y":34,"sort_order":257},"🚣‍♂️":{"category":"People & Body","sheet_x":34,"sheet_y":40,"sort_order":256},"🚣":{"category":"People & Body","sheet_x":34,"sheet_y":46,"sort_order":255},"🚤":{"category":"Travel & Places","sheet_x":34,"sheet_y":52,"sort_order":113},"🚥":{"category":"Travel & Places","sheet_x":34,"sheet_y":53,"sort_order":106},"🚦":{"category":"Travel & Places","sheet_x":34,"sheet_y":54,"sort_order":107},"🚧":{"category":"Travel & Places","sheet_x":34,"sheet_y":55,"sort_order":109},"🚨":{"category":"Travel & Places","sheet_x":34,"sheet_y":56,"sort_order":105},"🚩":{"category":"Flags","sheet_x":35,"sheet_y":0,"sort_order":2},"🚪":{"category":"Objects","sheet_x":35,"sheet_y":1,"sort_order":213},"🚫":{"category":"Symbols","sheet_x":35,"sheet_y":2,"sort_order":17},"🚬":{"category":"Objects","sheet_x":35,"sheet_y":3,"sort_order":230},"🚭":{"category":"Symbols","sheet_x":35,"sheet_y":4,"sort_order":19},"🚮":{"category":"Symbols","sheet_x":35,"sheet_y":5,"sort_order":2},"🚯":{"category":"Symbols","sheet_x":35,"sheet_y":6,"sort_order":20},"🚰":{"category":"Symbols","sheet_x":35,"sheet_y":7,"sort_order":3},"🚱":{"category":"Symbols","sheet_x":35,"sheet_y":8,"sort_order":21},"🚲":{"category":"Travel & Places","sheet_x":35,"sheet_y":9,"sort_order":97},"🚳":{"category":"Symbols","sheet_x":35,"sheet_y":10,"sort_order":18},"🚴‍♀️":{"category":"People & Body","sheet_x":35,"sheet_y":11,"sort_order":269},"🚴‍♂️":{"category":"People & Body","sheet_x":35,"sheet_y":17,"sort_order":268},"🚴":{"category":"People & Body","sheet_x":35,"sheet_y":23,"sort_order":267},"🚵‍♀️":{"category":"People & Body","sheet_x":35,"sheet_y":29,"sort_order":272},"🚵‍♂️":{"category":"People & Body","sheet_x":35,"sheet_y":35,"sort_order":271},"🚵":{"category":"People & Body","sheet_x":35,"sheet_y":41,"sort_order":270},"🚶‍♀️":{"category":"People & Body","sheet_x":35,"sheet_y":47,"sort_order":214},"🚶‍♂️":{"category":"People & Body","sheet_x":35,"sheet_y":53,"sort_order":213},"🚶":{"category":"People & Body","sheet_x":36,"sheet_y":2,"sort_order":212},"🚷":{"category":"Symbols","sheet_x":36,"sheet_y":8,"sort_order":22},"🚸":{"category":"Symbols","sheet_x":36,"sheet_y":9,"sort_order":15},"🚹":{"category":"Symbols","sheet_x":36,"sheet_y":10,"sort_order":5},"🚺":{"category":"Symbols","sheet_x":36,"sheet_y":11,"sort_order":6},"🚻":{"category":"Symbols","sheet_x":36,"sheet_y":12,"sort_order":7},"🚼":{"category":"Symbols","sheet_x":36,"sheet_y":13,"sort_order":8},"🚽":{"category":"Objects","sheet_x":36,"sheet_y":14,"sort_order":217},"🚾":{"category":"Symbols","sheet_x":36,"sheet_y":15,"sort_order":9},"🚿":{"category":"Objects","sheet_x":36,"sheet_y":16,"sort_order":218},"🛀":{"category":"People & Body","sheet_x":36,"sheet_y":17,"sort_order":291},"🛁":{"category":"Objects","sheet_x":36,"sheet_y":23,"sort_order":219},"🛂":{"category":"Symbols","sheet_x":36,"sheet_y":24,"sort_order":10},"🛃":{"category":"Symbols","sheet_x":36,"sheet_y":25,"sort_order":11},"🛄":{"category":"Symbols","sheet_x":36,"sheet_y":26,"sort_order":12},"🛅":{"category":"Symbols","sheet_x":36,"sheet_y":27,"sort_order":13},"🛋️":{"category":"Objects","sheet_x":36,"sheet_y":28,"sort_order":215},"🛌":{"category":"People & Body","sheet_x":36,"sheet_y":29,"sort_order":292},"🛍️":{"category":"Objects","sheet_x":36,"sheet_y":35,"sort_order":24},"🛎️":{"category":"Travel & Places","sheet_x":36,"sheet_y":36,"sort_order":131},"🛏️":{"category":"Objects","sheet_x":36,"sheet_y":37,"sort_order":214},"🛐":{"category":"Symbols","sheet_x":36,"sheet_y":38,"sort_order":48},"🛑":{"category":"Travel & Places","sheet_x":36,"sheet_y":39,"sort_order":108},"🛒":{"category":"Objects","sheet_x":36,"sheet_y":40,"sort_order":229},"🛕":{"category":"Travel & Places","sheet_x":36,"sheet_y":41,"sort_order":43},"🛠️":{"category":"Objects","sheet_x":36,"sheet_y":42,"sort_order":185},"🛡️":{"category":"Objects","sheet_x":36,"sheet_y":43,"sort_order":190},"🛢️":{"category":"Travel & Places","sheet_x":36,"sheet_y":44,"sort_order":103},"🛣️":{"category":"Travel & Places","sheet_x":36,"sheet_y":45,"sort_order":101},"🛤️":{"category":"Travel & Places","sheet_x":36,"sheet_y":46,"sort_order":102},"🛥️":{"category":"Travel & Places","sheet_x":36,"sheet_y":47,"sort_order":116},"🛩️":{"category":"Travel & Places","sheet_x":36,"sheet_y":48,"sort_order":119},"🛫":{"category":"Travel & Places","sheet_x":36,"sheet_y":49,"sort_order":120},"🛬":{"category":"Travel & Places","sheet_x":36,"sheet_y":50,"sort_order":121},"🛰️":{"category":"Travel & Places","sheet_x":36,"sheet_y":51,"sort_order":128},"🛳️":{"category":"Travel & Places","sheet_x":36,"sheet_y":52,"sort_order":114},"🛴":{"category":"Travel & Places","sheet_x":36,"sheet_y":53,"sort_order":98},"🛵":{"category":"Travel & Places","sheet_x":36,"sheet_y":54,"sort_order":93},"🛶":{"category":"Travel & Places","sheet_x":36,"sheet_y":55,"sort_order":112},"🛷":{"category":"Activities","sheet_x":36,"sheet_y":56,"sort_order":53},"🛸":{"category":"Travel & Places","sheet_x":37,"sheet_y":0,"sort_order":130},"🛹":{"category":"Travel & Places","sheet_x":37,"sheet_y":1,"sort_order":99},"🛺":{"category":"Travel & Places","sheet_x":37,"sheet_y":2,"sort_order":96},"🟠":{"category":"Symbols","sheet_x":37,"sheet_y":3,"sort_order":185},"🟡":{"category":"Symbols","sheet_x":37,"sheet_y":4,"sort_order":186},"🟢":{"category":"Symbols","sheet_x":37,"sheet_y":5,"sort_order":187},"🟣":{"category":"Symbols","sheet_x":37,"sheet_y":6,"sort_order":189},"🟤":{"category":"Symbols","sheet_x":37,"sheet_y":7,"sort_order":190},"🟥":{"category":"Symbols","sheet_x":37,"sheet_y":8,"sort_order":193},"🟦":{"category":"Symbols","sheet_x":37,"sheet_y":9,"sort_order":197},"🟧":{"category":"Symbols","sheet_x":37,"sheet_y":10,"sort_order":194},"🟨":{"category":"Symbols","sheet_x":37,"sheet_y":11,"sort_order":195},"🟩":{"category":"Symbols","sheet_x":37,"sheet_y":12,"sort_order":196},"🟪":{"category":"Symbols","sheet_x":37,"sheet_y":13,"sort_order":198},"🟫":{"category":"Symbols","sheet_x":37,"sheet_y":14,"sort_order":199},"🤍":{"category":"Smileys & Emotion","sheet_x":37,"sheet_y":15,"sort_order":135},"🤎":{"category":"Smileys & Emotion","sheet_x":37,"sheet_y":16,"sort_order":133},"🤏":{"category":"People & Body","sheet_x":37,"sheet_y":17,"sort_order":7},"🤐":{"category":"Smileys & Emotion","sheet_x":37,"sheet_y":23,"sort_order":32},"🤑":{"category":"Smileys & Emotion","sheet_x":37,"sheet_y":24,"sort_order":27},"🤒":{"category":"Smileys & Emotion","sheet_x":37,"sheet_y":25,"sort_order":48},"🤓":{"category":"Smileys & Emotion","sheet_x":37,"sheet_y":26,"sort_order":61},"🤔":{"category":"Smileys & Emotion","sheet_x":37,"sheet_y":27,"sort_order":31},"🤕":{"category":"Smileys & Emotion","sheet_x":37,"sheet_y":28,"sort_order":49},"🤖":{"category":"Smileys & Emotion","sheet_x":37,"sheet_y":29,"sort_order":102},"🤗":{"category":"Smileys & Emotion","sheet_x":37,"sheet_y":30,"sort_order":28},"🤘":{"category":"People & Body","sheet_x":37,"sheet_y":31,"sort_order":11},"🤙":{"category":"People & Body","sheet_x":37,"sheet_y":37,"sort_order":12},"🤚":{"category":"People & Body","sheet_x":37,"sheet_y":43,"sort_order":2},"🤛":{"category":"People & Body","sheet_x":37,"sheet_y":49,"sort_order":23},"🤜":{"category":"People & Body","sheet_x":37,"sheet_y":55,"sort_order":24},"🤝":{"category":"People & Body","sheet_x":38,"sheet_y":4,"sort_order":29},"🤞":{"category":"People & Body","sheet_x":38,"sheet_y":5,"sort_order":9},"🤟":{"category":"People & Body","sheet_x":38,"sheet_y":11,"sort_order":10},"🤠":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":17,"sort_order":58},"🤡":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":18,"sort_order":96},"🤢":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":19,"sort_order":50},"🤣":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":20,"sort_order":7},"🤤":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":21,"sort_order":45},"🤥":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":22,"sort_order":41},"🤦‍♀️":{"category":"People & Body","sheet_x":38,"sheet_y":23,"sort_order":101},"🤦‍♂️":{"category":"People & Body","sheet_x":38,"sheet_y":29,"sort_order":100},"🤦":{"category":"People & Body","sheet_x":38,"sheet_y":35,"sort_order":99},"🤧":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":41,"sort_order":52},"🤨":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":42,"sort_order":33},"🤩":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":43,"sort_order":16},"🤪":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":44,"sort_order":25},"🤫":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":45,"sort_order":30},"🤬":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":46,"sort_order":90},"🤭":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":47,"sort_order":29},"🤮":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":48,"sort_order":51},"🤯":{"category":"Smileys & Emotion","sheet_x":38,"sheet_y":49,"sort_order":57},"🤰":{"category":"People & Body","sheet_x":38,"sheet_y":50,"sort_order":174},"🤱":{"category":"People & Body","sheet_x":38,"sheet_y":56,"sort_order":175},"🤲":{"category":"People & Body","sheet_x":39,"sheet_y":5,"sort_order":28},"🤳":{"category":"People & Body","sheet_x":39,"sheet_y":11,"sort_order":33},"🤴":{"category":"People & Body","sheet_x":39,"sheet_y":17,"sort_order":165},"🤵":{"category":"People & Body","sheet_x":39,"sheet_y":23,"sort_order":172},"🤶":{"category":"People & Body","sheet_x":39,"sheet_y":29,"sort_order":178},"🤷‍♀️":{"category":"People & Body","sheet_x":39,"sheet_y":35,"sort_order":104},"🤷‍♂️":{"category":"People & Body","sheet_x":39,"sheet_y":41,"sort_order":103},"🤷":{"category":"People & Body","sheet_x":39,"sheet_y":47,"sort_order":102},"🤸‍♀️":{"category":"People & Body","sheet_x":39,"sheet_y":53,"sort_order":275},"🤸‍♂️":{"category":"People & Body","sheet_x":40,"sheet_y":2,"sort_order":274},"🤸":{"category":"People & Body","sheet_x":40,"sheet_y":8,"sort_order":273},"🤹‍♀️":{"category":"People & Body","sheet_x":40,"sheet_y":14,"sort_order":287},"🤹‍♂️":{"category":"People & Body","sheet_x":40,"sheet_y":20,"sort_order":286},"🤹":{"category":"People & Body","sheet_x":40,"sheet_y":26,"sort_order":285},"🤺":{"category":"People & Body","sheet_x":40,"sheet_y":32,"sort_order":245},"🤼‍♀️":{"category":"People & Body","sheet_x":40,"sheet_y":33,"sort_order":278},"🤼‍♂️":{"category":"People & Body","sheet_x":40,"sheet_y":34,"sort_order":277},"🤼":{"category":"People & Body","sheet_x":40,"sheet_y":35,"sort_order":276},"🤽‍♀️":{"category":"People & Body","sheet_x":40,"sheet_y":36,"sort_order":281},"🤽‍♂️":{"category":"People & Body","sheet_x":40,"sheet_y":42,"sort_order":280},"🤽":{"category":"People & Body","sheet_x":40,"sheet_y":48,"sort_order":279},"🤾‍♀️":{"category":"People & Body","sheet_x":40,"sheet_y":54,"sort_order":284},"🤾‍♂️":{"category":"People & Body","sheet_x":41,"sheet_y":3,"sort_order":283},"🤾":{"category":"People & Body","sheet_x":41,"sheet_y":9,"sort_order":282},"🤿":{"category":"Activities","sheet_x":41,"sheet_y":15,"sort_order":50},"🥀":{"category":"Animals & Nature","sheet_x":41,"sheet_y":16,"sort_order":111},"🥁":{"category":"Objects","sheet_x":41,"sheet_y":17,"sort_order":68},"🥂":{"category":"Food & Drink","sheet_x":41,"sheet_y":18,"sort_order":110},"🥃":{"category":"Food & Drink","sheet_x":41,"sheet_y":19,"sort_order":111},"🥄":{"category":"Food & Drink","sheet_x":41,"sheet_y":20,"sort_order":119},"🥅":{"category":"Activities","sheet_x":41,"sheet_y":21,"sort_order":46},"🥇":{"category":"Activities","sheet_x":41,"sheet_y":22,"sort_order":25},"🥈":{"category":"Activities","sheet_x":41,"sheet_y":23,"sort_order":26},"🥉":{"category":"Activities","sheet_x":41,"sheet_y":24,"sort_order":27},"🥊":{"category":"Activities","sheet_x":41,"sheet_y":25,"sort_order":44},"🥋":{"category":"Activities","sheet_x":41,"sheet_y":26,"sort_order":45},"🥌":{"category":"Activities","sheet_x":41,"sheet_y":27,"sort_order":54},"🥍":{"category":"Activities","sheet_x":41,"sheet_y":28,"sort_order":41},"🥎":{"category":"Activities","sheet_x":41,"sheet_y":29,"sort_order":30},"🥏":{"category":"Activities","sheet_x":41,"sheet_y":30,"sort_order":36},"🥐":{"category":"Food & Drink","sheet_x":41,"sheet_y":31,"sort_order":33},"🥑":{"category":"Food & Drink","sheet_x":41,"sheet_y":32,"sort_order":18},"🥒":{"category":"Food & Drink","sheet_x":41,"sheet_y":33,"sort_order":24},"🥓":{"category":"Food & Drink","sheet_x":41,"sheet_y":34,"sort_order":43},"🥔":{"category":"Food & Drink","sheet_x":41,"sheet_y":35,"sort_order":20},"🥕":{"category":"Food & Drink","sheet_x":41,"sheet_y":36,"sort_order":21},"🥖":{"category":"Food & Drink","sheet_x":41,"sheet_y":37,"sort_order":34},"🥗":{"category":"Food & Drink","sheet_x":41,"sheet_y":38,"sort_order":58},"🥘":{"category":"Food & Drink","sheet_x":41,"sheet_y":39,"sort_order":55},"🥙":{"category":"Food & Drink","sheet_x":41,"sheet_y":40,"sort_order":51},"🥚":{"category":"Food & Drink","sheet_x":41,"sheet_y":41,"sort_order":53},"🥛":{"category":"Food & Drink","sheet_x":41,"sheet_y":42,"sort_order":100},"🥜":{"category":"Food & Drink","sheet_x":41,"sheet_y":43,"sort_order":30},"🥝":{"category":"Food & Drink","sheet_x":41,"sheet_y":44,"sort_order":15},"🥞":{"category":"Food & Drink","sheet_x":41,"sheet_y":45,"sort_order":37},"🥟":{"category":"Food & Drink","sheet_x":41,"sheet_y":46,"sort_order":77},"🥠":{"category":"Food & Drink","sheet_x":41,"sheet_y":47,"sort_order":78},"🥡":{"category":"Food & Drink","sheet_x":41,"sheet_y":48,"sort_order":79},"🥢":{"category":"Food & Drink","sheet_x":41,"sheet_y":49,"sort_order":116},"🥣":{"category":"Food & Drink","sheet_x":41,"sheet_y":50,"sort_order":57},"🥤":{"category":"Food & Drink","sheet_x":41,"sheet_y":51,"sort_order":112},"🥥":{"category":"Food & Drink","sheet_x":41,"sheet_y":52,"sort_order":17},"🥦":{"category":"Food & Drink","sheet_x":41,"sheet_y":53,"sort_order":26},"🥧":{"category":"Food & Drink","sheet_x":41,"sheet_y":54,"sort_order":93},"🥨":{"category":"Food & Drink","sheet_x":41,"sheet_y":55,"sort_order":35},"🥩":{"category":"Food & Drink","sheet_x":41,"sheet_y":56,"sort_order":42},"🥪":{"category":"Food & Drink","sheet_x":42,"sheet_y":0,"sort_order":48},"🥫":{"category":"Food & Drink","sheet_x":42,"sheet_y":1,"sort_order":62},"🥬":{"category":"Food & Drink","sheet_x":42,"sheet_y":2,"sort_order":25},"🥭":{"category":"Food & Drink","sheet_x":42,"sheet_y":3,"sort_order":8},"🥮":{"category":"Food & Drink","sheet_x":42,"sheet_y":4,"sort_order":75},"🥯":{"category":"Food & Drink","sheet_x":42,"sheet_y":5,"sort_order":36},"🥰":{"category":"Smileys & Emotion","sheet_x":42,"sheet_y":6,"sort_order":14},"🥱":{"category":"Smileys & Emotion","sheet_x":42,"sheet_y":7,"sort_order":86},"🥳":{"category":"Smileys & Emotion","sheet_x":42,"sheet_y":8,"sort_order":59},"🥴":{"category":"Smileys & Emotion","sheet_x":42,"sheet_y":9,"sort_order":55},"🥵":{"category":"Smileys & Emotion","sheet_x":42,"sheet_y":10,"sort_order":53},"🥶":{"category":"Smileys & Emotion","sheet_x":42,"sheet_y":11,"sort_order":54},"🥺":{"category":"Smileys & Emotion","sheet_x":42,"sheet_y":12,"sort_order":71},"🥻":{"category":"Objects","sheet_x":42,"sheet_y":13,"sort_order":15},"🥼":{"category":"Objects","sheet_x":42,"sheet_y":14,"sort_order":4},"🥽":{"category":"Objects","sheet_x":42,"sheet_y":15,"sort_order":3},"🥾":{"category":"Objects","sheet_x":42,"sheet_y":16,"sort_order":28},"🥿":{"category":"Objects","sheet_x":42,"sheet_y":17,"sort_order":29},"🦀":{"category":"Food & Drink","sheet_x":42,"sheet_y":18,"sort_order":80},"🦁":{"category":"Animals & Nature","sheet_x":42,"sheet_y":19,"sort_order":15},"🦂":{"category":"Animals & Nature","sheet_x":42,"sheet_y":20,"sort_order":103},"🦃":{"category":"Animals & Nature","sheet_x":42,"sheet_y":21,"sort_order":60},"🦄":{"category":"Animals & Nature","sheet_x":42,"sheet_y":22,"sort_order":21},"🦅":{"category":"Animals & Nature","sheet_x":42,"sheet_y":23,"sort_order":69},"🦆":{"category":"Animals & Nature","sheet_x":42,"sheet_y":24,"sort_order":70},"🦇":{"category":"Animals & Nature","sheet_x":42,"sheet_y":25,"sort_order":50},"🦈":{"category":"Animals & Nature","sheet_x":42,"sheet_y":26,"sort_order":91},"🦉":{"category":"Animals & Nature","sheet_x":42,"sheet_y":27,"sort_order":72},"🦊":{"category":"Animals & Nature","sheet_x":42,"sheet_y":28,"sort_order":11},"🦋":{"category":"Animals & Nature","sheet_x":42,"sheet_y":29,"sort_order":95},"🦌":{"category":"Animals & Nature","sheet_x":42,"sheet_y":30,"sort_order":23},"🦍":{"category":"Animals & Nature","sheet_x":42,"sheet_y":31,"sort_order":3},"🦎":{"category":"Animals & Nature","sheet_x":42,"sheet_y":32,"sort_order":79},"🦏":{"category":"Animals & Nature","sheet_x":42,"sheet_y":33,"sort_order":40},"🦐":{"category":"Food & Drink","sheet_x":42,"sheet_y":34,"sort_order":82},"🦑":{"category":"Food & Drink","sheet_x":42,"sheet_y":35,"sort_order":83},"🦒":{"category":"Animals & Nature","sheet_x":42,"sheet_y":36,"sort_order":38},"🦓":{"category":"Animals & Nature","sheet_x":42,"sheet_y":37,"sort_order":22},"🦔":{"category":"Animals & Nature","sheet_x":42,"sheet_y":38,"sort_order":49},"🦕":{"category":"Animals & Nature","sheet_x":42,"sheet_y":39,"sort_order":83},"🦖":{"category":"Animals & Nature","sheet_x":42,"sheet_y":40,"sort_order":84},"🦗":{"category":"Animals & Nature","sheet_x":42,"sheet_y":41,"sort_order":100},"🦘":{"category":"Animals & Nature","sheet_x":42,"sheet_y":42,"sort_order":57},"🦙":{"category":"Animals & Nature","sheet_x":42,"sheet_y":43,"sort_order":37},"🦚":{"category":"Animals & Nature","sheet_x":42,"sheet_y":44,"sort_order":74},"🦛":{"category":"Animals & Nature","sheet_x":42,"sheet_y":45,"sort_order":41},"🦜":{"category":"Animals & Nature","sheet_x":42,"sheet_y":46,"sort_order":75},"🦝":{"category":"Animals & Nature","sheet_x":42,"sheet_y":47,"sort_order":12},"🦞":{"category":"Food & Drink","sheet_x":42,"sheet_y":48,"sort_order":81},"🦟":{"category":"Animals & Nature","sheet_x":42,"sheet_y":49,"sort_order":104},"🦠":{"category":"Animals & Nature","sheet_x":42,"sheet_y":50,"sort_order":105},"🦡":{"category":"Animals & Nature","sheet_x":42,"sheet_y":51,"sort_order":58},"🦢":{"category":"Animals & Nature","sheet_x":42,"sheet_y":52,"sort_order":71},"🦥":{"category":"Animals & Nature","sheet_x":42,"sheet_y":53,"sort_order":54},"🦦":{"category":"Animals & Nature","sheet_x":42,"sheet_y":54,"sort_order":55},"🦧":{"category":"Animals & Nature","sheet_x":42,"sheet_y":55,"sort_order":4},"🦨":{"category":"Animals & Nature","sheet_x":42,"sheet_y":56,"sort_order":56},"🦩":{"category":"Animals & Nature","sheet_x":43,"sheet_y":0,"sort_order":73},"🦪":{"category":"Food & Drink","sheet_x":43,"sheet_y":1,"sort_order":84},"🦮":{"category":"Animals & Nature","sheet_x":43,"sheet_y":2,"sort_order":7},"🦯":{"category":"Objects","sheet_x":43,"sheet_y":3,"sort_order":196},"🦴":{"category":"People & Body","sheet_x":43,"sheet_y":4,"sort_order":44},"🦵":{"category":"People & Body","sheet_x":43,"sheet_y":5,"sort_order":37},"🦶":{"category":"People & Body","sheet_x":43,"sheet_y":11,"sort_order":38},"🦷":{"category":"People & Body","sheet_x":43,"sheet_y":17,"sort_order":43},"🦸‍♀️":{"category":"People & Body","sheet_x":43,"sheet_y":18,"sort_order":181},"🦸‍♂️":{"category":"People & Body","sheet_x":43,"sheet_y":24,"sort_order":180},"🦸":{"category":"People & Body","sheet_x":43,"sheet_y":30,"sort_order":179},"🦹‍♀️":{"category":"People & Body","sheet_x":43,"sheet_y":36,"sort_order":184},"🦹‍♂️":{"category":"People & Body","sheet_x":43,"sheet_y":42,"sort_order":183},"🦹":{"category":"People & Body","sheet_x":43,"sheet_y":48,"sort_order":182},"🦺":{"category":"Objects","sheet_x":43,"sheet_y":54,"sort_order":5},"🦻":{"category":"People & Body","sheet_x":43,"sheet_y":55,"sort_order":40},"🦼":{"category":"Travel & Places","sheet_x":44,"sheet_y":4,"sort_order":95},"🦽":{"category":"Travel & Places","sheet_x":44,"sheet_y":5,"sort_order":94},"🦾":{"category":"People & Body","sheet_x":44,"sheet_y":6,"sort_order":35},"🦿":{"category":"People & Body","sheet_x":44,"sheet_y":7,"sort_order":36},"🧀":{"category":"Food & Drink","sheet_x":44,"sheet_y":8,"sort_order":39},"🧁":{"category":"Food & Drink","sheet_x":44,"sheet_y":9,"sort_order":92},"🧂":{"category":"Food & Drink","sheet_x":44,"sheet_y":10,"sort_order":61},"🧃":{"category":"Food & Drink","sheet_x":44,"sheet_y":11,"sort_order":113},"🧄":{"category":"Food & Drink","sheet_x":44,"sheet_y":12,"sort_order":27},"🧅":{"category":"Food & Drink","sheet_x":44,"sheet_y":13,"sort_order":28},"🧆":{"category":"Food & Drink","sheet_x":44,"sheet_y":14,"sort_order":52},"🧇":{"category":"Food & Drink","sheet_x":44,"sheet_y":15,"sort_order":38},"🧈":{"category":"Food & Drink","sheet_x":44,"sheet_y":16,"sort_order":60},"🧉":{"category":"Food & Drink","sheet_x":44,"sheet_y":17,"sort_order":114},"🧊":{"category":"Food & Drink","sheet_x":44,"sheet_y":18,"sort_order":115},"🧍‍♀️":{"category":"People & Body","sheet_x":44,"sheet_y":19,"sort_order":217},"🧍‍♂️":{"category":"People & Body","sheet_x":44,"sheet_y":25,"sort_order":216},"🧍":{"category":"People & Body","sheet_x":44,"sheet_y":31,"sort_order":215},"🧎‍♀️":{"category":"People & Body","sheet_x":44,"sheet_y":37,"sort_order":220},"🧎‍♂️":{"category":"People & Body","sheet_x":44,"sheet_y":43,"sort_order":219},"🧎":{"category":"People & Body","sheet_x":44,"sheet_y":49,"sort_order":218},"🧏‍♀️":{"category":"People & Body","sheet_x":44,"sheet_y":55,"sort_order":95},"🧏‍♂️":{"category":"People & Body","sheet_x":45,"sheet_y":4,"sort_order":94},"🧏":{"category":"People & Body","sheet_x":45,"sheet_y":10,"sort_order":93},"🧐":{"category":"Smileys & Emotion","sheet_x":45,"sheet_y":16,"sort_order":62},"🧑‍🌾":{"category":"People & Body","sheet_x":45,"sheet_y":17,"sort_order":117},"🧑‍🍳":{"category":"People & Body","sheet_x":45,"sheet_y":23,"sort_order":120},"🧑‍🎓":{"category":"People & Body","sheet_x":45,"sheet_y":29,"sort_order":108},"🧑‍🎤":{"category":"People & Body","sheet_x":45,"sheet_y":35,"sort_order":138},"🧑‍🎨":{"category":"People & Body","sheet_x":45,"sheet_y":41,"sort_order":141},"🧑‍🏫":{"category":"People & Body","sheet_x":45,"sheet_y":47,"sort_order":111},"🧑‍🏭":{"category":"People & Body","sheet_x":45,"sheet_y":53,"sort_order":126},"🧑‍💻":{"category":"People & Body","sheet_x":46,"sheet_y":2,"sort_order":135},"🧑‍💼":{"category":"People & Body","sheet_x":46,"sheet_y":8,"sort_order":129},"🧑‍🔧":{"category":"People & Body","sheet_x":46,"sheet_y":14,"sort_order":123},"🧑‍🔬":{"category":"People & Body","sheet_x":46,"sheet_y":20,"sort_order":132},"🧑‍🚀":{"category":"People & Body","sheet_x":46,"sheet_y":26,"sort_order":147},"🧑‍🚒":{"category":"People & Body","sheet_x":46,"sheet_y":32,"sort_order":150},"🧑‍🤝‍🧑":{"category":"People & Body","sheet_x":46,"sheet_y":38,"sort_order":293},"🧑‍🦯":{"category":"People & Body","sheet_x":47,"sheet_y":7,"sort_order":221},"🧑‍🦰":{"category":"People & Body","sheet_x":47,"sheet_y":13,"sort_order":63},"🧑‍🦱":{"category":"People & Body","sheet_x":47,"sheet_y":19,"sort_order":65},"🧑‍🦲":{"category":"People & Body","sheet_x":47,"sheet_y":25,"sort_order":69},"🧑‍🦳":{"category":"People & Body","sheet_x":47,"sheet_y":31,"sort_order":67},"🧑‍🦼":{"category":"People & Body","sheet_x":47,"sheet_y":37,"sort_order":224},"🧑‍🦽":{"category":"People & Body","sheet_x":47,"sheet_y":43,"sort_order":227},"🧑‍⚕️":{"category":"People & Body","sheet_x":47,"sheet_y":49,"sort_order":105},"🧑‍⚖️":{"category":"People & Body","sheet_x":47,"sheet_y":55,"sort_order":114},"🧑‍✈️":{"category":"People & Body","sheet_x":48,"sheet_y":4,"sort_order":144},"🧑":{"category":"People & Body","sheet_x":48,"sheet_y":10,"sort_order":53},"🧒":{"category":"People & Body","sheet_x":48,"sheet_y":16,"sort_order":50},"🧓":{"category":"People & Body","sheet_x":48,"sheet_y":22,"sort_order":72},"🧔":{"category":"People & Body","sheet_x":48,"sheet_y":28,"sort_order":56},"🧕":{"category":"People & Body","sheet_x":48,"sheet_y":34,"sort_order":171},"🧖‍♀️":{"category":"People & Body","sheet_x":48,"sheet_y":40,"sort_order":241},"🧖‍♂️":{"category":"People & Body","sheet_x":48,"sheet_y":46,"sort_order":240},"🧖":{"category":"People & Body","sheet_x":48,"sheet_y":52,"sort_order":239},"🧗‍♀️":{"category":"People & Body","sheet_x":49,"sheet_y":1,"sort_order":244},"🧗‍♂️":{"category":"People & Body","sheet_x":49,"sheet_y":7,"sort_order":243},"🧗":{"category":"People & Body","sheet_x":49,"sheet_y":13,"sort_order":242},"🧘‍♀️":{"category":"People & Body","sheet_x":49,"sheet_y":19,"sort_order":290},"🧘‍♂️":{"category":"People & Body","sheet_x":49,"sheet_y":25,"sort_order":289},"🧘":{"category":"People & Body","sheet_x":49,"sheet_y":31,"sort_order":288},"🧙‍♀️":{"category":"People & Body","sheet_x":49,"sheet_y":37,"sort_order":187},"🧙‍♂️":{"category":"People & Body","sheet_x":49,"sheet_y":43,"sort_order":186},"🧙":{"category":"People & Body","sheet_x":49,"sheet_y":49,"sort_order":185},"🧚‍♀️":{"category":"People & Body","sheet_x":49,"sheet_y":55,"sort_order":190},"🧚‍♂️":{"category":"People & Body","sheet_x":50,"sheet_y":4,"sort_order":189},"🧚":{"category":"People & Body","sheet_x":50,"sheet_y":10,"sort_order":188},"🧛‍♀️":{"category":"People & Body","sheet_x":50,"sheet_y":16,"sort_order":193},"🧛‍♂️":{"category":"People & Body","sheet_x":50,"sheet_y":22,"sort_order":192},"🧛":{"category":"People & Body","sheet_x":50,"sheet_y":28,"sort_order":191},"🧜‍♀️":{"category":"People & Body","sheet_x":50,"sheet_y":34,"sort_order":196},"🧜‍♂️":{"category":"People & Body","sheet_x":50,"sheet_y":40,"sort_order":195},"🧜":{"category":"People & Body","sheet_x":50,"sheet_y":46,"sort_order":194},"🧝‍♀️":{"category":"People & Body","sheet_x":50,"sheet_y":52,"sort_order":199},"🧝‍♂️":{"category":"People & Body","sheet_x":51,"sheet_y":1,"sort_order":198},"🧝":{"category":"People & Body","sheet_x":51,"sheet_y":7,"sort_order":197},"🧞‍♀️":{"category":"People & Body","sheet_x":51,"sheet_y":13,"sort_order":202},"🧞‍♂️":{"category":"People & Body","sheet_x":51,"sheet_y":14,"sort_order":201},"🧞":{"category":"People & Body","sheet_x":51,"sheet_y":15,"sort_order":200},"🧟‍♀️":{"category":"People & Body","sheet_x":51,"sheet_y":16,"sort_order":205},"🧟‍♂️":{"category":"People & Body","sheet_x":51,"sheet_y":17,"sort_order":204},"🧟":{"category":"People & Body","sheet_x":51,"sheet_y":18,"sort_order":203},"🧠":{"category":"People & Body","sheet_x":51,"sheet_y":19,"sort_order":42},"🧡":{"category":"Smileys & Emotion","sheet_x":51,"sheet_y":20,"sort_order":128},"🧢":{"category":"Objects","sheet_x":51,"sheet_y":21,"sort_order":38},"🧣":{"category":"Objects","sheet_x":51,"sheet_y":22,"sort_order":9},"🧤":{"category":"Objects","sheet_x":51,"sheet_y":23,"sort_order":10},"🧥":{"category":"Objects","sheet_x":51,"sheet_y":24,"sort_order":11},"🧦":{"category":"Objects","sheet_x":51,"sheet_y":25,"sort_order":12},"🧧":{"category":"Activities","sheet_x":51,"sheet_y":26,"sort_order":16},"🧨":{"category":"Activities","sheet_x":51,"sheet_y":27,"sort_order":5},"🧩":{"category":"Activities","sheet_x":51,"sheet_y":28,"sort_order":65},"🧪":{"category":"Objects","sheet_x":51,"sheet_y":29,"sort_order":202},"🧫":{"category":"Objects","sheet_x":51,"sheet_y":30,"sort_order":203},"🧬":{"category":"Objects","sheet_x":51,"sheet_y":31,"sort_order":204},"🧭":{"category":"Travel & Places","sheet_x":51,"sheet_y":32,"sort_order":7},"🧮":{"category":"Objects","sheet_x":51,"sheet_y":33,"sort_order":87},"🧯":{"category":"Objects","sheet_x":51,"sheet_y":34,"sort_order":228},"🧰":{"category":"Objects","sheet_x":51,"sheet_y":35,"sort_order":199},"🧱":{"category":"Travel & Places","sheet_x":51,"sheet_y":36,"sort_order":20},"🧲":{"category":"Objects","sheet_x":51,"sheet_y":37,"sort_order":200},"🧳":{"category":"Travel & Places","sheet_x":51,"sheet_y":38,"sort_order":132},"🧴":{"category":"Objects","sheet_x":51,"sheet_y":39,"sort_order":221},"🧵":{"category":"Activities","sheet_x":51,"sheet_y":40,"sort_order":78},"🧶":{"category":"Activities","sheet_x":51,"sheet_y":41,"sort_order":79},"🧷":{"category":"Objects","sheet_x":51,"sheet_y":42,"sort_order":222},"🧸":{"category":"Activities","sheet_x":51,"sheet_y":43,"sort_order":66},"🧹":{"category":"Objects","sheet_x":51,"sheet_y":44,"sort_order":223},"🧺":{"category":"Objects","sheet_x":51,"sheet_y":45,"sort_order":224},"🧻":{"category":"Objects","sheet_x":51,"sheet_y":46,"sort_order":225},"🧼":{"category":"Objects","sheet_x":51,"sheet_y":47,"sort_order":226},"🧽":{"category":"Objects","sheet_x":51,"sheet_y":48,"sort_order":227},"🧾":{"category":"Objects","sheet_x":51,"sheet_y":49,"sort_order":128},"🧿":{"category":"Activities","sheet_x":51,"sheet_y":50,"sort_order":60},"🩰":{"category":"Objects","sheet_x":51,"sheet_y":51,"sort_order":32},"🩱":{"category":"Objects","sheet_x":51,"sheet_y":52,"sort_order":16},"🩲":{"category":"Objects","sheet_x":51,"sheet_y":53,"sort_order":17},"🩳":{"category":"Objects","sheet_x":51,"sheet_y":54,"sort_order":18},"🩸":{"category":"Objects","sheet_x":51,"sheet_y":55,"sort_order":209},"🩹":{"category":"Objects","sheet_x":51,"sheet_y":56,"sort_order":211},"🩺":{"category":"Objects","sheet_x":52,"sheet_y":0,"sort_order":212},"🪀":{"category":"Activities","sheet_x":52,"sheet_y":1,"sort_order":56},"🪁":{"category":"Activities","sheet_x":52,"sheet_y":2,"sort_order":57},"🪂":{"category":"Travel & Places","sheet_x":52,"sheet_y":3,"sort_order":122},"🪐":{"category":"Travel & Places","sheet_x":52,"sheet_y":4,"sort_order":180},"🪑":{"category":"Objects","sheet_x":52,"sheet_y":5,"sort_order":216},"🪒":{"category":"Objects","sheet_x":52,"sheet_y":6,"sort_order":220},"🪓":{"category":"Objects","sheet_x":52,"sheet_y":7,"sort_order":182},"🪔":{"category":"Objects","sheet_x":52,"sheet_y":8,"sort_order":103},"🪕":{"category":"Objects","sheet_x":52,"sheet_y":9,"sort_order":67},"‼️":{"category":"Symbols","sheet_x":52,"sheet_y":10,"sort_order":122},"⁉️":{"category":"Symbols","sheet_x":52,"sheet_y":11,"sort_order":123},"™️":{"category":"Symbols","sheet_x":52,"sheet_y":12,"sort_order":131},"ℹ️":{"category":"Symbols","sheet_x":52,"sheet_y":13,"sort_order":156},"↔️":{"category":"Symbols","sheet_x":52,"sheet_y":14,"sort_order":36},"↕️":{"category":"Symbols","sheet_x":52,"sheet_y":15,"sort_order":35},"↖️":{"category":"Symbols","sheet_x":52,"sheet_y":16,"sort_order":34},"↗️":{"category":"Symbols","sheet_x":52,"sheet_y":17,"sort_order":28},"↘️":{"category":"Symbols","sheet_x":52,"sheet_y":18,"sort_order":30},"↙️":{"category":"Symbols","sheet_x":52,"sheet_y":19,"sort_order":32},"↩️":{"category":"Symbols","sheet_x":52,"sheet_y":20,"sort_order":37},"↪️":{"category":"Symbols","sheet_x":52,"sheet_y":21,"sort_order":38},"⌚":{"category":"Travel & Places","sheet_x":52,"sheet_y":22,"sort_order":135},"⌛":{"category":"Travel & Places","sheet_x":52,"sheet_y":23,"sort_order":133},"⌨️":{"category":"Objects","sheet_x":52,"sheet_y":24,"sort_order":80},"⏏️":{"category":"Symbols","sheet_x":52,"sheet_y":25,"sort_order":90},"⏩":{"category":"Symbols","sheet_x":52,"sheet_y":26,"sort_order":77},"⏪":{"category":"Symbols","sheet_x":52,"sheet_y":27,"sort_order":81},"⏫":{"category":"Symbols","sheet_x":52,"sheet_y":28,"sort_order":84},"⏬":{"category":"Symbols","sheet_x":52,"sheet_y":29,"sort_order":86},"⏭️":{"category":"Symbols","sheet_x":52,"sheet_y":30,"sort_order":78},"⏮️":{"category":"Symbols","sheet_x":52,"sheet_y":31,"sort_order":82},"⏯️":{"category":"Symbols","sheet_x":52,"sheet_y":32,"sort_order":79},"⏰":{"category":"Travel & Places","sheet_x":52,"sheet_y":33,"sort_order":136},"⏱️":{"category":"Travel & Places","sheet_x":52,"sheet_y":34,"sort_order":137},"⏲️":{"category":"Travel & Places","sheet_x":52,"sheet_y":35,"sort_order":138},"⏳":{"category":"Travel & Places","sheet_x":52,"sheet_y":36,"sort_order":134},"⏸️":{"category":"Symbols","sheet_x":52,"sheet_y":37,"sort_order":87},"⏹️":{"category":"Symbols","sheet_x":52,"sheet_y":38,"sort_order":88},"⏺️":{"category":"Symbols","sheet_x":52,"sheet_y":39,"sort_order":89},"Ⓜ️":{"category":"Symbols","sheet_x":52,"sheet_y":40,"sort_order":158},"▪️":{"category":"Symbols","sheet_x":52,"sheet_y":41,"sort_order":206},"▫️":{"category":"Symbols","sheet_x":52,"sheet_y":42,"sort_order":207},"▶️":{"category":"Symbols","sheet_x":52,"sheet_y":43,"sort_order":76},"◀️":{"category":"Symbols","sheet_x":52,"sheet_y":44,"sort_order":80},"◻️":{"category":"Symbols","sheet_x":52,"sheet_y":45,"sort_order":203},"◼️":{"category":"Symbols","sheet_x":52,"sheet_y":46,"sort_order":202},"◽":{"category":"Symbols","sheet_x":52,"sheet_y":47,"sort_order":205},"◾":{"category":"Symbols","sheet_x":52,"sheet_y":48,"sort_order":204},"☀️":{"category":"Travel & Places","sheet_x":52,"sheet_y":49,"sort_order":177},"☁️":{"category":"Travel & Places","sheet_x":52,"sheet_y":50,"sort_order":185},"☂️":{"category":"Travel & Places","sheet_x":52,"sheet_y":51,"sort_order":200},"☃️":{"category":"Travel & Places","sheet_x":52,"sheet_y":52,"sort_order":205},"☄️":{"category":"Travel & Places","sheet_x":52,"sheet_y":53,"sort_order":207},"☎️":{"category":"Objects","sheet_x":52,"sheet_y":54,"sort_order":71},"☑️":{"category":"Symbols","sheet_x":52,"sheet_y":55,"sort_order":108},"☔":{"category":"Travel & Places","sheet_x":52,"sheet_y":56,"sort_order":201},"☕":{"category":"Food & Drink","sheet_x":53,"sheet_y":0,"sort_order":101},"☘️":{"category":"Animals & Nature","sheet_x":53,"sheet_y":1,"sort_order":123},"☝️":{"category":"People & Body","sheet_x":53,"sheet_y":2,"sort_order":18},"☠️":{"category":"Smileys & Emotion","sheet_x":53,"sheet_y":8,"sort_order":94},"☢️":{"category":"Symbols","sheet_x":53,"sheet_y":9,"sort_order":25},"☣️":{"category":"Symbols","sheet_x":53,"sheet_y":10,"sort_order":26},"☦️":{"category":"Symbols","sheet_x":53,"sheet_y":11,"sort_order":55},"☪️":{"category":"Symbols","sheet_x":53,"sheet_y":12,"sort_order":56},"☮️":{"category":"Symbols","sheet_x":53,"sheet_y":13,"sort_order":57},"☯️":{"category":"Symbols","sheet_x":53,"sheet_y":14,"sort_order":53},"☸️":{"category":"Symbols","sheet_x":53,"sheet_y":15,"sort_order":52},"☹️":{"category":"Smileys & Emotion","sheet_x":53,"sheet_y":16,"sort_order":66},"☺️":{"category":"Smileys & Emotion","sheet_x":53,"sheet_y":17,"sort_order":19},"♈":{"category":"Symbols","sheet_x":53,"sheet_y":20,"sort_order":60},"♉":{"category":"Symbols","sheet_x":53,"sheet_y":21,"sort_order":61},"♊":{"category":"Symbols","sheet_x":53,"sheet_y":22,"sort_order":62},"♋":{"category":"Symbols","sheet_x":53,"sheet_y":23,"sort_order":63},"♌":{"category":"Symbols","sheet_x":53,"sheet_y":24,"sort_order":64},"♍":{"category":"Symbols","sheet_x":53,"sheet_y":25,"sort_order":65},"♎":{"category":"Symbols","sheet_x":53,"sheet_y":26,"sort_order":66},"♏":{"category":"Symbols","sheet_x":53,"sheet_y":27,"sort_order":67},"♐":{"category":"Symbols","sheet_x":53,"sheet_y":28,"sort_order":68},"♑":{"category":"Symbols","sheet_x":53,"sheet_y":29,"sort_order":69},"♒":{"category":"Symbols","sheet_x":53,"sheet_y":30,"sort_order":70},"♓":{"category":"Symbols","sheet_x":53,"sheet_y":31,"sort_order":71},"♟️":{"category":"Activities","sheet_x":53,"sheet_y":32,"sort_order":71},"♠️":{"category":"Activities","sheet_x":53,"sheet_y":33,"sort_order":67},"♣️":{"category":"Activities","sheet_x":53,"sheet_y":34,"sort_order":70},"♥️":{"category":"Activities","sheet_x":53,"sheet_y":35,"sort_order":68},"♦️":{"category":"Activities","sheet_x":53,"sheet_y":36,"sort_order":69},"♨️":{"category":"Travel & Places","sheet_x":53,"sheet_y":37,"sort_order":57},"♻️":{"category":"Symbols","sheet_x":53,"sheet_y":38,"sort_order":101},"♾️":{"category":"Symbols","sheet_x":53,"sheet_y":39,"sort_order":100},"♿":{"category":"Symbols","sheet_x":53,"sheet_y":40,"sort_order":4},"⚒️":{"category":"Objects","sheet_x":53,"sheet_y":41,"sort_order":184},"⚓":{"category":"Travel & Places","sheet_x":53,"sheet_y":42,"sort_order":110},"⚔️":{"category":"Objects","sheet_x":53,"sheet_y":43,"sort_order":187},"⚖️":{"category":"Objects","sheet_x":53,"sheet_y":45,"sort_order":195},"⚗️":{"category":"Objects","sheet_x":53,"sheet_y":46,"sort_order":201},"⚙️":{"category":"Objects","sheet_x":53,"sheet_y":47,"sort_order":193},"⚛️":{"category":"Symbols","sheet_x":53,"sheet_y":48,"sort_order":49},"⚜️":{"category":"Symbols","sheet_x":53,"sheet_y":49,"sort_order":102},"⚠️":{"category":"Symbols","sheet_x":53,"sheet_y":50,"sort_order":14},"⚡":{"category":"Travel & Places","sheet_x":53,"sheet_y":51,"sort_order":203},"⚪":{"category":"Symbols","sheet_x":53,"sheet_y":52,"sort_order":192},"⚫":{"category":"Symbols","sheet_x":53,"sheet_y":53,"sort_order":191},"⚰️":{"category":"Objects","sheet_x":53,"sheet_y":54,"sort_order":231},"⚱️":{"category":"Objects","sheet_x":53,"sheet_y":55,"sort_order":232},"⚽":{"category":"Activities","sheet_x":53,"sheet_y":56,"sort_order":28},"⚾":{"category":"Activities","sheet_x":54,"sheet_y":0,"sort_order":29},"⛄":{"category":"Travel & Places","sheet_x":54,"sheet_y":1,"sort_order":206},"⛅":{"category":"Travel & Places","sheet_x":54,"sheet_y":2,"sort_order":186},"⛈️":{"category":"Travel & Places","sheet_x":54,"sheet_y":3,"sort_order":187},"⛎":{"category":"Symbols","sheet_x":54,"sheet_y":4,"sort_order":72},"⛏️":{"category":"Objects","sheet_x":54,"sheet_y":5,"sort_order":183},"⛑️":{"category":"Objects","sheet_x":54,"sheet_y":6,"sort_order":39},"⛓️":{"category":"Objects","sheet_x":54,"sheet_y":7,"sort_order":198},"⛔":{"category":"Symbols","sheet_x":54,"sheet_y":8,"sort_order":16},"⛩️":{"category":"Travel & Places","sheet_x":54,"sheet_y":9,"sort_order":45},"⛪":{"category":"Travel & Places","sheet_x":54,"sheet_y":10,"sort_order":41},"⛰️":{"category":"Travel & Places","sheet_x":54,"sheet_y":11,"sort_order":9},"⛱️":{"category":"Travel & Places","sheet_x":54,"sheet_y":12,"sort_order":202},"⛲":{"category":"Travel & Places","sheet_x":54,"sheet_y":13,"sort_order":47},"⛳":{"category":"Activities","sheet_x":54,"sheet_y":14,"sort_order":47},"⛴️":{"category":"Travel & Places","sheet_x":54,"sheet_y":15,"sort_order":115},"⛵":{"category":"Travel & Places","sheet_x":54,"sheet_y":16,"sort_order":111},"⛷️":{"category":"People & Body","sheet_x":54,"sheet_y":17,"sort_order":247},"⛸️":{"category":"Activities","sheet_x":54,"sheet_y":18,"sort_order":48},"⛹️‍♀️":{"category":"People & Body","sheet_x":54,"sheet_y":19,"sort_order":263},"⛹️‍♂️":{"category":"People & Body","sheet_x":54,"sheet_y":25,"sort_order":262},"⛹️":{"category":"People & Body","sheet_x":54,"sheet_y":31,"sort_order":261},"⛺":{"category":"Travel & Places","sheet_x":54,"sheet_y":37,"sort_order":48},"⛽":{"category":"Travel & Places","sheet_x":54,"sheet_y":38,"sort_order":104},"✂️":{"category":"Objects","sheet_x":54,"sheet_y":39,"sort_order":171},"✅":{"category":"Symbols","sheet_x":54,"sheet_y":40,"sort_order":107},"✈️":{"category":"Travel & Places","sheet_x":54,"sheet_y":41,"sort_order":118},"✉️":{"category":"Objects","sheet_x":54,"sheet_y":42,"sort_order":132},"✊":{"category":"People & Body","sheet_x":54,"sheet_y":43,"sort_order":21},"✋":{"category":"People & Body","sheet_x":54,"sheet_y":49,"sort_order":4},"✌️":{"category":"People & Body","sheet_x":54,"sheet_y":55,"sort_order":8},"✍️":{"category":"People & Body","sheet_x":55,"sheet_y":4,"sort_order":31},"✏️":{"category":"Objects","sheet_x":55,"sheet_y":10,"sort_order":145},"✒️":{"category":"Objects","sheet_x":55,"sheet_y":11,"sort_order":146},"✔️":{"category":"Symbols","sheet_x":55,"sheet_y":12,"sort_order":109},"✖️":{"category":"Symbols","sheet_x":55,"sheet_y":13,"sort_order":110},"✝️":{"category":"Symbols","sheet_x":55,"sheet_y":14,"sort_order":54},"✡️":{"category":"Symbols","sheet_x":55,"sheet_y":15,"sort_order":51},"✨":{"category":"Activities","sheet_x":55,"sheet_y":16,"sort_order":6},"✳️":{"category":"Symbols","sheet_x":55,"sheet_y":17,"sort_order":119},"✴️":{"category":"Symbols","sheet_x":55,"sheet_y":18,"sort_order":120},"❄️":{"category":"Travel & Places","sheet_x":55,"sheet_y":19,"sort_order":204},"❇️":{"category":"Symbols","sheet_x":55,"sheet_y":20,"sort_order":121},"❌":{"category":"Symbols","sheet_x":55,"sheet_y":21,"sort_order":111},"❎":{"category":"Symbols","sheet_x":55,"sheet_y":22,"sort_order":112},"❓":{"category":"Symbols","sheet_x":55,"sheet_y":23,"sort_order":124},"❔":{"category":"Symbols","sheet_x":55,"sheet_y":24,"sort_order":125},"❕":{"category":"Symbols","sheet_x":55,"sheet_y":25,"sort_order":126},"❗":{"category":"Symbols","sheet_x":55,"sheet_y":26,"sort_order":127},"❣️":{"category":"Smileys & Emotion","sheet_x":55,"sheet_y":27,"sort_order":125},"❤️":{"category":"Smileys & Emotion","sheet_x":55,"sheet_y":28,"sort_order":127},"➕":{"category":"Symbols","sheet_x":55,"sheet_y":29,"sort_order":113},"➖":{"category":"Symbols","sheet_x":55,"sheet_y":30,"sort_order":114},"➗":{"category":"Symbols","sheet_x":55,"sheet_y":31,"sort_order":115},"➡️":{"category":"Symbols","sheet_x":55,"sheet_y":32,"sort_order":29},"➰":{"category":"Symbols","sheet_x":55,"sheet_y":33,"sort_order":116},"➿":{"category":"Symbols","sheet_x":55,"sheet_y":34,"sort_order":117},"⤴️":{"category":"Symbols","sheet_x":55,"sheet_y":35,"sort_order":39},"⤵️":{"category":"Symbols","sheet_x":55,"sheet_y":36,"sort_order":40},"⬅️":{"category":"Symbols","sheet_x":55,"sheet_y":37,"sort_order":33},"⬆️":{"category":"Symbols","sheet_x":55,"sheet_y":38,"sort_order":27},"⬇️":{"category":"Symbols","sheet_x":55,"sheet_y":39,"sort_order":31},"⬛":{"category":"Symbols","sheet_x":55,"sheet_y":40,"sort_order":200},"⬜":{"category":"Symbols","sheet_x":55,"sheet_y":41,"sort_order":201},"⭐":{"category":"Travel & Places","sheet_x":55,"sheet_y":42,"sort_order":181},"⭕":{"category":"Symbols","sheet_x":55,"sheet_y":43,"sort_order":106},"〰️":{"category":"Symbols","sheet_x":55,"sheet_y":44,"sort_order":128},"〽️":{"category":"Symbols","sheet_x":55,"sheet_y":45,"sort_order":118},"㊗️":{"category":"Symbols","sheet_x":55,"sheet_y":46,"sort_order":180},"㊙️":{"category":"Symbols","sheet_x":55,"sheet_y":47,"sort_order":181}}
  };
}

Config.Schema = Config.Schema || {};

Config.Schema.MTProto = {"constructors":[{"id":"481674261","predicate":"vector","params":[],"type":"Vector t"},{"id":"85337187","predicate":"resPQ","params":[{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"pq","type":"bytes"},{"name":"server_public_key_fingerprints","type":"Vector<long>"}],"type":"ResPQ"},{"id":"-2083955988","predicate":"p_q_inner_data","params":[{"name":"pq","type":"bytes"},{"name":"p","type":"bytes"},{"name":"q","type":"bytes"},{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"new_nonce","type":"int256"}],"type":"P_Q_inner_data"},{"id":"1013613780","predicate":"p_q_inner_data_temp","params":[{"name":"pq","type":"bytes"},{"name":"p","type":"bytes"},{"name":"q","type":"bytes"},{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"new_nonce","type":"int256"},{"name":"expires_in","type":"int"}],"type":"P_Q_inner_data"},{"id":"2043348061","predicate":"server_DH_params_fail","params":[{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"new_nonce_hash","type":"int128"}],"type":"Server_DH_Params"},{"id":"-790100132","predicate":"server_DH_params_ok","params":[{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"encrypted_answer","type":"bytes"}],"type":"Server_DH_Params"},{"id":"-1249309254","predicate":"server_DH_inner_data","params":[{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"g","type":"int"},{"name":"dh_prime","type":"bytes"},{"name":"g_a","type":"bytes"},{"name":"server_time","type":"int"}],"type":"Server_DH_inner_data"},{"id":"1715713620","predicate":"client_DH_inner_data","params":[{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"retry_id","type":"long"},{"name":"g_b","type":"bytes"}],"type":"Client_DH_Inner_Data"},{"id":"1003222836","predicate":"dh_gen_ok","params":[{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"new_nonce_hash1","type":"int128"}],"type":"Set_client_DH_params_answer"},{"id":"1188831161","predicate":"dh_gen_retry","params":[{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"new_nonce_hash2","type":"int128"}],"type":"Set_client_DH_params_answer"},{"id":"-1499615742","predicate":"dh_gen_fail","params":[{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"new_nonce_hash3","type":"int128"}],"type":"Set_client_DH_params_answer"},{"id":"-212046591","predicate":"rpc_result","params":[{"name":"req_msg_id","type":"long"},{"name":"result","type":"Object"}],"type":"RpcResult"},{"id":"558156313","predicate":"rpc_error","params":[{"name":"error_code","type":"int"},{"name":"error_message","type":"string"}],"type":"RpcError"},{"id":"1579864942","predicate":"rpc_answer_unknown","params":[],"type":"RpcDropAnswer"},{"id":"-847714938","predicate":"rpc_answer_dropped_running","params":[],"type":"RpcDropAnswer"},{"id":"-1539647305","predicate":"rpc_answer_dropped","params":[{"name":"msg_id","type":"long"},{"name":"seq_no","type":"int"},{"name":"bytes","type":"int"}],"type":"RpcDropAnswer"},{"id":"155834844","predicate":"future_salt","params":[{"name":"valid_since","type":"int"},{"name":"valid_until","type":"int"},{"name":"salt","type":"long"}],"type":"FutureSalt"},{"id":"-1370486635","predicate":"future_salts","params":[{"name":"req_msg_id","type":"long"},{"name":"now","type":"int"},{"name":"salts","type":"vector<future_salt>"}],"type":"FutureSalts"},{"id":"880243653","predicate":"pong","params":[{"name":"msg_id","type":"long"},{"name":"ping_id","type":"long"}],"type":"Pong"},{"id":"-501201412","predicate":"destroy_session_ok","params":[{"name":"session_id","type":"long"}],"type":"DestroySessionRes"},{"id":"1658015945","predicate":"destroy_session_none","params":[{"name":"session_id","type":"long"}],"type":"DestroySessionRes"},{"id":"-1631450872","predicate":"new_session_created","params":[{"name":"first_msg_id","type":"long"},{"name":"unique_id","type":"long"},{"name":"server_salt","type":"long"}],"type":"NewSession"},{"id":"1945237724","predicate":"msg_container","params":[{"name":"messages","type":"vector<%Message>"}],"type":"MessageContainer"},{"id":"1538843921","predicate":"message","params":[{"name":"msg_id","type":"long"},{"name":"seqno","type":"int"},{"name":"bytes","type":"int"},{"name":"body","type":"Object"}],"type":"Message"},{"id":"-530561358","predicate":"msg_copy","params":[{"name":"orig_message","type":"Message"}],"type":"MessageCopy"},{"id":"812830625","predicate":"gzip_packed","params":[{"name":"packed_data","type":"bytes"}],"type":"Object"},{"id":"1658238041","predicate":"msgs_ack","params":[{"name":"msg_ids","type":"Vector<long>"}],"type":"MsgsAck"},{"id":"-1477445615","predicate":"bad_msg_notification","params":[{"name":"bad_msg_id","type":"long"},{"name":"bad_msg_seqno","type":"int"},{"name":"error_code","type":"int"}],"type":"BadMsgNotification"},{"id":"-307542917","predicate":"bad_server_salt","params":[{"name":"bad_msg_id","type":"long"},{"name":"bad_msg_seqno","type":"int"},{"name":"error_code","type":"int"},{"name":"new_server_salt","type":"long"}],"type":"BadMsgNotification"},{"id":"2105940488","predicate":"msg_resend_req","params":[{"name":"msg_ids","type":"Vector<long>"}],"type":"MsgResendReq"},{"id":"-630588590","predicate":"msgs_state_req","params":[{"name":"msg_ids","type":"Vector<long>"}],"type":"MsgsStateReq"},{"id":"81704317","predicate":"msgs_state_info","params":[{"name":"req_msg_id","type":"long"},{"name":"info","type":"bytes"}],"type":"MsgsStateInfo"},{"id":"-1933520591","predicate":"msgs_all_info","params":[{"name":"msg_ids","type":"Vector<long>"},{"name":"info","type":"bytes"}],"type":"MsgsAllInfo"},{"id":"661470918","predicate":"msg_detailed_info","params":[{"name":"msg_id","type":"long"},{"name":"answer_msg_id","type":"long"},{"name":"bytes","type":"int"},{"name":"status","type":"int"}],"type":"MsgDetailedInfo"},{"id":"-2137147681","predicate":"msg_new_detailed_info","params":[{"name":"answer_msg_id","type":"long"},{"name":"bytes","type":"int"},{"name":"status","type":"int"}],"type":"MsgDetailedInfo"},{"id":"1973679973","predicate":"bind_auth_key_inner","params":[{"name":"nonce","type":"long"},{"name":"temp_auth_key_id","type":"long"},{"name":"perm_auth_key_id","type":"long"},{"name":"temp_session_id","type":"long"},{"name":"expires_at","type":"int"}],"type":"BindAuthKeyInner"}],"methods":[{"id":"3195965169","method":"req_pq_multi","params":[{"name":"nonce","type":"int128"}],"type":"ResPQ"},{"id":"1615239032","method":"req_pq","params":[{"name":"nonce","type":"int128"}],"type":"ResPQ"},{"id":"-686627650","method":"req_DH_params","params":[{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"p","type":"bytes"},{"name":"q","type":"bytes"},{"name":"public_key_fingerprint","type":"long"},{"name":"encrypted_data","type":"bytes"}],"type":"Server_DH_Params"},{"id":"-184262881","method":"set_client_DH_params","params":[{"name":"nonce","type":"int128"},{"name":"server_nonce","type":"int128"},{"name":"encrypted_data","type":"bytes"}],"type":"Set_client_DH_params_answer"},{"id":"1491380032","method":"rpc_drop_answer","params":[{"name":"req_msg_id","type":"long"}],"type":"RpcDropAnswer"},{"id":"-1188971260","method":"get_future_salts","params":[{"name":"num","type":"int"}],"type":"FutureSalts"},{"id":"2059302892","method":"ping","params":[{"name":"ping_id","type":"long"}],"type":"Pong"},{"id":"-213746804","method":"ping_delay_disconnect","params":[{"name":"ping_id","type":"long"},{"name":"disconnect_delay","type":"int"}],"type":"Pong"},{"id":"-414113498","method":"destroy_session","params":[{"name":"session_id","type":"long"}],"type":"DestroySessionRes"},{"id":"-1835453025","method":"http_wait","params":[{"name":"max_delay","type":"int"},{"name":"wait_after","type":"int"},{"name":"max_wait","type":"int"}],"type":"HttpWait"}]};

Config.Schema.API = {"constructors":[{"id":"-1132882121","predicate":"boolFalse","params":[],"type":"Bool"},{"id":"-1720552011","predicate":"boolTrue","params":[],"type":"Bool"},{"id":"1072550713","predicate":"true","params":[],"type":"True"},{"id":"481674261","predicate":"vector","params":[],"type":"Vector t"},{"id":"-994444869","predicate":"error","params":[{"name":"code","type":"int"},{"name":"text","type":"string"}],"type":"Error"},{"id":"1450380236","predicate":"null","params":[],"type":"Null"},{"id":"2134579434","predicate":"inputPeerEmpty","params":[],"type":"InputPeer"},{"id":"2107670217","predicate":"inputPeerSelf","params":[],"type":"InputPeer"},{"id":"396093539","predicate":"inputPeerChat","params":[{"name":"chat_id","type":"int"}],"type":"InputPeer"},{"id":"-1182234929","predicate":"inputUserEmpty","params":[],"type":"InputUser"},{"id":"-138301121","predicate":"inputUserSelf","params":[],"type":"InputUser"},{"id":"-208488460","predicate":"inputPhoneContact","params":[{"name":"client_id","type":"long"},{"name":"phone","type":"string"},{"name":"first_name","type":"string"},{"name":"last_name","type":"string"}],"type":"InputContact"},{"id":"-181407105","predicate":"inputFile","params":[{"name":"id","type":"long"},{"name":"parts","type":"int"},{"name":"name","type":"string"},{"name":"md5_checksum","type":"string"}],"type":"InputFile"},{"id":"-1771768449","predicate":"inputMediaEmpty","params":[],"type":"InputMedia"},{"id":"505969924","predicate":"inputMediaUploadedPhoto","params":[{"name":"flags","type":"#"},{"name":"file","type":"InputFile"},{"name":"stickers","type":"flags.0?Vector<InputDocument>"},{"name":"ttl_seconds","type":"flags.1?int"}],"type":"InputMedia"},{"id":"-1279654347","predicate":"inputMediaPhoto","params":[{"name":"flags","type":"#"},{"name":"id","type":"InputPhoto"},{"name":"ttl_seconds","type":"flags.0?int"}],"type":"InputMedia"},{"id":"-104578748","predicate":"inputMediaGeoPoint","params":[{"name":"geo_point","type":"InputGeoPoint"}],"type":"InputMedia"},{"id":"-122978821","predicate":"inputMediaContact","params":[{"name":"phone_number","type":"string"},{"name":"first_name","type":"string"},{"name":"last_name","type":"string"},{"name":"vcard","type":"string"}],"type":"InputMedia"},{"id":"480546647","predicate":"inputChatPhotoEmpty","params":[],"type":"InputChatPhoto"},{"id":"-1837345356","predicate":"inputChatUploadedPhoto","params":[{"name":"file","type":"InputFile"}],"type":"InputChatPhoto"},{"id":"-1991004873","predicate":"inputChatPhoto","params":[{"name":"id","type":"InputPhoto"}],"type":"InputChatPhoto"},{"id":"-457104426","predicate":"inputGeoPointEmpty","params":[],"type":"InputGeoPoint"},{"id":"-206066487","predicate":"inputGeoPoint","params":[{"name":"lat","type":"double"},{"name":"long","type":"double"}],"type":"InputGeoPoint"},{"id":"483901197","predicate":"inputPhotoEmpty","params":[],"type":"InputPhoto"},{"id":"1001634122","predicate":"inputPhoto","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"file_reference","type":"bytes"}],"type":"InputPhoto"},{"id":"-539317279","predicate":"inputFileLocation","params":[{"name":"volume_id","type":"long"},{"name":"local_id","type":"int"},{"name":"secret","type":"long"},{"name":"file_reference","type":"bytes"}],"type":"InputFileLocation"},{"id":"-1649296275","predicate":"peerUser","params":[{"name":"user_id","type":"int"}],"type":"Peer"},{"id":"-1160714821","predicate":"peerChat","params":[{"name":"chat_id","type":"int"}],"type":"Peer"},{"id":"-1432995067","predicate":"storage.fileUnknown","params":[],"type":"storage.FileType"},{"id":"1086091090","predicate":"storage.filePartial","params":[],"type":"storage.FileType"},{"id":"8322574","predicate":"storage.fileJpeg","params":[],"type":"storage.FileType"},{"id":"-891180321","predicate":"storage.fileGif","params":[],"type":"storage.FileType"},{"id":"172975040","predicate":"storage.filePng","params":[],"type":"storage.FileType"},{"id":"-1373745011","predicate":"storage.filePdf","params":[],"type":"storage.FileType"},{"id":"1384777335","predicate":"storage.fileMp3","params":[],"type":"storage.FileType"},{"id":"1258941372","predicate":"storage.fileMov","params":[],"type":"storage.FileType"},{"id":"-1278304028","predicate":"storage.fileMp4","params":[],"type":"storage.FileType"},{"id":"276907596","predicate":"storage.fileWebp","params":[],"type":"storage.FileType"},{"id":"537022650","predicate":"userEmpty","params":[{"name":"id","type":"int"}],"type":"User"},{"id":"1326562017","predicate":"userProfilePhotoEmpty","params":[],"type":"UserProfilePhoto"},{"id":"-321430132","predicate":"userProfilePhoto","params":[{"name":"photo_id","type":"long"},{"name":"photo_small","type":"FileLocation"},{"name":"photo_big","type":"FileLocation"},{"name":"dc_id","type":"int"}],"type":"UserProfilePhoto"},{"id":"164646985","predicate":"userStatusEmpty","params":[],"type":"UserStatus"},{"id":"-306628279","predicate":"userStatusOnline","params":[{"name":"expires","type":"int"}],"type":"UserStatus"},{"id":"9203775","predicate":"userStatusOffline","params":[{"name":"was_online","type":"int"}],"type":"UserStatus"},{"id":"-1683826688","predicate":"chatEmpty","params":[{"name":"id","type":"int"}],"type":"Chat"},{"id":"1004149726","predicate":"chat","params":[{"name":"flags","type":"#"},{"name":"creator","type":"flags.0?true"},{"name":"kicked","type":"flags.1?true"},{"name":"left","type":"flags.2?true"},{"name":"deactivated","type":"flags.5?true"},{"name":"id","type":"int"},{"name":"title","type":"string"},{"name":"photo","type":"ChatPhoto"},{"name":"participants_count","type":"int"},{"name":"date","type":"int"},{"name":"version","type":"int"},{"name":"migrated_to","type":"flags.6?InputChannel"},{"name":"admin_rights","type":"flags.14?ChatAdminRights"},{"name":"default_banned_rights","type":"flags.18?ChatBannedRights"}],"type":"Chat"},{"id":"120753115","predicate":"chatForbidden","params":[{"name":"id","type":"int"},{"name":"title","type":"string"}],"type":"Chat"},{"id":"461151667","predicate":"chatFull","params":[{"name":"flags","type":"#"},{"name":"can_set_username","type":"flags.7?true"},{"name":"has_scheduled","type":"flags.8?true"},{"name":"id","type":"int"},{"name":"about","type":"string"},{"name":"participants","type":"ChatParticipants"},{"name":"chat_photo","type":"flags.2?Photo"},{"name":"notify_settings","type":"PeerNotifySettings"},{"name":"exported_invite","type":"ExportedChatInvite"},{"name":"bot_info","type":"flags.3?Vector<BotInfo>"},{"name":"pinned_msg_id","type":"flags.6?int"},{"name":"folder_id","type":"flags.11?int"}],"type":"ChatFull"},{"id":"-925415106","predicate":"chatParticipant","params":[{"name":"user_id","type":"int"},{"name":"inviter_id","type":"int"},{"name":"date","type":"int"}],"type":"ChatParticipant"},{"id":"-57668565","predicate":"chatParticipantsForbidden","params":[{"name":"flags","type":"#"},{"name":"chat_id","type":"int"},{"name":"self_participant","type":"flags.0?ChatParticipant"}],"type":"ChatParticipants"},{"id":"1061556205","predicate":"chatParticipants","params":[{"name":"chat_id","type":"int"},{"name":"participants","type":"Vector<ChatParticipant>"},{"name":"version","type":"int"}],"type":"ChatParticipants"},{"id":"935395612","predicate":"chatPhotoEmpty","params":[],"type":"ChatPhoto"},{"id":"1197267925","predicate":"chatPhoto","params":[{"name":"photo_small","type":"FileLocation"},{"name":"photo_big","type":"FileLocation"},{"name":"dc_id","type":"int"}],"type":"ChatPhoto"},{"id":"-2082087340","predicate":"messageEmpty","params":[{"name":"id","type":"int"}],"type":"Message"},{"id":"1160515173","predicate":"message","params":[{"name":"flags","type":"#"},{"name":"out","type":"flags.1?true"},{"name":"mentioned","type":"flags.4?true"},{"name":"media_unread","type":"flags.5?true"},{"name":"silent","type":"flags.13?true"},{"name":"post","type":"flags.14?true"},{"name":"from_scheduled","type":"flags.18?true"},{"name":"legacy","type":"flags.19?true"},{"name":"edit_hide","type":"flags.21?true"},{"name":"id","type":"int"},{"name":"from_id","type":"flags.8?int"},{"name":"to_id","type":"Peer"},{"name":"fwd_from","type":"flags.2?MessageFwdHeader"},{"name":"via_bot_id","type":"flags.11?int"},{"name":"reply_to_msg_id","type":"flags.3?int"},{"name":"date","type":"int"},{"name":"message","type":"string"},{"name":"media","type":"flags.9?MessageMedia"},{"name":"reply_markup","type":"flags.6?ReplyMarkup"},{"name":"entities","type":"flags.7?Vector<MessageEntity>"},{"name":"views","type":"flags.10?int"},{"name":"edit_date","type":"flags.15?int"},{"name":"post_author","type":"flags.16?string"},{"name":"grouped_id","type":"flags.17?long"},{"name":"restriction_reason","type":"flags.22?Vector<RestrictionReason>"}],"type":"Message"},{"id":"-1642487306","predicate":"messageService","params":[{"name":"flags","type":"#"},{"name":"out","type":"flags.1?true"},{"name":"mentioned","type":"flags.4?true"},{"name":"media_unread","type":"flags.5?true"},{"name":"silent","type":"flags.13?true"},{"name":"post","type":"flags.14?true"},{"name":"legacy","type":"flags.19?true"},{"name":"id","type":"int"},{"name":"from_id","type":"flags.8?int"},{"name":"to_id","type":"Peer"},{"name":"reply_to_msg_id","type":"flags.3?int"},{"name":"date","type":"int"},{"name":"action","type":"MessageAction"}],"type":"Message"},{"id":"1038967584","predicate":"messageMediaEmpty","params":[],"type":"MessageMedia"},{"id":"1766936791","predicate":"messageMediaPhoto","params":[{"name":"flags","type":"#"},{"name":"photo","type":"flags.0?Photo"},{"name":"ttl_seconds","type":"flags.2?int"}],"type":"MessageMedia"},{"id":"1457575028","predicate":"messageMediaGeo","params":[{"name":"geo","type":"GeoPoint"}],"type":"MessageMedia"},{"id":"-873313984","predicate":"messageMediaContact","params":[{"name":"phone_number","type":"string"},{"name":"first_name","type":"string"},{"name":"last_name","type":"string"},{"name":"vcard","type":"string"},{"name":"user_id","type":"int"}],"type":"MessageMedia"},{"id":"-1618676578","predicate":"messageMediaUnsupported","params":[],"type":"MessageMedia"},{"id":"-1230047312","predicate":"messageActionEmpty","params":[],"type":"MessageAction"},{"id":"-1503425638","predicate":"messageActionChatCreate","params":[{"name":"title","type":"string"},{"name":"users","type":"Vector<int>"}],"type":"MessageAction"},{"id":"-1247687078","predicate":"messageActionChatEditTitle","params":[{"name":"title","type":"string"}],"type":"MessageAction"},{"id":"2144015272","predicate":"messageActionChatEditPhoto","params":[{"name":"photo","type":"Photo"}],"type":"MessageAction"},{"id":"-1780220945","predicate":"messageActionChatDeletePhoto","params":[],"type":"MessageAction"},{"id":"1217033015","predicate":"messageActionChatAddUser","params":[{"name":"users","type":"Vector<int>"}],"type":"MessageAction"},{"id":"-1297179892","predicate":"messageActionChatDeleteUser","params":[{"name":"user_id","type":"int"}],"type":"MessageAction"},{"id":"739712882","predicate":"dialog","params":[{"name":"flags","type":"#"},{"name":"pinned","type":"flags.2?true"},{"name":"unread_mark","type":"flags.3?true"},{"name":"peer","type":"Peer"},{"name":"top_message","type":"int"},{"name":"read_inbox_max_id","type":"int"},{"name":"read_outbox_max_id","type":"int"},{"name":"unread_count","type":"int"},{"name":"unread_mentions_count","type":"int"},{"name":"notify_settings","type":"PeerNotifySettings"},{"name":"pts","type":"flags.0?int"},{"name":"draft","type":"flags.1?DraftMessage"},{"name":"folder_id","type":"flags.4?int"}],"type":"Dialog"},{"id":"590459437","predicate":"photoEmpty","params":[{"name":"id","type":"long"}],"type":"Photo"},{"id":"-797637467","predicate":"photo","params":[{"name":"flags","type":"#"},{"name":"has_stickers","type":"flags.0?true"},{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"file_reference","type":"bytes"},{"name":"date","type":"int"},{"name":"sizes","type":"Vector<PhotoSize>"},{"name":"dc_id","type":"int"}],"type":"Photo"},{"id":"236446268","predicate":"photoSizeEmpty","params":[{"name":"type","type":"string"}],"type":"PhotoSize"},{"id":"2009052699","predicate":"photoSize","params":[{"name":"type","type":"string"},{"name":"location","type":"FileLocation"},{"name":"w","type":"int"},{"name":"h","type":"int"},{"name":"size","type":"int"}],"type":"PhotoSize"},{"id":"-374917894","predicate":"photoCachedSize","params":[{"name":"type","type":"string"},{"name":"location","type":"FileLocation"},{"name":"w","type":"int"},{"name":"h","type":"int"},{"name":"bytes","type":"bytes"}],"type":"PhotoSize"},{"id":"286776671","predicate":"geoPointEmpty","params":[],"type":"GeoPoint"},{"id":"43446532","predicate":"geoPoint","params":[{"name":"long","type":"double"},{"name":"lat","type":"double"},{"name":"access_hash","type":"long"}],"type":"GeoPoint"},{"id":"1577067778","predicate":"auth.sentCode","params":[{"name":"flags","type":"#"},{"name":"type","type":"auth.SentCodeType"},{"name":"phone_code_hash","type":"string"},{"name":"next_type","type":"flags.1?auth.CodeType"},{"name":"timeout","type":"flags.2?int"}],"type":"auth.SentCode"},{"id":"-855308010","predicate":"auth.authorization","params":[{"name":"flags","type":"#"},{"name":"tmp_sessions","type":"flags.0?int"},{"name":"user","type":"User"}],"type":"auth.Authorization"},{"id":"-543777747","predicate":"auth.exportedAuthorization","params":[{"name":"id","type":"int"},{"name":"bytes","type":"bytes"}],"type":"auth.ExportedAuthorization"},{"id":"-1195615476","predicate":"inputNotifyPeer","params":[{"name":"peer","type":"InputPeer"}],"type":"InputNotifyPeer"},{"id":"423314455","predicate":"inputNotifyUsers","params":[],"type":"InputNotifyPeer"},{"id":"1251338318","predicate":"inputNotifyChats","params":[],"type":"InputNotifyPeer"},{"id":"-1673717362","predicate":"inputPeerNotifySettings","params":[{"name":"flags","type":"#"},{"name":"show_previews","type":"flags.0?Bool"},{"name":"silent","type":"flags.1?Bool"},{"name":"mute_until","type":"flags.2?int"},{"name":"sound","type":"flags.3?string"}],"type":"InputPeerNotifySettings"},{"id":"-1353671392","predicate":"peerNotifySettings","params":[{"name":"flags","type":"#"},{"name":"show_previews","type":"flags.0?Bool"},{"name":"silent","type":"flags.1?Bool"},{"name":"mute_until","type":"flags.2?int"},{"name":"sound","type":"flags.3?string"}],"type":"PeerNotifySettings"},{"id":"-2122045747","predicate":"peerSettings","params":[{"name":"flags","type":"#"},{"name":"report_spam","type":"flags.0?true"},{"name":"add_contact","type":"flags.1?true"},{"name":"block_contact","type":"flags.2?true"},{"name":"share_contact","type":"flags.3?true"},{"name":"need_contacts_exception","type":"flags.4?true"},{"name":"report_geo","type":"flags.5?true"}],"type":"PeerSettings"},{"id":"-1539849235","predicate":"wallPaper","params":[{"name":"id","type":"long"},{"name":"flags","type":"#"},{"name":"creator","type":"flags.0?true"},{"name":"default","type":"flags.1?true"},{"name":"pattern","type":"flags.3?true"},{"name":"dark","type":"flags.4?true"},{"name":"access_hash","type":"long"},{"name":"slug","type":"string"},{"name":"document","type":"Document"},{"name":"settings","type":"flags.2?WallPaperSettings"}],"type":"WallPaper"},{"id":"1490799288","predicate":"inputReportReasonSpam","params":[],"type":"ReportReason"},{"id":"505595789","predicate":"inputReportReasonViolence","params":[],"type":"ReportReason"},{"id":"777640226","predicate":"inputReportReasonPornography","params":[],"type":"ReportReason"},{"id":"-1376497949","predicate":"inputReportReasonChildAbuse","params":[],"type":"ReportReason"},{"id":"-512463606","predicate":"inputReportReasonOther","params":[{"name":"text","type":"string"}],"type":"ReportReason"},{"id":"-302941166","predicate":"userFull","params":[{"name":"flags","type":"#"},{"name":"blocked","type":"flags.0?true"},{"name":"phone_calls_available","type":"flags.4?true"},{"name":"phone_calls_private","type":"flags.5?true"},{"name":"can_pin_message","type":"flags.7?true"},{"name":"has_scheduled","type":"flags.12?true"},{"name":"user","type":"User"},{"name":"about","type":"flags.1?string"},{"name":"settings","type":"PeerSettings"},{"name":"profile_photo","type":"flags.2?Photo"},{"name":"notify_settings","type":"PeerNotifySettings"},{"name":"bot_info","type":"flags.3?BotInfo"},{"name":"pinned_msg_id","type":"flags.6?int"},{"name":"common_chats_count","type":"int"},{"name":"folder_id","type":"flags.11?int"}],"type":"UserFull"},{"id":"-116274796","predicate":"contact","params":[{"name":"user_id","type":"int"},{"name":"mutual","type":"Bool"}],"type":"Contact"},{"id":"-805141448","predicate":"importedContact","params":[{"name":"user_id","type":"int"},{"name":"client_id","type":"long"}],"type":"ImportedContact"},{"id":"1444661369","predicate":"contactBlocked","params":[{"name":"user_id","type":"int"},{"name":"date","type":"int"}],"type":"ContactBlocked"},{"id":"-748155807","predicate":"contactStatus","params":[{"name":"user_id","type":"int"},{"name":"status","type":"UserStatus"}],"type":"ContactStatus"},{"id":"-1219778094","predicate":"contacts.contactsNotModified","params":[],"type":"contacts.Contacts"},{"id":"-353862078","predicate":"contacts.contacts","params":[{"name":"contacts","type":"Vector<Contact>"},{"name":"saved_count","type":"int"},{"name":"users","type":"Vector<User>"}],"type":"contacts.Contacts"},{"id":"2010127419","predicate":"contacts.importedContacts","params":[{"name":"imported","type":"Vector<ImportedContact>"},{"name":"popular_invites","type":"Vector<PopularContact>"},{"name":"retry_contacts","type":"Vector<long>"},{"name":"users","type":"Vector<User>"}],"type":"contacts.ImportedContacts"},{"id":"471043349","predicate":"contacts.blocked","params":[{"name":"blocked","type":"Vector<ContactBlocked>"},{"name":"users","type":"Vector<User>"}],"type":"contacts.Blocked"},{"id":"-1878523231","predicate":"contacts.blockedSlice","params":[{"name":"count","type":"int"},{"name":"blocked","type":"Vector<ContactBlocked>"},{"name":"users","type":"Vector<User>"}],"type":"contacts.Blocked"},{"id":"364538944","predicate":"messages.dialogs","params":[{"name":"dialogs","type":"Vector<Dialog>"},{"name":"messages","type":"Vector<Message>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"messages.Dialogs"},{"id":"1910543603","predicate":"messages.dialogsSlice","params":[{"name":"count","type":"int"},{"name":"dialogs","type":"Vector<Dialog>"},{"name":"messages","type":"Vector<Message>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"messages.Dialogs"},{"id":"-1938715001","predicate":"messages.messages","params":[{"name":"messages","type":"Vector<Message>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"messages.Messages"},{"id":"-923939298","predicate":"messages.messagesSlice","params":[{"name":"flags","type":"#"},{"name":"inexact","type":"flags.1?true"},{"name":"count","type":"int"},{"name":"next_rate","type":"flags.0?int"},{"name":"messages","type":"Vector<Message>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"messages.Messages"},{"id":"1694474197","predicate":"messages.chats","params":[{"name":"chats","type":"Vector<Chat>"}],"type":"messages.Chats"},{"id":"-438840932","predicate":"messages.chatFull","params":[{"name":"full_chat","type":"ChatFull"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"messages.ChatFull"},{"id":"-1269012015","predicate":"messages.affectedHistory","params":[{"name":"pts","type":"int"},{"name":"pts_count","type":"int"},{"name":"offset","type":"int"}],"type":"messages.AffectedHistory"},{"id":"1474492012","predicate":"inputMessagesFilterEmpty","params":[],"type":"MessagesFilter"},{"id":"-1777752804","predicate":"inputMessagesFilterPhotos","params":[],"type":"MessagesFilter"},{"id":"-1614803355","predicate":"inputMessagesFilterVideo","params":[],"type":"MessagesFilter"},{"id":"1458172132","predicate":"inputMessagesFilterPhotoVideo","params":[],"type":"MessagesFilter"},{"id":"-1629621880","predicate":"inputMessagesFilterDocument","params":[],"type":"MessagesFilter"},{"id":"2129714567","predicate":"inputMessagesFilterUrl","params":[],"type":"MessagesFilter"},{"id":"-3644025","predicate":"inputMessagesFilterGif","params":[],"type":"MessagesFilter"},{"id":"522914557","predicate":"updateNewMessage","params":[{"name":"message","type":"Message"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"1318109142","predicate":"updateMessageID","params":[{"name":"id","type":"int"},{"name":"random_id","type":"long"}],"type":"Update"},{"id":"-1576161051","predicate":"updateDeleteMessages","params":[{"name":"messages","type":"Vector<int>"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"1548249383","predicate":"updateUserTyping","params":[{"name":"user_id","type":"int"},{"name":"action","type":"SendMessageAction"}],"type":"Update"},{"id":"-1704596961","predicate":"updateChatUserTyping","params":[{"name":"chat_id","type":"int"},{"name":"user_id","type":"int"},{"name":"action","type":"SendMessageAction"}],"type":"Update"},{"id":"125178264","predicate":"updateChatParticipants","params":[{"name":"participants","type":"ChatParticipants"}],"type":"Update"},{"id":"469489699","predicate":"updateUserStatus","params":[{"name":"user_id","type":"int"},{"name":"status","type":"UserStatus"}],"type":"Update"},{"id":"-1489818765","predicate":"updateUserName","params":[{"name":"user_id","type":"int"},{"name":"first_name","type":"string"},{"name":"last_name","type":"string"},{"name":"username","type":"string"}],"type":"Update"},{"id":"-1791935732","predicate":"updateUserPhoto","params":[{"name":"user_id","type":"int"},{"name":"date","type":"int"},{"name":"photo","type":"UserProfilePhoto"},{"name":"previous","type":"Bool"}],"type":"Update"},{"id":"-1519637954","predicate":"updates.state","params":[{"name":"pts","type":"int"},{"name":"qts","type":"int"},{"name":"date","type":"int"},{"name":"seq","type":"int"},{"name":"unread_count","type":"int"}],"type":"updates.State"},{"id":"1567990072","predicate":"updates.differenceEmpty","params":[{"name":"date","type":"int"},{"name":"seq","type":"int"}],"type":"updates.Difference"},{"id":"16030880","predicate":"updates.difference","params":[{"name":"new_messages","type":"Vector<Message>"},{"name":"new_encrypted_messages","type":"Vector<EncryptedMessage>"},{"name":"other_updates","type":"Vector<Update>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"},{"name":"state","type":"updates.State"}],"type":"updates.Difference"},{"id":"-1459938943","predicate":"updates.differenceSlice","params":[{"name":"new_messages","type":"Vector<Message>"},{"name":"new_encrypted_messages","type":"Vector<EncryptedMessage>"},{"name":"other_updates","type":"Vector<Update>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"},{"name":"intermediate_state","type":"updates.State"}],"type":"updates.Difference"},{"id":"-484987010","predicate":"updatesTooLong","params":[],"type":"Updates"},{"id":"-1857044719","predicate":"updateShortMessage","params":[{"name":"flags","type":"#"},{"name":"out","type":"flags.1?true"},{"name":"mentioned","type":"flags.4?true"},{"name":"media_unread","type":"flags.5?true"},{"name":"silent","type":"flags.13?true"},{"name":"id","type":"int"},{"name":"user_id","type":"int"},{"name":"message","type":"string"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"},{"name":"date","type":"int"},{"name":"fwd_from","type":"flags.2?MessageFwdHeader"},{"name":"via_bot_id","type":"flags.11?int"},{"name":"reply_to_msg_id","type":"flags.3?int"},{"name":"entities","type":"flags.7?Vector<MessageEntity>"}],"type":"Updates"},{"id":"377562760","predicate":"updateShortChatMessage","params":[{"name":"flags","type":"#"},{"name":"out","type":"flags.1?true"},{"name":"mentioned","type":"flags.4?true"},{"name":"media_unread","type":"flags.5?true"},{"name":"silent","type":"flags.13?true"},{"name":"id","type":"int"},{"name":"from_id","type":"int"},{"name":"chat_id","type":"int"},{"name":"message","type":"string"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"},{"name":"date","type":"int"},{"name":"fwd_from","type":"flags.2?MessageFwdHeader"},{"name":"via_bot_id","type":"flags.11?int"},{"name":"reply_to_msg_id","type":"flags.3?int"},{"name":"entities","type":"flags.7?Vector<MessageEntity>"}],"type":"Updates"},{"id":"2027216577","predicate":"updateShort","params":[{"name":"update","type":"Update"},{"name":"date","type":"int"}],"type":"Updates"},{"id":"1918567619","predicate":"updatesCombined","params":[{"name":"updates","type":"Vector<Update>"},{"name":"users","type":"Vector<User>"},{"name":"chats","type":"Vector<Chat>"},{"name":"date","type":"int"},{"name":"seq_start","type":"int"},{"name":"seq","type":"int"}],"type":"Updates"},{"id":"1957577280","predicate":"updates","params":[{"name":"updates","type":"Vector<Update>"},{"name":"users","type":"Vector<User>"},{"name":"chats","type":"Vector<Chat>"},{"name":"date","type":"int"},{"name":"seq","type":"int"}],"type":"Updates"},{"id":"-1916114267","predicate":"photos.photos","params":[{"name":"photos","type":"Vector<Photo>"},{"name":"users","type":"Vector<User>"}],"type":"photos.Photos"},{"id":"352657236","predicate":"photos.photosSlice","params":[{"name":"count","type":"int"},{"name":"photos","type":"Vector<Photo>"},{"name":"users","type":"Vector<User>"}],"type":"photos.Photos"},{"id":"539045032","predicate":"photos.photo","params":[{"name":"photo","type":"Photo"},{"name":"users","type":"Vector<User>"}],"type":"photos.Photo"},{"id":"157948117","predicate":"upload.file","params":[{"name":"type","type":"storage.FileType"},{"name":"mtime","type":"int"},{"name":"bytes","type":"bytes"}],"type":"upload.File"},{"id":"414687501","predicate":"dcOption","params":[{"name":"flags","type":"#"},{"name":"ipv6","type":"flags.0?true"},{"name":"media_only","type":"flags.1?true"},{"name":"tcpo_only","type":"flags.2?true"},{"name":"cdn","type":"flags.3?true"},{"name":"static","type":"flags.4?true"},{"name":"id","type":"int"},{"name":"ip_address","type":"string"},{"name":"port","type":"int"},{"name":"secret","type":"flags.10?bytes"}],"type":"DcOption"},{"id":"856375399","predicate":"config","params":[{"name":"flags","type":"#"},{"name":"phonecalls_enabled","type":"flags.1?true"},{"name":"default_p2p_contacts","type":"flags.3?true"},{"name":"preload_featured_stickers","type":"flags.4?true"},{"name":"ignore_phone_entities","type":"flags.5?true"},{"name":"revoke_pm_inbox","type":"flags.6?true"},{"name":"blocked_mode","type":"flags.8?true"},{"name":"pfs_enabled","type":"flags.13?true"},{"name":"date","type":"int"},{"name":"expires","type":"int"},{"name":"test_mode","type":"Bool"},{"name":"this_dc","type":"int"},{"name":"dc_options","type":"Vector<DcOption>"},{"name":"dc_txt_domain_name","type":"string"},{"name":"chat_size_max","type":"int"},{"name":"megagroup_size_max","type":"int"},{"name":"forwarded_count_max","type":"int"},{"name":"online_update_period_ms","type":"int"},{"name":"offline_blur_timeout_ms","type":"int"},{"name":"offline_idle_timeout_ms","type":"int"},{"name":"online_cloud_timeout_ms","type":"int"},{"name":"notify_cloud_delay_ms","type":"int"},{"name":"notify_default_delay_ms","type":"int"},{"name":"push_chat_period_ms","type":"int"},{"name":"push_chat_limit","type":"int"},{"name":"saved_gifs_limit","type":"int"},{"name":"edit_time_limit","type":"int"},{"name":"revoke_time_limit","type":"int"},{"name":"revoke_pm_time_limit","type":"int"},{"name":"rating_e_decay","type":"int"},{"name":"stickers_recent_limit","type":"int"},{"name":"stickers_faved_limit","type":"int"},{"name":"channels_read_media_period","type":"int"},{"name":"tmp_sessions","type":"flags.0?int"},{"name":"pinned_dialogs_count_max","type":"int"},{"name":"pinned_infolder_count_max","type":"int"},{"name":"call_receive_timeout_ms","type":"int"},{"name":"call_ring_timeout_ms","type":"int"},{"name":"call_connect_timeout_ms","type":"int"},{"name":"call_packet_timeout_ms","type":"int"},{"name":"me_url_prefix","type":"string"},{"name":"autoupdate_url_prefix","type":"flags.7?string"},{"name":"gif_search_username","type":"flags.9?string"},{"name":"venue_search_username","type":"flags.10?string"},{"name":"img_search_username","type":"flags.11?string"},{"name":"static_maps_provider","type":"flags.12?string"},{"name":"caption_length_max","type":"int"},{"name":"message_length_max","type":"int"},{"name":"webfile_dc_id","type":"int"},{"name":"suggested_lang_code","type":"flags.2?string"},{"name":"lang_pack_version","type":"flags.2?int"},{"name":"base_lang_pack_version","type":"flags.2?int"}],"type":"Config"},{"id":"-1910892683","predicate":"nearestDc","params":[{"name":"country","type":"string"},{"name":"this_dc","type":"int"},{"name":"nearest_dc","type":"int"}],"type":"NearestDc"},{"id":"497489295","predicate":"help.appUpdate","params":[{"name":"flags","type":"#"},{"name":"can_not_skip","type":"flags.0?true"},{"name":"id","type":"int"},{"name":"version","type":"string"},{"name":"text","type":"string"},{"name":"entities","type":"Vector<MessageEntity>"},{"name":"document","type":"flags.1?Document"},{"name":"url","type":"flags.2?string"}],"type":"help.AppUpdate"},{"id":"-1000708810","predicate":"help.noAppUpdate","params":[],"type":"help.AppUpdate"},{"id":"415997816","predicate":"help.inviteText","params":[{"name":"message","type":"string"}],"type":"help.InviteText"},{"id":"314359194","predicate":"updateNewEncryptedMessage","params":[{"name":"message","type":"EncryptedMessage"},{"name":"qts","type":"int"}],"type":"Update"},{"id":"386986326","predicate":"updateEncryptedChatTyping","params":[{"name":"chat_id","type":"int"}],"type":"Update"},{"id":"-1264392051","predicate":"updateEncryption","params":[{"name":"chat","type":"EncryptedChat"},{"name":"date","type":"int"}],"type":"Update"},{"id":"956179895","predicate":"updateEncryptedMessagesRead","params":[{"name":"chat_id","type":"int"},{"name":"max_date","type":"int"},{"name":"date","type":"int"}],"type":"Update"},{"id":"-1417756512","predicate":"encryptedChatEmpty","params":[{"name":"id","type":"int"}],"type":"EncryptedChat"},{"id":"1006044124","predicate":"encryptedChatWaiting","params":[{"name":"id","type":"int"},{"name":"access_hash","type":"long"},{"name":"date","type":"int"},{"name":"admin_id","type":"int"},{"name":"participant_id","type":"int"}],"type":"EncryptedChat"},{"id":"-931638658","predicate":"encryptedChatRequested","params":[{"name":"id","type":"int"},{"name":"access_hash","type":"long"},{"name":"date","type":"int"},{"name":"admin_id","type":"int"},{"name":"participant_id","type":"int"},{"name":"g_a","type":"bytes"}],"type":"EncryptedChat"},{"id":"-94974410","predicate":"encryptedChat","params":[{"name":"id","type":"int"},{"name":"access_hash","type":"long"},{"name":"date","type":"int"},{"name":"admin_id","type":"int"},{"name":"participant_id","type":"int"},{"name":"g_a_or_b","type":"bytes"},{"name":"key_fingerprint","type":"long"}],"type":"EncryptedChat"},{"id":"332848423","predicate":"encryptedChatDiscarded","params":[{"name":"id","type":"int"}],"type":"EncryptedChat"},{"id":"-247351839","predicate":"inputEncryptedChat","params":[{"name":"chat_id","type":"int"},{"name":"access_hash","type":"long"}],"type":"InputEncryptedChat"},{"id":"-1038136962","predicate":"encryptedFileEmpty","params":[],"type":"EncryptedFile"},{"id":"1248893260","predicate":"encryptedFile","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"size","type":"int"},{"name":"dc_id","type":"int"},{"name":"key_fingerprint","type":"int"}],"type":"EncryptedFile"},{"id":"406307684","predicate":"inputEncryptedFileEmpty","params":[],"type":"InputEncryptedFile"},{"id":"1690108678","predicate":"inputEncryptedFileUploaded","params":[{"name":"id","type":"long"},{"name":"parts","type":"int"},{"name":"md5_checksum","type":"string"},{"name":"key_fingerprint","type":"int"}],"type":"InputEncryptedFile"},{"id":"1511503333","predicate":"inputEncryptedFile","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"}],"type":"InputEncryptedFile"},{"id":"-182231723","predicate":"inputEncryptedFileLocation","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"}],"type":"InputFileLocation"},{"id":"-317144808","predicate":"encryptedMessage","params":[{"name":"random_id","type":"long"},{"name":"chat_id","type":"int"},{"name":"date","type":"int"},{"name":"bytes","type":"bytes"},{"name":"file","type":"EncryptedFile"}],"type":"EncryptedMessage"},{"id":"594758406","predicate":"encryptedMessageService","params":[{"name":"random_id","type":"long"},{"name":"chat_id","type":"int"},{"name":"date","type":"int"},{"name":"bytes","type":"bytes"}],"type":"EncryptedMessage"},{"id":"-1058912715","predicate":"messages.dhConfigNotModified","params":[{"name":"random","type":"bytes"}],"type":"messages.DhConfig"},{"id":"740433629","predicate":"messages.dhConfig","params":[{"name":"g","type":"int"},{"name":"p","type":"bytes"},{"name":"version","type":"int"},{"name":"random","type":"bytes"}],"type":"messages.DhConfig"},{"id":"1443858741","predicate":"messages.sentEncryptedMessage","params":[{"name":"date","type":"int"}],"type":"messages.SentEncryptedMessage"},{"id":"-1802240206","predicate":"messages.sentEncryptedFile","params":[{"name":"date","type":"int"},{"name":"file","type":"EncryptedFile"}],"type":"messages.SentEncryptedMessage"},{"id":"-95482955","predicate":"inputFileBig","params":[{"name":"id","type":"long"},{"name":"parts","type":"int"},{"name":"name","type":"string"}],"type":"InputFile"},{"id":"767652808","predicate":"inputEncryptedFileBigUploaded","params":[{"name":"id","type":"long"},{"name":"parts","type":"int"},{"name":"key_fingerprint","type":"int"}],"type":"InputEncryptedFile"},{"id":"-364179876","predicate":"updateChatParticipantAdd","params":[{"name":"chat_id","type":"int"},{"name":"user_id","type":"int"},{"name":"inviter_id","type":"int"},{"name":"date","type":"int"},{"name":"version","type":"int"}],"type":"Update"},{"id":"1851755554","predicate":"updateChatParticipantDelete","params":[{"name":"chat_id","type":"int"},{"name":"user_id","type":"int"},{"name":"version","type":"int"}],"type":"Update"},{"id":"-1906403213","predicate":"updateDcOptions","params":[{"name":"dc_options","type":"Vector<DcOption>"}],"type":"Update"},{"id":"1530447553","predicate":"inputMediaUploadedDocument","params":[{"name":"flags","type":"#"},{"name":"nosound_video","type":"flags.3?true"},{"name":"file","type":"InputFile"},{"name":"thumb","type":"flags.2?InputFile"},{"name":"mime_type","type":"string"},{"name":"attributes","type":"Vector<DocumentAttribute>"},{"name":"stickers","type":"flags.0?Vector<InputDocument>"},{"name":"ttl_seconds","type":"flags.1?int"}],"type":"InputMedia"},{"id":"598418386","predicate":"inputMediaDocument","params":[{"name":"flags","type":"#"},{"name":"id","type":"InputDocument"},{"name":"ttl_seconds","type":"flags.0?int"}],"type":"InputMedia"},{"id":"-1666158377","predicate":"messageMediaDocument","params":[{"name":"flags","type":"#"},{"name":"document","type":"flags.0?Document"},{"name":"ttl_seconds","type":"flags.2?int"}],"type":"MessageMedia"},{"id":"1928391342","predicate":"inputDocumentEmpty","params":[],"type":"InputDocument"},{"id":"448771445","predicate":"inputDocument","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"file_reference","type":"bytes"}],"type":"InputDocument"},{"id":"-1160743548","predicate":"inputDocumentFileLocation","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"file_reference","type":"bytes"},{"name":"thumb_size","type":"string"}],"type":"InputFileLocation"},{"id":"922273905","predicate":"documentEmpty","params":[{"name":"id","type":"long"}],"type":"Document"},{"id":"-1683841855","predicate":"document","params":[{"name":"flags","type":"#"},{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"file_reference","type":"bytes"},{"name":"date","type":"int"},{"name":"mime_type","type":"string"},{"name":"size","type":"int"},{"name":"thumbs","type":"flags.0?Vector<PhotoSize>"},{"name":"dc_id","type":"int"},{"name":"attributes","type":"Vector<DocumentAttribute>"}],"type":"Document"},{"id":"398898678","predicate":"help.support","params":[{"name":"phone_number","type":"string"},{"name":"user","type":"User"}],"type":"help.Support"},{"id":"-1613493288","predicate":"notifyPeer","params":[{"name":"peer","type":"Peer"}],"type":"NotifyPeer"},{"id":"-1261946036","predicate":"notifyUsers","params":[],"type":"NotifyPeer"},{"id":"-1073230141","predicate":"notifyChats","params":[],"type":"NotifyPeer"},{"id":"-2131957734","predicate":"updateUserBlocked","params":[{"name":"user_id","type":"int"},{"name":"blocked","type":"Bool"}],"type":"Update"},{"id":"-1094555409","predicate":"updateNotifySettings","params":[{"name":"peer","type":"NotifyPeer"},{"name":"notify_settings","type":"PeerNotifySettings"}],"type":"Update"},{"id":"381645902","predicate":"sendMessageTypingAction","params":[],"type":"SendMessageAction"},{"id":"-44119819","predicate":"sendMessageCancelAction","params":[],"type":"SendMessageAction"},{"id":"-1584933265","predicate":"sendMessageRecordVideoAction","params":[],"type":"SendMessageAction"},{"id":"-378127636","predicate":"sendMessageUploadVideoAction","params":[{"name":"progress","type":"int"}],"type":"SendMessageAction"},{"id":"-718310409","predicate":"sendMessageRecordAudioAction","params":[],"type":"SendMessageAction"},{"id":"-212740181","predicate":"sendMessageUploadAudioAction","params":[{"name":"progress","type":"int"}],"type":"SendMessageAction"},{"id":"-774682074","predicate":"sendMessageUploadPhotoAction","params":[{"name":"progress","type":"int"}],"type":"SendMessageAction"},{"id":"-1441998364","predicate":"sendMessageUploadDocumentAction","params":[{"name":"progress","type":"int"}],"type":"SendMessageAction"},{"id":"393186209","predicate":"sendMessageGeoLocationAction","params":[],"type":"SendMessageAction"},{"id":"1653390447","predicate":"sendMessageChooseContactAction","params":[],"type":"SendMessageAction"},{"id":"-1290580579","predicate":"contacts.found","params":[{"name":"my_results","type":"Vector<Peer>"},{"name":"results","type":"Vector<Peer>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"contacts.Found"},{"id":"-337352679","predicate":"updateServiceNotification","params":[{"name":"flags","type":"#"},{"name":"popup","type":"flags.0?true"},{"name":"inbox_date","type":"flags.1?int"},{"name":"type","type":"string"},{"name":"message","type":"string"},{"name":"media","type":"MessageMedia"},{"name":"entities","type":"Vector<MessageEntity>"}],"type":"Update"},{"id":"-496024847","predicate":"userStatusRecently","params":[],"type":"UserStatus"},{"id":"129960444","predicate":"userStatusLastWeek","params":[],"type":"UserStatus"},{"id":"2011940674","predicate":"userStatusLastMonth","params":[],"type":"UserStatus"},{"id":"-298113238","predicate":"updatePrivacy","params":[{"name":"key","type":"PrivacyKey"},{"name":"rules","type":"Vector<PrivacyRule>"}],"type":"Update"},{"id":"1335282456","predicate":"inputPrivacyKeyStatusTimestamp","params":[],"type":"InputPrivacyKey"},{"id":"-1137792208","predicate":"privacyKeyStatusTimestamp","params":[],"type":"PrivacyKey"},{"id":"218751099","predicate":"inputPrivacyValueAllowContacts","params":[],"type":"InputPrivacyRule"},{"id":"407582158","predicate":"inputPrivacyValueAllowAll","params":[],"type":"InputPrivacyRule"},{"id":"320652927","predicate":"inputPrivacyValueAllowUsers","params":[{"name":"users","type":"Vector<InputUser>"}],"type":"InputPrivacyRule"},{"id":"195371015","predicate":"inputPrivacyValueDisallowContacts","params":[],"type":"InputPrivacyRule"},{"id":"-697604407","predicate":"inputPrivacyValueDisallowAll","params":[],"type":"InputPrivacyRule"},{"id":"-1877932953","predicate":"inputPrivacyValueDisallowUsers","params":[{"name":"users","type":"Vector<InputUser>"}],"type":"InputPrivacyRule"},{"id":"-123988","predicate":"privacyValueAllowContacts","params":[],"type":"PrivacyRule"},{"id":"1698855810","predicate":"privacyValueAllowAll","params":[],"type":"PrivacyRule"},{"id":"1297858060","predicate":"privacyValueAllowUsers","params":[{"name":"users","type":"Vector<int>"}],"type":"PrivacyRule"},{"id":"-125240806","predicate":"privacyValueDisallowContacts","params":[],"type":"PrivacyRule"},{"id":"-1955338397","predicate":"privacyValueDisallowAll","params":[],"type":"PrivacyRule"},{"id":"209668535","predicate":"privacyValueDisallowUsers","params":[{"name":"users","type":"Vector<int>"}],"type":"PrivacyRule"},{"id":"1352683077","predicate":"account.privacyRules","params":[{"name":"rules","type":"Vector<PrivacyRule>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"account.PrivacyRules"},{"id":"-1194283041","predicate":"accountDaysTTL","params":[{"name":"days","type":"int"}],"type":"AccountDaysTTL"},{"id":"314130811","predicate":"updateUserPhone","params":[{"name":"user_id","type":"int"},{"name":"phone","type":"string"}],"type":"Update"},{"id":"1815593308","predicate":"documentAttributeImageSize","params":[{"name":"w","type":"int"},{"name":"h","type":"int"}],"type":"DocumentAttribute"},{"id":"297109817","predicate":"documentAttributeAnimated","params":[],"type":"DocumentAttribute"},{"id":"1662637586","predicate":"documentAttributeSticker","params":[{"name":"flags","type":"#"},{"name":"mask","type":"flags.1?true"},{"name":"alt","type":"string"},{"name":"stickerset","type":"InputStickerSet"},{"name":"mask_coords","type":"flags.0?MaskCoords"}],"type":"DocumentAttribute"},{"id":"250621158","predicate":"documentAttributeVideo","params":[{"name":"flags","type":"#"},{"name":"round_message","type":"flags.0?true"},{"name":"supports_streaming","type":"flags.1?true"},{"name":"duration","type":"int"},{"name":"w","type":"int"},{"name":"h","type":"int"}],"type":"DocumentAttribute"},{"id":"-1739392570","predicate":"documentAttributeAudio","params":[{"name":"flags","type":"#"},{"name":"voice","type":"flags.10?true"},{"name":"duration","type":"int"},{"name":"title","type":"flags.0?string"},{"name":"performer","type":"flags.1?string"},{"name":"waveform","type":"flags.2?bytes"}],"type":"DocumentAttribute"},{"id":"358154344","predicate":"documentAttributeFilename","params":[{"name":"file_name","type":"string"}],"type":"DocumentAttribute"},{"id":"-244016606","predicate":"messages.stickersNotModified","params":[],"type":"messages.Stickers"},{"id":"-463889475","predicate":"messages.stickers","params":[{"name":"hash","type":"int"},{"name":"stickers","type":"Vector<Document>"}],"type":"messages.Stickers"},{"id":"313694676","predicate":"stickerPack","params":[{"name":"emoticon","type":"string"},{"name":"documents","type":"Vector<long>"}],"type":"StickerPack"},{"id":"-395967805","predicate":"messages.allStickersNotModified","params":[],"type":"messages.AllStickers"},{"id":"-302170017","predicate":"messages.allStickers","params":[{"name":"hash","type":"int"},{"name":"sets","type":"Vector<StickerSet>"}],"type":"messages.AllStickers"},{"id":"-1667805217","predicate":"updateReadHistoryInbox","params":[{"name":"flags","type":"#"},{"name":"folder_id","type":"flags.0?int"},{"name":"peer","type":"Peer"},{"name":"max_id","type":"int"},{"name":"still_unread_count","type":"int"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"791617983","predicate":"updateReadHistoryOutbox","params":[{"name":"peer","type":"Peer"},{"name":"max_id","type":"int"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"-2066640507","predicate":"messages.affectedMessages","params":[{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"messages.AffectedMessages"},{"id":"2139689491","predicate":"updateWebPage","params":[{"name":"webpage","type":"WebPage"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"-350980120","predicate":"webPageEmpty","params":[{"name":"id","type":"long"}],"type":"WebPage"},{"id":"-981018084","predicate":"webPagePending","params":[{"name":"id","type":"long"},{"name":"date","type":"int"}],"type":"WebPage"},{"id":"-94051982","predicate":"webPage","params":[{"name":"flags","type":"#"},{"name":"id","type":"long"},{"name":"url","type":"string"},{"name":"display_url","type":"string"},{"name":"hash","type":"int"},{"name":"type","type":"flags.0?string"},{"name":"site_name","type":"flags.1?string"},{"name":"title","type":"flags.2?string"},{"name":"description","type":"flags.3?string"},{"name":"photo","type":"flags.4?Photo"},{"name":"embed_url","type":"flags.5?string"},{"name":"embed_type","type":"flags.5?string"},{"name":"embed_width","type":"flags.6?int"},{"name":"embed_height","type":"flags.6?int"},{"name":"duration","type":"flags.7?int"},{"name":"author","type":"flags.8?string"},{"name":"document","type":"flags.9?Document"},{"name":"documents","type":"flags.11?Vector<Document>"},{"name":"cached_page","type":"flags.10?Page"}],"type":"WebPage"},{"id":"-1557277184","predicate":"messageMediaWebPage","params":[{"name":"webpage","type":"WebPage"}],"type":"MessageMedia"},{"id":"-1392388579","predicate":"authorization","params":[{"name":"flags","type":"#"},{"name":"current","type":"flags.0?true"},{"name":"official_app","type":"flags.1?true"},{"name":"password_pending","type":"flags.2?true"},{"name":"hash","type":"long"},{"name":"device_model","type":"string"},{"name":"platform","type":"string"},{"name":"system_version","type":"string"},{"name":"api_id","type":"int"},{"name":"app_name","type":"string"},{"name":"app_version","type":"string"},{"name":"date_created","type":"int"},{"name":"date_active","type":"int"},{"name":"ip","type":"string"},{"name":"country","type":"string"},{"name":"region","type":"string"}],"type":"Authorization"},{"id":"307276766","predicate":"account.authorizations","params":[{"name":"authorizations","type":"Vector<Authorization>"}],"type":"account.Authorizations"},{"id":"-1390001672","predicate":"account.password","params":[{"name":"flags","type":"#"},{"name":"has_recovery","type":"flags.0?true"},{"name":"has_secure_values","type":"flags.1?true"},{"name":"has_password","type":"flags.2?true"},{"name":"current_algo","type":"flags.2?PasswordKdfAlgo"},{"name":"srp_B","type":"flags.2?bytes"},{"name":"srp_id","type":"flags.2?long"},{"name":"hint","type":"flags.3?string"},{"name":"email_unconfirmed_pattern","type":"flags.4?string"},{"name":"new_algo","type":"PasswordKdfAlgo"},{"name":"new_secure_algo","type":"SecurePasswordKdfAlgo"},{"name":"secure_random","type":"bytes"}],"type":"account.Password"},{"id":"-1705233435","predicate":"account.passwordSettings","params":[{"name":"flags","type":"#"},{"name":"email","type":"flags.0?string"},{"name":"secure_settings","type":"flags.1?SecureSecretSettings"}],"type":"account.PasswordSettings"},{"id":"-1036572727","predicate":"account.passwordInputSettings","params":[{"name":"flags","type":"#"},{"name":"new_algo","type":"flags.0?PasswordKdfAlgo"},{"name":"new_password_hash","type":"flags.0?bytes"},{"name":"hint","type":"flags.0?string"},{"name":"email","type":"flags.1?string"},{"name":"new_secure_settings","type":"flags.2?SecureSecretSettings"}],"type":"account.PasswordInputSettings"},{"id":"326715557","predicate":"auth.passwordRecovery","params":[{"name":"email_pattern","type":"string"}],"type":"auth.PasswordRecovery"},{"id":"-1052959727","predicate":"inputMediaVenue","params":[{"name":"geo_point","type":"InputGeoPoint"},{"name":"title","type":"string"},{"name":"address","type":"string"},{"name":"provider","type":"string"},{"name":"venue_id","type":"string"},{"name":"venue_type","type":"string"}],"type":"InputMedia"},{"id":"784356159","predicate":"messageMediaVenue","params":[{"name":"geo","type":"GeoPoint"},{"name":"title","type":"string"},{"name":"address","type":"string"},{"name":"provider","type":"string"},{"name":"venue_id","type":"string"},{"name":"venue_type","type":"string"}],"type":"MessageMedia"},{"id":"-1551583367","predicate":"receivedNotifyMessage","params":[{"name":"id","type":"int"},{"name":"flags","type":"int"}],"type":"ReceivedNotifyMessage"},{"id":"1776236393","predicate":"chatInviteEmpty","params":[],"type":"ExportedChatInvite"},{"id":"-64092740","predicate":"chatInviteExported","params":[{"name":"link","type":"string"}],"type":"ExportedChatInvite"},{"id":"1516793212","predicate":"chatInviteAlready","params":[{"name":"chat","type":"Chat"}],"type":"ChatInvite"},{"id":"-540871282","predicate":"chatInvite","params":[{"name":"flags","type":"#"},{"name":"channel","type":"flags.0?true"},{"name":"broadcast","type":"flags.1?true"},{"name":"public","type":"flags.2?true"},{"name":"megagroup","type":"flags.3?true"},{"name":"title","type":"string"},{"name":"photo","type":"Photo"},{"name":"participants_count","type":"int"},{"name":"participants","type":"flags.4?Vector<User>"}],"type":"ChatInvite"},{"id":"-123931160","predicate":"messageActionChatJoinedByLink","params":[{"name":"inviter_id","type":"int"}],"type":"MessageAction"},{"id":"1757493555","predicate":"updateReadMessagesContents","params":[{"name":"messages","type":"Vector<int>"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"-4838507","predicate":"inputStickerSetEmpty","params":[],"type":"InputStickerSet"},{"id":"-1645763991","predicate":"inputStickerSetID","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"}],"type":"InputStickerSet"},{"id":"-2044933984","predicate":"inputStickerSetShortName","params":[{"name":"short_name","type":"string"}],"type":"InputStickerSet"},{"id":"-290164953","predicate":"stickerSet","params":[{"name":"flags","type":"#"},{"name":"archived","type":"flags.1?true"},{"name":"official","type":"flags.2?true"},{"name":"masks","type":"flags.3?true"},{"name":"animated","type":"flags.5?true"},{"name":"installed_date","type":"flags.0?int"},{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"title","type":"string"},{"name":"short_name","type":"string"},{"name":"thumb","type":"flags.4?PhotoSize"},{"name":"thumb_dc_id","type":"flags.4?int"},{"name":"count","type":"int"},{"name":"hash","type":"int"}],"type":"StickerSet"},{"id":"-1240849242","predicate":"messages.stickerSet","params":[{"name":"set","type":"StickerSet"},{"name":"packs","type":"Vector<StickerPack>"},{"name":"documents","type":"Vector<Document>"}],"type":"messages.StickerSet"},{"id":"-1820043071","predicate":"user","params":[{"name":"flags","type":"#"},{"name":"self","type":"flags.10?true"},{"name":"contact","type":"flags.11?true"},{"name":"mutual_contact","type":"flags.12?true"},{"name":"deleted","type":"flags.13?true"},{"name":"bot","type":"flags.14?true"},{"name":"bot_chat_history","type":"flags.15?true"},{"name":"bot_nochats","type":"flags.16?true"},{"name":"verified","type":"flags.17?true"},{"name":"restricted","type":"flags.18?true"},{"name":"min","type":"flags.20?true"},{"name":"bot_inline_geo","type":"flags.21?true"},{"name":"support","type":"flags.23?true"},{"name":"scam","type":"flags.24?true"},{"name":"id","type":"int"},{"name":"access_hash","type":"flags.0?long"},{"name":"first_name","type":"flags.1?string"},{"name":"last_name","type":"flags.2?string"},{"name":"username","type":"flags.3?string"},{"name":"phone","type":"flags.4?string"},{"name":"photo","type":"flags.5?UserProfilePhoto"},{"name":"status","type":"flags.6?UserStatus"},{"name":"bot_info_version","type":"flags.14?int"},{"name":"restriction_reason","type":"flags.18?Vector<RestrictionReason>"},{"name":"bot_inline_placeholder","type":"flags.19?string"},{"name":"lang_code","type":"flags.22?string"}],"type":"User"},{"id":"-1032140601","predicate":"botCommand","params":[{"name":"command","type":"string"},{"name":"description","type":"string"}],"type":"BotCommand"},{"id":"-1729618630","predicate":"botInfo","params":[{"name":"user_id","type":"int"},{"name":"description","type":"string"},{"name":"commands","type":"Vector<BotCommand>"}],"type":"BotInfo"},{"id":"-1560655744","predicate":"keyboardButton","params":[{"name":"text","type":"string"}],"type":"KeyboardButton"},{"id":"2002815875","predicate":"keyboardButtonRow","params":[{"name":"buttons","type":"Vector<KeyboardButton>"}],"type":"KeyboardButtonRow"},{"id":"-1606526075","predicate":"replyKeyboardHide","params":[{"name":"flags","type":"#"},{"name":"selective","type":"flags.2?true"}],"type":"ReplyMarkup"},{"id":"-200242528","predicate":"replyKeyboardForceReply","params":[{"name":"flags","type":"#"},{"name":"single_use","type":"flags.1?true"},{"name":"selective","type":"flags.2?true"}],"type":"ReplyMarkup"},{"id":"889353612","predicate":"replyKeyboardMarkup","params":[{"name":"flags","type":"#"},{"name":"resize","type":"flags.0?true"},{"name":"single_use","type":"flags.1?true"},{"name":"selective","type":"flags.2?true"},{"name":"rows","type":"Vector<KeyboardButtonRow>"}],"type":"ReplyMarkup"},{"id":"2072935910","predicate":"inputPeerUser","params":[{"name":"user_id","type":"int"},{"name":"access_hash","type":"long"}],"type":"InputPeer"},{"id":"-668391402","predicate":"inputUser","params":[{"name":"user_id","type":"int"},{"name":"access_hash","type":"long"}],"type":"InputUser"},{"id":"-1148011883","predicate":"messageEntityUnknown","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"-100378723","predicate":"messageEntityMention","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"1868782349","predicate":"messageEntityHashtag","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"1827637959","predicate":"messageEntityBotCommand","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"1859134776","predicate":"messageEntityUrl","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"1692693954","predicate":"messageEntityEmail","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"-1117713463","predicate":"messageEntityBold","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"-2106619040","predicate":"messageEntityItalic","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"681706865","predicate":"messageEntityCode","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"1938967520","predicate":"messageEntityPre","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"},{"name":"language","type":"string"}],"type":"MessageEntity"},{"id":"1990644519","predicate":"messageEntityTextUrl","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"},{"name":"url","type":"string"}],"type":"MessageEntity"},{"id":"301019932","predicate":"updateShortSentMessage","params":[{"name":"flags","type":"#"},{"name":"out","type":"flags.1?true"},{"name":"id","type":"int"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"},{"name":"date","type":"int"},{"name":"media","type":"flags.9?MessageMedia"},{"name":"entities","type":"flags.7?Vector<MessageEntity>"}],"type":"Updates"},{"id":"-292807034","predicate":"inputChannelEmpty","params":[],"type":"InputChannel"},{"id":"-1343524562","predicate":"inputChannel","params":[{"name":"channel_id","type":"int"},{"name":"access_hash","type":"long"}],"type":"InputChannel"},{"id":"-1109531342","predicate":"peerChannel","params":[{"name":"channel_id","type":"int"}],"type":"Peer"},{"id":"548253432","predicate":"inputPeerChannel","params":[{"name":"channel_id","type":"int"},{"name":"access_hash","type":"long"}],"type":"InputPeer"},{"id":"-753232354","predicate":"channel","params":[{"name":"flags","type":"#"},{"name":"creator","type":"flags.0?true"},{"name":"left","type":"flags.2?true"},{"name":"broadcast","type":"flags.5?true"},{"name":"verified","type":"flags.7?true"},{"name":"megagroup","type":"flags.8?true"},{"name":"restricted","type":"flags.9?true"},{"name":"signatures","type":"flags.11?true"},{"name":"min","type":"flags.12?true"},{"name":"scam","type":"flags.19?true"},{"name":"has_link","type":"flags.20?true"},{"name":"has_geo","type":"flags.21?true"},{"name":"slowmode_enabled","type":"flags.22?true"},{"name":"id","type":"int"},{"name":"access_hash","type":"flags.13?long"},{"name":"title","type":"string"},{"name":"username","type":"flags.6?string"},{"name":"photo","type":"ChatPhoto"},{"name":"date","type":"int"},{"name":"version","type":"int"},{"name":"restriction_reason","type":"flags.9?Vector<RestrictionReason>"},{"name":"admin_rights","type":"flags.14?ChatAdminRights"},{"name":"banned_rights","type":"flags.15?ChatBannedRights"},{"name":"default_banned_rights","type":"flags.18?ChatBannedRights"},{"name":"participants_count","type":"flags.17?int"}],"type":"Chat"},{"id":"681420594","predicate":"channelForbidden","params":[{"name":"flags","type":"#"},{"name":"broadcast","type":"flags.5?true"},{"name":"megagroup","type":"flags.8?true"},{"name":"id","type":"int"},{"name":"access_hash","type":"long"},{"name":"title","type":"string"},{"name":"until_date","type":"flags.16?int"}],"type":"Chat"},{"id":"2131196633","predicate":"contacts.resolvedPeer","params":[{"name":"peer","type":"Peer"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"contacts.ResolvedPeer"},{"id":"763976820","predicate":"channelFull","params":[{"name":"flags","type":"#"},{"name":"can_view_participants","type":"flags.3?true"},{"name":"can_set_username","type":"flags.6?true"},{"name":"can_set_stickers","type":"flags.7?true"},{"name":"hidden_prehistory","type":"flags.10?true"},{"name":"can_view_stats","type":"flags.12?true"},{"name":"can_set_location","type":"flags.16?true"},{"name":"has_scheduled","type":"flags.19?true"},{"name":"id","type":"int"},{"name":"about","type":"string"},{"name":"participants_count","type":"flags.0?int"},{"name":"admins_count","type":"flags.1?int"},{"name":"kicked_count","type":"flags.2?int"},{"name":"banned_count","type":"flags.2?int"},{"name":"online_count","type":"flags.13?int"},{"name":"read_inbox_max_id","type":"int"},{"name":"read_outbox_max_id","type":"int"},{"name":"unread_count","type":"int"},{"name":"chat_photo","type":"Photo"},{"name":"notify_settings","type":"PeerNotifySettings"},{"name":"exported_invite","type":"ExportedChatInvite"},{"name":"bot_info","type":"Vector<BotInfo>"},{"name":"migrated_from_chat_id","type":"flags.4?int"},{"name":"migrated_from_max_id","type":"flags.4?int"},{"name":"pinned_msg_id","type":"flags.5?int"},{"name":"stickerset","type":"flags.8?StickerSet"},{"name":"available_min_id","type":"flags.9?int"},{"name":"folder_id","type":"flags.11?int"},{"name":"linked_chat_id","type":"flags.14?int"},{"name":"location","type":"flags.15?ChannelLocation"},{"name":"slowmode_seconds","type":"flags.17?int"},{"name":"slowmode_next_send_date","type":"flags.18?int"},{"name":"pts","type":"int"}],"type":"ChatFull"},{"id":"182649427","predicate":"messageRange","params":[{"name":"min_id","type":"int"},{"name":"max_id","type":"int"}],"type":"MessageRange"},{"id":"-1725551049","predicate":"messages.channelMessages","params":[{"name":"flags","type":"#"},{"name":"inexact","type":"flags.1?true"},{"name":"pts","type":"int"},{"name":"count","type":"int"},{"name":"messages","type":"Vector<Message>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"messages.Messages"},{"id":"-1781355374","predicate":"messageActionChannelCreate","params":[{"name":"title","type":"string"}],"type":"MessageAction"},{"id":"-352032773","predicate":"updateChannelTooLong","params":[{"name":"flags","type":"#"},{"name":"channel_id","type":"int"},{"name":"pts","type":"flags.0?int"}],"type":"Update"},{"id":"-1227598250","predicate":"updateChannel","params":[{"name":"channel_id","type":"int"}],"type":"Update"},{"id":"1656358105","predicate":"updateNewChannelMessage","params":[{"name":"message","type":"Message"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"856380452","predicate":"updateReadChannelInbox","params":[{"name":"flags","type":"#"},{"name":"folder_id","type":"flags.0?int"},{"name":"channel_id","type":"int"},{"name":"max_id","type":"int"},{"name":"still_unread_count","type":"int"},{"name":"pts","type":"int"}],"type":"Update"},{"id":"-1015733815","predicate":"updateDeleteChannelMessages","params":[{"name":"channel_id","type":"int"},{"name":"messages","type":"Vector<int>"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"-1734268085","predicate":"updateChannelMessageViews","params":[{"name":"channel_id","type":"int"},{"name":"id","type":"int"},{"name":"views","type":"int"}],"type":"Update"},{"id":"1041346555","predicate":"updates.channelDifferenceEmpty","params":[{"name":"flags","type":"#"},{"name":"final","type":"flags.0?true"},{"name":"pts","type":"int"},{"name":"timeout","type":"flags.1?int"}],"type":"updates.ChannelDifference"},{"id":"-1531132162","predicate":"updates.channelDifferenceTooLong","params":[{"name":"flags","type":"#"},{"name":"final","type":"flags.0?true"},{"name":"timeout","type":"flags.1?int"},{"name":"dialog","type":"Dialog"},{"name":"messages","type":"Vector<Message>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"updates.ChannelDifference"},{"id":"543450958","predicate":"updates.channelDifference","params":[{"name":"flags","type":"#"},{"name":"final","type":"flags.0?true"},{"name":"pts","type":"int"},{"name":"timeout","type":"flags.1?int"},{"name":"new_messages","type":"Vector<Message>"},{"name":"other_updates","type":"Vector<Update>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"updates.ChannelDifference"},{"id":"-1798033689","predicate":"channelMessagesFilterEmpty","params":[],"type":"ChannelMessagesFilter"},{"id":"-847783593","predicate":"channelMessagesFilter","params":[{"name":"flags","type":"#"},{"name":"exclude_new_messages","type":"flags.1?true"},{"name":"ranges","type":"Vector<MessageRange>"}],"type":"ChannelMessagesFilter"},{"id":"367766557","predicate":"channelParticipant","params":[{"name":"user_id","type":"int"},{"name":"date","type":"int"}],"type":"ChannelParticipant"},{"id":"-1557620115","predicate":"channelParticipantSelf","params":[{"name":"user_id","type":"int"},{"name":"inviter_id","type":"int"},{"name":"date","type":"int"}],"type":"ChannelParticipant"},{"id":"-2138237532","predicate":"channelParticipantCreator","params":[{"name":"flags","type":"#"},{"name":"user_id","type":"int"},{"name":"rank","type":"flags.0?string"}],"type":"ChannelParticipant"},{"id":"-566281095","predicate":"channelParticipantsRecent","params":[],"type":"ChannelParticipantsFilter"},{"id":"-1268741783","predicate":"channelParticipantsAdmins","params":[],"type":"ChannelParticipantsFilter"},{"id":"-1548400251","predicate":"channelParticipantsKicked","params":[{"name":"q","type":"string"}],"type":"ChannelParticipantsFilter"},{"id":"-177282392","predicate":"channels.channelParticipants","params":[{"name":"count","type":"int"},{"name":"participants","type":"Vector<ChannelParticipant>"},{"name":"users","type":"Vector<User>"}],"type":"channels.ChannelParticipants"},{"id":"-791039645","predicate":"channels.channelParticipant","params":[{"name":"participant","type":"ChannelParticipant"},{"name":"users","type":"Vector<User>"}],"type":"channels.ChannelParticipant"},{"id":"-636267638","predicate":"chatParticipantCreator","params":[{"name":"user_id","type":"int"}],"type":"ChatParticipant"},{"id":"-489233354","predicate":"chatParticipantAdmin","params":[{"name":"user_id","type":"int"},{"name":"inviter_id","type":"int"},{"name":"date","type":"int"}],"type":"ChatParticipant"},{"id":"-1232070311","predicate":"updateChatParticipantAdmin","params":[{"name":"chat_id","type":"int"},{"name":"user_id","type":"int"},{"name":"is_admin","type":"Bool"},{"name":"version","type":"int"}],"type":"Update"},{"id":"1371385889","predicate":"messageActionChatMigrateTo","params":[{"name":"channel_id","type":"int"}],"type":"MessageAction"},{"id":"-1336546578","predicate":"messageActionChannelMigrateFrom","params":[{"name":"title","type":"string"},{"name":"chat_id","type":"int"}],"type":"MessageAction"},{"id":"-1328445861","predicate":"channelParticipantsBots","params":[],"type":"ChannelParticipantsFilter"},{"id":"2013922064","predicate":"help.termsOfService","params":[{"name":"flags","type":"#"},{"name":"popup","type":"flags.0?true"},{"name":"id","type":"DataJSON"},{"name":"text","type":"string"},{"name":"entities","type":"Vector<MessageEntity>"},{"name":"min_age_confirm","type":"flags.1?int"}],"type":"help.TermsOfService"},{"id":"1753886890","predicate":"updateNewStickerSet","params":[{"name":"stickerset","type":"messages.StickerSet"}],"type":"Update"},{"id":"196268545","predicate":"updateStickerSetsOrder","params":[{"name":"flags","type":"#"},{"name":"masks","type":"flags.0?true"},{"name":"order","type":"Vector<long>"}],"type":"Update"},{"id":"1135492588","predicate":"updateStickerSets","params":[],"type":"Update"},{"id":"372165663","predicate":"foundGif","params":[{"name":"url","type":"string"},{"name":"thumb_url","type":"string"},{"name":"content_url","type":"string"},{"name":"content_type","type":"string"},{"name":"w","type":"int"},{"name":"h","type":"int"}],"type":"FoundGif"},{"id":"-1670052855","predicate":"foundGifCached","params":[{"name":"url","type":"string"},{"name":"photo","type":"Photo"},{"name":"document","type":"Document"}],"type":"FoundGif"},{"id":"1212395773","predicate":"inputMediaGifExternal","params":[{"name":"url","type":"string"},{"name":"q","type":"string"}],"type":"InputMedia"},{"id":"1158290442","predicate":"messages.foundGifs","params":[{"name":"next_offset","type":"int"},{"name":"results","type":"Vector<FoundGif>"}],"type":"messages.FoundGifs"},{"id":"-402498398","predicate":"messages.savedGifsNotModified","params":[],"type":"messages.SavedGifs"},{"id":"772213157","predicate":"messages.savedGifs","params":[{"name":"hash","type":"int"},{"name":"gifs","type":"Vector<Document>"}],"type":"messages.SavedGifs"},{"id":"-1821035490","predicate":"updateSavedGifs","params":[],"type":"Update"},{"id":"864077702","predicate":"inputBotInlineMessageMediaAuto","params":[{"name":"flags","type":"#"},{"name":"message","type":"string"},{"name":"entities","type":"flags.1?Vector<MessageEntity>"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"}],"type":"InputBotInlineMessage"},{"id":"1036876423","predicate":"inputBotInlineMessageText","params":[{"name":"flags","type":"#"},{"name":"no_webpage","type":"flags.0?true"},{"name":"message","type":"string"},{"name":"entities","type":"flags.1?Vector<MessageEntity>"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"}],"type":"InputBotInlineMessage"},{"id":"-2000710887","predicate":"inputBotInlineResult","params":[{"name":"flags","type":"#"},{"name":"id","type":"string"},{"name":"type","type":"string"},{"name":"title","type":"flags.1?string"},{"name":"description","type":"flags.2?string"},{"name":"url","type":"flags.3?string"},{"name":"thumb","type":"flags.4?InputWebDocument"},{"name":"content","type":"flags.5?InputWebDocument"},{"name":"send_message","type":"InputBotInlineMessage"}],"type":"InputBotInlineResult"},{"id":"1984755728","predicate":"botInlineMessageMediaAuto","params":[{"name":"flags","type":"#"},{"name":"message","type":"string"},{"name":"entities","type":"flags.1?Vector<MessageEntity>"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"}],"type":"BotInlineMessage"},{"id":"-1937807902","predicate":"botInlineMessageText","params":[{"name":"flags","type":"#"},{"name":"no_webpage","type":"flags.0?true"},{"name":"message","type":"string"},{"name":"entities","type":"flags.1?Vector<MessageEntity>"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"}],"type":"BotInlineMessage"},{"id":"295067450","predicate":"botInlineResult","params":[{"name":"flags","type":"#"},{"name":"id","type":"string"},{"name":"type","type":"string"},{"name":"title","type":"flags.1?string"},{"name":"description","type":"flags.2?string"},{"name":"url","type":"flags.3?string"},{"name":"thumb","type":"flags.4?WebDocument"},{"name":"content","type":"flags.5?WebDocument"},{"name":"send_message","type":"BotInlineMessage"}],"type":"BotInlineResult"},{"id":"-1803769784","predicate":"messages.botResults","params":[{"name":"flags","type":"#"},{"name":"gallery","type":"flags.0?true"},{"name":"query_id","type":"long"},{"name":"next_offset","type":"flags.1?string"},{"name":"switch_pm","type":"flags.2?InlineBotSwitchPM"},{"name":"results","type":"Vector<BotInlineResult>"},{"name":"cache_time","type":"int"},{"name":"users","type":"Vector<User>"}],"type":"messages.BotResults"},{"id":"1417832080","predicate":"updateBotInlineQuery","params":[{"name":"flags","type":"#"},{"name":"query_id","type":"long"},{"name":"user_id","type":"int"},{"name":"query","type":"string"},{"name":"geo","type":"flags.0?GeoPoint"},{"name":"offset","type":"string"}],"type":"Update"},{"id":"239663460","predicate":"updateBotInlineSend","params":[{"name":"flags","type":"#"},{"name":"user_id","type":"int"},{"name":"query","type":"string"},{"name":"geo","type":"flags.0?GeoPoint"},{"name":"id","type":"string"},{"name":"msg_id","type":"flags.1?InputBotInlineMessageID"}],"type":"Update"},{"id":"1358283666","predicate":"inputMessagesFilterVoice","params":[],"type":"MessagesFilter"},{"id":"928101534","predicate":"inputMessagesFilterMusic","params":[],"type":"MessagesFilter"},{"id":"-1107622874","predicate":"inputPrivacyKeyChatInvite","params":[],"type":"InputPrivacyKey"},{"id":"1343122938","predicate":"privacyKeyChatInvite","params":[],"type":"PrivacyKey"},{"id":"1571494644","predicate":"exportedMessageLink","params":[{"name":"link","type":"string"},{"name":"html","type":"string"}],"type":"ExportedMessageLink"},{"id":"-332168592","predicate":"messageFwdHeader","params":[{"name":"flags","type":"#"},{"name":"from_id","type":"flags.0?int"},{"name":"from_name","type":"flags.5?string"},{"name":"date","type":"int"},{"name":"channel_id","type":"flags.1?int"},{"name":"channel_post","type":"flags.2?int"},{"name":"post_author","type":"flags.3?string"},{"name":"saved_from_peer","type":"flags.4?Peer"},{"name":"saved_from_msg_id","type":"flags.4?int"}],"type":"MessageFwdHeader"},{"id":"457133559","predicate":"updateEditChannelMessage","params":[{"name":"message","type":"Message"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"-1738988427","predicate":"updateChannelPinnedMessage","params":[{"name":"channel_id","type":"int"},{"name":"id","type":"int"}],"type":"Update"},{"id":"-1799538451","predicate":"messageActionPinMessage","params":[],"type":"MessageAction"},{"id":"1923290508","predicate":"auth.codeTypeSms","params":[],"type":"auth.CodeType"},{"id":"1948046307","predicate":"auth.codeTypeCall","params":[],"type":"auth.CodeType"},{"id":"577556219","predicate":"auth.codeTypeFlashCall","params":[],"type":"auth.CodeType"},{"id":"1035688326","predicate":"auth.sentCodeTypeApp","params":[{"name":"length","type":"int"}],"type":"auth.SentCodeType"},{"id":"-1073693790","predicate":"auth.sentCodeTypeSms","params":[{"name":"length","type":"int"}],"type":"auth.SentCodeType"},{"id":"1398007207","predicate":"auth.sentCodeTypeCall","params":[{"name":"length","type":"int"}],"type":"auth.SentCodeType"},{"id":"-1425815847","predicate":"auth.sentCodeTypeFlashCall","params":[{"name":"pattern","type":"string"}],"type":"auth.SentCodeType"},{"id":"629866245","predicate":"keyboardButtonUrl","params":[{"name":"text","type":"string"},{"name":"url","type":"string"}],"type":"KeyboardButton"},{"id":"1748655686","predicate":"keyboardButtonCallback","params":[{"name":"text","type":"string"},{"name":"data","type":"bytes"}],"type":"KeyboardButton"},{"id":"-1318425559","predicate":"keyboardButtonRequestPhone","params":[{"name":"text","type":"string"}],"type":"KeyboardButton"},{"id":"-59151553","predicate":"keyboardButtonRequestGeoLocation","params":[{"name":"text","type":"string"}],"type":"KeyboardButton"},{"id":"90744648","predicate":"keyboardButtonSwitchInline","params":[{"name":"flags","type":"#"},{"name":"same_peer","type":"flags.0?true"},{"name":"text","type":"string"},{"name":"query","type":"string"}],"type":"KeyboardButton"},{"id":"1218642516","predicate":"replyInlineMarkup","params":[{"name":"rows","type":"Vector<KeyboardButtonRow>"}],"type":"ReplyMarkup"},{"id":"911761060","predicate":"messages.botCallbackAnswer","params":[{"name":"flags","type":"#"},{"name":"alert","type":"flags.1?true"},{"name":"has_url","type":"flags.3?true"},{"name":"native_ui","type":"flags.4?true"},{"name":"message","type":"flags.0?string"},{"name":"url","type":"flags.2?string"},{"name":"cache_time","type":"int"}],"type":"messages.BotCallbackAnswer"},{"id":"-415938591","predicate":"updateBotCallbackQuery","params":[{"name":"flags","type":"#"},{"name":"query_id","type":"long"},{"name":"user_id","type":"int"},{"name":"peer","type":"Peer"},{"name":"msg_id","type":"int"},{"name":"chat_instance","type":"long"},{"name":"data","type":"flags.0?bytes"},{"name":"game_short_name","type":"flags.1?string"}],"type":"Update"},{"id":"649453030","predicate":"messages.messageEditData","params":[{"name":"flags","type":"#"},{"name":"caption","type":"flags.0?true"}],"type":"messages.MessageEditData"},{"id":"-469536605","predicate":"updateEditMessage","params":[{"name":"message","type":"Message"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"-1045340827","predicate":"inputBotInlineMessageMediaGeo","params":[{"name":"flags","type":"#"},{"name":"geo_point","type":"InputGeoPoint"},{"name":"period","type":"int"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"}],"type":"InputBotInlineMessage"},{"id":"1098628881","predicate":"inputBotInlineMessageMediaVenue","params":[{"name":"flags","type":"#"},{"name":"geo_point","type":"InputGeoPoint"},{"name":"title","type":"string"},{"name":"address","type":"string"},{"name":"provider","type":"string"},{"name":"venue_id","type":"string"},{"name":"venue_type","type":"string"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"}],"type":"InputBotInlineMessage"},{"id":"-1494368259","predicate":"inputBotInlineMessageMediaContact","params":[{"name":"flags","type":"#"},{"name":"phone_number","type":"string"},{"name":"first_name","type":"string"},{"name":"last_name","type":"string"},{"name":"vcard","type":"string"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"}],"type":"InputBotInlineMessage"},{"id":"-1222451611","predicate":"botInlineMessageMediaGeo","params":[{"name":"flags","type":"#"},{"name":"geo","type":"GeoPoint"},{"name":"period","type":"int"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"}],"type":"BotInlineMessage"},{"id":"-1970903652","predicate":"botInlineMessageMediaVenue","params":[{"name":"flags","type":"#"},{"name":"geo","type":"GeoPoint"},{"name":"title","type":"string"},{"name":"address","type":"string"},{"name":"provider","type":"string"},{"name":"venue_id","type":"string"},{"name":"venue_type","type":"string"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"}],"type":"BotInlineMessage"},{"id":"416402882","predicate":"botInlineMessageMediaContact","params":[{"name":"flags","type":"#"},{"name":"phone_number","type":"string"},{"name":"first_name","type":"string"},{"name":"last_name","type":"string"},{"name":"vcard","type":"string"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"}],"type":"BotInlineMessage"},{"id":"-1462213465","predicate":"inputBotInlineResultPhoto","params":[{"name":"id","type":"string"},{"name":"type","type":"string"},{"name":"photo","type":"InputPhoto"},{"name":"send_message","type":"InputBotInlineMessage"}],"type":"InputBotInlineResult"},{"id":"-459324","predicate":"inputBotInlineResultDocument","params":[{"name":"flags","type":"#"},{"name":"id","type":"string"},{"name":"type","type":"string"},{"name":"title","type":"flags.1?string"},{"name":"description","type":"flags.2?string"},{"name":"document","type":"InputDocument"},{"name":"send_message","type":"InputBotInlineMessage"}],"type":"InputBotInlineResult"},{"id":"400266251","predicate":"botInlineMediaResult","params":[{"name":"flags","type":"#"},{"name":"id","type":"string"},{"name":"type","type":"string"},{"name":"photo","type":"flags.0?Photo"},{"name":"document","type":"flags.1?Document"},{"name":"title","type":"flags.2?string"},{"name":"description","type":"flags.3?string"},{"name":"send_message","type":"BotInlineMessage"}],"type":"BotInlineResult"},{"id":"-1995686519","predicate":"inputBotInlineMessageID","params":[{"name":"dc_id","type":"int"},{"name":"id","type":"long"},{"name":"access_hash","type":"long"}],"type":"InputBotInlineMessageID"},{"id":"-103646630","predicate":"updateInlineBotCallbackQuery","params":[{"name":"flags","type":"#"},{"name":"query_id","type":"long"},{"name":"user_id","type":"int"},{"name":"msg_id","type":"InputBotInlineMessageID"},{"name":"chat_instance","type":"long"},{"name":"data","type":"flags.0?bytes"},{"name":"game_short_name","type":"flags.1?string"}],"type":"Update"},{"id":"1008755359","predicate":"inlineBotSwitchPM","params":[{"name":"text","type":"string"},{"name":"start_param","type":"string"}],"type":"InlineBotSwitchPM"},{"id":"863093588","predicate":"messages.peerDialogs","params":[{"name":"dialogs","type":"Vector<Dialog>"},{"name":"messages","type":"Vector<Message>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"},{"name":"state","type":"updates.State"}],"type":"messages.PeerDialogs"},{"id":"-305282981","predicate":"topPeer","params":[{"name":"peer","type":"Peer"},{"name":"rating","type":"double"}],"type":"TopPeer"},{"id":"-1419371685","predicate":"topPeerCategoryBotsPM","params":[],"type":"TopPeerCategory"},{"id":"344356834","predicate":"topPeerCategoryBotsInline","params":[],"type":"TopPeerCategory"},{"id":"104314861","predicate":"topPeerCategoryCorrespondents","params":[],"type":"TopPeerCategory"},{"id":"-1122524854","predicate":"topPeerCategoryGroups","params":[],"type":"TopPeerCategory"},{"id":"371037736","predicate":"topPeerCategoryChannels","params":[],"type":"TopPeerCategory"},{"id":"-75283823","predicate":"topPeerCategoryPeers","params":[{"name":"category","type":"TopPeerCategory"},{"name":"count","type":"int"},{"name":"peers","type":"Vector<TopPeer>"}],"type":"TopPeerCategoryPeers"},{"id":"-567906571","predicate":"contacts.topPeersNotModified","params":[],"type":"contacts.TopPeers"},{"id":"1891070632","predicate":"contacts.topPeers","params":[{"name":"categories","type":"Vector<TopPeerCategoryPeers>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"contacts.TopPeers"},{"id":"892193368","predicate":"messageEntityMentionName","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"},{"name":"user_id","type":"int"}],"type":"MessageEntity"},{"id":"546203849","predicate":"inputMessageEntityMentionName","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"},{"name":"user_id","type":"InputUser"}],"type":"MessageEntity"},{"id":"975236280","predicate":"inputMessagesFilterChatPhotos","params":[],"type":"MessagesFilter"},{"id":"634833351","predicate":"updateReadChannelOutbox","params":[{"name":"channel_id","type":"int"},{"name":"max_id","type":"int"}],"type":"Update"},{"id":"-299124375","predicate":"updateDraftMessage","params":[{"name":"peer","type":"Peer"},{"name":"draft","type":"DraftMessage"}],"type":"Update"},{"id":"453805082","predicate":"draftMessageEmpty","params":[{"name":"flags","type":"#"},{"name":"date","type":"flags.0?int"}],"type":"DraftMessage"},{"id":"-40996577","predicate":"draftMessage","params":[{"name":"flags","type":"#"},{"name":"no_webpage","type":"flags.1?true"},{"name":"reply_to_msg_id","type":"flags.0?int"},{"name":"message","type":"string"},{"name":"entities","type":"flags.3?Vector<MessageEntity>"},{"name":"date","type":"int"}],"type":"DraftMessage"},{"id":"-1615153660","predicate":"messageActionHistoryClear","params":[],"type":"MessageAction"},{"id":"82699215","predicate":"messages.featuredStickersNotModified","params":[],"type":"messages.FeaturedStickers"},{"id":"-123893531","predicate":"messages.featuredStickers","params":[{"name":"hash","type":"int"},{"name":"sets","type":"Vector<StickerSetCovered>"},{"name":"unread","type":"Vector<long>"}],"type":"messages.FeaturedStickers"},{"id":"1461528386","predicate":"updateReadFeaturedStickers","params":[],"type":"Update"},{"id":"186120336","predicate":"messages.recentStickersNotModified","params":[],"type":"messages.RecentStickers"},{"id":"586395571","predicate":"messages.recentStickers","params":[{"name":"hash","type":"int"},{"name":"packs","type":"Vector<StickerPack>"},{"name":"stickers","type":"Vector<Document>"},{"name":"dates","type":"Vector<int>"}],"type":"messages.RecentStickers"},{"id":"-1706939360","predicate":"updateRecentStickers","params":[],"type":"Update"},{"id":"1338747336","predicate":"messages.archivedStickers","params":[{"name":"count","type":"int"},{"name":"sets","type":"Vector<StickerSetCovered>"}],"type":"messages.ArchivedStickers"},{"id":"946083368","predicate":"messages.stickerSetInstallResultSuccess","params":[],"type":"messages.StickerSetInstallResult"},{"id":"904138920","predicate":"messages.stickerSetInstallResultArchive","params":[{"name":"sets","type":"Vector<StickerSetCovered>"}],"type":"messages.StickerSetInstallResult"},{"id":"1678812626","predicate":"stickerSetCovered","params":[{"name":"set","type":"StickerSet"},{"name":"cover","type":"Document"}],"type":"StickerSetCovered"},{"id":"-1574314746","predicate":"updateConfig","params":[],"type":"Update"},{"id":"861169551","predicate":"updatePtsChanged","params":[],"type":"Update"},{"id":"-440664550","predicate":"inputMediaPhotoExternal","params":[{"name":"flags","type":"#"},{"name":"url","type":"string"},{"name":"ttl_seconds","type":"flags.0?int"}],"type":"InputMedia"},{"id":"-78455655","predicate":"inputMediaDocumentExternal","params":[{"name":"flags","type":"#"},{"name":"url","type":"string"},{"name":"ttl_seconds","type":"flags.0?int"}],"type":"InputMedia"},{"id":"872932635","predicate":"stickerSetMultiCovered","params":[{"name":"set","type":"StickerSet"},{"name":"covers","type":"Vector<Document>"}],"type":"StickerSetCovered"},{"id":"-1361650766","predicate":"maskCoords","params":[{"name":"n","type":"int"},{"name":"x","type":"double"},{"name":"y","type":"double"},{"name":"zoom","type":"double"}],"type":"MaskCoords"},{"id":"-1744710921","predicate":"documentAttributeHasStickers","params":[],"type":"DocumentAttribute"},{"id":"1251549527","predicate":"inputStickeredMediaPhoto","params":[{"name":"id","type":"InputPhoto"}],"type":"InputStickeredMedia"},{"id":"70813275","predicate":"inputStickeredMediaDocument","params":[{"name":"id","type":"InputDocument"}],"type":"InputStickeredMedia"},{"id":"-1107729093","predicate":"game","params":[{"name":"flags","type":"#"},{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"short_name","type":"string"},{"name":"title","type":"string"},{"name":"description","type":"string"},{"name":"photo","type":"Photo"},{"name":"document","type":"flags.0?Document"}],"type":"Game"},{"id":"1336154098","predicate":"inputBotInlineResultGame","params":[{"name":"id","type":"string"},{"name":"short_name","type":"string"},{"name":"send_message","type":"InputBotInlineMessage"}],"type":"InputBotInlineResult"},{"id":"1262639204","predicate":"inputBotInlineMessageGame","params":[{"name":"flags","type":"#"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"}],"type":"InputBotInlineMessage"},{"id":"-38694904","predicate":"messageMediaGame","params":[{"name":"game","type":"Game"}],"type":"MessageMedia"},{"id":"-750828557","predicate":"inputMediaGame","params":[{"name":"id","type":"InputGame"}],"type":"InputMedia"},{"id":"53231223","predicate":"inputGameID","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"}],"type":"InputGame"},{"id":"-1020139510","predicate":"inputGameShortName","params":[{"name":"bot_id","type":"InputUser"},{"name":"short_name","type":"string"}],"type":"InputGame"},{"id":"1358175439","predicate":"keyboardButtonGame","params":[{"name":"text","type":"string"}],"type":"KeyboardButton"},{"id":"-1834538890","predicate":"messageActionGameScore","params":[{"name":"game_id","type":"long"},{"name":"score","type":"int"}],"type":"MessageAction"},{"id":"1493171408","predicate":"highScore","params":[{"name":"pos","type":"int"},{"name":"user_id","type":"int"},{"name":"score","type":"int"}],"type":"HighScore"},{"id":"-1707344487","predicate":"messages.highScores","params":[{"name":"scores","type":"Vector<HighScore>"},{"name":"users","type":"Vector<User>"}],"type":"messages.HighScores"},{"id":"1258196845","predicate":"updates.differenceTooLong","params":[{"name":"pts","type":"int"}],"type":"updates.Difference"},{"id":"1081547008","predicate":"updateChannelWebPage","params":[{"name":"channel_id","type":"int"},{"name":"webpage","type":"WebPage"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"-1663561404","predicate":"messages.chatsSlice","params":[{"name":"count","type":"int"},{"name":"chats","type":"Vector<Chat>"}],"type":"messages.Chats"},{"id":"-599948721","predicate":"textEmpty","params":[],"type":"RichText"},{"id":"1950782688","predicate":"textPlain","params":[{"name":"text","type":"string"}],"type":"RichText"},{"id":"1730456516","predicate":"textBold","params":[{"name":"text","type":"RichText"}],"type":"RichText"},{"id":"-653089380","predicate":"textItalic","params":[{"name":"text","type":"RichText"}],"type":"RichText"},{"id":"-1054465340","predicate":"textUnderline","params":[{"name":"text","type":"RichText"}],"type":"RichText"},{"id":"-1678197867","predicate":"textStrike","params":[{"name":"text","type":"RichText"}],"type":"RichText"},{"id":"1816074681","predicate":"textFixed","params":[{"name":"text","type":"RichText"}],"type":"RichText"},{"id":"1009288385","predicate":"textUrl","params":[{"name":"text","type":"RichText"},{"name":"url","type":"string"},{"name":"webpage_id","type":"long"}],"type":"RichText"},{"id":"-564523562","predicate":"textEmail","params":[{"name":"text","type":"RichText"},{"name":"email","type":"string"}],"type":"RichText"},{"id":"2120376535","predicate":"textConcat","params":[{"name":"texts","type":"Vector<RichText>"}],"type":"RichText"},{"id":"324435594","predicate":"pageBlockUnsupported","params":[],"type":"PageBlock"},{"id":"1890305021","predicate":"pageBlockTitle","params":[{"name":"text","type":"RichText"}],"type":"PageBlock"},{"id":"-1879401953","predicate":"pageBlockSubtitle","params":[{"name":"text","type":"RichText"}],"type":"PageBlock"},{"id":"-1162877472","predicate":"pageBlockAuthorDate","params":[{"name":"author","type":"RichText"},{"name":"published_date","type":"int"}],"type":"PageBlock"},{"id":"-1076861716","predicate":"pageBlockHeader","params":[{"name":"text","type":"RichText"}],"type":"PageBlock"},{"id":"-248793375","predicate":"pageBlockSubheader","params":[{"name":"text","type":"RichText"}],"type":"PageBlock"},{"id":"1182402406","predicate":"pageBlockParagraph","params":[{"name":"text","type":"RichText"}],"type":"PageBlock"},{"id":"-1066346178","predicate":"pageBlockPreformatted","params":[{"name":"text","type":"RichText"},{"name":"language","type":"string"}],"type":"PageBlock"},{"id":"1216809369","predicate":"pageBlockFooter","params":[{"name":"text","type":"RichText"}],"type":"PageBlock"},{"id":"-618614392","predicate":"pageBlockDivider","params":[],"type":"PageBlock"},{"id":"-837994576","predicate":"pageBlockAnchor","params":[{"name":"name","type":"string"}],"type":"PageBlock"},{"id":"-454524911","predicate":"pageBlockList","params":[{"name":"items","type":"Vector<PageListItem>"}],"type":"PageBlock"},{"id":"641563686","predicate":"pageBlockBlockquote","params":[{"name":"text","type":"RichText"},{"name":"caption","type":"RichText"}],"type":"PageBlock"},{"id":"1329878739","predicate":"pageBlockPullquote","params":[{"name":"text","type":"RichText"},{"name":"caption","type":"RichText"}],"type":"PageBlock"},{"id":"391759200","predicate":"pageBlockPhoto","params":[{"name":"flags","type":"#"},{"name":"photo_id","type":"long"},{"name":"caption","type":"PageCaption"},{"name":"url","type":"flags.0?string"},{"name":"webpage_id","type":"flags.0?long"}],"type":"PageBlock"},{"id":"2089805750","predicate":"pageBlockVideo","params":[{"name":"flags","type":"#"},{"name":"autoplay","type":"flags.0?true"},{"name":"loop","type":"flags.1?true"},{"name":"video_id","type":"long"},{"name":"caption","type":"PageCaption"}],"type":"PageBlock"},{"id":"972174080","predicate":"pageBlockCover","params":[{"name":"cover","type":"PageBlock"}],"type":"PageBlock"},{"id":"-1468953147","predicate":"pageBlockEmbed","params":[{"name":"flags","type":"#"},{"name":"full_width","type":"flags.0?true"},{"name":"allow_scrolling","type":"flags.3?true"},{"name":"url","type":"flags.1?string"},{"name":"html","type":"flags.2?string"},{"name":"poster_photo_id","type":"flags.4?long"},{"name":"w","type":"flags.5?int"},{"name":"h","type":"flags.5?int"},{"name":"caption","type":"PageCaption"}],"type":"PageBlock"},{"id":"-229005301","predicate":"pageBlockEmbedPost","params":[{"name":"url","type":"string"},{"name":"webpage_id","type":"long"},{"name":"author_photo_id","type":"long"},{"name":"author","type":"string"},{"name":"date","type":"int"},{"name":"blocks","type":"Vector<PageBlock>"},{"name":"caption","type":"PageCaption"}],"type":"PageBlock"},{"id":"1705048653","predicate":"pageBlockCollage","params":[{"name":"items","type":"Vector<PageBlock>"},{"name":"caption","type":"PageCaption"}],"type":"PageBlock"},{"id":"52401552","predicate":"pageBlockSlideshow","params":[{"name":"items","type":"Vector<PageBlock>"},{"name":"caption","type":"PageCaption"}],"type":"PageBlock"},{"id":"-2054908813","predicate":"webPageNotModified","params":[],"type":"WebPage"},{"id":"-88417185","predicate":"inputPrivacyKeyPhoneCall","params":[],"type":"InputPrivacyKey"},{"id":"1030105979","predicate":"privacyKeyPhoneCall","params":[],"type":"PrivacyKey"},{"id":"-580219064","predicate":"sendMessageGamePlayAction","params":[],"type":"SendMessageAction"},{"id":"-2048646399","predicate":"phoneCallDiscardReasonMissed","params":[],"type":"PhoneCallDiscardReason"},{"id":"-527056480","predicate":"phoneCallDiscardReasonDisconnect","params":[],"type":"PhoneCallDiscardReason"},{"id":"1471006352","predicate":"phoneCallDiscardReasonHangup","params":[],"type":"PhoneCallDiscardReason"},{"id":"-84416311","predicate":"phoneCallDiscardReasonBusy","params":[],"type":"PhoneCallDiscardReason"},{"id":"1852826908","predicate":"updateDialogPinned","params":[{"name":"flags","type":"#"},{"name":"pinned","type":"flags.0?true"},{"name":"folder_id","type":"flags.1?int"},{"name":"peer","type":"DialogPeer"}],"type":"Update"},{"id":"-99664734","predicate":"updatePinnedDialogs","params":[{"name":"flags","type":"#"},{"name":"folder_id","type":"flags.1?int"},{"name":"order","type":"flags.0?Vector<DialogPeer>"}],"type":"Update"},{"id":"2104790276","predicate":"dataJSON","params":[{"name":"data","type":"string"}],"type":"DataJSON"},{"id":"-2095595325","predicate":"updateBotWebhookJSON","params":[{"name":"data","type":"DataJSON"}],"type":"Update"},{"id":"-1684914010","predicate":"updateBotWebhookJSONQuery","params":[{"name":"query_id","type":"long"},{"name":"data","type":"DataJSON"},{"name":"timeout","type":"int"}],"type":"Update"},{"id":"-886477832","predicate":"labeledPrice","params":[{"name":"label","type":"string"},{"name":"amount","type":"long"}],"type":"LabeledPrice"},{"id":"-1022713000","predicate":"invoice","params":[{"name":"flags","type":"#"},{"name":"test","type":"flags.0?true"},{"name":"name_requested","type":"flags.1?true"},{"name":"phone_requested","type":"flags.2?true"},{"name":"email_requested","type":"flags.3?true"},{"name":"shipping_address_requested","type":"flags.4?true"},{"name":"flexible","type":"flags.5?true"},{"name":"phone_to_provider","type":"flags.6?true"},{"name":"email_to_provider","type":"flags.7?true"},{"name":"currency","type":"string"},{"name":"prices","type":"Vector<LabeledPrice>"}],"type":"Invoice"},{"id":"-186607933","predicate":"inputMediaInvoice","params":[{"name":"flags","type":"#"},{"name":"title","type":"string"},{"name":"description","type":"string"},{"name":"photo","type":"flags.0?InputWebDocument"},{"name":"invoice","type":"Invoice"},{"name":"payload","type":"bytes"},{"name":"provider","type":"string"},{"name":"provider_data","type":"DataJSON"},{"name":"start_param","type":"string"}],"type":"InputMedia"},{"id":"-368917890","predicate":"paymentCharge","params":[{"name":"id","type":"string"},{"name":"provider_charge_id","type":"string"}],"type":"PaymentCharge"},{"id":"-1892568281","predicate":"messageActionPaymentSentMe","params":[{"name":"flags","type":"#"},{"name":"currency","type":"string"},{"name":"total_amount","type":"long"},{"name":"payload","type":"bytes"},{"name":"info","type":"flags.0?PaymentRequestedInfo"},{"name":"shipping_option_id","type":"flags.1?string"},{"name":"charge","type":"PaymentCharge"}],"type":"MessageAction"},{"id":"-2074799289","predicate":"messageMediaInvoice","params":[{"name":"flags","type":"#"},{"name":"shipping_address_requested","type":"flags.1?true"},{"name":"test","type":"flags.3?true"},{"name":"title","type":"string"},{"name":"description","type":"string"},{"name":"photo","type":"flags.0?WebDocument"},{"name":"receipt_msg_id","type":"flags.2?int"},{"name":"currency","type":"string"},{"name":"total_amount","type":"long"},{"name":"start_param","type":"string"}],"type":"MessageMedia"},{"id":"512535275","predicate":"postAddress","params":[{"name":"street_line1","type":"string"},{"name":"street_line2","type":"string"},{"name":"city","type":"string"},{"name":"state","type":"string"},{"name":"country_iso2","type":"string"},{"name":"post_code","type":"string"}],"type":"PostAddress"},{"id":"-1868808300","predicate":"paymentRequestedInfo","params":[{"name":"flags","type":"#"},{"name":"name","type":"flags.0?string"},{"name":"phone","type":"flags.1?string"},{"name":"email","type":"flags.2?string"},{"name":"shipping_address","type":"flags.3?PostAddress"}],"type":"PaymentRequestedInfo"},{"id":"-1344716869","predicate":"keyboardButtonBuy","params":[{"name":"text","type":"string"}],"type":"KeyboardButton"},{"id":"1080663248","predicate":"messageActionPaymentSent","params":[{"name":"currency","type":"string"},{"name":"total_amount","type":"long"}],"type":"MessageAction"},{"id":"-842892769","predicate":"paymentSavedCredentialsCard","params":[{"name":"id","type":"string"},{"name":"title","type":"string"}],"type":"PaymentSavedCredentials"},{"id":"475467473","predicate":"webDocument","params":[{"name":"url","type":"string"},{"name":"access_hash","type":"long"},{"name":"size","type":"int"},{"name":"mime_type","type":"string"},{"name":"attributes","type":"Vector<DocumentAttribute>"}],"type":"WebDocument"},{"id":"-1678949555","predicate":"inputWebDocument","params":[{"name":"url","type":"string"},{"name":"size","type":"int"},{"name":"mime_type","type":"string"},{"name":"attributes","type":"Vector<DocumentAttribute>"}],"type":"InputWebDocument"},{"id":"-1036396922","predicate":"inputWebFileLocation","params":[{"name":"url","type":"string"},{"name":"access_hash","type":"long"}],"type":"InputWebFileLocation"},{"id":"568808380","predicate":"upload.webFile","params":[{"name":"size","type":"int"},{"name":"mime_type","type":"string"},{"name":"file_type","type":"storage.FileType"},{"name":"mtime","type":"int"},{"name":"bytes","type":"bytes"}],"type":"upload.WebFile"},{"id":"1062645411","predicate":"payments.paymentForm","params":[{"name":"flags","type":"#"},{"name":"can_save_credentials","type":"flags.2?true"},{"name":"password_missing","type":"flags.3?true"},{"name":"bot_id","type":"int"},{"name":"invoice","type":"Invoice"},{"name":"provider_id","type":"int"},{"name":"url","type":"string"},{"name":"native_provider","type":"flags.4?string"},{"name":"native_params","type":"flags.4?DataJSON"},{"name":"saved_info","type":"flags.0?PaymentRequestedInfo"},{"name":"saved_credentials","type":"flags.1?PaymentSavedCredentials"},{"name":"users","type":"Vector<User>"}],"type":"payments.PaymentForm"},{"id":"-784000893","predicate":"payments.validatedRequestedInfo","params":[{"name":"flags","type":"#"},{"name":"id","type":"flags.0?string"},{"name":"shipping_options","type":"flags.1?Vector<ShippingOption>"}],"type":"payments.ValidatedRequestedInfo"},{"id":"1314881805","predicate":"payments.paymentResult","params":[{"name":"updates","type":"Updates"}],"type":"payments.PaymentResult"},{"id":"1342771681","predicate":"payments.paymentReceipt","params":[{"name":"flags","type":"#"},{"name":"date","type":"int"},{"name":"bot_id","type":"int"},{"name":"invoice","type":"Invoice"},{"name":"provider_id","type":"int"},{"name":"info","type":"flags.0?PaymentRequestedInfo"},{"name":"shipping","type":"flags.1?ShippingOption"},{"name":"currency","type":"string"},{"name":"total_amount","type":"long"},{"name":"credentials_title","type":"string"},{"name":"users","type":"Vector<User>"}],"type":"payments.PaymentReceipt"},{"id":"-74456004","predicate":"payments.savedInfo","params":[{"name":"flags","type":"#"},{"name":"has_saved_credentials","type":"flags.1?true"},{"name":"saved_info","type":"flags.0?PaymentRequestedInfo"}],"type":"payments.SavedInfo"},{"id":"-1056001329","predicate":"inputPaymentCredentialsSaved","params":[{"name":"id","type":"string"},{"name":"tmp_password","type":"bytes"}],"type":"InputPaymentCredentials"},{"id":"873977640","predicate":"inputPaymentCredentials","params":[{"name":"flags","type":"#"},{"name":"save","type":"flags.0?true"},{"name":"data","type":"DataJSON"}],"type":"InputPaymentCredentials"},{"id":"-614138572","predicate":"account.tmpPassword","params":[{"name":"tmp_password","type":"bytes"},{"name":"valid_until","type":"int"}],"type":"account.TmpPassword"},{"id":"-1239335713","predicate":"shippingOption","params":[{"name":"id","type":"string"},{"name":"title","type":"string"},{"name":"prices","type":"Vector<LabeledPrice>"}],"type":"ShippingOption"},{"id":"-523384512","predicate":"updateBotShippingQuery","params":[{"name":"query_id","type":"long"},{"name":"user_id","type":"int"},{"name":"payload","type":"bytes"},{"name":"shipping_address","type":"PostAddress"}],"type":"Update"},{"id":"1563376297","predicate":"updateBotPrecheckoutQuery","params":[{"name":"flags","type":"#"},{"name":"query_id","type":"long"},{"name":"user_id","type":"int"},{"name":"payload","type":"bytes"},{"name":"info","type":"flags.0?PaymentRequestedInfo"},{"name":"shipping_option_id","type":"flags.1?string"},{"name":"currency","type":"string"},{"name":"total_amount","type":"long"}],"type":"Update"},{"id":"-6249322","predicate":"inputStickerSetItem","params":[{"name":"flags","type":"#"},{"name":"document","type":"InputDocument"},{"name":"emoji","type":"string"},{"name":"mask_coords","type":"flags.0?MaskCoords"}],"type":"InputStickerSetItem"},{"id":"-1425052898","predicate":"updatePhoneCall","params":[{"name":"phone_call","type":"PhoneCall"}],"type":"Update"},{"id":"506920429","predicate":"inputPhoneCall","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"}],"type":"InputPhoneCall"},{"id":"1399245077","predicate":"phoneCallEmpty","params":[{"name":"id","type":"long"}],"type":"PhoneCall"},{"id":"462375633","predicate":"phoneCallWaiting","params":[{"name":"flags","type":"#"},{"name":"video","type":"flags.5?true"},{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"date","type":"int"},{"name":"admin_id","type":"int"},{"name":"participant_id","type":"int"},{"name":"protocol","type":"PhoneCallProtocol"},{"name":"receive_date","type":"flags.0?int"}],"type":"PhoneCall"},{"id":"-2014659757","predicate":"phoneCallRequested","params":[{"name":"flags","type":"#"},{"name":"video","type":"flags.5?true"},{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"date","type":"int"},{"name":"admin_id","type":"int"},{"name":"participant_id","type":"int"},{"name":"g_a_hash","type":"bytes"},{"name":"protocol","type":"PhoneCallProtocol"}],"type":"PhoneCall"},{"id":"-1719909046","predicate":"phoneCallAccepted","params":[{"name":"flags","type":"#"},{"name":"video","type":"flags.5?true"},{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"date","type":"int"},{"name":"admin_id","type":"int"},{"name":"participant_id","type":"int"},{"name":"g_b","type":"bytes"},{"name":"protocol","type":"PhoneCallProtocol"}],"type":"PhoneCall"},{"id":"-2025673089","predicate":"phoneCall","params":[{"name":"flags","type":"#"},{"name":"p2p_allowed","type":"flags.5?true"},{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"date","type":"int"},{"name":"admin_id","type":"int"},{"name":"participant_id","type":"int"},{"name":"g_a_or_b","type":"bytes"},{"name":"key_fingerprint","type":"long"},{"name":"protocol","type":"PhoneCallProtocol"},{"name":"connections","type":"Vector<PhoneConnection>"},{"name":"start_date","type":"int"}],"type":"PhoneCall"},{"id":"1355435489","predicate":"phoneCallDiscarded","params":[{"name":"flags","type":"#"},{"name":"need_rating","type":"flags.2?true"},{"name":"need_debug","type":"flags.3?true"},{"name":"video","type":"flags.5?true"},{"name":"id","type":"long"},{"name":"reason","type":"flags.0?PhoneCallDiscardReason"},{"name":"duration","type":"flags.1?int"}],"type":"PhoneCall"},{"id":"-1655957568","predicate":"phoneConnection","params":[{"name":"id","type":"long"},{"name":"ip","type":"string"},{"name":"ipv6","type":"string"},{"name":"port","type":"int"},{"name":"peer_tag","type":"bytes"}],"type":"PhoneConnection"},{"id":"-1564789301","predicate":"phoneCallProtocol","params":[{"name":"flags","type":"#"},{"name":"udp_p2p","type":"flags.0?true"},{"name":"udp_reflector","type":"flags.1?true"},{"name":"min_layer","type":"int"},{"name":"max_layer","type":"int"}],"type":"PhoneCallProtocol"},{"id":"-326966976","predicate":"phone.phoneCall","params":[{"name":"phone_call","type":"PhoneCall"},{"name":"users","type":"Vector<User>"}],"type":"phone.PhoneCall"},{"id":"-2134272152","predicate":"inputMessagesFilterPhoneCalls","params":[{"name":"flags","type":"#"},{"name":"missed","type":"flags.0?true"}],"type":"MessagesFilter"},{"id":"-2132731265","predicate":"messageActionPhoneCall","params":[{"name":"flags","type":"#"},{"name":"video","type":"flags.2?true"},{"name":"call_id","type":"long"},{"name":"reason","type":"flags.0?PhoneCallDiscardReason"},{"name":"duration","type":"flags.1?int"}],"type":"MessageAction"},{"id":"2054952868","predicate":"inputMessagesFilterRoundVoice","params":[],"type":"MessagesFilter"},{"id":"-1253451181","predicate":"inputMessagesFilterRoundVideo","params":[],"type":"MessagesFilter"},{"id":"-1997373508","predicate":"sendMessageRecordRoundAction","params":[],"type":"SendMessageAction"},{"id":"608050278","predicate":"sendMessageUploadRoundAction","params":[{"name":"progress","type":"int"}],"type":"SendMessageAction"},{"id":"-242427324","predicate":"upload.fileCdnRedirect","params":[{"name":"dc_id","type":"int"},{"name":"file_token","type":"bytes"},{"name":"encryption_key","type":"bytes"},{"name":"encryption_iv","type":"bytes"},{"name":"file_hashes","type":"Vector<FileHash>"}],"type":"upload.File"},{"id":"-290921362","predicate":"upload.cdnFileReuploadNeeded","params":[{"name":"request_token","type":"bytes"}],"type":"upload.CdnFile"},{"id":"-1449145777","predicate":"upload.cdnFile","params":[{"name":"bytes","type":"bytes"}],"type":"upload.CdnFile"},{"id":"-914167110","predicate":"cdnPublicKey","params":[{"name":"dc_id","type":"int"},{"name":"public_key","type":"string"}],"type":"CdnPublicKey"},{"id":"1462101002","predicate":"cdnConfig","params":[{"name":"public_keys","type":"Vector<CdnPublicKey>"}],"type":"CdnConfig"},{"id":"-283684427","predicate":"pageBlockChannel","params":[{"name":"channel","type":"Chat"}],"type":"PageBlock"},{"id":"-892239370","predicate":"langPackString","params":[{"name":"key","type":"string"},{"name":"value","type":"string"}],"type":"LangPackString"},{"id":"1816636575","predicate":"langPackStringPluralized","params":[{"name":"flags","type":"#"},{"name":"key","type":"string"},{"name":"zero_value","type":"flags.0?string"},{"name":"one_value","type":"flags.1?string"},{"name":"two_value","type":"flags.2?string"},{"name":"few_value","type":"flags.3?string"},{"name":"many_value","type":"flags.4?string"},{"name":"other_value","type":"string"}],"type":"LangPackString"},{"id":"695856818","predicate":"langPackStringDeleted","params":[{"name":"key","type":"string"}],"type":"LangPackString"},{"id":"-209337866","predicate":"langPackDifference","params":[{"name":"lang_code","type":"string"},{"name":"from_version","type":"int"},{"name":"version","type":"int"},{"name":"strings","type":"Vector<LangPackString>"}],"type":"LangPackDifference"},{"id":"-288727837","predicate":"langPackLanguage","params":[{"name":"flags","type":"#"},{"name":"official","type":"flags.0?true"},{"name":"rtl","type":"flags.2?true"},{"name":"beta","type":"flags.3?true"},{"name":"name","type":"string"},{"name":"native_name","type":"string"},{"name":"lang_code","type":"string"},{"name":"base_lang_code","type":"flags.1?string"},{"name":"plural_code","type":"string"},{"name":"strings_count","type":"int"},{"name":"translated_count","type":"int"},{"name":"translations_url","type":"string"}],"type":"LangPackLanguage"},{"id":"1180041828","predicate":"updateLangPackTooLong","params":[{"name":"lang_code","type":"string"}],"type":"Update"},{"id":"1442983757","predicate":"updateLangPack","params":[{"name":"difference","type":"LangPackDifference"}],"type":"Update"},{"id":"-859915345","predicate":"channelParticipantAdmin","params":[{"name":"flags","type":"#"},{"name":"can_edit","type":"flags.0?true"},{"name":"self","type":"flags.1?true"},{"name":"user_id","type":"int"},{"name":"inviter_id","type":"flags.1?int"},{"name":"promoted_by","type":"int"},{"name":"date","type":"int"},{"name":"admin_rights","type":"ChatAdminRights"},{"name":"rank","type":"flags.2?string"}],"type":"ChannelParticipant"},{"id":"470789295","predicate":"channelParticipantBanned","params":[{"name":"flags","type":"#"},{"name":"left","type":"flags.0?true"},{"name":"user_id","type":"int"},{"name":"kicked_by","type":"int"},{"name":"date","type":"int"},{"name":"banned_rights","type":"ChatBannedRights"}],"type":"ChannelParticipant"},{"id":"338142689","predicate":"channelParticipantsBanned","params":[{"name":"q","type":"string"}],"type":"ChannelParticipantsFilter"},{"id":"106343499","predicate":"channelParticipantsSearch","params":[{"name":"q","type":"string"}],"type":"ChannelParticipantsFilter"},{"id":"-421545947","predicate":"channelAdminLogEventActionChangeTitle","params":[{"name":"prev_value","type":"string"},{"name":"new_value","type":"string"}],"type":"ChannelAdminLogEventAction"},{"id":"1427671598","predicate":"channelAdminLogEventActionChangeAbout","params":[{"name":"prev_value","type":"string"},{"name":"new_value","type":"string"}],"type":"ChannelAdminLogEventAction"},{"id":"1783299128","predicate":"channelAdminLogEventActionChangeUsername","params":[{"name":"prev_value","type":"string"},{"name":"new_value","type":"string"}],"type":"ChannelAdminLogEventAction"},{"id":"1129042607","predicate":"channelAdminLogEventActionChangePhoto","params":[{"name":"prev_photo","type":"Photo"},{"name":"new_photo","type":"Photo"}],"type":"ChannelAdminLogEventAction"},{"id":"460916654","predicate":"channelAdminLogEventActionToggleInvites","params":[{"name":"new_value","type":"Bool"}],"type":"ChannelAdminLogEventAction"},{"id":"648939889","predicate":"channelAdminLogEventActionToggleSignatures","params":[{"name":"new_value","type":"Bool"}],"type":"ChannelAdminLogEventAction"},{"id":"-370660328","predicate":"channelAdminLogEventActionUpdatePinned","params":[{"name":"message","type":"Message"}],"type":"ChannelAdminLogEventAction"},{"id":"1889215493","predicate":"channelAdminLogEventActionEditMessage","params":[{"name":"prev_message","type":"Message"},{"name":"new_message","type":"Message"}],"type":"ChannelAdminLogEventAction"},{"id":"1121994683","predicate":"channelAdminLogEventActionDeleteMessage","params":[{"name":"message","type":"Message"}],"type":"ChannelAdminLogEventAction"},{"id":"405815507","predicate":"channelAdminLogEventActionParticipantJoin","params":[],"type":"ChannelAdminLogEventAction"},{"id":"-124291086","predicate":"channelAdminLogEventActionParticipantLeave","params":[],"type":"ChannelAdminLogEventAction"},{"id":"-484690728","predicate":"channelAdminLogEventActionParticipantInvite","params":[{"name":"participant","type":"ChannelParticipant"}],"type":"ChannelAdminLogEventAction"},{"id":"-422036098","predicate":"channelAdminLogEventActionParticipantToggleBan","params":[{"name":"prev_participant","type":"ChannelParticipant"},{"name":"new_participant","type":"ChannelParticipant"}],"type":"ChannelAdminLogEventAction"},{"id":"-714643696","predicate":"channelAdminLogEventActionParticipantToggleAdmin","params":[{"name":"prev_participant","type":"ChannelParticipant"},{"name":"new_participant","type":"ChannelParticipant"}],"type":"ChannelAdminLogEventAction"},{"id":"995769920","predicate":"channelAdminLogEvent","params":[{"name":"id","type":"long"},{"name":"date","type":"int"},{"name":"user_id","type":"int"},{"name":"action","type":"ChannelAdminLogEventAction"}],"type":"ChannelAdminLogEvent"},{"id":"-309659827","predicate":"channels.adminLogResults","params":[{"name":"events","type":"Vector<ChannelAdminLogEvent>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"channels.AdminLogResults"},{"id":"-368018716","predicate":"channelAdminLogEventsFilter","params":[{"name":"flags","type":"#"},{"name":"join","type":"flags.0?true"},{"name":"leave","type":"flags.1?true"},{"name":"invite","type":"flags.2?true"},{"name":"ban","type":"flags.3?true"},{"name":"unban","type":"flags.4?true"},{"name":"kick","type":"flags.5?true"},{"name":"unkick","type":"flags.6?true"},{"name":"promote","type":"flags.7?true"},{"name":"demote","type":"flags.8?true"},{"name":"info","type":"flags.9?true"},{"name":"settings","type":"flags.10?true"},{"name":"pinned","type":"flags.11?true"},{"name":"edit","type":"flags.12?true"},{"name":"delete","type":"flags.13?true"}],"type":"ChannelAdminLogEventsFilter"},{"id":"511092620","predicate":"topPeerCategoryPhoneCalls","params":[],"type":"TopPeerCategory"},{"id":"-2143067670","predicate":"pageBlockAudio","params":[{"name":"audio_id","type":"long"},{"name":"caption","type":"PageCaption"}],"type":"PageBlock"},{"id":"1558266229","predicate":"popularContact","params":[{"name":"client_id","type":"long"},{"name":"importers","type":"int"}],"type":"PopularContact"},{"id":"1200788123","predicate":"messageActionScreenshotTaken","params":[],"type":"MessageAction"},{"id":"-1634752813","predicate":"messages.favedStickersNotModified","params":[],"type":"messages.FavedStickers"},{"id":"-209768682","predicate":"messages.favedStickers","params":[{"name":"hash","type":"int"},{"name":"packs","type":"Vector<StickerPack>"},{"name":"stickers","type":"Vector<Document>"}],"type":"messages.FavedStickers"},{"id":"-451831443","predicate":"updateFavedStickers","params":[],"type":"Update"},{"id":"-1987495099","predicate":"updateChannelReadMessagesContents","params":[{"name":"channel_id","type":"int"},{"name":"messages","type":"Vector<int>"}],"type":"Update"},{"id":"-1040652646","predicate":"inputMessagesFilterMyMentions","params":[],"type":"MessagesFilter"},{"id":"1887741886","predicate":"updateContactsReset","params":[],"type":"Update"},{"id":"-1312568665","predicate":"channelAdminLogEventActionChangeStickerSet","params":[{"name":"prev_stickerset","type":"InputStickerSet"},{"name":"new_stickerset","type":"InputStickerSet"}],"type":"ChannelAdminLogEventAction"},{"id":"-85549226","predicate":"messageActionCustomAction","params":[{"name":"message","type":"string"}],"type":"MessageAction"},{"id":"178373535","predicate":"inputPaymentCredentialsApplePay","params":[{"name":"payment_data","type":"DataJSON"}],"type":"InputPaymentCredentials"},{"id":"-905587442","predicate":"inputPaymentCredentialsAndroidPay","params":[{"name":"payment_token","type":"DataJSON"},{"name":"google_transaction_id","type":"string"}],"type":"InputPaymentCredentials"},{"id":"-419271411","predicate":"inputMessagesFilterGeo","params":[],"type":"MessagesFilter"},{"id":"-530392189","predicate":"inputMessagesFilterContacts","params":[],"type":"MessagesFilter"},{"id":"1893427255","predicate":"updateChannelAvailableMessages","params":[{"name":"channel_id","type":"int"},{"name":"available_min_id","type":"int"}],"type":"Update"},{"id":"1599903217","predicate":"channelAdminLogEventActionTogglePreHistoryHidden","params":[{"name":"new_value","type":"Bool"}],"type":"ChannelAdminLogEventAction"},{"id":"-833715459","predicate":"inputMediaGeoLive","params":[{"name":"flags","type":"#"},{"name":"stopped","type":"flags.0?true"},{"name":"geo_point","type":"InputGeoPoint"},{"name":"period","type":"flags.1?int"}],"type":"InputMedia"},{"id":"2084316681","predicate":"messageMediaGeoLive","params":[{"name":"geo","type":"GeoPoint"},{"name":"period","type":"int"}],"type":"MessageMedia"},{"id":"1189204285","predicate":"recentMeUrlUnknown","params":[{"name":"url","type":"string"}],"type":"RecentMeUrl"},{"id":"-1917045962","predicate":"recentMeUrlUser","params":[{"name":"url","type":"string"},{"name":"user_id","type":"int"}],"type":"RecentMeUrl"},{"id":"-1608834311","predicate":"recentMeUrlChat","params":[{"name":"url","type":"string"},{"name":"chat_id","type":"int"}],"type":"RecentMeUrl"},{"id":"-347535331","predicate":"recentMeUrlChatInvite","params":[{"name":"url","type":"string"},{"name":"chat_invite","type":"ChatInvite"}],"type":"RecentMeUrl"},{"id":"-1140172836","predicate":"recentMeUrlStickerSet","params":[{"name":"url","type":"string"},{"name":"set","type":"StickerSetCovered"}],"type":"RecentMeUrl"},{"id":"235081943","predicate":"help.recentMeUrls","params":[{"name":"urls","type":"Vector<RecentMeUrl>"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"help.RecentMeUrls"},{"id":"-266911767","predicate":"channels.channelParticipantsNotModified","params":[],"type":"channels.ChannelParticipants"},{"id":"1951620897","predicate":"messages.messagesNotModified","params":[{"name":"count","type":"int"}],"type":"messages.Messages"},{"id":"482797855","predicate":"inputSingleMedia","params":[{"name":"flags","type":"#"},{"name":"media","type":"InputMedia"},{"name":"random_id","type":"long"},{"name":"message","type":"string"},{"name":"entities","type":"flags.0?Vector<MessageEntity>"}],"type":"InputSingleMedia"},{"id":"-892779534","predicate":"webAuthorization","params":[{"name":"hash","type":"long"},{"name":"bot_id","type":"int"},{"name":"domain","type":"string"},{"name":"browser","type":"string"},{"name":"platform","type":"string"},{"name":"date_created","type":"int"},{"name":"date_active","type":"int"},{"name":"ip","type":"string"},{"name":"region","type":"string"}],"type":"WebAuthorization"},{"id":"-313079300","predicate":"account.webAuthorizations","params":[{"name":"authorizations","type":"Vector<WebAuthorization>"},{"name":"users","type":"Vector<User>"}],"type":"account.WebAuthorizations"},{"id":"-1502174430","predicate":"inputMessageID","params":[{"name":"id","type":"int"}],"type":"InputMessage"},{"id":"-1160215659","predicate":"inputMessageReplyTo","params":[{"name":"id","type":"int"}],"type":"InputMessage"},{"id":"-2037963464","predicate":"inputMessagePinned","params":[],"type":"InputMessage"},{"id":"-1687559349","predicate":"messageEntityPhone","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"1280209983","predicate":"messageEntityCashtag","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"-1410748418","predicate":"messageActionBotAllowed","params":[{"name":"domain","type":"string"}],"type":"MessageAction"},{"id":"-55902537","predicate":"inputDialogPeer","params":[{"name":"peer","type":"InputPeer"}],"type":"InputDialogPeer"},{"id":"-445792507","predicate":"dialogPeer","params":[{"name":"peer","type":"Peer"}],"type":"DialogPeer"},{"id":"223655517","predicate":"messages.foundStickerSetsNotModified","params":[],"type":"messages.FoundStickerSets"},{"id":"1359533640","predicate":"messages.foundStickerSets","params":[{"name":"hash","type":"int"},{"name":"sets","type":"Vector<StickerSetCovered>"}],"type":"messages.FoundStickerSets"},{"id":"1648543603","predicate":"fileHash","params":[{"name":"offset","type":"int"},{"name":"limit","type":"int"},{"name":"hash","type":"bytes"}],"type":"FileHash"},{"id":"-104284986","predicate":"webDocumentNoProxy","params":[{"name":"url","type":"string"},{"name":"size","type":"int"},{"name":"mime_type","type":"string"},{"name":"attributes","type":"Vector<DocumentAttribute>"}],"type":"WebDocument"},{"id":"1968737087","predicate":"inputClientProxy","params":[{"name":"address","type":"string"},{"name":"port","type":"int"}],"type":"InputClientProxy"},{"id":"-526508104","predicate":"help.proxyDataEmpty","params":[{"name":"expires","type":"int"}],"type":"help.ProxyData"},{"id":"737668643","predicate":"help.proxyDataPromo","params":[{"name":"expires","type":"int"},{"name":"peer","type":"Peer"},{"name":"chats","type":"Vector<Chat>"},{"name":"users","type":"Vector<User>"}],"type":"help.ProxyData"},{"id":"-483352705","predicate":"help.termsOfServiceUpdateEmpty","params":[{"name":"expires","type":"int"}],"type":"help.TermsOfServiceUpdate"},{"id":"686618977","predicate":"help.termsOfServiceUpdate","params":[{"name":"expires","type":"int"},{"name":"terms_of_service","type":"help.TermsOfService"}],"type":"help.TermsOfServiceUpdate"},{"id":"859091184","predicate":"inputSecureFileUploaded","params":[{"name":"id","type":"long"},{"name":"parts","type":"int"},{"name":"md5_checksum","type":"string"},{"name":"file_hash","type":"bytes"},{"name":"secret","type":"bytes"}],"type":"InputSecureFile"},{"id":"1399317950","predicate":"inputSecureFile","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"}],"type":"InputSecureFile"},{"id":"-876089816","predicate":"inputSecureFileLocation","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"}],"type":"InputFileLocation"},{"id":"1679398724","predicate":"secureFileEmpty","params":[],"type":"SecureFile"},{"id":"-534283678","predicate":"secureFile","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"size","type":"int"},{"name":"dc_id","type":"int"},{"name":"date","type":"int"},{"name":"file_hash","type":"bytes"},{"name":"secret","type":"bytes"}],"type":"SecureFile"},{"id":"-1964327229","predicate":"secureData","params":[{"name":"data","type":"bytes"},{"name":"data_hash","type":"bytes"},{"name":"secret","type":"bytes"}],"type":"SecureData"},{"id":"2103482845","predicate":"securePlainPhone","params":[{"name":"phone","type":"string"}],"type":"SecurePlainData"},{"id":"569137759","predicate":"securePlainEmail","params":[{"name":"email","type":"string"}],"type":"SecurePlainData"},{"id":"-1658158621","predicate":"secureValueTypePersonalDetails","params":[],"type":"SecureValueType"},{"id":"1034709504","predicate":"secureValueTypePassport","params":[],"type":"SecureValueType"},{"id":"115615172","predicate":"secureValueTypeDriverLicense","params":[],"type":"SecureValueType"},{"id":"-1596951477","predicate":"secureValueTypeIdentityCard","params":[],"type":"SecureValueType"},{"id":"-1717268701","predicate":"secureValueTypeInternalPassport","params":[],"type":"SecureValueType"},{"id":"-874308058","predicate":"secureValueTypeAddress","params":[],"type":"SecureValueType"},{"id":"-63531698","predicate":"secureValueTypeUtilityBill","params":[],"type":"SecureValueType"},{"id":"-1995211763","predicate":"secureValueTypeBankStatement","params":[],"type":"SecureValueType"},{"id":"-1954007928","predicate":"secureValueTypeRentalAgreement","params":[],"type":"SecureValueType"},{"id":"-1713143702","predicate":"secureValueTypePassportRegistration","params":[],"type":"SecureValueType"},{"id":"-368907213","predicate":"secureValueTypeTemporaryRegistration","params":[],"type":"SecureValueType"},{"id":"-1289704741","predicate":"secureValueTypePhone","params":[],"type":"SecureValueType"},{"id":"-1908627474","predicate":"secureValueTypeEmail","params":[],"type":"SecureValueType"},{"id":"411017418","predicate":"secureValue","params":[{"name":"flags","type":"#"},{"name":"type","type":"SecureValueType"},{"name":"data","type":"flags.0?SecureData"},{"name":"front_side","type":"flags.1?SecureFile"},{"name":"reverse_side","type":"flags.2?SecureFile"},{"name":"selfie","type":"flags.3?SecureFile"},{"name":"translation","type":"flags.6?Vector<SecureFile>"},{"name":"files","type":"flags.4?Vector<SecureFile>"},{"name":"plain_data","type":"flags.5?SecurePlainData"},{"name":"hash","type":"bytes"}],"type":"SecureValue"},{"id":"-618540889","predicate":"inputSecureValue","params":[{"name":"flags","type":"#"},{"name":"type","type":"SecureValueType"},{"name":"data","type":"flags.0?SecureData"},{"name":"front_side","type":"flags.1?InputSecureFile"},{"name":"reverse_side","type":"flags.2?InputSecureFile"},{"name":"selfie","type":"flags.3?InputSecureFile"},{"name":"translation","type":"flags.6?Vector<InputSecureFile>"},{"name":"files","type":"flags.4?Vector<InputSecureFile>"},{"name":"plain_data","type":"flags.5?SecurePlainData"}],"type":"InputSecureValue"},{"id":"-316748368","predicate":"secureValueHash","params":[{"name":"type","type":"SecureValueType"},{"name":"hash","type":"bytes"}],"type":"SecureValueHash"},{"id":"-391902247","predicate":"secureValueErrorData","params":[{"name":"type","type":"SecureValueType"},{"name":"data_hash","type":"bytes"},{"name":"field","type":"string"},{"name":"text","type":"string"}],"type":"SecureValueError"},{"id":"12467706","predicate":"secureValueErrorFrontSide","params":[{"name":"type","type":"SecureValueType"},{"name":"file_hash","type":"bytes"},{"name":"text","type":"string"}],"type":"SecureValueError"},{"id":"-2037765467","predicate":"secureValueErrorReverseSide","params":[{"name":"type","type":"SecureValueType"},{"name":"file_hash","type":"bytes"},{"name":"text","type":"string"}],"type":"SecureValueError"},{"id":"-449327402","predicate":"secureValueErrorSelfie","params":[{"name":"type","type":"SecureValueType"},{"name":"file_hash","type":"bytes"},{"name":"text","type":"string"}],"type":"SecureValueError"},{"id":"2054162547","predicate":"secureValueErrorFile","params":[{"name":"type","type":"SecureValueType"},{"name":"file_hash","type":"bytes"},{"name":"text","type":"string"}],"type":"SecureValueError"},{"id":"1717706985","predicate":"secureValueErrorFiles","params":[{"name":"type","type":"SecureValueType"},{"name":"file_hash","type":"Vector<bytes>"},{"name":"text","type":"string"}],"type":"SecureValueError"},{"id":"871426631","predicate":"secureCredentialsEncrypted","params":[{"name":"data","type":"bytes"},{"name":"hash","type":"bytes"},{"name":"secret","type":"bytes"}],"type":"SecureCredentialsEncrypted"},{"id":"-1389486888","predicate":"account.authorizationForm","params":[{"name":"flags","type":"#"},{"name":"required_types","type":"Vector<SecureRequiredType>"},{"name":"values","type":"Vector<SecureValue>"},{"name":"errors","type":"Vector<SecureValueError>"},{"name":"users","type":"Vector<User>"},{"name":"privacy_policy_url","type":"flags.0?string"}],"type":"account.AuthorizationForm"},{"id":"-2128640689","predicate":"account.sentEmailCode","params":[{"name":"email_pattern","type":"string"},{"name":"length","type":"int"}],"type":"account.SentEmailCode"},{"id":"455635795","predicate":"messageActionSecureValuesSentMe","params":[{"name":"values","type":"Vector<SecureValue>"},{"name":"credentials","type":"SecureCredentialsEncrypted"}],"type":"MessageAction"},{"id":"-648257196","predicate":"messageActionSecureValuesSent","params":[{"name":"types","type":"Vector<SecureValueType>"}],"type":"MessageAction"},{"id":"1722786150","predicate":"help.deepLinkInfoEmpty","params":[],"type":"help.DeepLinkInfo"},{"id":"1783556146","predicate":"help.deepLinkInfo","params":[{"name":"flags","type":"#"},{"name":"update_app","type":"flags.0?true"},{"name":"message","type":"string"},{"name":"entities","type":"flags.1?Vector<MessageEntity>"}],"type":"help.DeepLinkInfo"},{"id":"289586518","predicate":"savedPhoneContact","params":[{"name":"phone","type":"string"},{"name":"first_name","type":"string"},{"name":"last_name","type":"string"},{"name":"date","type":"int"}],"type":"SavedContact"},{"id":"1304052993","predicate":"account.takeout","params":[{"name":"id","type":"long"}],"type":"account.Takeout"},{"id":"700340377","predicate":"inputTakeoutFileLocation","params":[],"type":"InputFileLocation"},{"id":"-513517117","predicate":"updateDialogUnreadMark","params":[{"name":"flags","type":"#"},{"name":"unread","type":"flags.0?true"},{"name":"peer","type":"DialogPeer"}],"type":"Update"},{"id":"-253500010","predicate":"messages.dialogsNotModified","params":[{"name":"count","type":"int"}],"type":"messages.Dialogs"},{"id":"-1625153079","predicate":"inputWebFileGeoPointLocation","params":[{"name":"geo_point","type":"InputGeoPoint"},{"name":"access_hash","type":"long"},{"name":"w","type":"int"},{"name":"h","type":"int"},{"name":"zoom","type":"int"},{"name":"scale","type":"int"}],"type":"InputWebFileLocation"},{"id":"-1255369827","predicate":"contacts.topPeersDisabled","params":[],"type":"contacts.TopPeers"},{"id":"-1685456582","predicate":"inputReportReasonCopyright","params":[],"type":"ReportReason"},{"id":"-732254058","predicate":"passwordKdfAlgoUnknown","params":[],"type":"PasswordKdfAlgo"},{"id":"4883767","predicate":"securePasswordKdfAlgoUnknown","params":[],"type":"SecurePasswordKdfAlgo"},{"id":"-1141711456","predicate":"securePasswordKdfAlgoPBKDF2HMACSHA512iter100000","params":[{"name":"salt","type":"bytes"}],"type":"SecurePasswordKdfAlgo"},{"id":"-2042159726","predicate":"securePasswordKdfAlgoSHA512","params":[{"name":"salt","type":"bytes"}],"type":"SecurePasswordKdfAlgo"},{"id":"354925740","predicate":"secureSecretSettings","params":[{"name":"secure_algo","type":"SecurePasswordKdfAlgo"},{"name":"secure_secret","type":"bytes"},{"name":"secure_secret_id","type":"long"}],"type":"SecureSecretSettings"},{"id":"982592842","predicate":"passwordKdfAlgoSHA256SHA256PBKDF2HMACSHA512iter100000SHA256ModPow","params":[{"name":"salt1","type":"bytes"},{"name":"salt2","type":"bytes"},{"name":"g","type":"int"},{"name":"p","type":"bytes"}],"type":"PasswordKdfAlgo"},{"id":"-1736378792","predicate":"inputCheckPasswordEmpty","params":[],"type":"InputCheckPasswordSRP"},{"id":"-763367294","predicate":"inputCheckPasswordSRP","params":[{"name":"srp_id","type":"long"},{"name":"A","type":"bytes"},{"name":"M1","type":"bytes"}],"type":"InputCheckPasswordSRP"},{"id":"-2036501105","predicate":"secureValueError","params":[{"name":"type","type":"SecureValueType"},{"name":"hash","type":"bytes"},{"name":"text","type":"string"}],"type":"SecureValueError"},{"id":"-1592506512","predicate":"secureValueErrorTranslationFile","params":[{"name":"type","type":"SecureValueType"},{"name":"file_hash","type":"bytes"},{"name":"text","type":"string"}],"type":"SecureValueError"},{"id":"878931416","predicate":"secureValueErrorTranslationFiles","params":[{"name":"type","type":"SecureValueType"},{"name":"file_hash","type":"Vector<bytes>"},{"name":"text","type":"string"}],"type":"SecureValueError"},{"id":"-2103600678","predicate":"secureRequiredType","params":[{"name":"flags","type":"#"},{"name":"native_names","type":"flags.0?true"},{"name":"selfie_required","type":"flags.1?true"},{"name":"translation_required","type":"flags.2?true"},{"name":"type","type":"SecureValueType"}],"type":"SecureRequiredType"},{"id":"41187252","predicate":"secureRequiredTypeOneOf","params":[{"name":"types","type":"Vector<SecureRequiredType>"}],"type":"SecureRequiredType"},{"id":"-1078332329","predicate":"help.passportConfigNotModified","params":[],"type":"help.PassportConfig"},{"id":"-1600596305","predicate":"help.passportConfig","params":[{"name":"hash","type":"int"},{"name":"countries_langs","type":"DataJSON"}],"type":"help.PassportConfig"},{"id":"488313413","predicate":"inputAppEvent","params":[{"name":"time","type":"double"},{"name":"type","type":"string"},{"name":"peer","type":"long"},{"name":"data","type":"JSONValue"}],"type":"InputAppEvent"},{"id":"-1059185703","predicate":"jsonObjectValue","params":[{"name":"key","type":"string"},{"name":"value","type":"JSONValue"}],"type":"JSONObjectValue"},{"id":"1064139624","predicate":"jsonNull","params":[],"type":"JSONValue"},{"id":"-952869270","predicate":"jsonBool","params":[{"name":"value","type":"Bool"}],"type":"JSONValue"},{"id":"736157604","predicate":"jsonNumber","params":[{"name":"value","type":"double"}],"type":"JSONValue"},{"id":"-1222740358","predicate":"jsonString","params":[{"name":"value","type":"string"}],"type":"JSONValue"},{"id":"-146520221","predicate":"jsonArray","params":[{"name":"value","type":"Vector<JSONValue>"}],"type":"JSONValue"},{"id":"-1715350371","predicate":"jsonObject","params":[{"name":"value","type":"Vector<JSONObjectValue>"}],"type":"JSONValue"},{"id":"1279515160","predicate":"updateUserPinnedMessage","params":[{"name":"user_id","type":"int"},{"name":"id","type":"int"}],"type":"Update"},{"id":"-519195831","predicate":"updateChatPinnedMessage","params":[{"name":"chat_id","type":"int"},{"name":"id","type":"int"},{"name":"version","type":"int"}],"type":"Update"},{"id":"-1311015810","predicate":"inputNotifyBroadcasts","params":[],"type":"InputNotifyPeer"},{"id":"-703403793","predicate":"notifyBroadcasts","params":[],"type":"NotifyPeer"},{"id":"-311786236","predicate":"textSubscript","params":[{"name":"text","type":"RichText"}],"type":"RichText"},{"id":"-939827711","predicate":"textSuperscript","params":[{"name":"text","type":"RichText"}],"type":"RichText"},{"id":"55281185","predicate":"textMarked","params":[{"name":"text","type":"RichText"}],"type":"RichText"},{"id":"483104362","predicate":"textPhone","params":[{"name":"text","type":"RichText"},{"name":"phone","type":"string"}],"type":"RichText"},{"id":"136105807","predicate":"textImage","params":[{"name":"document_id","type":"long"},{"name":"w","type":"int"},{"name":"h","type":"int"}],"type":"RichText"},{"id":"504660880","predicate":"pageBlockKicker","params":[{"name":"text","type":"RichText"}],"type":"PageBlock"},{"id":"878078826","predicate":"pageTableCell","params":[{"name":"flags","type":"#"},{"name":"header","type":"flags.0?true"},{"name":"align_center","type":"flags.3?true"},{"name":"align_right","type":"flags.4?true"},{"name":"valign_middle","type":"flags.5?true"},{"name":"valign_bottom","type":"flags.6?true"},{"name":"text","type":"flags.7?RichText"},{"name":"colspan","type":"flags.1?int"},{"name":"rowspan","type":"flags.2?int"}],"type":"PageTableCell"},{"id":"-524237339","predicate":"pageTableRow","params":[{"name":"cells","type":"Vector<PageTableCell>"}],"type":"PageTableRow"},{"id":"-1085412734","predicate":"pageBlockTable","params":[{"name":"flags","type":"#"},{"name":"bordered","type":"flags.0?true"},{"name":"striped","type":"flags.1?true"},{"name":"title","type":"RichText"},{"name":"rows","type":"Vector<PageTableRow>"}],"type":"PageBlock"},{"id":"1869903447","predicate":"pageCaption","params":[{"name":"text","type":"RichText"},{"name":"credit","type":"RichText"}],"type":"PageCaption"},{"id":"-1188055347","predicate":"pageListItemText","params":[{"name":"text","type":"RichText"}],"type":"PageListItem"},{"id":"635466748","predicate":"pageListItemBlocks","params":[{"name":"blocks","type":"Vector<PageBlock>"}],"type":"PageListItem"},{"id":"1577484359","predicate":"pageListOrderedItemText","params":[{"name":"num","type":"string"},{"name":"text","type":"RichText"}],"type":"PageListOrderedItem"},{"id":"-1730311882","predicate":"pageListOrderedItemBlocks","params":[{"name":"num","type":"string"},{"name":"blocks","type":"Vector<PageBlock>"}],"type":"PageListOrderedItem"},{"id":"-1702174239","predicate":"pageBlockOrderedList","params":[{"name":"items","type":"Vector<PageListOrderedItem>"}],"type":"PageBlock"},{"id":"1987480557","predicate":"pageBlockDetails","params":[{"name":"flags","type":"#"},{"name":"open","type":"flags.0?true"},{"name":"blocks","type":"Vector<PageBlock>"},{"name":"title","type":"RichText"}],"type":"PageBlock"},{"id":"-1282352120","predicate":"pageRelatedArticle","params":[{"name":"flags","type":"#"},{"name":"url","type":"string"},{"name":"webpage_id","type":"long"},{"name":"title","type":"flags.0?string"},{"name":"description","type":"flags.1?string"},{"name":"photo_id","type":"flags.2?long"},{"name":"author","type":"flags.3?string"},{"name":"published_date","type":"flags.4?int"}],"type":"PageRelatedArticle"},{"id":"370236054","predicate":"pageBlockRelatedArticles","params":[{"name":"title","type":"RichText"},{"name":"articles","type":"Vector<PageRelatedArticle>"}],"type":"PageBlock"},{"id":"-1538310410","predicate":"pageBlockMap","params":[{"name":"geo","type":"GeoPoint"},{"name":"zoom","type":"int"},{"name":"w","type":"int"},{"name":"h","type":"int"},{"name":"caption","type":"PageCaption"}],"type":"PageBlock"},{"id":"-1366746132","predicate":"page","params":[{"name":"flags","type":"#"},{"name":"part","type":"flags.0?true"},{"name":"rtl","type":"flags.1?true"},{"name":"v2","type":"flags.2?true"},{"name":"url","type":"string"},{"name":"blocks","type":"Vector<PageBlock>"},{"name":"photos","type":"Vector<Photo>"},{"name":"documents","type":"Vector<Document>"}],"type":"Page"},{"id":"-610373422","predicate":"inputPrivacyKeyPhoneP2P","params":[],"type":"InputPrivacyKey"},{"id":"961092808","predicate":"privacyKeyPhoneP2P","params":[],"type":"PrivacyKey"},{"id":"894777186","predicate":"textAnchor","params":[{"name":"text","type":"RichText"},{"name":"name","type":"string"}],"type":"RichText"},{"id":"-1945767479","predicate":"help.supportName","params":[{"name":"name","type":"string"}],"type":"help.SupportName"},{"id":"-206688531","predicate":"help.userInfoEmpty","params":[],"type":"help.UserInfo"},{"id":"32192344","predicate":"help.userInfo","params":[{"name":"message","type":"string"},{"name":"entities","type":"Vector<MessageEntity>"},{"name":"author","type":"string"},{"name":"date","type":"int"}],"type":"help.UserInfo"},{"id":"-202219658","predicate":"messageActionContactSignUp","params":[],"type":"MessageAction"},{"id":"-1398708869","predicate":"updateMessagePoll","params":[{"name":"flags","type":"#"},{"name":"poll_id","type":"long"},{"name":"poll","type":"flags.0?Poll"},{"name":"results","type":"PollResults"}],"type":"Update"},{"id":"1823064809","predicate":"pollAnswer","params":[{"name":"text","type":"string"},{"name":"option","type":"bytes"}],"type":"PollAnswer"},{"id":"-716006138","predicate":"poll","params":[{"name":"id","type":"long"},{"name":"flags","type":"#"},{"name":"closed","type":"flags.0?true"},{"name":"question","type":"string"},{"name":"answers","type":"Vector<PollAnswer>"}],"type":"Poll"},{"id":"997055186","predicate":"pollAnswerVoters","params":[{"name":"flags","type":"#"},{"name":"chosen","type":"flags.0?true"},{"name":"option","type":"bytes"},{"name":"voters","type":"int"}],"type":"PollAnswerVoters"},{"id":"1465219162","predicate":"pollResults","params":[{"name":"flags","type":"#"},{"name":"min","type":"flags.0?true"},{"name":"results","type":"flags.1?Vector<PollAnswerVoters>"},{"name":"total_voters","type":"flags.2?int"}],"type":"PollResults"},{"id":"112424539","predicate":"inputMediaPoll","params":[{"name":"poll","type":"Poll"}],"type":"InputMedia"},{"id":"1272375192","predicate":"messageMediaPoll","params":[{"name":"poll","type":"Poll"},{"name":"results","type":"PollResults"}],"type":"MessageMedia"},{"id":"-264117680","predicate":"chatOnlines","params":[{"name":"onlines","type":"int"}],"type":"ChatOnlines"},{"id":"1202287072","predicate":"statsURL","params":[{"name":"url","type":"string"}],"type":"StatsURL"},{"id":"-525288402","predicate":"photoStrippedSize","params":[{"name":"type","type":"string"},{"name":"bytes","type":"bytes"}],"type":"PhotoSize"},{"id":"1605510357","predicate":"chatAdminRights","params":[{"name":"flags","type":"#"},{"name":"change_info","type":"flags.0?true"},{"name":"post_messages","type":"flags.1?true"},{"name":"edit_messages","type":"flags.2?true"},{"name":"delete_messages","type":"flags.3?true"},{"name":"ban_users","type":"flags.4?true"},{"name":"invite_users","type":"flags.5?true"},{"name":"pin_messages","type":"flags.7?true"},{"name":"add_admins","type":"flags.9?true"}],"type":"ChatAdminRights"},{"id":"-1626209256","predicate":"chatBannedRights","params":[{"name":"flags","type":"#"},{"name":"view_messages","type":"flags.0?true"},{"name":"send_messages","type":"flags.1?true"},{"name":"send_media","type":"flags.2?true"},{"name":"send_stickers","type":"flags.3?true"},{"name":"send_gifs","type":"flags.4?true"},{"name":"send_games","type":"flags.5?true"},{"name":"send_inline","type":"flags.6?true"},{"name":"embed_links","type":"flags.7?true"},{"name":"send_polls","type":"flags.8?true"},{"name":"change_info","type":"flags.10?true"},{"name":"invite_users","type":"flags.15?true"},{"name":"pin_messages","type":"flags.17?true"},{"name":"until_date","type":"int"}],"type":"ChatBannedRights"},{"id":"1421875280","predicate":"updateChatDefaultBannedRights","params":[{"name":"peer","type":"Peer"},{"name":"default_banned_rights","type":"ChatBannedRights"},{"name":"version","type":"int"}],"type":"Update"},{"id":"-433014407","predicate":"inputWallPaper","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"}],"type":"InputWallPaper"},{"id":"1913199744","predicate":"inputWallPaperSlug","params":[{"name":"slug","type":"string"}],"type":"InputWallPaper"},{"id":"-1150621555","predicate":"channelParticipantsContacts","params":[{"name":"q","type":"string"}],"type":"ChannelParticipantsFilter"},{"id":"771095562","predicate":"channelAdminLogEventActionDefaultBannedRights","params":[{"name":"prev_banned_rights","type":"ChatBannedRights"},{"name":"new_banned_rights","type":"ChatBannedRights"}],"type":"ChannelAdminLogEventAction"},{"id":"-1895328189","predicate":"channelAdminLogEventActionStopPoll","params":[{"name":"message","type":"Message"}],"type":"ChannelAdminLogEventAction"},{"id":"471437699","predicate":"account.wallPapersNotModified","params":[],"type":"account.WallPapers"},{"id":"1881892265","predicate":"account.wallPapers","params":[{"name":"hash","type":"int"},{"name":"wallpapers","type":"Vector<WallPaper>"}],"type":"account.WallPapers"},{"id":"-557924733","predicate":"codeSettings","params":[{"name":"flags","type":"#"},{"name":"allow_flashcall","type":"flags.0?true"},{"name":"current_number","type":"flags.1?true"},{"name":"allow_app_hash","type":"flags.4?true"}],"type":"CodeSettings"},{"id":"-1590738760","predicate":"wallPaperSettings","params":[{"name":"flags","type":"#"},{"name":"blur","type":"flags.1?true"},{"name":"motion","type":"flags.2?true"},{"name":"background_color","type":"flags.0?int"},{"name":"intensity","type":"flags.3?int"}],"type":"WallPaperSettings"},{"id":"-767099577","predicate":"autoDownloadSettings","params":[{"name":"flags","type":"#"},{"name":"disabled","type":"flags.0?true"},{"name":"video_preload_large","type":"flags.1?true"},{"name":"audio_preload_next","type":"flags.2?true"},{"name":"phonecalls_less_data","type":"flags.3?true"},{"name":"photo_size_max","type":"int"},{"name":"video_size_max","type":"int"},{"name":"file_size_max","type":"int"}],"type":"AutoDownloadSettings"},{"id":"1674235686","predicate":"account.autoDownloadSettings","params":[{"name":"low","type":"AutoDownloadSettings"},{"name":"medium","type":"AutoDownloadSettings"},{"name":"high","type":"AutoDownloadSettings"}],"type":"account.AutoDownloadSettings"},{"id":"-709641735","predicate":"emojiKeyword","params":[{"name":"keyword","type":"string"},{"name":"emoticons","type":"Vector<string>"}],"type":"EmojiKeyword"},{"id":"594408994","predicate":"emojiKeywordDeleted","params":[{"name":"keyword","type":"string"},{"name":"emoticons","type":"Vector<string>"}],"type":"EmojiKeyword"},{"id":"1556570557","predicate":"emojiKeywordsDifference","params":[{"name":"lang_code","type":"string"},{"name":"from_version","type":"int"},{"name":"version","type":"int"},{"name":"keywords","type":"Vector<EmojiKeyword>"}],"type":"EmojiKeywordsDifference"},{"id":"-1519029347","predicate":"emojiURL","params":[{"name":"url","type":"string"}],"type":"EmojiURL"},{"id":"-1275374751","predicate":"emojiLanguage","params":[{"name":"lang_code","type":"string"}],"type":"EmojiLanguage"},{"id":"-1529000952","predicate":"inputPrivacyKeyForwards","params":[],"type":"InputPrivacyKey"},{"id":"1777096355","predicate":"privacyKeyForwards","params":[],"type":"PrivacyKey"},{"id":"1461304012","predicate":"inputPrivacyKeyProfilePhoto","params":[],"type":"InputPrivacyKey"},{"id":"-1777000467","predicate":"privacyKeyProfilePhoto","params":[],"type":"PrivacyKey"},{"id":"-1132476723","predicate":"fileLocationToBeDeprecated","params":[{"name":"volume_id","type":"long"},{"name":"local_id","type":"int"}],"type":"FileLocation"},{"id":"1075322878","predicate":"inputPhotoFileLocation","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"file_reference","type":"bytes"},{"name":"thumb_size","type":"string"}],"type":"InputFileLocation"},{"id":"-667654413","predicate":"inputPhotoLegacyFileLocation","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"file_reference","type":"bytes"},{"name":"volume_id","type":"long"},{"name":"local_id","type":"int"},{"name":"secret","type":"long"}],"type":"InputFileLocation"},{"id":"668375447","predicate":"inputPeerPhotoFileLocation","params":[{"name":"flags","type":"#"},{"name":"big","type":"flags.0?true"},{"name":"peer","type":"InputPeer"},{"name":"volume_id","type":"long"},{"name":"local_id","type":"int"}],"type":"InputFileLocation"},{"id":"230353641","predicate":"inputStickerSetThumb","params":[{"name":"stickerset","type":"InputStickerSet"},{"name":"volume_id","type":"long"},{"name":"local_id","type":"int"}],"type":"InputFileLocation"},{"id":"-11252123","predicate":"folder","params":[{"name":"flags","type":"#"},{"name":"autofill_new_broadcasts","type":"flags.0?true"},{"name":"autofill_public_groups","type":"flags.1?true"},{"name":"autofill_new_correspondents","type":"flags.2?true"},{"name":"id","type":"int"},{"name":"title","type":"string"},{"name":"photo","type":"flags.3?ChatPhoto"}],"type":"Folder"},{"id":"1908216652","predicate":"dialogFolder","params":[{"name":"flags","type":"#"},{"name":"pinned","type":"flags.2?true"},{"name":"folder","type":"Folder"},{"name":"peer","type":"Peer"},{"name":"top_message","type":"int"},{"name":"unread_muted_peers_count","type":"int"},{"name":"unread_unmuted_peers_count","type":"int"},{"name":"unread_muted_messages_count","type":"int"},{"name":"unread_unmuted_messages_count","type":"int"}],"type":"Dialog"},{"id":"1684014375","predicate":"inputDialogPeerFolder","params":[{"name":"folder_id","type":"int"}],"type":"InputDialogPeer"},{"id":"1363483106","predicate":"dialogPeerFolder","params":[{"name":"folder_id","type":"int"}],"type":"DialogPeer"},{"id":"-70073706","predicate":"inputFolderPeer","params":[{"name":"peer","type":"InputPeer"},{"name":"folder_id","type":"int"}],"type":"InputFolderPeer"},{"id":"-373643672","predicate":"folderPeer","params":[{"name":"peer","type":"Peer"},{"name":"folder_id","type":"int"}],"type":"FolderPeer"},{"id":"422972864","predicate":"updateFolderPeers","params":[{"name":"folder_peers","type":"Vector<FolderPeer>"},{"name":"pts","type":"int"},{"name":"pts_count","type":"int"}],"type":"Update"},{"id":"756118935","predicate":"inputUserFromMessage","params":[{"name":"peer","type":"InputPeer"},{"name":"msg_id","type":"int"},{"name":"user_id","type":"int"}],"type":"InputUser"},{"id":"707290417","predicate":"inputChannelFromMessage","params":[{"name":"peer","type":"InputPeer"},{"name":"msg_id","type":"int"},{"name":"channel_id","type":"int"}],"type":"InputChannel"},{"id":"398123750","predicate":"inputPeerUserFromMessage","params":[{"name":"peer","type":"InputPeer"},{"name":"msg_id","type":"int"},{"name":"user_id","type":"int"}],"type":"InputPeer"},{"id":"-1667893317","predicate":"inputPeerChannelFromMessage","params":[{"name":"peer","type":"InputPeer"},{"name":"msg_id","type":"int"},{"name":"channel_id","type":"int"}],"type":"InputPeer"},{"id":"55761658","predicate":"inputPrivacyKeyPhoneNumber","params":[],"type":"InputPrivacyKey"},{"id":"-778378131","predicate":"privacyKeyPhoneNumber","params":[],"type":"PrivacyKey"},{"id":"-1472172887","predicate":"topPeerCategoryForwardUsers","params":[],"type":"TopPeerCategory"},{"id":"-68239120","predicate":"topPeerCategoryForwardChats","params":[],"type":"TopPeerCategory"},{"id":"-1569748965","predicate":"channelAdminLogEventActionChangeLinkedChat","params":[{"name":"prev_value","type":"int"},{"name":"new_value","type":"int"}],"type":"ChannelAdminLogEventAction"},{"id":"-398136321","predicate":"messages.searchCounter","params":[{"name":"flags","type":"#"},{"name":"inexact","type":"flags.1?true"},{"name":"filter","type":"MessagesFilter"},{"name":"count","type":"int"}],"type":"messages.SearchCounter"},{"id":"280464681","predicate":"keyboardButtonUrlAuth","params":[{"name":"flags","type":"#"},{"name":"text","type":"string"},{"name":"fwd_text","type":"flags.0?string"},{"name":"url","type":"string"},{"name":"button_id","type":"int"}],"type":"KeyboardButton"},{"id":"-802258988","predicate":"inputKeyboardButtonUrlAuth","params":[{"name":"flags","type":"#"},{"name":"request_write_access","type":"flags.0?true"},{"name":"text","type":"string"},{"name":"fwd_text","type":"flags.1?string"},{"name":"url","type":"string"},{"name":"bot","type":"InputUser"}],"type":"KeyboardButton"},{"id":"-1831650802","predicate":"urlAuthResultRequest","params":[{"name":"flags","type":"#"},{"name":"request_write_access","type":"flags.0?true"},{"name":"bot","type":"User"},{"name":"domain","type":"string"}],"type":"UrlAuthResult"},{"id":"-1886646706","predicate":"urlAuthResultAccepted","params":[{"name":"url","type":"string"}],"type":"UrlAuthResult"},{"id":"-1445536993","predicate":"urlAuthResultDefault","params":[],"type":"UrlAuthResult"},{"id":"1283572154","predicate":"inputPrivacyValueAllowChatParticipants","params":[{"name":"chats","type":"Vector<int>"}],"type":"InputPrivacyRule"},{"id":"-668769361","predicate":"inputPrivacyValueDisallowChatParticipants","params":[{"name":"chats","type":"Vector<int>"}],"type":"InputPrivacyRule"},{"id":"415136107","predicate":"privacyValueAllowChatParticipants","params":[{"name":"chats","type":"Vector<int>"}],"type":"PrivacyRule"},{"id":"-1397881200","predicate":"privacyValueDisallowChatParticipants","params":[{"name":"chats","type":"Vector<int>"}],"type":"PrivacyRule"},{"id":"-1672577397","predicate":"messageEntityUnderline","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"-1090087980","predicate":"messageEntityStrike","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"34469328","predicate":"messageEntityBlockquote","params":[{"name":"offset","type":"int"},{"name":"length","type":"int"}],"type":"MessageEntity"},{"id":"1786671974","predicate":"updatePeerSettings","params":[{"name":"peer","type":"Peer"},{"name":"settings","type":"PeerSettings"}],"type":"Update"},{"id":"-1078612597","predicate":"channelLocationEmpty","params":[],"type":"ChannelLocation"},{"id":"547062491","predicate":"channelLocation","params":[{"name":"geo_point","type":"GeoPoint"},{"name":"address","type":"string"}],"type":"ChannelLocation"},{"id":"-901375139","predicate":"peerLocated","params":[{"name":"peer","type":"Peer"},{"name":"expires","type":"int"},{"name":"distance","type":"int"}],"type":"PeerLocated"},{"id":"-1263546448","predicate":"updatePeerLocated","params":[{"name":"peers","type":"Vector<PeerLocated>"}],"type":"Update"},{"id":"241923758","predicate":"channelAdminLogEventActionChangeLocation","params":[{"name":"prev_value","type":"ChannelLocation"},{"name":"new_value","type":"ChannelLocation"}],"type":"ChannelAdminLogEventAction"},{"id":"-606798099","predicate":"inputReportReasonGeoIrrelevant","params":[],"type":"ReportReason"},{"id":"1401984889","predicate":"channelAdminLogEventActionToggleSlowMode","params":[{"name":"prev_value","type":"int"},{"name":"new_value","type":"int"}],"type":"ChannelAdminLogEventAction"},{"id":"1148485274","predicate":"auth.authorizationSignUpRequired","params":[{"name":"flags","type":"#"},{"name":"terms_of_service","type":"flags.0?help.TermsOfService"}],"type":"auth.Authorization"},{"id":"-666824391","predicate":"payments.paymentVerificationNeeded","params":[{"name":"url","type":"string"}],"type":"payments.PaymentResult"},{"id":"42402760","predicate":"inputStickerSetAnimatedEmoji","params":[],"type":"InputStickerSet"},{"id":"967122427","predicate":"updateNewScheduledMessage","params":[{"name":"message","type":"Message"}],"type":"Update"},{"id":"-1870238482","predicate":"updateDeleteScheduledMessages","params":[{"name":"peer","type":"Peer"},{"name":"messages","type":"Vector<int>"}],"type":"Update"},{"id":"-797791052","predicate":"restrictionReason","params":[{"name":"platform","type":"string"},{"name":"reason","type":"string"},{"name":"text","type":"string"}],"type":"RestrictionReason"},{"id":"1012306921","predicate":"inputTheme","params":[{"name":"id","type":"long"},{"name":"access_hash","type":"long"}],"type":"InputTheme"},{"id":"-175567375","predicate":"inputThemeSlug","params":[{"name":"slug","type":"string"}],"type":"InputTheme"},{"id":"1211967244","predicate":"themeDocumentNotModified","params":[],"type":"Theme"},{"id":"-136770336","predicate":"theme","params":[{"name":"flags","type":"#"},{"name":"creator","type":"flags.0?true"},{"name":"default","type":"flags.1?true"},{"name":"id","type":"long"},{"name":"access_hash","type":"long"},{"name":"slug","type":"string"},{"name":"title","type":"string"},{"name":"document","type":"flags.2?Document"},{"name":"installs_count","type":"int"}],"type":"Theme"},{"id":"-199313886","predicate":"account.themesNotModified","params":[],"type":"account.Themes"},{"id":"2137482273","predicate":"account.themes","params":[{"name":"hash","type":"int"},{"name":"themes","type":"Vector<Theme>"}],"type":"account.Themes"},{"id":"-2112423005","predicate":"updateTheme","params":[{"name":"theme","type":"Theme"}],"type":"Update"},{"id":"-786326563","predicate":"inputPrivacyKeyAddedByPhone","params":[],"type":"InputPrivacyKey"},{"id":"1124062251","predicate":"privacyKeyAddedByPhone","params":[],"type":"PrivacyKey"}],"methods":[{"id":"-878758099","method":"invokeAfterMsg","params":[{"name":"msg_id","type":"long"},{"name":"query","type":"!X"}],"type":"X"},{"id":"1036301552","method":"invokeAfterMsgs","params":[{"name":"msg_ids","type":"Vector<long>"},{"name":"query","type":"!X"}],"type":"X"},{"id":"-1502141361","method":"auth.sendCode","params":[{"name":"phone_number","type":"string"},{"name":"api_id","type":"int"},{"name":"api_hash","type":"string"},{"name":"settings","type":"CodeSettings"}],"type":"auth.SentCode"},{"id":"-2131827673","method":"auth.signUp","params":[{"name":"phone_number","type":"string"},{"name":"phone_code_hash","type":"string"},{"name":"first_name","type":"string"},{"name":"last_name","type":"string"}],"type":"auth.Authorization"},{"id":"-1126886015","method":"auth.signIn","params":[{"name":"phone_number","type":"string"},{"name":"phone_code_hash","type":"string"},{"name":"phone_code","type":"string"}],"type":"auth.Authorization"},{"id":"1461180992","method":"auth.logOut","params":[],"type":"Bool"},{"id":"-1616179942","method":"auth.resetAuthorizations","params":[],"type":"Bool"},{"id":"-440401971","method":"auth.exportAuthorization","params":[{"name":"dc_id","type":"int"}],"type":"auth.ExportedAuthorization"},{"id":"-470837741","method":"auth.importAuthorization","params":[{"name":"id","type":"int"},{"name":"bytes","type":"bytes"}],"type":"auth.Authorization"},{"id":"-841733627","method":"auth.bindTempAuthKey","params":[{"name":"perm_auth_key_id","type":"long"},{"name":"nonce","type":"long"},{"name":"expires_at","type":"int"},{"name":"encrypted_message","type":"bytes"}],"type":"Bool"},{"id":"1754754159","method":"account.registerDevice","params":[{"name":"flags","type":"#"},{"name":"no_muted","type":"flags.0?true"},{"name":"token_type","type":"int"},{"name":"token","type":"string"},{"name":"app_sandbox","type":"Bool"},{"name":"secret","type":"bytes"},{"name":"other_uids","type":"Vector<int>"}],"type":"Bool"},{"id":"813089983","method":"account.unregisterDevice","params":[{"name":"token_type","type":"int"},{"name":"token","type":"string"},{"name":"other_uids","type":"Vector<int>"}],"type":"Bool"},{"id":"-2067899501","method":"account.updateNotifySettings","params":[{"name":"peer","type":"InputNotifyPeer"},{"name":"settings","type":"InputPeerNotifySettings"}],"type":"Bool"},{"id":"313765169","method":"account.getNotifySettings","params":[{"name":"peer","type":"InputNotifyPeer"}],"type":"PeerNotifySettings"},{"id":"-612493497","method":"account.resetNotifySettings","params":[],"type":"Bool"},{"id":"2018596725","method":"account.updateProfile","params":[{"name":"flags","type":"#"},{"name":"first_name","type":"flags.0?string"},{"name":"last_name","type":"flags.1?string"},{"name":"about","type":"flags.2?string"}],"type":"User"},{"id":"1713919532","method":"account.updateStatus","params":[{"name":"offline","type":"Bool"}],"type":"Bool"},{"id":"-1430579357","method":"account.getWallPapers","params":[{"name":"hash","type":"int"}],"type":"account.WallPapers"},{"id":"-1374118561","method":"account.reportPeer","params":[{"name":"peer","type":"InputPeer"},{"name":"reason","type":"ReportReason"}],"type":"Bool"},{"id":"227648840","method":"users.getUsers","params":[{"name":"id","type":"Vector<InputUser>"}],"type":"Vector<User>"},{"id":"-902781519","method":"users.getFullUser","params":[{"name":"id","type":"InputUser"}],"type":"UserFull"},{"id":"749357634","method":"contacts.getContactIDs","params":[{"name":"hash","type":"int"}],"type":"Vector<int>"},{"id":"-995929106","method":"contacts.getStatuses","params":[],"type":"Vector<ContactStatus>"},{"id":"-1071414113","method":"contacts.getContacts","params":[{"name":"hash","type":"int"}],"type":"contacts.Contacts"},{"id":"746589157","method":"contacts.importContacts","params":[{"name":"contacts","type":"Vector<InputContact>"}],"type":"contacts.ImportedContacts"},{"id":"157945344","method":"contacts.deleteContacts","params":[{"name":"id","type":"Vector<InputUser>"}],"type":"Updates"},{"id":"269745566","method":"contacts.deleteByPhones","params":[{"name":"phones","type":"Vector<string>"}],"type":"Bool"},{"id":"858475004","method":"contacts.block","params":[{"name":"id","type":"InputUser"}],"type":"Bool"},{"id":"-448724803","method":"contacts.unblock","params":[{"name":"id","type":"InputUser"}],"type":"Bool"},{"id":"-176409329","method":"contacts.getBlocked","params":[{"name":"offset","type":"int"},{"name":"limit","type":"int"}],"type":"contacts.Blocked"},{"id":"1673946374","method":"messages.getMessages","params":[{"name":"id","type":"Vector<InputMessage>"}],"type":"messages.Messages"},{"id":"-1594999949","method":"messages.getDialogs","params":[{"name":"flags","type":"#"},{"name":"exclude_pinned","type":"flags.0?true"},{"name":"folder_id","type":"flags.1?int"},{"name":"offset_date","type":"int"},{"name":"offset_id","type":"int"},{"name":"offset_peer","type":"InputPeer"},{"name":"limit","type":"int"},{"name":"hash","type":"int"}],"type":"messages.Dialogs"},{"id":"-591691168","method":"messages.getHistory","params":[{"name":"peer","type":"InputPeer"},{"name":"offset_id","type":"int"},{"name":"offset_date","type":"int"},{"name":"add_offset","type":"int"},{"name":"limit","type":"int"},{"name":"max_id","type":"int"},{"name":"min_id","type":"int"},{"name":"hash","type":"int"}],"type":"messages.Messages"},{"id":"-2045448344","method":"messages.search","params":[{"name":"flags","type":"#"},{"name":"peer","type":"InputPeer"},{"name":"q","type":"string"},{"name":"from_id","type":"flags.0?InputUser"},{"name":"filter","type":"MessagesFilter"},{"name":"min_date","type":"int"},{"name":"max_date","type":"int"},{"name":"offset_id","type":"int"},{"name":"add_offset","type":"int"},{"name":"limit","type":"int"},{"name":"max_id","type":"int"},{"name":"min_id","type":"int"},{"name":"hash","type":"int"}],"type":"messages.Messages"},{"id":"238054714","method":"messages.readHistory","params":[{"name":"peer","type":"InputPeer"},{"name":"max_id","type":"int"}],"type":"messages.AffectedMessages"},{"id":"469850889","method":"messages.deleteHistory","params":[{"name":"flags","type":"#"},{"name":"just_clear","type":"flags.0?true"},{"name":"revoke","type":"flags.1?true"},{"name":"peer","type":"InputPeer"},{"name":"max_id","type":"int"}],"type":"messages.AffectedHistory"},{"id":"-443640366","method":"messages.deleteMessages","params":[{"name":"flags","type":"#"},{"name":"revoke","type":"flags.0?true"},{"name":"id","type":"Vector<int>"}],"type":"messages.AffectedMessages"},{"id":"94983360","method":"messages.receivedMessages","params":[{"name":"max_id","type":"int"}],"type":"Vector<ReceivedNotifyMessage>"},{"id":"-1551737264","method":"messages.setTyping","params":[{"name":"peer","type":"InputPeer"},{"name":"action","type":"SendMessageAction"}],"type":"Bool"},{"id":"1376532592","method":"messages.sendMessage","params":[{"name":"flags","type":"#"},{"name":"no_webpage","type":"flags.1?true"},{"name":"silent","type":"flags.5?true"},{"name":"background","type":"flags.6?true"},{"name":"clear_draft","type":"flags.7?true"},{"name":"peer","type":"InputPeer"},{"name":"reply_to_msg_id","type":"flags.0?int"},{"name":"message","type":"string"},{"name":"random_id","type":"long"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"},{"name":"entities","type":"flags.3?Vector<MessageEntity>"},{"name":"schedule_date","type":"flags.10?int"}],"type":"Updates"},{"id":"881978281","method":"messages.sendMedia","params":[{"name":"flags","type":"#"},{"name":"silent","type":"flags.5?true"},{"name":"background","type":"flags.6?true"},{"name":"clear_draft","type":"flags.7?true"},{"name":"peer","type":"InputPeer"},{"name":"reply_to_msg_id","type":"flags.0?int"},{"name":"media","type":"InputMedia"},{"name":"message","type":"string"},{"name":"random_id","type":"long"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"},{"name":"entities","type":"flags.3?Vector<MessageEntity>"},{"name":"schedule_date","type":"flags.10?int"}],"type":"Updates"},{"id":"-637606386","method":"messages.forwardMessages","params":[{"name":"flags","type":"#"},{"name":"silent","type":"flags.5?true"},{"name":"background","type":"flags.6?true"},{"name":"with_my_score","type":"flags.8?true"},{"name":"grouped","type":"flags.9?true"},{"name":"from_peer","type":"InputPeer"},{"name":"id","type":"Vector<int>"},{"name":"random_id","type":"Vector<long>"},{"name":"to_peer","type":"InputPeer"},{"name":"schedule_date","type":"flags.10?int"}],"type":"Updates"},{"id":"-820669733","method":"messages.reportSpam","params":[{"name":"peer","type":"InputPeer"}],"type":"Bool"},{"id":"913498268","method":"messages.getPeerSettings","params":[{"name":"peer","type":"InputPeer"}],"type":"PeerSettings"},{"id":"-1115507112","method":"messages.report","params":[{"name":"peer","type":"InputPeer"},{"name":"id","type":"Vector<int>"},{"name":"reason","type":"ReportReason"}],"type":"Bool"},{"id":"1013621127","method":"messages.getChats","params":[{"name":"id","type":"Vector<int>"}],"type":"messages.Chats"},{"id":"998448230","method":"messages.getFullChat","params":[{"name":"chat_id","type":"int"}],"type":"messages.ChatFull"},{"id":"-599447467","method":"messages.editChatTitle","params":[{"name":"chat_id","type":"int"},{"name":"title","type":"string"}],"type":"Updates"},{"id":"-900957736","method":"messages.editChatPhoto","params":[{"name":"chat_id","type":"int"},{"name":"photo","type":"InputChatPhoto"}],"type":"Updates"},{"id":"-106911223","method":"messages.addChatUser","params":[{"name":"chat_id","type":"int"},{"name":"user_id","type":"InputUser"},{"name":"fwd_limit","type":"int"}],"type":"Updates"},{"id":"-530505962","method":"messages.deleteChatUser","params":[{"name":"chat_id","type":"int"},{"name":"user_id","type":"InputUser"}],"type":"Updates"},{"id":"164303470","method":"messages.createChat","params":[{"name":"users","type":"Vector<InputUser>"},{"name":"title","type":"string"}],"type":"Updates"},{"id":"-304838614","method":"updates.getState","params":[],"type":"updates.State"},{"id":"630429265","method":"updates.getDifference","params":[{"name":"flags","type":"#"},{"name":"pts","type":"int"},{"name":"pts_total_limit","type":"flags.0?int"},{"name":"date","type":"int"},{"name":"qts","type":"int"}],"type":"updates.Difference"},{"id":"-256159406","method":"photos.updateProfilePhoto","params":[{"name":"id","type":"InputPhoto"}],"type":"UserProfilePhoto"},{"id":"1328726168","method":"photos.uploadProfilePhoto","params":[{"name":"file","type":"InputFile"}],"type":"photos.Photo"},{"id":"-2016444625","method":"photos.deletePhotos","params":[{"name":"id","type":"Vector<InputPhoto>"}],"type":"Vector<long>"},{"id":"-1291540959","method":"upload.saveFilePart","params":[{"name":"file_id","type":"long"},{"name":"file_part","type":"int"},{"name":"bytes","type":"bytes"}],"type":"Bool"},{"id":"-1319462148","method":"upload.getFile","params":[{"name":"flags","type":"#"},{"name":"precise","type":"flags.0?true"},{"name":"location","type":"InputFileLocation"},{"name":"offset","type":"int"},{"name":"limit","type":"int"}],"type":"upload.File"},{"id":"-990308245","method":"help.getConfig","params":[],"type":"Config"},{"id":"531836966","method":"help.getNearestDc","params":[],"type":"NearestDc"},{"id":"1378703997","method":"help.getAppUpdate","params":[{"name":"source","type":"string"}],"type":"help.AppUpdate"},{"id":"1295590211","method":"help.getInviteText","params":[],"type":"help.InviteText"},{"id":"-1848823128","method":"photos.getUserPhotos","params":[{"name":"user_id","type":"InputUser"},{"name":"offset","type":"int"},{"name":"max_id","type":"long"},{"name":"limit","type":"int"}],"type":"photos.Photos"},{"id":"651135312","method":"messages.getDhConfig","params":[{"name":"version","type":"int"},{"name":"random_length","type":"int"}],"type":"messages.DhConfig"},{"id":"-162681021","method":"messages.requestEncryption","params":[{"name":"user_id","type":"InputUser"},{"name":"random_id","type":"int"},{"name":"g_a","type":"bytes"}],"type":"EncryptedChat"},{"id":"1035731989","method":"messages.acceptEncryption","params":[{"name":"peer","type":"InputEncryptedChat"},{"name":"g_b","type":"bytes"},{"name":"key_fingerprint","type":"long"}],"type":"EncryptedChat"},{"id":"-304536635","method":"messages.discardEncryption","params":[{"name":"chat_id","type":"int"}],"type":"Bool"},{"id":"2031374829","method":"messages.setEncryptedTyping","params":[{"name":"peer","type":"InputEncryptedChat"},{"name":"typing","type":"Bool"}],"type":"Bool"},{"id":"2135648522","method":"messages.readEncryptedHistory","params":[{"name":"peer","type":"InputEncryptedChat"},{"name":"max_date","type":"int"}],"type":"Bool"},{"id":"-1451792525","method":"messages.sendEncrypted","params":[{"name":"peer","type":"InputEncryptedChat"},{"name":"random_id","type":"long"},{"name":"data","type":"bytes"}],"type":"messages.SentEncryptedMessage"},{"id":"-1701831834","method":"messages.sendEncryptedFile","params":[{"name":"peer","type":"InputEncryptedChat"},{"name":"random_id","type":"long"},{"name":"data","type":"bytes"},{"name":"file","type":"InputEncryptedFile"}],"type":"messages.SentEncryptedMessage"},{"id":"852769188","method":"messages.sendEncryptedService","params":[{"name":"peer","type":"InputEncryptedChat"},{"name":"random_id","type":"long"},{"name":"data","type":"bytes"}],"type":"messages.SentEncryptedMessage"},{"id":"1436924774","method":"messages.receivedQueue","params":[{"name":"max_qts","type":"int"}],"type":"Vector<long>"},{"id":"1259113487","method":"messages.reportEncryptedSpam","params":[{"name":"peer","type":"InputEncryptedChat"}],"type":"Bool"},{"id":"-562337987","method":"upload.saveBigFilePart","params":[{"name":"file_id","type":"long"},{"name":"file_part","type":"int"},{"name":"file_total_parts","type":"int"},{"name":"bytes","type":"bytes"}],"type":"Bool"},{"id":"2018609336","method":"initConnection","params":[{"name":"flags","type":"#"},{"name":"api_id","type":"int"},{"name":"device_model","type":"string"},{"name":"system_version","type":"string"},{"name":"app_version","type":"string"},{"name":"system_lang_code","type":"string"},{"name":"lang_pack","type":"string"},{"name":"lang_code","type":"string"},{"name":"proxy","type":"flags.0?InputClientProxy"},{"name":"query","type":"!X"}],"type":"X"},{"id":"-1663104819","method":"help.getSupport","params":[],"type":"help.Support"},{"id":"916930423","method":"messages.readMessageContents","params":[{"name":"id","type":"Vector<int>"}],"type":"messages.AffectedMessages"},{"id":"655677548","method":"account.checkUsername","params":[{"name":"username","type":"string"}],"type":"Bool"},{"id":"1040964988","method":"account.updateUsername","params":[{"name":"username","type":"string"}],"type":"User"},{"id":"301470424","method":"contacts.search","params":[{"name":"q","type":"string"},{"name":"limit","type":"int"}],"type":"contacts.Found"},{"id":"-623130288","method":"account.getPrivacy","params":[{"name":"key","type":"InputPrivacyKey"}],"type":"account.PrivacyRules"},{"id":"-906486552","method":"account.setPrivacy","params":[{"name":"key","type":"InputPrivacyKey"},{"name":"rules","type":"Vector<InputPrivacyRule>"}],"type":"account.PrivacyRules"},{"id":"1099779595","method":"account.deleteAccount","params":[{"name":"reason","type":"string"}],"type":"Bool"},{"id":"150761757","method":"account.getAccountTTL","params":[],"type":"AccountDaysTTL"},{"id":"608323678","method":"account.setAccountTTL","params":[{"name":"ttl","type":"AccountDaysTTL"}],"type":"Bool"},{"id":"-627372787","method":"invokeWithLayer","params":[{"name":"layer","type":"int"},{"name":"query","type":"!X"}],"type":"X"},{"id":"-113456221","method":"contacts.resolveUsername","params":[{"name":"username","type":"string"}],"type":"contacts.ResolvedPeer"},{"id":"-2108208411","method":"account.sendChangePhoneCode","params":[{"name":"phone_number","type":"string"},{"name":"settings","type":"CodeSettings"}],"type":"auth.SentCode"},{"id":"1891839707","method":"account.changePhone","params":[{"name":"phone_number","type":"string"},{"name":"phone_code_hash","type":"string"},{"name":"phone_code","type":"string"}],"type":"User"},{"id":"71126828","method":"messages.getStickers","params":[{"name":"emoticon","type":"string"},{"name":"hash","type":"int"}],"type":"messages.Stickers"},{"id":"479598769","method":"messages.getAllStickers","params":[{"name":"hash","type":"int"}],"type":"messages.AllStickers"},{"id":"954152242","method":"account.updateDeviceLocked","params":[{"name":"period","type":"int"}],"type":"Bool"},{"id":"1738800940","method":"auth.importBotAuthorization","params":[{"name":"flags","type":"int"},{"name":"api_id","type":"int"},{"name":"api_hash","type":"string"},{"name":"bot_auth_token","type":"string"}],"type":"auth.Authorization"},{"id":"-1956073268","method":"messages.getWebPagePreview","params":[{"name":"flags","type":"#"},{"name":"message","type":"string"},{"name":"entities","type":"flags.3?Vector<MessageEntity>"}],"type":"MessageMedia"},{"id":"-484392616","method":"account.getAuthorizations","params":[],"type":"account.Authorizations"},{"id":"-545786948","method":"account.resetAuthorization","params":[{"name":"hash","type":"long"}],"type":"Bool"},{"id":"1418342645","method":"account.getPassword","params":[],"type":"account.Password"},{"id":"-1663767815","method":"account.getPasswordSettings","params":[{"name":"password","type":"InputCheckPasswordSRP"}],"type":"account.PasswordSettings"},{"id":"-1516564433","method":"account.updatePasswordSettings","params":[{"name":"password","type":"InputCheckPasswordSRP"},{"name":"new_settings","type":"account.PasswordInputSettings"}],"type":"Bool"},{"id":"-779399914","method":"auth.checkPassword","params":[{"name":"password","type":"InputCheckPasswordSRP"}],"type":"auth.Authorization"},{"id":"-661144474","method":"auth.requestPasswordRecovery","params":[],"type":"auth.PasswordRecovery"},{"id":"1319464594","method":"auth.recoverPassword","params":[{"name":"code","type":"string"}],"type":"auth.Authorization"},{"id":"-1080796745","method":"invokeWithoutUpdates","params":[{"name":"query","type":"!X"}],"type":"X"},{"id":"234312524","method":"messages.exportChatInvite","params":[{"name":"peer","type":"InputPeer"}],"type":"ExportedChatInvite"},{"id":"1051570619","method":"messages.checkChatInvite","params":[{"name":"hash","type":"string"}],"type":"ChatInvite"},{"id":"1817183516","method":"messages.importChatInvite","params":[{"name":"hash","type":"string"}],"type":"Updates"},{"id":"639215886","method":"messages.getStickerSet","params":[{"name":"stickerset","type":"InputStickerSet"}],"type":"messages.StickerSet"},{"id":"-946871200","method":"messages.installStickerSet","params":[{"name":"stickerset","type":"InputStickerSet"},{"name":"archived","type":"Bool"}],"type":"messages.StickerSetInstallResult"},{"id":"-110209570","method":"messages.uninstallStickerSet","params":[{"name":"stickerset","type":"InputStickerSet"}],"type":"Bool"},{"id":"-421563528","method":"messages.startBot","params":[{"name":"bot","type":"InputUser"},{"name":"peer","type":"InputPeer"},{"name":"random_id","type":"long"},{"name":"start_param","type":"string"}],"type":"Updates"},{"id":"-1877938321","method":"help.getAppChangelog","params":[{"name":"prev_app_version","type":"string"}],"type":"Updates"},{"id":"-993483427","method":"messages.getMessagesViews","params":[{"name":"peer","type":"InputPeer"},{"name":"id","type":"Vector<int>"},{"name":"increment","type":"Bool"}],"type":"Vector<int>"},{"id":"-871347913","method":"channels.readHistory","params":[{"name":"channel","type":"InputChannel"},{"name":"max_id","type":"int"}],"type":"Bool"},{"id":"-2067661490","method":"channels.deleteMessages","params":[{"name":"channel","type":"InputChannel"},{"name":"id","type":"Vector<int>"}],"type":"messages.AffectedMessages"},{"id":"-787622117","method":"channels.deleteUserHistory","params":[{"name":"channel","type":"InputChannel"},{"name":"user_id","type":"InputUser"}],"type":"messages.AffectedHistory"},{"id":"-32999408","method":"channels.reportSpam","params":[{"name":"channel","type":"InputChannel"},{"name":"user_id","type":"InputUser"},{"name":"id","type":"Vector<int>"}],"type":"Bool"},{"id":"-1383294429","method":"channels.getMessages","params":[{"name":"channel","type":"InputChannel"},{"name":"id","type":"Vector<InputMessage>"}],"type":"messages.Messages"},{"id":"306054633","method":"channels.getParticipants","params":[{"name":"channel","type":"InputChannel"},{"name":"filter","type":"ChannelParticipantsFilter"},{"name":"offset","type":"int"},{"name":"limit","type":"int"},{"name":"hash","type":"int"}],"type":"channels.ChannelParticipants"},{"id":"1416484774","method":"channels.getParticipant","params":[{"name":"channel","type":"InputChannel"},{"name":"user_id","type":"InputUser"}],"type":"channels.ChannelParticipant"},{"id":"176122811","method":"channels.getChannels","params":[{"name":"id","type":"Vector<InputChannel>"}],"type":"messages.Chats"},{"id":"141781513","method":"channels.getFullChannel","params":[{"name":"channel","type":"InputChannel"}],"type":"messages.ChatFull"},{"id":"1029681423","method":"channels.createChannel","params":[{"name":"flags","type":"#"},{"name":"broadcast","type":"flags.0?true"},{"name":"megagroup","type":"flags.1?true"},{"name":"title","type":"string"},{"name":"about","type":"string"},{"name":"geo_point","type":"flags.2?InputGeoPoint"},{"name":"address","type":"flags.2?string"}],"type":"Updates"},{"id":"-751007486","method":"channels.editAdmin","params":[{"name":"channel","type":"InputChannel"},{"name":"user_id","type":"InputUser"},{"name":"admin_rights","type":"ChatAdminRights"},{"name":"rank","type":"string"}],"type":"Updates"},{"id":"1450044624","method":"channels.editTitle","params":[{"name":"channel","type":"InputChannel"},{"name":"title","type":"string"}],"type":"Updates"},{"id":"-248621111","method":"channels.editPhoto","params":[{"name":"channel","type":"InputChannel"},{"name":"photo","type":"InputChatPhoto"}],"type":"Updates"},{"id":"283557164","method":"channels.checkUsername","params":[{"name":"channel","type":"InputChannel"},{"name":"username","type":"string"}],"type":"Bool"},{"id":"890549214","method":"channels.updateUsername","params":[{"name":"channel","type":"InputChannel"},{"name":"username","type":"string"}],"type":"Bool"},{"id":"615851205","method":"channels.joinChannel","params":[{"name":"channel","type":"InputChannel"}],"type":"Updates"},{"id":"-130635115","method":"channels.leaveChannel","params":[{"name":"channel","type":"InputChannel"}],"type":"Updates"},{"id":"429865580","method":"channels.inviteToChannel","params":[{"name":"channel","type":"InputChannel"},{"name":"users","type":"Vector<InputUser>"}],"type":"Updates"},{"id":"-1072619549","method":"channels.deleteChannel","params":[{"name":"channel","type":"InputChannel"}],"type":"Updates"},{"id":"51854712","method":"updates.getChannelDifference","params":[{"name":"flags","type":"#"},{"name":"force","type":"flags.0?true"},{"name":"channel","type":"InputChannel"},{"name":"filter","type":"ChannelMessagesFilter"},{"name":"pts","type":"int"},{"name":"limit","type":"int"}],"type":"updates.ChannelDifference"},{"id":"-1444503762","method":"messages.editChatAdmin","params":[{"name":"chat_id","type":"int"},{"name":"user_id","type":"InputUser"},{"name":"is_admin","type":"Bool"}],"type":"Bool"},{"id":"363051235","method":"messages.migrateChat","params":[{"name":"chat_id","type":"int"}],"type":"Updates"},{"id":"-1083038300","method":"messages.searchGlobal","params":[{"name":"flags","type":"#"},{"name":"folder_id","type":"flags.0?int"},{"name":"q","type":"string"},{"name":"offset_rate","type":"int"},{"name":"offset_peer","type":"InputPeer"},{"name":"offset_id","type":"int"},{"name":"limit","type":"int"}],"type":"messages.Messages"},{"id":"2016638777","method":"messages.reorderStickerSets","params":[{"name":"flags","type":"#"},{"name":"masks","type":"flags.0?true"},{"name":"order","type":"Vector<long>"}],"type":"Bool"},{"id":"864953444","method":"messages.getDocumentByHash","params":[{"name":"sha256","type":"bytes"},{"name":"size","type":"int"},{"name":"mime_type","type":"string"}],"type":"Document"},{"id":"-1080395925","method":"messages.searchGifs","params":[{"name":"q","type":"string"},{"name":"offset","type":"int"}],"type":"messages.FoundGifs"},{"id":"-2084618926","method":"messages.getSavedGifs","params":[{"name":"hash","type":"int"}],"type":"messages.SavedGifs"},{"id":"846868683","method":"messages.saveGif","params":[{"name":"id","type":"InputDocument"},{"name":"unsave","type":"Bool"}],"type":"Bool"},{"id":"1364105629","method":"messages.getInlineBotResults","params":[{"name":"flags","type":"#"},{"name":"bot","type":"InputUser"},{"name":"peer","type":"InputPeer"},{"name":"geo_point","type":"flags.0?InputGeoPoint"},{"name":"query","type":"string"},{"name":"offset","type":"string"}],"type":"messages.BotResults"},{"id":"-346119674","method":"messages.setInlineBotResults","params":[{"name":"flags","type":"#"},{"name":"gallery","type":"flags.0?true"},{"name":"private","type":"flags.1?true"},{"name":"query_id","type":"long"},{"name":"results","type":"Vector<InputBotInlineResult>"},{"name":"cache_time","type":"int"},{"name":"next_offset","type":"flags.2?string"},{"name":"switch_pm","type":"flags.3?InlineBotSwitchPM"}],"type":"Bool"},{"id":"570955184","method":"messages.sendInlineBotResult","params":[{"name":"flags","type":"#"},{"name":"silent","type":"flags.5?true"},{"name":"background","type":"flags.6?true"},{"name":"clear_draft","type":"flags.7?true"},{"name":"hide_via","type":"flags.11?true"},{"name":"peer","type":"InputPeer"},{"name":"reply_to_msg_id","type":"flags.0?int"},{"name":"random_id","type":"long"},{"name":"query_id","type":"long"},{"name":"id","type":"string"},{"name":"schedule_date","type":"flags.10?int"}],"type":"Updates"},{"id":"-826838685","method":"channels.exportMessageLink","params":[{"name":"channel","type":"InputChannel"},{"name":"id","type":"int"},{"name":"grouped","type":"Bool"}],"type":"ExportedMessageLink"},{"id":"527021574","method":"channels.toggleSignatures","params":[{"name":"channel","type":"InputChannel"},{"name":"enabled","type":"Bool"}],"type":"Updates"},{"id":"1056025023","method":"auth.resendCode","params":[{"name":"phone_number","type":"string"},{"name":"phone_code_hash","type":"string"}],"type":"auth.SentCode"},{"id":"520357240","method":"auth.cancelCode","params":[{"name":"phone_number","type":"string"},{"name":"phone_code_hash","type":"string"}],"type":"Bool"},{"id":"-39416522","method":"messages.getMessageEditData","params":[{"name":"peer","type":"InputPeer"},{"name":"id","type":"int"}],"type":"messages.MessageEditData"},{"id":"1224152952","method":"messages.editMessage","params":[{"name":"flags","type":"#"},{"name":"no_webpage","type":"flags.1?true"},{"name":"peer","type":"InputPeer"},{"name":"id","type":"int"},{"name":"message","type":"flags.11?string"},{"name":"media","type":"flags.14?InputMedia"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"},{"name":"entities","type":"flags.3?Vector<MessageEntity>"},{"name":"schedule_date","type":"flags.15?int"}],"type":"Updates"},{"id":"-2091549254","method":"messages.editInlineBotMessage","params":[{"name":"flags","type":"#"},{"name":"no_webpage","type":"flags.1?true"},{"name":"id","type":"InputBotInlineMessageID"},{"name":"message","type":"flags.11?string"},{"name":"media","type":"flags.14?InputMedia"},{"name":"reply_markup","type":"flags.2?ReplyMarkup"},{"name":"entities","type":"flags.3?Vector<MessageEntity>"}],"type":"Bool"},{"id":"-2130010132","method":"messages.getBotCallbackAnswer","params":[{"name":"flags","type":"#"},{"name":"game","type":"flags.1?true"},{"name":"peer","type":"InputPeer"},{"name":"msg_id","type":"int"},{"name":"data","type":"flags.0?bytes"}],"type":"messages.BotCallbackAnswer"},{"id":"-712043766","method":"messages.setBotCallbackAnswer","params":[{"name":"flags","type":"#"},{"name":"alert","type":"flags.1?true"},{"name":"query_id","type":"long"},{"name":"message","type":"flags.0?string"},{"name":"url","type":"flags.2?string"},{"name":"cache_time","type":"int"}],"type":"Bool"},{"id":"-728224331","method":"contacts.getTopPeers","params":[{"name":"flags","type":"#"},{"name":"correspondents","type":"flags.0?true"},{"name":"bots_pm","type":"flags.1?true"},{"name":"bots_inline","type":"flags.2?true"},{"name":"phone_calls","type":"flags.3?true"},{"name":"forward_users","type":"flags.4?true"},{"name":"forward_chats","type":"flags.5?true"},{"name":"groups","type":"flags.10?true"},{"name":"channels","type":"flags.15?true"},{"name":"offset","type":"int"},{"name":"limit","type":"int"},{"name":"hash","type":"int"}],"type":"contacts.TopPeers"},{"id":"451113900","method":"contacts.resetTopPeerRating","params":[{"name":"category","type":"TopPeerCategory"},{"name":"peer","type":"InputPeer"}],"type":"Bool"},{"id":"-462373635","method":"messages.getPeerDialogs","params":[{"name":"peers","type":"Vector<InputDialogPeer>"}],"type":"messages.PeerDialogs"},{"id":"-1137057461","method":"messages.saveDraft","params":[{"name":"flags","type":"#"},{"name":"no_webpage","type":"flags.1?true"},{"name":"reply_to_msg_id","type":"flags.0?int"},{"name":"peer","type":"InputPeer"},{"name":"message","type":"string"},{"name":"entities","type":"flags.3?Vector<MessageEntity>"}],"type":"Bool"},{"id":"1782549861","method":"messages.getAllDrafts","params":[],"type":"Updates"},{"id":"766298703","method":"messages.getFeaturedStickers","params":[{"name":"hash","type":"int"}],"type":"messages.FeaturedStickers"},{"id":"1527873830","method":"messages.readFeaturedStickers","params":[{"name":"id","type":"Vector<long>"}],"type":"Bool"},{"id":"1587647177","method":"messages.getRecentStickers","params":[{"name":"flags","type":"#"},{"name":"attached","type":"flags.0?true"},{"name":"hash","type":"int"}],"type":"messages.RecentStickers"},{"id":"958863608","method":"messages.saveRecentSticker","params":[{"name":"flags","type":"#"},{"name":"attached","type":"flags.0?true"},{"name":"id","type":"InputDocument"},{"name":"unsave","type":"Bool"}],"type":"Bool"},{"id":"-1986437075","method":"messages.clearRecentStickers","params":[{"name":"flags","type":"#"},{"name":"attached","type":"flags.0?true"}],"type":"Bool"},{"id":"1475442322","method":"messages.getArchivedStickers","params":[{"name":"flags","type":"#"},{"name":"masks","type":"flags.0?true"},{"name":"offset_id","type":"long"},{"name":"limit","type":"int"}],"type":"messages.ArchivedStickers"},{"id":"457157256","method":"account.sendConfirmPhoneCode","params":[{"name":"hash","type":"string"},{"name":"settings","type":"CodeSettings"}],"type":"auth.SentCode"},{"id":"1596029123","method":"account.confirmPhone","params":[{"name":"phone_code_hash","type":"string"},{"name":"phone_code","type":"string"}],"type":"Bool"},{"id":"-122669393","method":"channels.getAdminedPublicChannels","params":[{"name":"flags","type":"#"},{"name":"by_location","type":"flags.0?true"},{"name":"check_limit","type":"flags.1?true"}],"type":"messages.Chats"},{"id":"1706608543","method":"messages.getMaskStickers","params":[{"name":"hash","type":"int"}],"type":"messages.AllStickers"},{"id":"-866424884","method":"messages.getAttachedStickers","params":[{"name":"media","type":"InputStickeredMedia"}],"type":"Vector<StickerSetCovered>"},{"id":"-1907842680","method":"auth.dropTempAuthKeys","params":[{"name":"except_auth_keys","type":"Vector<long>"}],"type":"Bool"},{"id":"-1896289088","method":"messages.setGameScore","params":[{"name":"flags","type":"#"},{"name":"edit_message","type":"flags.0?true"},{"name":"force","type":"flags.1?true"},{"name":"peer","type":"InputPeer"},{"name":"id","type":"int"},{"name":"user_id","type":"InputUser"},{"name":"score","type":"int"}],"type":"Updates"},{"id":"363700068","method":"messages.setInlineGameScore","params":[{"name":"flags","type":"#"},{"name":"edit_message","type":"flags.0?true"},{"name":"force","type":"flags.1?true"},{"name":"id","type":"InputBotInlineMessageID"},{"name":"user_id","type":"InputUser"},{"name":"score","type":"int"}],"type":"Bool"},{"id":"-400399203","method":"messages.getGameHighScores","params":[{"name":"peer","type":"InputPeer"},{"name":"id","type":"int"},{"name":"user_id","type":"InputUser"}],"type":"messages.HighScores"},{"id":"258170395","method":"messages.getInlineGameHighScores","params":[{"name":"id","type":"InputBotInlineMessageID"},{"name":"user_id","type":"InputUser"}],"type":"messages.HighScores"},{"id":"218777796","method":"messages.getCommonChats","params":[{"name":"user_id","type":"InputUser"},{"name":"max_id","type":"int"},{"name":"limit","type":"int"}],"type":"messages.Chats"},{"id":"-341307408","method":"messages.getAllChats","params":[{"name":"except_ids","type":"Vector<int>"}],"type":"messages.Chats"},{"id":"-333262899","method":"help.setBotUpdatesStatus","params":[{"name":"pending_updates_count","type":"int"},{"name":"message","type":"string"}],"type":"Bool"},{"id":"852135825","method":"messages.getWebPage","params":[{"name":"url","type":"string"},{"name":"hash","type":"int"}],"type":"WebPage"},{"id":"-1489903017","method":"messages.toggleDialogPin","params":[{"name":"flags","type":"#"},{"name":"pinned","type":"flags.0?true"},{"name":"peer","type":"InputDialogPeer"}],"type":"Bool"},{"id":"991616823","method":"messages.reorderPinnedDialogs","params":[{"name":"flags","type":"#"},{"name":"force","type":"flags.0?true"},{"name":"folder_id","type":"int"},{"name":"order","type":"Vector<InputDialogPeer>"}],"type":"Bool"},{"id":"-692498958","method":"messages.getPinnedDialogs","params":[{"name":"folder_id","type":"int"}],"type":"messages.PeerDialogs"},{"id":"-1440257555","method":"bots.sendCustomRequest","params":[{"name":"custom_method","type":"string"},{"name":"params","type":"DataJSON"}],"type":"DataJSON"},{"id":"-434028723","method":"bots.answerWebhookJSONQuery","params":[{"name":"query_id","type":"long"},{"name":"data","type":"DataJSON"}],"type":"Bool"},{"id":"619086221","method":"upload.getWebFile","params":[{"name":"location","type":"InputWebFileLocation"},{"name":"offset","type":"int"},{"name":"limit","type":"int"}],"type":"upload.WebFile"},{"id":"-1712285883","method":"payments.getPaymentForm","params":[{"name":"msg_id","type":"int"}],"type":"payments.PaymentForm"},{"id":"-1601001088","method":"payments.getPaymentReceipt","params":[{"name":"msg_id","type":"int"}],"type":"payments.PaymentReceipt"},{"id":"1997180532","method":"payments.validateRequestedInfo","params":[{"name":"flags","type":"#"},{"name":"save","type":"flags.0?true"},{"name":"msg_id","type":"int"},{"name":"info","type":"PaymentRequestedInfo"}],"type":"payments.ValidatedRequestedInfo"},{"id":"730364339","method":"payments.sendPaymentForm","params":[{"name":"flags","type":"#"},{"name":"msg_id","type":"int"},{"name":"requested_info_id","type":"flags.0?string"},{"name":"shipping_option_id","type":"flags.1?string"},{"name":"credentials","type":"InputPaymentCredentials"}],"type":"payments.PaymentResult"},{"id":"1151208273","method":"account.getTmpPassword","params":[{"name":"password","type":"InputCheckPasswordSRP"},{"name":"period","type":"int"}],"type":"account.TmpPassword"},{"id":"578650699","method":"payments.getSavedInfo","params":[],"type":"payments.SavedInfo"},{"id":"-667062079","method":"payments.clearSavedInfo","params":[{"name":"flags","type":"#"},{"name":"credentials","type":"flags.0?true"},{"name":"info","type":"flags.1?true"}],"type":"Bool"},{"id":"-436833542","method":"messages.setBotShippingResults","params":[{"name":"flags","type":"#"},{"name":"query_id","type":"long"},{"name":"error","type":"flags.0?string"},{"name":"shipping_options","type":"flags.1?Vector<ShippingOption>"}],"type":"Bool"},{"id":"163765653","method":"messages.setBotPrecheckoutResults","params":[{"name":"flags","type":"#"},{"name":"success","type":"flags.1?true"},{"name":"query_id","type":"long"},{"name":"error","type":"flags.0?string"}],"type":"Bool"},{"id":"-1680314774","method":"stickers.createStickerSet","params":[{"name":"flags","type":"#"},{"name":"masks","type":"flags.0?true"},{"name":"user_id","type":"InputUser"},{"name":"title","type":"string"},{"name":"short_name","type":"string"},{"name":"stickers","type":"Vector<InputStickerSetItem>"}],"type":"messages.StickerSet"},{"id":"-143257775","method":"stickers.removeStickerFromSet","params":[{"name":"sticker","type":"InputDocument"}],"type":"messages.StickerSet"},{"id":"-4795190","method":"stickers.changeStickerPosition","params":[{"name":"sticker","type":"InputDocument"},{"name":"position","type":"int"}],"type":"messages.StickerSet"},{"id":"-2041315650","method":"stickers.addStickerToSet","params":[{"name":"stickerset","type":"InputStickerSet"},{"name":"sticker","type":"InputStickerSetItem"}],"type":"messages.StickerSet"},{"id":"1369162417","method":"messages.uploadMedia","params":[{"name":"peer","type":"InputPeer"},{"name":"media","type":"InputMedia"}],"type":"MessageMedia"},{"id":"1430593449","method":"phone.getCallConfig","params":[],"type":"DataJSON"},{"id":"1124046573","method":"phone.requestCall","params":[{"name":"flags","type":"#"},{"name":"video","type":"flags.0?true"},{"name":"user_id","type":"InputUser"},{"name":"random_id","type":"int"},{"name":"g_a_hash","type":"bytes"},{"name":"protocol","type":"PhoneCallProtocol"}],"type":"phone.PhoneCall"},{"id":"1003664544","method":"phone.acceptCall","params":[{"name":"peer","type":"InputPhoneCall"},{"name":"g_b","type":"bytes"},{"name":"protocol","type":"PhoneCallProtocol"}],"type":"phone.PhoneCall"},{"id":"788404002","method":"phone.confirmCall","params":[{"name":"peer","type":"InputPhoneCall"},{"name":"g_a","type":"bytes"},{"name":"key_fingerprint","type":"long"},{"name":"protocol","type":"PhoneCallProtocol"}],"type":"phone.PhoneCall"},{"id":"399855457","method":"phone.receivedCall","params":[{"name":"peer","type":"InputPhoneCall"}],"type":"Bool"},{"id":"-1295269440","method":"phone.discardCall","params":[{"name":"flags","type":"#"},{"name":"video","type":"flags.0?true"},{"name":"peer","type":"InputPhoneCall"},{"name":"duration","type":"int"},{"name":"reason","type":"PhoneCallDiscardReason"},{"name":"connection_id","type":"long"}],"type":"Updates"},{"id":"1508562471","method":"phone.setCallRating","params":[{"name":"flags","type":"#"},{"name":"user_initiative","type":"flags.0?true"},{"name":"peer","type":"InputPhoneCall"},{"name":"rating","type":"int"},{"name":"comment","type":"string"}],"type":"Updates"},{"id":"662363518","method":"phone.saveCallDebug","params":[{"name":"peer","type":"InputPhoneCall"},{"name":"debug","type":"DataJSON"}],"type":"Bool"},{"id":"536919235","method":"upload.getCdnFile","params":[{"name":"file_token","type":"bytes"},{"name":"offset","type":"int"},{"name":"limit","type":"int"}],"type":"upload.CdnFile"},{"id":"-1691921240","method":"upload.reuploadCdnFile","params":[{"name":"file_token","type":"bytes"},{"name":"request_token","type":"bytes"}],"type":"Vector<FileHash>"},{"id":"1375900482","method":"help.getCdnConfig","params":[],"type":"CdnConfig"},{"id":"-219008246","method":"langpack.getLangPack","params":[{"name":"lang_pack","type":"string"},{"name":"lang_code","type":"string"}],"type":"LangPackDifference"},{"id":"-269862909","method":"langpack.getStrings","params":[{"name":"lang_pack","type":"string"},{"name":"lang_code","type":"string"},{"name":"keys","type":"Vector<string>"}],"type":"Vector<LangPackString>"},{"id":"-845657435","method":"langpack.getDifference","params":[{"name":"lang_pack","type":"string"},{"name":"lang_code","type":"string"},{"name":"from_version","type":"int"}],"type":"LangPackDifference"},{"id":"1120311183","method":"langpack.getLanguages","params":[{"name":"lang_pack","type":"string"}],"type":"Vector<LangPackLanguage>"},{"id":"1920559378","method":"channels.editBanned","params":[{"name":"channel","type":"InputChannel"},{"name":"user_id","type":"InputUser"},{"name":"banned_rights","type":"ChatBannedRights"}],"type":"Updates"},{"id":"870184064","method":"channels.getAdminLog","params":[{"name":"flags","type":"#"},{"name":"channel","type":"InputChannel"},{"name":"q","type":"string"},{"name":"events_filter","type":"flags.0?ChannelAdminLogEventsFilter"},{"name":"admins","type":"flags.1?Vector<InputUser>"},{"name":"max_id","type":"long"},{"name":"min_id","type":"long"},{"name":"limit","type":"int"}],"type":"channels.AdminLogResults"},{"id":"1302676017","method":"upload.getCdnFileHashes","params":[{"name":"file_token","type":"bytes"},{"name":"offset","type":"int"}],"type":"Vector<FileHash>"},{"id":"-914493408","method":"messages.sendScreenshotNotification","params":[{"name":"peer","type":"InputPeer"},{"name":"reply_to_msg_id","type":"int"},{"name":"random_id","type":"long"}],"type":"Updates"},{"id":"-359881479","method":"channels.setStickers","params":[{"name":"channel","type":"InputChannel"},{"name":"stickerset","type":"InputStickerSet"}],"type":"Bool"},{"id":"567151374","method":"messages.getFavedStickers","params":[{"name":"hash","type":"int"}],"type":"messages.FavedStickers"},{"id":"-1174420133","method":"messages.faveSticker","params":[{"name":"id","type":"InputDocument"},{"name":"unfave","type":"Bool"}],"type":"Bool"},{"id":"-357180360","method":"channels.readMessageContents","params":[{"name":"channel","type":"InputChannel"},{"name":"id","type":"Vector<int>"}],"type":"Bool"},{"id":"-2020263951","method":"contacts.resetSaved","params":[],"type":"Bool"},{"id":"1180140658","method":"messages.getUnreadMentions","params":[{"name":"peer","type":"InputPeer"},{"name":"offset_id","type":"int"},{"name":"add_offset","type":"int"},{"name":"limit","type":"int"},{"name":"max_id","type":"int"},{"name":"min_id","type":"int"}],"type":"messages.Messages"},{"id":"-1355375294","method":"channels.deleteHistory","params":[{"name":"channel","type":"InputChannel"},{"name":"max_id","type":"int"}],"type":"Bool"},{"id":"1036054804","method":"help.getRecentMeUrls","params":[{"name":"referer","type":"string"}],"type":"help.RecentMeUrls"},{"id":"-356796084","method":"channels.togglePreHistoryHidden","params":[{"name":"channel","type":"InputChannel"},{"name":"enabled","type":"Bool"}],"type":"Updates"},{"id":"251759059","method":"messages.readMentions","params":[{"name":"peer","type":"InputPeer"}],"type":"messages.AffectedHistory"},{"id":"-1144759543","method":"messages.getRecentLocations","params":[{"name":"peer","type":"InputPeer"},{"name":"limit","type":"int"},{"name":"hash","type":"int"}],"type":"messages.Messages"},{"id":"-872345397","method":"messages.sendMultiMedia","params":[{"name":"flags","type":"#"},{"name":"silent","type":"flags.5?true"},{"name":"background","type":"flags.6?true"},{"name":"clear_draft","type":"flags.7?true"},{"name":"peer","type":"InputPeer"},{"name":"reply_to_msg_id","type":"flags.0?int"},{"name":"multi_media","type":"Vector<InputSingleMedia>"},{"name":"schedule_date","type":"flags.10?int"}],"type":"Updates"},{"id":"1347929239","method":"messages.uploadEncryptedFile","params":[{"name":"peer","type":"InputEncryptedChat"},{"name":"file","type":"InputEncryptedFile"}],"type":"EncryptedFile"},{"id":"405695855","method":"account.getWebAuthorizations","params":[],"type":"account.WebAuthorizations"},{"id":"755087855","method":"account.resetWebAuthorization","params":[{"name":"hash","type":"long"}],"type":"Bool"},{"id":"1747789204","method":"account.resetWebAuthorizations","params":[],"type":"Bool"},{"id":"-1028140917","method":"messages.searchStickerSets","params":[{"name":"flags","type":"#"},{"name":"exclude_featured","type":"flags.0?true"},{"name":"q","type":"string"},{"name":"hash","type":"int"}],"type":"messages.FoundStickerSets"},{"id":"-956147407","method":"upload.getFileHashes","params":[{"name":"location","type":"InputFileLocation"},{"name":"offset","type":"int"}],"type":"Vector<FileHash>"},{"id":"1031231713","method":"help.getProxyData","params":[],"type":"help.ProxyData"},{"id":"749019089","method":"help.getTermsOfServiceUpdate","params":[],"type":"help.TermsOfServiceUpdate"},{"id":"-294455398","method":"help.acceptTermsOfService","params":[{"name":"id","type":"DataJSON"}],"type":"Bool"},{"id":"-1299661699","method":"account.getAllSecureValues","params":[],"type":"Vector<SecureValue>"},{"id":"1936088002","method":"account.getSecureValue","params":[{"name":"types","type":"Vector<SecureValueType>"}],"type":"Vector<SecureValue>"},{"id":"-1986010339","method":"account.saveSecureValue","params":[{"name":"value","type":"InputSecureValue"},{"name":"secure_secret_id","type":"long"}],"type":"SecureValue"},{"id":"-1199522741","method":"account.deleteSecureValue","params":[{"name":"types","type":"Vector<SecureValueType>"}],"type":"Bool"},{"id":"-1865902923","method":"users.setSecureValueErrors","params":[{"name":"id","type":"InputUser"},{"name":"errors","type":"Vector<SecureValueError>"}],"type":"Bool"},{"id":"-1200903967","method":"account.getAuthorizationForm","params":[{"name":"bot_id","type":"int"},{"name":"scope","type":"string"},{"name":"public_key","type":"string"}],"type":"account.AuthorizationForm"},{"id":"-419267436","method":"account.acceptAuthorization","params":[{"name":"bot_id","type":"int"},{"name":"scope","type":"string"},{"name":"public_key","type":"string"},{"name":"value_hashes","type":"Vector<SecureValueHash>"},{"name":"credentials","type":"SecureCredentialsEncrypted"}],"type":"Bool"},{"id":"-1516022023","method":"account.sendVerifyPhoneCode","params":[{"name":"phone_number","type":"string"},{"name":"settings","type":"CodeSettings"}],"type":"auth.SentCode"},{"id":"1305716726","method":"account.verifyPhone","params":[{"name":"phone_number","type":"string"},{"name":"phone_code_hash","type":"string"},{"name":"phone_code","type":"string"}],"type":"Bool"},{"id":"1880182943","method":"account.sendVerifyEmailCode","params":[{"name":"email","type":"string"}],"type":"account.SentEmailCode"},{"id":"-323339813","method":"account.verifyEmail","params":[{"name":"email","type":"string"},{"name":"code","type":"string"}],"type":"Bool"},{"id":"1072547679","method":"help.getDeepLinkInfo","params":[{"name":"path","type":"string"}],"type":"help.DeepLinkInfo"},{"id":"-2098076769","method":"contacts.getSaved","params":[],"type":"Vector<SavedContact>"},{"id":"-2092831552","method":"channels.getLeftChannels","params":[{"name":"offset","type":"int"}],"type":"messages.Chats"},{"id":"-262453244","method":"account.initTakeoutSession","params":[{"name":"flags","type":"#"},{"name":"contacts","type":"flags.0?true"},{"name":"message_users","type":"flags.1?true"},{"name":"message_chats","type":"flags.2?true"},{"name":"message_megagroups","type":"flags.3?true"},{"name":"message_channels","type":"flags.4?true"},{"name":"files","type":"flags.5?true"},{"name":"file_max_size","type":"flags.5?int"}],"type":"account.Takeout"},{"id":"489050862","method":"account.finishTakeoutSession","params":[{"name":"flags","type":"#"},{"name":"success","type":"flags.0?true"}],"type":"Bool"},{"id":"486505992","method":"messages.getSplitRanges","params":[],"type":"Vector<MessageRange>"},{"id":"911373810","method":"invokeWithMessagesRange","params":[{"name":"range","type":"MessageRange"},{"name":"query","type":"!X"}],"type":"X"},{"id":"-1398145746","method":"invokeWithTakeout","params":[{"name":"takeout_id","type":"long"},{"name":"query","type":"!X"}],"type":"X"},{"id":"-1031349873","method":"messages.markDialogUnread","params":[{"name":"flags","type":"#"},{"name":"unread","type":"flags.0?true"},{"name":"peer","type":"InputDialogPeer"}],"type":"Bool"},{"id":"585256482","method":"messages.getDialogUnreadMarks","params":[],"type":"Vector<DialogPeer>"},{"id":"-2062238246","method":"contacts.toggleTopPeers","params":[{"name":"enabled","type":"Bool"}],"type":"Bool"},{"id":"2119757468","method":"messages.clearAllDrafts","params":[],"type":"Bool"},{"id":"-1735311088","method":"help.getAppConfig","params":[],"type":"JSONValue"},{"id":"1862465352","method":"help.saveAppLog","params":[{"name":"events","type":"Vector<InputAppEvent>"}],"type":"Bool"},{"id":"-966677240","method":"help.getPassportConfig","params":[{"name":"hash","type":"int"}],"type":"help.PassportConfig"},{"id":"1784243458","method":"langpack.getLanguage","params":[{"name":"lang_pack","type":"string"},{"name":"lang_code","type":"string"}],"type":"LangPackLanguage"},{"id":"-760547348","method":"messages.updatePinnedMessage","params":[{"name":"flags","type":"#"},{"name":"silent","type":"flags.0?true"},{"name":"peer","type":"InputPeer"},{"name":"id","type":"int"}],"type":"Updates"},{"id":"-1881204448","method":"account.confirmPasswordEmail","params":[{"name":"code","type":"string"}],"type":"Bool"},{"id":"2055154197","method":"account.resendPasswordEmail","params":[],"type":"Bool"},{"id":"-1043606090","method":"account.cancelPasswordEmail","params":[],"type":"Bool"},{"id":"-748624084","method":"help.getSupportName","params":[],"type":"help.SupportName"},{"id":"59377875","method":"help.getUserInfo","params":[{"name":"user_id","type":"InputUser"}],"type":"help.UserInfo"},{"id":"1723407216","method":"help.editUserInfo","params":[{"name":"user_id","type":"InputUser"},{"name":"message","type":"string"},{"name":"entities","type":"Vector<MessageEntity>"}],"type":"help.UserInfo"},{"id":"-1626880216","method":"account.getContactSignUpNotification","params":[],"type":"Bool"},{"id":"-806076575","method":"account.setContactSignUpNotification","params":[{"name":"silent","type":"Bool"}],"type":"Bool"},{"id":"1398240377","method":"account.getNotifyExceptions","params":[{"name":"flags","type":"#"},{"name":"compare_sound","type":"flags.1?true"},{"name":"peer","type":"flags.0?InputNotifyPeer"}],"type":"Updates"},{"id":"283795844","method":"messages.sendVote","params":[{"name":"peer","type":"InputPeer"},{"name":"msg_id","type":"int"},{"name":"options","type":"Vector<bytes>"}],"type":"Updates"},{"id":"1941660731","method":"messages.getPollResults","params":[{"name":"peer","type":"InputPeer"},{"name":"msg_id","type":"int"}],"type":"Updates"},{"id":"1848369232","method":"messages.getOnlines","params":[{"name":"peer","type":"InputPeer"}],"type":"ChatOnlines"},{"id":"-2127811866","method":"messages.getStatsURL","params":[{"name":"flags","type":"#"},{"name":"dark","type":"flags.0?true"},{"name":"peer","type":"InputPeer"},{"name":"params","type":"string"}],"type":"StatsURL"},{"id":"-554301545","method":"messages.editChatAbout","params":[{"name":"peer","type":"InputPeer"},{"name":"about","type":"string"}],"type":"Bool"},{"id":"-1517917375","method":"messages.editChatDefaultBannedRights","params":[{"name":"peer","type":"InputPeer"},{"name":"banned_rights","type":"ChatBannedRights"}],"type":"Updates"},{"id":"-57811990","method":"account.getWallPaper","params":[{"name":"wallpaper","type":"InputWallPaper"}],"type":"WallPaper"},{"id":"-578472351","method":"account.uploadWallPaper","params":[{"name":"file","type":"InputFile"},{"name":"mime_type","type":"string"},{"name":"settings","type":"WallPaperSettings"}],"type":"WallPaper"},{"id":"1817860919","method":"account.saveWallPaper","params":[{"name":"wallpaper","type":"InputWallPaper"},{"name":"unsave","type":"Bool"},{"name":"settings","type":"WallPaperSettings"}],"type":"Bool"},{"id":"-18000023","method":"account.installWallPaper","params":[{"name":"wallpaper","type":"InputWallPaper"},{"name":"settings","type":"WallPaperSettings"}],"type":"Bool"},{"id":"-1153722364","method":"account.resetWallPapers","params":[],"type":"Bool"},{"id":"1457130303","method":"account.getAutoDownloadSettings","params":[],"type":"account.AutoDownloadSettings"},{"id":"1995661875","method":"account.saveAutoDownloadSettings","params":[{"name":"flags","type":"#"},{"name":"low","type":"flags.0?true"},{"name":"high","type":"flags.1?true"},{"name":"settings","type":"AutoDownloadSettings"}],"type":"Bool"},{"id":"899735650","method":"messages.getEmojiKeywords","params":[{"name":"lang_code","type":"string"}],"type":"EmojiKeywordsDifference"},{"id":"352892591","method":"messages.getEmojiKeywordsDifference","params":[{"name":"lang_code","type":"string"},{"name":"from_version","type":"int"}],"type":"EmojiKeywordsDifference"},{"id":"1318675378","method":"messages.getEmojiKeywordsLanguages","params":[{"name":"lang_codes","type":"Vector<string>"}],"type":"Vector<EmojiLanguage>"},{"id":"-709817306","method":"messages.getEmojiURL","params":[{"name":"lang_code","type":"string"}],"type":"EmojiURL"},{"id":"1749536939","method":"folders.editPeerFolders","params":[{"name":"folder_peers","type":"Vector<InputFolderPeer>"}],"type":"Updates"},{"id":"472471681","method":"folders.deleteFolder","params":[{"name":"folder_id","type":"int"}],"type":"Updates"},{"id":"1932455680","method":"messages.getSearchCounters","params":[{"name":"peer","type":"InputPeer"},{"name":"filters","type":"Vector<MessagesFilter>"}],"type":"Vector<messages.SearchCounter>"},{"id":"-170208392","method":"channels.getGroupsForDiscussion","params":[],"type":"messages.Chats"},{"id":"1079520178","method":"channels.setDiscussionGroup","params":[{"name":"broadcast","type":"InputChannel"},{"name":"group","type":"InputChannel"}],"type":"Bool"},{"id":"-482388461","method":"messages.requestUrlAuth","params":[{"name":"peer","type":"InputPeer"},{"name":"msg_id","type":"int"},{"name":"button_id","type":"int"}],"type":"UrlAuthResult"},{"id":"-148247912","method":"messages.acceptUrlAuth","params":[{"name":"flags","type":"#"},{"name":"write_allowed","type":"flags.0?true"},{"name":"peer","type":"InputPeer"},{"name":"msg_id","type":"int"},{"name":"button_id","type":"int"}],"type":"UrlAuthResult"},{"id":"1336717624","method":"messages.hidePeerSettingsBar","params":[{"name":"peer","type":"InputPeer"}],"type":"Bool"},{"id":"-386636848","method":"contacts.addContact","params":[{"name":"flags","type":"#"},{"name":"add_phone_privacy_exception","type":"flags.0?true"},{"name":"id","type":"InputUser"},{"name":"first_name","type":"string"},{"name":"last_name","type":"string"},{"name":"phone","type":"string"}],"type":"Updates"},{"id":"-130964977","method":"contacts.acceptContact","params":[{"name":"id","type":"InputUser"}],"type":"Updates"},{"id":"-1892102881","method":"channels.editCreator","params":[{"name":"channel","type":"InputChannel"},{"name":"user_id","type":"InputUser"},{"name":"password","type":"InputCheckPasswordSRP"}],"type":"Updates"},{"id":"171270230","method":"contacts.getLocated","params":[{"name":"geo_point","type":"InputGeoPoint"}],"type":"Updates"},{"id":"1491484525","method":"channels.editLocation","params":[{"name":"channel","type":"InputChannel"},{"name":"geo_point","type":"InputGeoPoint"},{"name":"address","type":"string"}],"type":"Bool"},{"id":"-304832784","method":"channels.toggleSlowMode","params":[{"name":"channel","type":"InputChannel"},{"name":"seconds","type":"int"}],"type":"Updates"},{"id":"-490575781","method":"messages.getScheduledHistory","params":[{"name":"peer","type":"InputPeer"},{"name":"hash","type":"int"}],"type":"messages.Messages"},{"id":"-1111817116","method":"messages.getScheduledMessages","params":[{"name":"peer","type":"InputPeer"},{"name":"id","type":"Vector<int>"}],"type":"messages.Messages"},{"id":"-1120369398","method":"messages.sendScheduledMessages","params":[{"name":"peer","type":"InputPeer"},{"name":"id","type":"Vector<int>"}],"type":"Updates"},{"id":"1504586518","method":"messages.deleteScheduledMessages","params":[{"name":"peer","type":"InputPeer"},{"name":"id","type":"Vector<int>"}],"type":"Updates"},{"id":"473805619","method":"account.uploadTheme","params":[{"name":"flags","type":"#"},{"name":"file","type":"InputFile"},{"name":"thumb","type":"flags.0?InputFile"},{"name":"file_name","type":"string"},{"name":"mime_type","type":"string"}],"type":"Document"},{"id":"729808255","method":"account.createTheme","params":[{"name":"slug","type":"string"},{"name":"title","type":"string"},{"name":"document","type":"InputDocument"}],"type":"Theme"},{"id":"999203330","method":"account.updateTheme","params":[{"name":"flags","type":"#"},{"name":"format","type":"string"},{"name":"theme","type":"InputTheme"},{"name":"slug","type":"flags.0?string"},{"name":"title","type":"flags.1?string"},{"name":"document","type":"flags.2?InputDocument"}],"type":"Theme"},{"id":"-229175188","method":"account.saveTheme","params":[{"name":"theme","type":"InputTheme"},{"name":"unsave","type":"Bool"}],"type":"Bool"},{"id":"2061776695","method":"account.installTheme","params":[{"name":"flags","type":"#"},{"name":"dark","type":"flags.0?true"},{"name":"format","type":"flags.1?string"},{"name":"theme","type":"flags.1?InputTheme"}],"type":"Bool"},{"id":"-1919060949","method":"account.getTheme","params":[{"name":"format","type":"string"},{"name":"theme","type":"InputTheme"},{"name":"document_id","type":"long"}],"type":"Theme"},{"id":"676939512","method":"account.getThemes","params":[{"name":"format","type":"string"},{"name":"hash","type":"int"}],"type":"account.Themes"}]};

Config.Schema.API.layer = 105;

// From https://github.com/stephenmathieson/node-tlds/blob/master/index.js
Config.TLD = ['abogado', 'ac', 'academy', 'accountants', 'active', 'actor', 'ad', 'adult', 'ae', 'aero', 'af', 'ag', 'agency', 'ai', 'airforce', 'al', 'allfinanz', 'alsace', 'am', 'amsterdam', 'an', 'android', 'ao', 'apartments', 'aq', 'aquarelle', 'ar', 'archi', 'army', 'arpa', 'as', 'asia', 'associates', 'at', 'attorney', 'au', 'auction', 'audio', 'autos', 'aw', 'ax', 'axa', 'az', 'ba', 'band', 'bank', 'bar', 'barclaycard', 'barclays', 'bargains', 'bayern', 'bb', 'bd', 'be', 'beer', 'berlin', 'best', 'bf', 'bg', 'bh', 'bi', 'bid', 'bike', 'bingo', 'bio', 'biz', 'bj', 'black', 'blackfriday', 'bloomberg', 'blue', 'bm', 'bmw', 'bn', 'bnpparibas', 'bo', 'boo', 'boutique', 'br', 'brussels', 'bs', 'bt', 'budapest', 'build', 'builders', 'business', 'buzz', 'bv', 'bw', 'by', 'bz', 'bzh', 'ca', 'cab', 'cal', 'camera', 'camp', 'cancerresearch', 'canon', 'capetown', 'capital', 'caravan', 'cards', 'care', 'career', 'careers', 'cartier', 'casa', 'cash', 'cat', 'catering', 'cc', 'cd', 'center', 'ceo', 'cern', 'cf', 'cg', 'ch', 'channel', 'chat', 'cheap', 'christmas', 'chrome', 'church', 'ci', 'citic', 'city', 'ck', 'cl', 'claims', 'cleaning', 'click', 'clinic', 'clothing', 'club', 'cm', 'cn', 'co', 'coach', 'codes', 'coffee', 'college', 'cologne', 'com', 'community', 'company', 'computer', 'condos', 'construction', 'consulting', 'contractors', 'cooking', 'cool', 'coop', 'country', 'cr', 'credit', 'creditcard', 'cricket', 'crs', 'cruises', 'cu', 'cuisinella', 'cv', 'cw', 'cx', 'cy', 'cymru', 'cz', 'dabur', 'dad', 'dance', 'dating', 'day', 'dclk', 'de', 'deals', 'degree', 'delivery', 'democrat', 'dental', 'dentist', 'desi', 'design', 'dev', 'diamonds', 'diet', 'digital', 'direct', 'directory', 'discount', 'dj', 'dk', 'dm', 'dnp', 'do', 'docs', 'domains', 'doosan', 'durban', 'dvag', 'dz', 'eat', 'ec', 'edu', 'education', 'ee', 'eg', 'email', 'emerck', 'energy', 'engineer', 'engineering', 'enterprises', 'equipment', 'er', 'es', 'esq', 'estate', 'et', 'eu', 'eurovision', 'eus', 'events', 'everbank', 'exchange', 'expert', 'exposed', 'fail', 'farm', 'fashion', 'feedback', 'fi', 'finance', 'financial', 'firmdale', 'fish', 'fishing', 'fit', 'fitness', 'fj', 'fk', 'flights', 'florist', 'flowers', 'flsmidth', 'fly', 'fm', 'fo', 'foo', 'forsale', 'foundation', 'fr', 'frl', 'frogans', 'fund', 'furniture', 'futbol', 'ga', 'gal', 'gallery', 'garden', 'gb', 'gbiz', 'gd', 'ge', 'gent', 'gf', 'gg', 'ggee', 'gh', 'gi', 'gift', 'gifts', 'gives', 'gl', 'glass', 'gle', 'global', 'globo', 'gm', 'gmail', 'gmo', 'gmx', 'gn', 'goog', 'google', 'gop', 'gov', 'gp', 'gq', 'gr', 'graphics', 'gratis', 'green', 'gripe', 'gs', 'gt', 'gu', 'guide', 'guitars', 'guru', 'gw', 'gy', 'hamburg', 'hangout', 'haus', 'healthcare', 'help', 'here', 'hermes', 'hiphop', 'hiv', 'hk', 'hm', 'hn', 'holdings', 'holiday', 'homes', 'horse', 'host', 'hosting', 'house', 'how', 'hr', 'ht', 'hu', 'ibm', 'id', 'ie', 'ifm', 'il', 'im', 'immo', 'immobilien', 'in', 'industries', 'info', 'ing', 'ink', 'institute', 'insure', 'int', 'international', 'investments', 'io', 'iq', 'ir', 'irish', 'is', 'it', 'iwc', 'jcb', 'je', 'jetzt', 'jm', 'jo', 'jobs', 'joburg', 'jp', 'juegos', 'kaufen', 'kddi', 'ke', 'kg', 'kh', 'ki', 'kim', 'kitchen', 'kiwi', 'km', 'kn', 'koeln', 'kp', 'kr', 'krd', 'kred', 'kw', 'ky', 'kyoto', 'kz', 'la', 'lacaixa', 'land', 'lat', 'latrobe', 'lawyer', 'lb', 'lc', 'lds', 'lease', 'legal', 'lgbt', 'li', 'lidl', 'life', 'lighting', 'limited', 'limo', 'link', 'lk', 'loans', 'london', 'lotte', 'lotto', 'lr', 'ls', 'lt', 'ltda', 'lu', 'luxe', 'luxury', 'lv', 'ly', 'ma', 'madrid', 'maison', 'management', 'mango', 'market', 'marketing', 'marriott', 'mc', 'md', 'me', 'media', 'meet', 'melbourne', 'meme', 'memorial', 'menu', 'mg', 'mh', 'miami', 'mil', 'mini', 'mk', 'ml', 'mm', 'mn', 'mo', 'mobi', 'moda', 'moe', 'monash', 'money', 'mormon', 'mortgage', 'moscow', 'motorcycles', 'mov', 'mp', 'mq', 'mr', 'ms', 'mt', 'mu', 'museum', 'mv', 'mw', 'mx', 'my', 'mz', 'na', 'nagoya', 'name', 'navy', 'nc', 'ne', 'net', 'network', 'neustar', 'new', 'nexus', 'nf', 'ng', 'ngo', 'nhk', 'ni', 'nico', 'ninja', 'nl', 'no', 'np', 'nr', 'nra', 'nrw', 'ntt', 'nu', 'nyc', 'nz', 'okinawa', 'om', 'one', 'ong', 'onl', 'ooo', 'org', 'organic', 'osaka', 'otsuka', 'ovh', 'pa', 'paris', 'partners', 'parts', 'party', 'pe', 'pf', 'pg', 'ph', 'pharmacy', 'photo', 'photography', 'photos', 'physio', 'pics', 'pictures', 'pink', 'pizza', 'pk', 'pl', 'place', 'plumbing', 'pm', 'pn', 'pohl', 'poker', 'porn', 'post', 'pr', 'praxi', 'press', 'pro', 'prod', 'productions', 'prof', 'properties', 'property', 'ps', 'pt', 'pub', 'pw', 'py', 'qa', 'qpon', 'quebec', 're', 'realtor', 'recipes', 'red', 'rehab', 'reise', 'reisen', 'reit', 'ren', 'rentals', 'repair', 'report', 'republican', 'rest', 'restaurant', 'reviews', 'rich', 'rio', 'rip', 'ro', 'rocks', 'rodeo', 'rs', 'rsvp', 'ru', 'ruhr', 'rw', 'ryukyu', 'sa', 'saarland', 'sale', 'samsung', 'sarl', 'saxo', 'sb', 'sc', 'sca', 'scb', 'schmidt', 'schule', 'schwarz', 'science', 'scot', 'sd', 'se', 'services', 'sew', 'sexy', 'sg', 'sh', 'shiksha', 'shoes', 'shriram', 'si', 'singles', 'sj', 'sk', 'sky', 'sl', 'sm', 'sn', 'so', 'social', 'software', 'sohu', 'solar', 'solutions', 'soy', 'space', 'spiegel', 'sr', 'st', 'style', 'su', 'supplies', 'supply', 'support', 'surf', 'surgery', 'suzuki', 'sv', 'sx', 'sy', 'sydney', 'systems', 'sz', 'taipei', 'tatar', 'tattoo', 'tax', 'tc', 'td', 'technology', 'tel', 'temasek', 'tennis', 'tf', 'tg', 'th', 'tienda', 'tips', 'tires', 'tirol', 'tj', 'tk', 'tl', 'tm', 'tn', 'to', 'today', 'tokyo', 'tools', 'top', 'toshiba', 'town', 'toys', 'tp', 'tr', 'trade', 'training', 'travel', 'trust', 'tt', 'tui', 'tv', 'tw', 'tz', 'ua', 'ug', 'uk', 'university', 'uno', 'uol', 'us', 'uy', 'uz', 'va', 'vacations', 'vc', 've', 'vegas', 'ventures', 'versicherung', 'vet', 'vg', 'vi', 'viajes', 'video', 'villas', 'vision', 'vlaanderen', 'vn', 'vodka', 'vote', 'voting', 'voto', 'voyage', 'vu', 'wales', 'wang', 'watch', 'webcam', 'website', 'wed', 'wedding', 'wf', 'whoswho', 'wien', 'wiki', 'williamhill', 'wme', 'work', 'works', 'world', 'ws', 'wtc', 'wtf', '佛山', '集团', '在线', '한국', 'ভারত', '八卦', 'موقع', '公益', '公司', '移动', '我爱你', 'москва', 'қаз', 'онлайн', 'сайт', 'срб', '淡马锡', 'орг', '삼성', 'சிங்கப்பூர்', '商标', '商店', '商城', 'дети', 'мкд', '中文网', '中信', '中国', '中國', '谷歌', 'భారత్', 'ලංකා', 'ભારત', 'भारत', '网店', 'संगठन', '网络', 'укр', '香港', '台湾', '台灣', '手机', 'мон', 'الجزائر', 'عمان', 'ایران', 'امارات', 'بازار', 'الاردن', 'بھارت', 'المغرب', 'السعودية', 'مليسيا', 'شبكة', 'გე', '机构', '组织机构', 'ไทย', 'سورية', 'рус', 'рф', 'تونس', 'みんな', 'グーグル', '世界', 'ਭਾਰਤ', '网址', '游戏', 'vermögensberater', 'vermögensberatung', '企业', 'مصر', 'قطر', '广东', 'இலங்கை', 'இந்தியா', '新加坡', 'فلسطين', '政务', 'xxx', 'xyz', 'yachts', 'yandex', 'ye', 'yoga', 'yokohama', 'youtube', 'yt', 'za', 'zip', 'zm', 'zone', 'zuerich', 'zw'];

// From https://raw.githubusercontent.com/FGRibreau/latenize/master/latinize_map.js
Config.LatinizeMap = {'Á': 'A','Ă': 'A','Ắ': 'A','Ặ': 'A','Ằ': 'A','Ẳ': 'A','Ẵ': 'A','Ǎ': 'A','Â': 'A','Ấ': 'A','Ậ': 'A','Ầ': 'A','Ẩ': 'A','Ẫ': 'A','Ä': 'A','Ǟ': 'A','Ȧ': 'A','Ǡ': 'A','Ạ': 'A','Ȁ': 'A','À': 'A','Ả': 'A','Ȃ': 'A','Ā': 'A','Ą': 'A','Å': 'A','Ǻ': 'A','Ḁ': 'A','Ⱥ': 'A','Ã': 'A','Ꜳ': 'AA','Æ': 'AE','Ǽ': 'AE','Ǣ': 'AE','Ꜵ': 'AO','Ꜷ': 'AU','Ꜹ': 'AV','Ꜻ': 'AV','Ꜽ': 'AY','Ḃ': 'B','Ḅ': 'B','Ɓ': 'B','Ḇ': 'B','Ƀ': 'B','Ƃ': 'B','Ć': 'C','Č': 'C','Ç': 'C','Ḉ': 'C','Ĉ': 'C','Ċ': 'C','Ƈ': 'C','Ȼ': 'C','Ď': 'D','Ḑ': 'D','Ḓ': 'D','Ḋ': 'D','Ḍ': 'D','Ɗ': 'D','Ḏ': 'D','ǲ': 'D','ǅ': 'D','Đ': 'D','Ƌ': 'D','Ǳ': 'DZ','Ǆ': 'DZ','É': 'E','Ĕ': 'E','Ě': 'E','Ȩ': 'E','Ḝ': 'E','Ê': 'E','Ế': 'E','Ệ': 'E','Ề': 'E','Ể': 'E','Ễ': 'E','Ḙ': 'E','Ë': 'E','Ė': 'E','Ẹ': 'E','Ȅ': 'E','È': 'E','Ẻ': 'E','Ȇ': 'E','Ē': 'E','Ḗ': 'E','Ḕ': 'E','Ę': 'E','Ɇ': 'E','Ẽ': 'E','Ḛ': 'E','Ꝫ': 'ET','Ḟ': 'F','Ƒ': 'F','Ǵ': 'G','Ğ': 'G','Ǧ': 'G','Ģ': 'G','Ĝ': 'G','Ġ': 'G','Ɠ': 'G','Ḡ': 'G','Ǥ': 'G','Ḫ': 'H','Ȟ': 'H','Ḩ': 'H','Ĥ': 'H','Ⱨ': 'H','Ḧ': 'H','Ḣ': 'H','Ḥ': 'H','Ħ': 'H','Í': 'I','Ĭ': 'I','Ǐ': 'I','Î': 'I','Ï': 'I','Ḯ': 'I','İ': 'I','Ị': 'I','Ȉ': 'I','Ì': 'I','Ỉ': 'I','Ȋ': 'I','Ī': 'I','Į': 'I','Ɨ': 'I','Ĩ': 'I','Ḭ': 'I','Ꝺ': 'D','Ꝼ': 'F','Ᵹ': 'G','Ꞃ': 'R','Ꞅ': 'S','Ꞇ': 'T','Ꝭ': 'IS','Ĵ': 'J','Ɉ': 'J','Ḱ': 'K','Ǩ': 'K','Ķ': 'K','Ⱪ': 'K','Ꝃ': 'K','Ḳ': 'K','Ƙ': 'K','Ḵ': 'K','Ꝁ': 'K','Ꝅ': 'K','Ĺ': 'L','Ƚ': 'L','Ľ': 'L','Ļ': 'L','Ḽ': 'L','Ḷ': 'L','Ḹ': 'L','Ⱡ': 'L','Ꝉ': 'L','Ḻ': 'L','Ŀ': 'L','Ɫ': 'L','ǈ': 'L','Ł': 'L','Ǉ': 'LJ','Ḿ': 'M','Ṁ': 'M','Ṃ': 'M','Ɱ': 'M','Ń': 'N','Ň': 'N','Ņ': 'N','Ṋ': 'N','Ṅ': 'N','Ṇ': 'N','Ǹ': 'N','Ɲ': 'N','Ṉ': 'N','Ƞ': 'N','ǋ': 'N','Ñ': 'N','Ǌ': 'NJ','Ó': 'O','Ŏ': 'O','Ǒ': 'O','Ô': 'O','Ố': 'O','Ộ': 'O','Ồ': 'O','Ổ': 'O','Ỗ': 'O','Ö': 'O','Ȫ': 'O','Ȯ': 'O','Ȱ': 'O','Ọ': 'O','Ő': 'O','Ȍ': 'O','Ò': 'O','Ỏ': 'O','Ơ': 'O','Ớ': 'O','Ợ': 'O','Ờ': 'O','Ở': 'O','Ỡ': 'O','Ȏ': 'O','Ꝋ': 'O','Ꝍ': 'O','Ō': 'O','Ṓ': 'O','Ṑ': 'O','Ɵ': 'O','Ǫ': 'O','Ǭ': 'O','Ø': 'O','Ǿ': 'O','Õ': 'O','Ṍ': 'O','Ṏ': 'O','Ȭ': 'O','Ƣ': 'OI','Ꝏ': 'OO','Ɛ': 'E','Ɔ': 'O','Ȣ': 'OU','Ṕ': 'P','Ṗ': 'P','Ꝓ': 'P','Ƥ': 'P','Ꝕ': 'P','Ᵽ': 'P','Ꝑ': 'P','Ꝙ': 'Q','Ꝗ': 'Q','Ŕ': 'R','Ř': 'R','Ŗ': 'R','Ṙ': 'R','Ṛ': 'R','Ṝ': 'R','Ȑ': 'R','Ȓ': 'R','Ṟ': 'R','Ɍ': 'R','Ɽ': 'R','Ꜿ': 'C','Ǝ': 'E','Ś': 'S','Ṥ': 'S','Š': 'S','Ṧ': 'S','Ş': 'S','Ŝ': 'S','Ș': 'S','Ṡ': 'S','Ṣ': 'S','Ṩ': 'S','ẞ': 'SS','Ť': 'T','Ţ': 'T','Ṱ': 'T','Ț': 'T','Ⱦ': 'T','Ṫ': 'T','Ṭ': 'T','Ƭ': 'T','Ṯ': 'T','Ʈ': 'T','Ŧ': 'T','Ɐ': 'A','Ꞁ': 'L','Ɯ': 'M','Ʌ': 'V','Ꜩ': 'TZ','Ú': 'U','Ŭ': 'U','Ǔ': 'U','Û': 'U','Ṷ': 'U','Ü': 'U','Ǘ': 'U','Ǚ': 'U','Ǜ': 'U','Ǖ': 'U','Ṳ': 'U','Ụ': 'U','Ű': 'U','Ȕ': 'U','Ù': 'U','Ủ': 'U','Ư': 'U','Ứ': 'U','Ự': 'U','Ừ': 'U','Ử': 'U','Ữ': 'U','Ȗ': 'U','Ū': 'U','Ṻ': 'U','Ų': 'U','Ů': 'U','Ũ': 'U','Ṹ': 'U','Ṵ': 'U','Ꝟ': 'V','Ṿ': 'V','Ʋ': 'V','Ṽ': 'V','Ꝡ': 'VY','Ẃ': 'W','Ŵ': 'W','Ẅ': 'W','Ẇ': 'W','Ẉ': 'W','Ẁ': 'W','Ⱳ': 'W','Ẍ': 'X','Ẋ': 'X','Ý': 'Y','Ŷ': 'Y','Ÿ': 'Y','Ẏ': 'Y','Ỵ': 'Y','Ỳ': 'Y','Ƴ': 'Y','Ỷ': 'Y','Ỿ': 'Y','Ȳ': 'Y','Ɏ': 'Y','Ỹ': 'Y','Ź': 'Z','Ž': 'Z','Ẑ': 'Z','Ⱬ': 'Z','Ż': 'Z','Ẓ': 'Z','Ȥ': 'Z','Ẕ': 'Z','Ƶ': 'Z','Ĳ': 'IJ','Œ': 'OE','ᴀ': 'A','ᴁ': 'AE','ʙ': 'B','ᴃ': 'B','ᴄ': 'C','ᴅ': 'D','ᴇ': 'E','ꜰ': 'F','ɢ': 'G','ʛ': 'G','ʜ': 'H','ɪ': 'I','ʁ': 'R','ᴊ': 'J','ᴋ': 'K','ʟ': 'L','ᴌ': 'L','ᴍ': 'M','ɴ': 'N','ᴏ': 'O','ɶ': 'OE','ᴐ': 'O','ᴕ': 'OU','ᴘ': 'P','ʀ': 'R','ᴎ': 'N','ᴙ': 'R','ꜱ': 'S','ᴛ': 'T','ⱻ': 'E','ᴚ': 'R','ᴜ': 'U','ᴠ': 'V','ᴡ': 'W','ʏ': 'Y','ᴢ': 'Z','á': 'a','ă': 'a','ắ': 'a','ặ': 'a','ằ': 'a','ẳ': 'a','ẵ': 'a','ǎ': 'a','â': 'a','ấ': 'a','ậ': 'a','ầ': 'a','ẩ': 'a','ẫ': 'a','ä': 'a','ǟ': 'a','ȧ': 'a','ǡ': 'a','ạ': 'a','ȁ': 'a','à': 'a','ả': 'a','ȃ': 'a','ā': 'a','ą': 'a','ᶏ': 'a','ẚ': 'a','å': 'a','ǻ': 'a','ḁ': 'a','ⱥ': 'a','ã': 'a','ꜳ': 'aa','æ': 'ae','ǽ': 'ae','ǣ': 'ae','ꜵ': 'ao','ꜷ': 'au','ꜹ': 'av','ꜻ': 'av','ꜽ': 'ay','ḃ': 'b','ḅ': 'b','ɓ': 'b','ḇ': 'b','ᵬ': 'b','ᶀ': 'b','ƀ': 'b','ƃ': 'b','ɵ': 'o','ć': 'c','č': 'c','ç': 'c','ḉ': 'c','ĉ': 'c','ɕ': 'c','ċ': 'c','ƈ': 'c','ȼ': 'c','ď': 'd','ḑ': 'd','ḓ': 'd','ȡ': 'd','ḋ': 'd','ḍ': 'd','ɗ': 'd','ᶑ': 'd','ḏ': 'd','ᵭ': 'd','ᶁ': 'd','đ': 'd','ɖ': 'd','ƌ': 'd','ı': 'i','ȷ': 'j','ɟ': 'j','ʄ': 'j','ǳ': 'dz','ǆ': 'dz','é': 'e','ĕ': 'e','ě': 'e','ȩ': 'e','ḝ': 'e','ê': 'e','ế': 'e','ệ': 'e','ề': 'e','ể': 'e','ễ': 'e','ḙ': 'e','ë': 'e','ė': 'e','ẹ': 'e','ȅ': 'e','è': 'e','ẻ': 'e','ȇ': 'e','ē': 'e','ḗ': 'e','ḕ': 'e','ⱸ': 'e','ę': 'e','ᶒ': 'e','ɇ': 'e','ẽ': 'e','ḛ': 'e','ꝫ': 'et','ḟ': 'f','ƒ': 'f','ᵮ': 'f','ᶂ': 'f','ǵ': 'g','ğ': 'g','ǧ': 'g','ģ': 'g','ĝ': 'g','ġ': 'g','ɠ': 'g','ḡ': 'g','ᶃ': 'g','ǥ': 'g','ḫ': 'h','ȟ': 'h','ḩ': 'h','ĥ': 'h','ⱨ': 'h','ḧ': 'h','ḣ': 'h','ḥ': 'h','ɦ': 'h','ẖ': 'h','ħ': 'h','ƕ': 'hv','í': 'i','ĭ': 'i','ǐ': 'i','î': 'i','ï': 'i','ḯ': 'i','ị': 'i','ȉ': 'i','ì': 'i','ỉ': 'i','ȋ': 'i','ī': 'i','į': 'i','ᶖ': 'i','ɨ': 'i','ĩ': 'i','ḭ': 'i','ꝺ': 'd','ꝼ': 'f','ᵹ': 'g','ꞃ': 'r','ꞅ': 's','ꞇ': 't','ꝭ': 'is','ǰ': 'j','ĵ': 'j','ʝ': 'j','ɉ': 'j','ḱ': 'k','ǩ': 'k','ķ': 'k','ⱪ': 'k','ꝃ': 'k','ḳ': 'k','ƙ': 'k','ḵ': 'k','ᶄ': 'k','ꝁ': 'k','ꝅ': 'k','ĺ': 'l','ƚ': 'l','ɬ': 'l','ľ': 'l','ļ': 'l','ḽ': 'l','ȴ': 'l','ḷ': 'l','ḹ': 'l','ⱡ': 'l','ꝉ': 'l','ḻ': 'l','ŀ': 'l','ɫ': 'l','ᶅ': 'l','ɭ': 'l','ł': 'l','ǉ': 'lj','ſ': 's','ẜ': 's','ẛ': 's','ẝ': 's','ḿ': 'm','ṁ': 'm','ṃ': 'm','ɱ': 'm','ᵯ': 'm','ᶆ': 'm','ń': 'n','ň': 'n','ņ': 'n','ṋ': 'n','ȵ': 'n','ṅ': 'n','ṇ': 'n','ǹ': 'n','ɲ': 'n','ṉ': 'n','ƞ': 'n','ᵰ': 'n','ᶇ': 'n','ɳ': 'n','ñ': 'n','ǌ': 'nj','ó': 'o','ŏ': 'o','ǒ': 'o','ô': 'o','ố': 'o','ộ': 'o','ồ': 'o','ổ': 'o','ỗ': 'o','ö': 'o','ȫ': 'o','ȯ': 'o','ȱ': 'o','ọ': 'o','ő': 'o','ȍ': 'o','ò': 'o','ỏ': 'o','ơ': 'o','ớ': 'o','ợ': 'o','ờ': 'o','ở': 'o','ỡ': 'o','ȏ': 'o','ꝋ': 'o','ꝍ': 'o','ⱺ': 'o','ō': 'o','ṓ': 'o','ṑ': 'o','ǫ': 'o','ǭ': 'o','ø': 'o','ǿ': 'o','õ': 'o','ṍ': 'o','ṏ': 'o','ȭ': 'o','ƣ': 'oi','ꝏ': 'oo','ɛ': 'e','ᶓ': 'e','ɔ': 'o','ᶗ': 'o','ȣ': 'ou','ṕ': 'p','ṗ': 'p','ꝓ': 'p','ƥ': 'p','ᵱ': 'p','ᶈ': 'p','ꝕ': 'p','ᵽ': 'p','ꝑ': 'p','ꝙ': 'q','ʠ': 'q','ɋ': 'q','ꝗ': 'q','ŕ': 'r','ř': 'r','ŗ': 'r','ṙ': 'r','ṛ': 'r','ṝ': 'r','ȑ': 'r','ɾ': 'r','ᵳ': 'r','ȓ': 'r','ṟ': 'r','ɼ': 'r','ᵲ': 'r','ᶉ': 'r','ɍ': 'r','ɽ': 'r','ↄ': 'c','ꜿ': 'c','ɘ': 'e','ɿ': 'r','ś': 's','ṥ': 's','š': 's','ṧ': 's','ş': 's','ŝ': 's','ș': 's','ṡ': 's','ṣ': 's','ṩ': 's','ʂ': 's','ᵴ': 's','ᶊ': 's','ȿ': 's','ɡ': 'g','ß': 'ss','ᴑ': 'o','ᴓ': 'o','ᴝ': 'u','ť': 't','ţ': 't','ṱ': 't','ț': 't','ȶ': 't','ẗ': 't','ⱦ': 't','ṫ': 't','ṭ': 't','ƭ': 't','ṯ': 't','ᵵ': 't','ƫ': 't','ʈ': 't','ŧ': 't','ᵺ': 'th','ɐ': 'a','ᴂ': 'ae','ǝ': 'e','ᵷ': 'g','ɥ': 'h','ʮ': 'h','ʯ': 'h','ᴉ': 'i','ʞ': 'k','ꞁ': 'l','ɯ': 'm','ɰ': 'm','ᴔ': 'oe','ɹ': 'r','ɻ': 'r','ɺ': 'r','ⱹ': 'r','ʇ': 't','ʌ': 'v','ʍ': 'w','ʎ': 'y','ꜩ': 'tz','ú': 'u','ŭ': 'u','ǔ': 'u','û': 'u','ṷ': 'u','ü': 'u','ǘ': 'u','ǚ': 'u','ǜ': 'u','ǖ': 'u','ṳ': 'u','ụ': 'u','ű': 'u','ȕ': 'u','ù': 'u','ủ': 'u','ư': 'u','ứ': 'u','ự': 'u','ừ': 'u','ử': 'u','ữ': 'u','ȗ': 'u','ū': 'u','ṻ': 'u','ų': 'u','ᶙ': 'u','ů': 'u','ũ': 'u','ṹ': 'u','ṵ': 'u','ᵫ': 'ue','ꝸ': 'um','ⱴ': 'v','ꝟ': 'v','ṿ': 'v','ʋ': 'v','ᶌ': 'v','ⱱ': 'v','ṽ': 'v','ꝡ': 'vy','ẃ': 'w','ŵ': 'w','ẅ': 'w','ẇ': 'w','ẉ': 'w','ẁ': 'w','ⱳ': 'w','ẘ': 'w','ẍ': 'x','ẋ': 'x','ᶍ': 'x','ý': 'y','ŷ': 'y','ÿ': 'y','ẏ': 'y','ỵ': 'y','ỳ': 'y','ƴ': 'y','ỷ': 'y','ỿ': 'y','ȳ': 'y','ẙ': 'y','ɏ': 'y','ỹ': 'y','ź': 'z','ž': 'z','ẑ': 'z','ʑ': 'z','ⱬ': 'z','ż': 'z','ẓ': 'z','ȥ': 'z','ẕ': 'z','ᵶ': 'z','ᶎ': 'z','ʐ': 'z','ƶ': 'z','ɀ': 'z','ﬀ': 'ff','ﬃ': 'ffi','ﬄ': 'ffl','ﬁ': 'fi','ﬂ': 'fl','ĳ': 'ij','œ': 'oe','ﬆ': 'st','ₐ': 'a','ₑ': 'e','ᵢ': 'i','ⱼ': 'j','ₒ': 'o','ᵣ': 'r','ᵤ': 'u','ᵥ': 'v','ₓ': 'x','Ё': 'YO', 'Й': 'I', 'Ц': 'TS', 'У': 'U', 'К': 'K', 'Е': 'E', 'Н': 'N', 'Г': 'G', 'Ш': 'SH', 'Щ': 'SCH', 'З': 'Z', 'Х': 'H', 'Ъ': '', 'ё': 'yo', 'й': 'i', 'ц': 'ts', 'у': 'u', 'к': 'k', 'е': 'e', 'н': 'n', 'г': 'g', 'ш': 'sh', 'щ': 'sch', 'з': 'z', 'х': 'h', 'ъ': '', 'Ф': 'F', 'Ы': 'I', 'В': 'V', 'А': 'A', 'П': 'P', 'Р': 'R', 'О': 'O', 'Л': 'L', 'Д': 'D', 'Ж': 'ZH', 'Э': 'E', 'ф': 'f', 'ы': 'i', 'в': 'v', 'а': 'a', 'п': 'p', 'р': 'r', 'о': 'o', 'л': 'l', 'д': 'd', 'ж': 'zh', 'э': 'e', 'Я': 'Ya', 'Ч': 'CH', 'С': 'S', 'М': 'M', 'И': 'I', 'Т': 'T', 'Ь': '', 'Б': 'B', 'Ю': 'YU', 'я': 'ya', 'ч': 'ch', 'с': 's', 'м': 'm', 'и': 'i', 'т': 't', 'ь': '', 'б': 'b', 'ю': 'yu'}

// ConfigStorage
//;(function (window) {
  var keyPrefix = '';
  var noPrefix = false;
  var cache = {};
  var useCs = !!(window.chrome && chrome.storage && chrome.storage.local);
  var useLs = !useCs && !!window.localStorage;

  function storageSetPrefix(newPrefix) {
    keyPrefix = newPrefix;
  }

  function storageSetNoPrefix() {
    noPrefix = true;
  }

  function storageGetPrefix() {
    if(noPrefix) {
      noPrefix = false;
      return '';
    }

    return keyPrefix;
  }

  function storageGetValue(keys, callback) {
    var single = false;
    if(!Array.isArray(keys)) {
      keys = Array.prototype.slice.call(arguments);
      callback = keys.pop();
      single = keys.length == 1;
    }
    var result = [],
      value;
    var allFound = true;
    var prefix = storageGetPrefix(),
      i, key;

    for(i = 0; i < keys.length; i++) {
      key = keys[i] = prefix + keys[i];
      if(key.substr(0, 3) != 'xt_' && cache[key] !== undefined) {
        result.push(cache[key]);
      } else if(useLs) {
        try {
          value = localStorage.getItem(key);
        } catch(e) {
          useLs = false;
        }

        try {
          value = (value === undefined || value === null) ? false : JSON.parse(value);
        } catch(e) {
          value = false;
        }
        result.push(cache[key] = value);
      } else if(!useCs) {
        result.push(cache[key] = false);
      } else {
        allFound = false;
      }
    }

    if(allFound) {
      return callback(single ? result[0] : result);
    }

    chrome.storage.local.get(keys, function(resultObj) {
      var value;
      result = [];
      for(i = 0; i < keys.length; i++) {
        key = keys[i];
        value = resultObj[key];
        value = value === undefined || value === null ? false : JSON.parse(value);
        result.push(cache[key] = value);
      }

      callback(single ? result[0] : result);
    });
  }

  function storageSetValue(obj, callback) {
    var keyValues = {};
    var prefix = storageGetPrefix(),
      key, value;

    //console.log('storageSetValue', obj, callback, arguments);

    for(key in obj) {
      if(obj.hasOwnProperty(key)) {
        value = obj[key];
        key = prefix + key;
        cache[key] = value;
        //value = value instanceof Uint8Array ? Array.from(value) : JSON.stringify(value);
        value = JSON.stringify(value);
        if(useLs) {
          try {
            //console.log('setItem', key, value);
            localStorage.setItem(key, value);
          } catch (e) {
            useLs = false;
          }
        } else {
          keyValues[key] = value;
        }
      }
    }

    if(useLs || !useCs) {
      if(callback) {
        callback();
      }

      return;
    }

    chrome.storage.local.set(keyValues, callback);
  }

  function storageRemoveValue(keys, callback) {
    if(!Array.isArray(keys)) {
      keys = Array.prototype.slice.call(arguments)
      if(typeof keys[keys.length - 1] === 'function') {
        callback = keys.pop();
      }
    }

    var prefix = storageGetPrefix(),
      i, key;

    for(i = 0; i < keys.length; i++) {
      key = keys[i] = prefix + keys[i];
      delete cache[key];
      if(useLs) {
        try {
          localStorage.removeItem(key);
        } catch(e) {
          useLs = false;
        }
      }
    }

    if(useCs) {
      chrome.storage.local.remove(keys, callback);
    } else if(callback) {
      callback();
    }
  }

  function storageClear(callback) {
    if(useLs) {
      try {
        localStorage.clear();
      } catch (e) {
        useLs = false;
      }
    }

    if(useCs) {
      chrome.storage.local.clear(function() {
        cache = {};
        callback();
      })
    } else {
      cache = {};
      callback();
    }
  }

  

  window.ConfigStorage = {
    prefix: storageSetPrefix,
    noPrefix: storageSetNoPrefix,
    get: storageGetValue,
    set: storageSetValue,
    remove: storageRemoveValue,
    clear: storageClear
  };

  //window.Config = Config;

  Config.Storage = window.ConfigStorage;

  module.exports = Config;
//})(this)
